<?php

namespace App;

use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\SoftDeletes;

class AdminJournalVoucher extends Model
{
    use SoftDeletes;

    // RELATION
    function account()
    {
        return $this->morphTo();
    }

    public function buyer()
    {
        return $this->hasOne(OtherAccountBuyer::class, 'invoice_no', 'invoice_no');
    }
    public function customer()
    {
        return $this->belongsTo(Customer::class, 'account_id', 'id');
    }
    public function supplier()
    {
        return $this->belongsTo(Supplier::class, 'account_id', 'id');
    }
    public function staffAndSalesman()
    {
        return $this->belongsTo(StaffAndSalesman::class, 'account_id', 'id');
    }
    public function expenseTable()
    {
        return $this->belongsTo(Expense::class, 'account_id', 'id');
    }
    public function adminOtherAccount()
    {
        return $this->belongsTo(AdminOtherAccount::class, 'account_id', 'id');
    }
}
