<?php

namespace App;

use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\SoftDeletes;

class AdminSalesInvoice extends Model
{
    use SoftDeletes;

    public function expenses()
    {
        return $this->belongsToMany(Expense::class, 'admin_sales_invoice_expenses', 'admin_sales_invoice_id', 'expense_id')->withPivot('expense_amount')->withTrashed();
    }

    public function expense()
    {
        return $this->belongsToMany(Expense::class, 'admin_sales_invoice_expenses', 'admin_sales_invoice_id', 'expense_id')->withPivot('expense_amount')->withTrashed();
    }

    function account()
    {
        return $this->morphTo();
    }

    public function item()
    {
        return $this->belongsTo(ItemName::class, 'item_id', 'id');
    }

    public function warehouse()
    {
        return $this->belongsTo(WareHouse::class, 'warehouse_id', 'id');
    }

    public function buyer()
    {
        return $this->hasOne(OtherAccountBuyer::class, 'invoice_no', 'invoice_no');
    }
    public function customer()
    {
        return $this->belongsTo(Customer::class, 'account_id', 'id');
    }
    public function supplier()
    {
        return $this->belongsTo(Supplier::class, 'account_id', 'id');
    }
    public function staffAndSalesman()
    {
        return $this->belongsTo(StaffAndSalesman::class, 'account_id', 'id');
    }
    public function expenseTable()
    {
        return $this->belongsTo(Expense::class, 'account_id', 'id');
    }
    public function adminOtherAccount()
    {
        return $this->belongsTo(AdminOtherAccount::class, 'account_id', 'id');
    }
}

