<?php

namespace App\Http\Controllers;

use App\AdminOtherAccount;
use App\ClassOfAccount;
use Illuminate\Database\Eloquent\SoftDeletes;
use Illuminate\Http\Request;
use App\Http\Requests\StoreOtherAccountMasterRequest;
use App\Http\Requests\UpdateOtherAccountMasterRequest;
use App\Permission;
use App\BranchPermission;
use App\AssignedPermission;
use App\Branches;
use App\User;
use App\AccountMasterPermission;
use Auth;

class AdminOtherAccountController extends Controller
{
    use SoftDeletes;

    public function index()
    {
        // $otherAccounts = AdminOtherAccount::where('branch_id', session()->get('selected_branch'))->orderBy('id', 'desc')->get();

        //  // Retrieve permission titles from Permission table
        //  $permissionTitles = Permission::where('branch_id', session()->get('selected_branch'))->pluck('name')->toArray();

        //  // Filter permission titles using hasBranchPermission function
        //  $filteredPermissionTitles = [];
        //  $branchId = session()->get('selected_branch');
        //  foreach ($permissionTitles as $permissionTitle) {
        //      if (Branches::hasBranchPermission($branchId, $permissionTitle)) {
        //          $filteredPermissionTitles[] = $permissionTitle;
        //      }
        //  }

        //  // Retrieve AdminOtherAccount whose name_of_organisation matches filtered permission titles
        //  $otherAccounts = AdminOtherAccount::where('branch_id', $branchId)
        //      ->whereIn('account_name', $filteredPermissionTitles)
        //      ->orderBy('id', 'desc')
        //      ->get();

        // $permissionTitles = Permission::where('branch_id', session()->get('selected_branch'))->pluck('name')->toArray();

        // $filteredPermissionTitles = [];
        // $branchId = session()->get('selected_branch');
        // foreach ($permissionTitles as $permissionTitle) {
        //     if (Branches::hasBranchAccountPermission($branchId, $permissionTitle)) {
        //         $filteredPermissionTitles[] = $permissionTitle;
        //     }
        // }

        // $otherAccounts = AdminOtherAccount::where('branch_id', $branchId)
        //     ->orderBy('id', 'desc')
        //     ->get();

        // foreach ($otherAccounts as $otherAccount) {
        //     $otherAccount->account_name = str_replace(' ', '-', $otherAccount->account_name);
        // }

        // $filteredExpenses = $otherAccounts->filter(function ($customer) use ($filteredPermissionTitles) {
        //     return in_array($customer->account_name, $filteredPermissionTitles);
        // });

        $userId = Auth::id();
        // dd($userId);
        $branchId = session('selected_branch');

        $otherAccountIds = AccountMasterPermission::where([
            ['user_id', $userId],
            ['branch_id', $branchId],
            ['account_master_type', 'otherAccount']
        ])->pluck('account_master_id');

        $otherAccounts = AdminOtherAccount::whereIn('id', $otherAccountIds)->where('branch_id', $branchId)
            ->orderBy('id', 'desc')
            ->get();

        return view('crusher.otheraccount_master.index', compact('otherAccounts'));
    }

    public function create()
    {
        $classOfAccount = ClassOfAccount::all();
        $subadmins = User::where(['admin_id'=>auth()->id(), 'status'=>1])->get();

        return view('crusher.otheraccount_master.create', compact('classOfAccount','subadmins'));
    }
    public function store(StoreOtherAccountMasterRequest $request)
    {
        $masterName = 'other-account';
        $latestAccount = AdminOtherAccount::withTrashed()->where('branch_id', session()->get('selected_branch'))
            ->latest('account_no')->first();

        if ($latestAccount) {
            $explodedAccountNo = explode('-', $latestAccount->account_no);
            $lastAccountNumber = end($explodedAccountNo);
            $newAccountNumber = $masterName . '-' . str_pad((int)$lastAccountNumber + 1, 4, '0', STR_PAD_LEFT);
        } else {
            $newAccountNumber = $masterName . '-0001';
        }

        try {
            $validatedData = $request->validated();
            $validatedData['branch_id'] = session()->get('selected_branch');
            $validatedData['account_no'] = $newAccountNumber;

            $otherAccount = AdminOtherAccount::create($validatedData);

            // use App\Permission;
            // use App\BranchPermission;
            // use App\AssignedPermission;

            // $name = $request->account_name;
            $name = str_replace(' ', '-', $request->account_name);
            $selectedBranchId = session('selected_branch');

            $current_other_account_id = $otherAccount->id;
            $current_other_account_no = $otherAccount->account_no;

            if(isset($request->show_user)){
                foreach ($request->show_user as $key => $request->show_user) {
                    $account_master_permission = new AccountMasterPermission();
                    $account_master_permission->user_id = $request->show_user;
                    $account_master_permission->branch_id = $selectedBranchId;
                    $account_master_permission->account_master_id = $current_other_account_id;
                    $account_master_permission->account_master_no = $current_other_account_no;
                    $account_master_permission->account_master_type = "otherAccount";
                    $account_master_permission->account_master_name = $name;
                    $account_master_permission->save();
                }
            }

            if(Auth::check() && Auth::user()->role === 'admin')
            {
                $account_master_permission = new AccountMasterPermission();
                $account_master_permission->user_id = Auth::user()->id;
                $account_master_permission->branch_id = $selectedBranchId;
                $account_master_permission->account_master_id = $current_other_account_id;
                $account_master_permission->account_master_no = $current_other_account_no;
                $account_master_permission->account_master_type = "otherAccount";
                $account_master_permission->account_master_name = $name;
                $account_master_permission->save();
            }else{
                $account_master_permission = new AccountMasterPermission();
                $account_master_permission->user_id = Auth::user()->id;
                $account_master_permission->branch_id = $selectedBranchId;
                $account_master_permission->account_master_id = $current_other_account_id;
                $account_master_permission->account_master_no = $current_other_account_no;
                $account_master_permission->account_master_type = "otherAccount";
                $account_master_permission->account_master_name = $name;
                $account_master_permission->save();

                $account_master_permission = new AccountMasterPermission();
                $account_master_permission->user_id = Auth::user()->admin_id;
                $account_master_permission->branch_id = $selectedBranchId;
                $account_master_permission->account_master_id = $current_other_account_id;
                $account_master_permission->account_master_no = $current_other_account_no;
                $account_master_permission->account_master_type = "otherAccount";
                $account_master_permission->account_master_name = $name;
                $account_master_permission->save();
            }

            // $permission = Permission::create([
            //     'name' => $name,
            //     'guard_name' => 'web',
            //     'type' => 'Ledger Other Account Master',
            //     'branch_id' => $selectedBranchId,
            // ]);

            // $BranchPermission = BranchPermission::create([
            //     'branch_id' => $permission->branch_id,
            //     'permission_id' => $permission->id,
            // ]);

            // if (auth()->check() && auth()->user()->role == 'subadmin') {
            //     $subadminId = auth()->user()->id;

            //     AssignedPermission::create([
            //         'subadmin_id' => $subadminId,
            //         'branch_permission_id' => $BranchPermission->id
            //     ]);
            // } else {

            // }

            flash()->addSuccess('Record Created');
            return redirect()->route('software.other_accounts.index');
        } catch (\Throwable $th) {
            flash()->addError($th->getMessage());
            return redirect()->back()->withInput();
        }
    }

    public function edit($otherAccount)
    {
        $subadmins = User::where(['admin_id'=>auth()->id(), 'status'=>1])->get();

        $branchId = session('selected_branch');

        $account_master_permission = AccountMasterPermission::where([
            ['branch_id', $branchId],
            ['account_master_id', $otherAccount],
            ['account_master_type', 'otherAccount']
        ])->pluck('user_id');

        // dd($account_master_permission);

        $classOfAccount = ClassOfAccount::all();
        $otherAccount = AdminOtherAccount::find($otherAccount);
        return view('crusher.otheraccount_master.edit', compact('otherAccount','classOfAccount','subadmins','account_master_permission'));
    }

    function update(UpdateOtherAccountMasterRequest $request, $otherAccount)
    {
        try {
            $validatedData = $request->validate($request->rules());
            $validatedData['branch_id'] = session()->get('selected_branch');
            $current_other_account_id = $otherAccount;

            $otherAccount = AdminOtherAccount::find($otherAccount)->update($validatedData);

            $name = str_replace(' ', '-', $request->account_name);

            $selectedBranchId = session('selected_branch');
            $current_other_account_no = $request->account_no;

            $account_master_permission = AccountMasterPermission::where([
                ['branch_id', $selectedBranchId],
                ['account_master_id', $current_other_account_id],
                ['account_master_type', 'otherAccount']
            ])->get();

            foreach ($account_master_permission as $item) {
                    $item->delete();
            }

            if(isset($request->show_user)){
                foreach ($request->show_user as $key => $request->show_user) {
                    $account_master_permission = new AccountMasterPermission();
                    $account_master_permission->user_id = $request->show_user;
                    $account_master_permission->branch_id = $selectedBranchId;
                    $account_master_permission->account_master_id = $current_other_account_id;
                    $account_master_permission->account_master_no = $current_other_account_no;
                    $account_master_permission->account_master_type = "otherAccount";
                    $account_master_permission->account_master_name = $name;
                    $account_master_permission->save();
                }
            }

            if(Auth::check() && Auth::user()->role === 'admin')
            {
                $account_master_permission = new AccountMasterPermission();
                $account_master_permission->user_id = Auth::user()->id;
                $account_master_permission->branch_id = $selectedBranchId;
                $account_master_permission->account_master_id = $current_other_account_id;
                $account_master_permission->account_master_no = $current_other_account_no;
                $account_master_permission->account_master_type = "otherAccount";
                $account_master_permission->account_master_name = $name;
                $account_master_permission->save();
            }else{
                $account_master_permission = new AccountMasterPermission();
                $account_master_permission->user_id = Auth::user()->id;
                $account_master_permission->branch_id = $selectedBranchId;
                $account_master_permission->account_master_id = $current_other_account_id;
                $account_master_permission->account_master_no = $current_other_account_no;
                $account_master_permission->account_master_type = "otherAccount";
                $account_master_permission->account_master_name = $name;
                $account_master_permission->save();

                $account_master_permission = new AccountMasterPermission();
                $account_master_permission->user_id = Auth::user()->admin_id;
                $account_master_permission->branch_id = $selectedBranchId;
                $account_master_permission->account_master_id = $current_other_account_id;
                $account_master_permission->account_master_no = $current_other_account_no;
                $account_master_permission->account_master_type = "otherAccount";
                $account_master_permission->account_master_name = $name;
                $account_master_permission->save();
            }

            flash()->addSuccess('Record Updated');
            return redirect()->route('software.other_accounts.index');
        } catch (\Throwable $th) {
            flash()->addError($th->getMessage());
            return redirect()->back()->withInput();
        }
    }

    public function show($otherAccount)
    {
        $subadmins = User::where(['admin_id'=>auth()->id(), 'status'=>1])->get();

        $branchId = session('selected_branch');

        $account_master_permission = AccountMasterPermission::where([
            ['branch_id', $branchId],
            ['account_master_id', $otherAccount],
            ['account_master_type', 'otherAccount']
        ])->pluck('user_id');

        $otherAccount = AdminOtherAccount::with('classOfAccount')->find($otherAccount);
        return view('crusher.otheraccount_master.view', compact('otherAccount','subadmins','account_master_permission'));
    }

    public function softDelete($otherAccount)
    {
        $otherAccount = AdminOtherAccount::findOrFail($otherAccount);
        $otherAccount->delete();
        flash()->addSuccess('Success');
        return redirect()->route('software.other_accounts.index');
    }
}
