<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use App\AdminOtherAccount;
use App\Branches;
use App\BranchPermission;
use App\Company;
use App\Customer;
use App\Expense;
use App\ItemUnit;
use App\AdminItemGroup;
use App\ItemName;
use App\AdminPeriodClosing;
use App\Supplier;
use App\StaffAndSalesman;
use App\AdminWarehouse;
use App\AdminTermsAndCondition;
use App\Quotation;
use App\DeliveryNote;
use App\AdminSalesInvoice;
use App\CreditNote;
use App\PurchaseOrder;
use App\AdminPurchaesInvoice;
use App\WarehouseTransfer;
use App\DebitNote;
use App\AdminReceiptVoucher;
use App\ReceiptVoucherExpense;
use App\OpeningBalance;
use App\AdminJournalVoucher;
use App\Notifications;
use App\Remainder;
use App\Permission;
use App\AdminPaymentVoucher;
use App\PaymentVoucherExpense;
use Illuminate\Support\Facades\DB;
class ClearDataController extends Controller
{
    public function cleardata()
    {
        $data['branches'] = Branches::all();
        $data['companies'] = Company::all();
        return view('super_admin.superadmin-cleardata')->with($data);
    }

    public function allclearData($branchId)
    {
        DB::beginTransaction();

        try {

            Customer::where('branch_id', $branchId)->forceDelete();
            Expense::where('branch_id', $branchId)->forceDelete();
            ItemUnit::where('branch_id', $branchId)->forceDelete();
            AdminItemGroup::where('branch_id', $branchId)->forceDelete();
            ItemName::where('branch_id', $branchId)->forceDelete();
            AdminOtherAccount::where('branch_id', $branchId)->forceDelete();
            AdminPeriodClosing::where('branch_id', $branchId)->forceDelete();
            Supplier::where('branch_id', $branchId)->forceDelete();
            StaffAndSalesman::where('branch_id', $branchId)->forceDelete();
            AdminWarehouse::where('branch_id', $branchId)->forceDelete();
            AdminTermsAndCondition::where('branch_id', $branchId)->forceDelete();
            Quotation::where('branch_id', $branchId)->forceDelete();
            DeliveryNote::where('branch_id', $branchId)->forceDelete();
            AdminPaymentVoucher::where('branch_id', $branchId)->forceDelete();
            PaymentVoucherExpense::where('branch_id', $branchId)->forceDelete();
            AdminReceiptVoucher::where('branch_id', $branchId)->forceDelete();
            ReceiptVoucherExpense::where('branch_id', $branchId)->forceDelete();
            AdminSalesInvoice::where('branch_id', $branchId)->forceDelete();
            CreditNote::where('branch_id', $branchId)->forceDelete();
            PurchaseOrder::where('branch_id', $branchId)->forceDelete();
            AdminPurchaesInvoice::where('branch_id', $branchId)->forceDelete();
            WarehouseTransfer::where('branch_id', $branchId)->forceDelete();
            DebitNote::where('branch_id', $branchId)->forceDelete();
            OpeningBalance::where('branch_id', $branchId)->forceDelete();
            AdminJournalVoucher::where('branch_id', $branchId)->forceDelete();
            Notifications::where('branch_id', $branchId)->forceDelete();
            Remainder::where('branch_id', $branchId)->forceDelete();

            DB::commit();

            return redirect()->back()->with('success', 'Data for the branch has been cleared successfully.');
        } catch (\Exception $e) {
            DB::rollback();

            return redirect()->back()->with('error', 'An error occurred while clearing data for the branch.');
        }
    }
    public function StockSearch()
        {
            $branch = Branches::where('id', session()->get('selected_branch'))->first();
            $company = Company::where('id', $branch->company_id)->first();

            $items = ItemName::where('branch_id', session()->get('selected_branch'))->get();
            $warehouses = AdminWarehouse::where('branch_id', session()->get('selected_branch'))->get();

            $remainingQty = [];

            // Calculate remaining quantities
            foreach ($warehouses as $warehouse) {
                foreach ($items as $item) {
                    $openingBalanceForInventories = OpeningBalance::where('branch_id', session()->get('selected_branch'))
                        ->where('warehouse_id', $warehouse->id)
                        ->where('item_id', $item->id)
                        ->sum('quantity');

                    $purchaseInvoices = AdminPurchaesInvoice::where('branch_id', session()->get('selected_branch'))
                        ->where('warehouse_id', $warehouse->id)
                        ->where('item_id', $item->id)
                        ->sum('quantity');

                    $salesInvoices = AdminSalesInvoice::where('branch_id', session()->get('selected_branch'))
                        ->where('warehouse_id', $warehouse->id)
                        ->where('item_id', $item->id)
                        ->sum('quantity');

                    $purchaseReturnInvoices = DebitNote::where('branch_id', session()->get('selected_branch'))
                        ->where('warehouse_id', $warehouse->id)
                        ->where('item_id', $item->id)
                        ->sum('quantity');

                    $salesReturnInvoices = CreditNote::where('branch_id', session()->get('selected_branch'))
                        ->where('warehouse_id', $warehouse->id)
                        ->where('item_id', $item->id)
                        ->sum('quantity');

                    $pp = ($openingBalanceForInventories + $purchaseInvoices) + $salesReturnInvoices;
                    $ss = ($salesInvoices + $salesReturnInvoices) + $purchaseReturnInvoices;
                    $remainingQuantity = $pp - $ss;

                    // Only add to remainingQty if remainingQuantity is greater than 0
                    if ($remainingQuantity > 0) {
                        $remainingQty[] = [
                            'company_name' => $company->name,
                            'branch_name' => $branch->name,
                            'warehouse_name' => $warehouse->name,
                            'item_name' => $item->name,
                            'remaining_quantity' => $remainingQuantity
                        ];
                    }
                }
            }

            // dd($remainingQty);

            return view('crusher.stock.stock-search',compact('remainingQty'));
        }

        public function notify($branchId)
        {
            try {

                $branch = Branches::where('id', $branchId)->first();
                $branch->branch_status = 'deleted';
                $branch->save();

                return redirect()->back()->with('success', 'Notification Sent successfully.');
            } catch (\Exception $e) {
                return redirect()->back()->with('error', 'An error occurred while Notification.');
            }
        }

    }


