<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use App\Branches;
use App\AdminItemGroup;
use App\AdminSalesInvoice;
use App\AdminPurchaesInvoice;
use App\Customer;
use App\DebitNote;
use App\CreditNote;
use App\PaymentVoucherExpense;
use App\ReceiptVoucherExpense;
use App\AdminReceiptVoucher;
use App\AdminPaymentVoucher;
use App\AdminJournalVoucher;
use Illuminate\Support\Facades\DB;
use App\AdminPeriodClosing;

class DayBookReportController extends Controller
{
    public function view()
    {
        $periodClosings = AdminPeriodClosing::where('branch_id', session()->get('selected_branch'))->pluck('to')->toArray();

        // dd($periodClosings);

        return view('crusher.reports.day_book',compact('periodClosings'));
    }
    public function dayBookReport(Request $request)
    {
        $from_date = $request->from_date;
        $to_date = $request->to_date;

        $Debit_Notes = DebitNote::with([
            'customer' => function ($query) {
                $query->where('branch_id', session()->get('selected_branch'));
            },
            'supplier' => function ($query) {
                $query->where('branch_id', session()->get('selected_branch'));
            },
            'staffAndSalesman' => function ($query) {
                $query->where('branch_id', session()->get('selected_branch'));
            },
            'expenseTable' => function ($query) {
                $query->where('branch_id', session()->get('selected_branch'));
            },
            'adminOtherAccount' => function ($query) {
                $query->where('branch_id', session()->get('selected_branch'));
            }
        ])
        ->where('branch_id', session()->get('selected_branch'))
        ->where('date', '>=', $from_date . ' 00:00:00')
        ->where('date', '<=', $to_date . ' 23:59:59')
        ->groupBy('invoice_no')
        ->get();

        $Credit_Notes = CreditNote::with([
            'customer' => function ($query) {
                $query->where('branch_id', session()->get('selected_branch'));
            },
            'supplier' => function ($query) {
                $query->where('branch_id', session()->get('selected_branch'));
            },
            'staffAndSalesman' => function ($query) {
                $query->where('branch_id', session()->get('selected_branch'));
            },
            'expenseTable' => function ($query) {
                $query->where('branch_id', session()->get('selected_branch'));
            },
            'adminOtherAccount' => function ($query) {
                $query->where('branch_id', session()->get('selected_branch'));
            }
        ])
        ->where('branch_id', session()->get('selected_branch'))
        ->where('date', '>=', $from_date . ' 00:00:00')
        ->where('date', '<=', $to_date . ' 23:59:59')
        ->groupBy('invoice_no')
        ->get();

        $sale_invoices = AdminSalesInvoice::with([
            'customer' => function ($query) {
                $query->where('branch_id', session()->get('selected_branch'));
            },
            'supplier' => function ($query) {
                $query->where('branch_id', session()->get('selected_branch'));
            },
            'staffAndSalesman' => function ($query) {
                $query->where('branch_id', session()->get('selected_branch'));
            },
            'expenseTable' => function ($query) {
                $query->where('branch_id', session()->get('selected_branch'));
            },
            'adminOtherAccount' => function ($query) {
                $query->where('branch_id', session()->get('selected_branch'));
            }
        ])
            ->where('branch_id', session()->get('selected_branch'))
            ->where('date', '>=', $from_date . ' 00:00:00')
            ->where('date', '<=', $to_date . ' 23:59:59')
            ->groupBy('invoice_no')
            ->get();

        $purchase_invoices = AdminPurchaesInvoice::with([
            'customer' => function ($query) {
                $query->where('branch_id', session()->get('selected_branch'));
            },
            'supplier' => function ($query) {
                $query->where('branch_id', session()->get('selected_branch'));
            },
            'staffAndSalesman' => function ($query) {
                $query->where('branch_id', session()->get('selected_branch'));
            },
            'expenseTable' => function ($query) {
                $query->where('branch_id', session()->get('selected_branch'));
            },
            'adminOtherAccount' => function ($query) {
                $query->where('branch_id', session()->get('selected_branch'));
            }
        ])
            ->where('branch_id', session()->get('selected_branch'))
            ->where('date', '>=', $from_date . ' 00:00:00')
            ->where('date', '<=', $to_date . ' 23:59:59')
            ->groupBy('invoice_no')
            ->get();

        $Receipt_Voucher_Expenses = AdminReceiptVoucher::with('expense')->with([
            'customer' => function ($query) {
                $query->where('branch_id', session()->get('selected_branch'));
            },
            'supplier' => function ($query) {
                $query->where('branch_id', session()->get('selected_branch'));
            },
            'staffAndSalesman' => function ($query) {
                $query->where('branch_id', session()->get('selected_branch'));
            },
            'expenseTable' => function ($query) {
                $query->where('branch_id', session()->get('selected_branch'));
            },
            'adminOtherAccount' => function ($query) {
                $query->where('branch_id', session()->get('selected_branch'));
            }
        ])
        ->where('branch_id', session()->get('selected_branch'))
        ->where('date', '>=', $from_date . ' 00:00:00')
        ->where('date', '<=', $to_date . ' 23:59:59')
        // ->where('payment_method', 'Cash')
        ->groupBy('invoice_no')
        ->get();

        foreach ($Receipt_Voucher_Expenses as $receiptVoucher) {
            $receiptVoucher->mergedExpenses = $receiptVoucher->expense
                ->groupBy('receipt_id')
                ->map(function ($group) {
                    return [
                        'receipt_id' => $group->first()->receipt_id,
                        'total_amount' => $group->sum('amount'),
                    ];
                })
                ->values();
        }


        $Payment_Voucher_Expenses = AdminPaymentVoucher::with('expense')->with([
            'customer' => function ($query) {
                $query->where('branch_id', session()->get('selected_branch'));
            },
            'supplier' => function ($query) {
                $query->where('branch_id', session()->get('selected_branch'));
            },
            'staffAndSalesman' => function ($query) {
                $query->where('branch_id', session()->get('selected_branch'));
            },
            'expenseTable' => function ($query) {
                $query->where('branch_id', session()->get('selected_branch'));
            },
            'adminOtherAccount' => function ($query) {
                $query->where('branch_id', session()->get('selected_branch'));
            }
        ])
        ->where('branch_id', session()->get('selected_branch'))
        ->where('date', '>=', $from_date . ' 00:00:00')
        ->where('date', '<=', $to_date . ' 23:59:59')
        // ->where('payment_method', 'Cash')
        ->groupBy('invoice_no')
        ->get();

        foreach ($Payment_Voucher_Expenses as $PaymentVoucher) {
            $PaymentVoucher->mergedExpenses = $PaymentVoucher->expense
                ->groupBy('voucher_id')
                ->map(function ($group) {
                    return [
                        'voucher_id' => $group->first()->voucher_id,
                        'total_amount' => $group->sum('amount'),
                    ];
                })
                ->values();
        }

        $journal_voucher = AdminJournalVoucher::with([
            'customer' => function ($query) {
                $query->where('branch_id', session()->get('selected_branch'));
            },
            'supplier' => function ($query) {
                $query->where('branch_id', session()->get('selected_branch'));
            },
            'staffAndSalesman' => function ($query) {
                $query->where('branch_id', session()->get('selected_branch'));
            },
            'expenseTable' => function ($query) {
                $query->where('branch_id', session()->get('selected_branch'));
            },
            'adminOtherAccount' => function ($query) {
                $query->where('branch_id', session()->get('selected_branch'));
            }
        ])
        ->where('branch_id', session()->get('selected_branch'))
        ->where('date', '>=', $from_date . ' 00:00:00')
        ->where('date', '<=', $to_date . ' 23:59:59')
        ->groupBy('invoice_no')
        ->get();

        // dd($journal_voucher);

        $allDayBookReportData = $Debit_Notes
        ->concat($sale_invoices)
        ->concat($Credit_Notes)
        ->concat($purchase_invoices)
        ->concat($Payment_Voucher_Expenses)
        ->concat($Receipt_Voucher_Expenses)
        ->concat($journal_voucher);

        // dd($allDayBookReportData);

        return view('crusher.reports.day_book_report',compact('allDayBookReportData','from_date','to_date','Debit_Notes','Credit_Notes','sale_invoices', 'purchase_invoices','Receipt_Voucher_Expenses','Payment_Voucher_Expenses','journal_voucher'));
    }
}
