<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use App\AccountMaster;
use App\AccountMastersAccountsDetail;
use App\ClassOfAccount;
use App\Currency;
use App\Http\Controllers\Controller;
use App\PurchaseInvoice;
use App\PurchaseReturnVoucher;
use App\SaleInvoice;
use App\SalesReturnVoucher;
use App\Services\Utils;
use Carbon\Carbon;
use PDF;
use Auth;
use App\Customer;
use App\Expense;
use App\Supplier;
use App\StaffAndSalesman;
use App\AdminOtherAccount;
use App\AdminSalesInvoice;
use App\AdminJournalVoucher;
use App\AdminReceiptVoucher;
use App\ReceiptVoucherExpense;
use App\PaymentVoucherExpense ;
use App\Company;
use App\DeliveryNote;
use App\CreditNote;
use App\DebitNote;
use App\OpeningBalance;
use App\PurchaseOrder;
use App\Quotation;
use App\WarehouseTransfer;
use App\AdminPurchaesInvoice;
use App\AdminPaymentVoucher;
use App\AdminTermsAndCondition;
use App\AdminPeriodClosing;
use Illuminate\Support\Facades\DB;

class DiscountReportController extends Controller
{
    public function display()
    {
        $periodClosings = AdminPeriodClosing::where('branch_id', session()->get('selected_branch'))->pluck('to')->toArray();

        // dd($periodClosings);

        return view('crusher.reports.discount_ledger_report_display',compact('periodClosings'));
    }
    public function discountLedgerReport(Request $request)
    {
        $lastFromDate = date("2003-01-01");
        $from_date = $request->from_date;
        $to_date = $request->to_date;
        $lastDay = Carbon::parse($to_date)->subDay()->format('Y-m-d');
        // dd($lastDay, $lastFromDate);

        $currentYearFirstDate = date("2003-01-01");
        $oneDayPreviousDate = date('Y-m-d', strtotime('-1 day', strtotime($from_date)));

        $obEexpense = Expense::where('branch_id', session()->get('selected_branch'))
        ->where('account_name', 'Discount')
        ->first();

        // Initialize all variables to null at the beginning
        $ExpenseAccountId = null;
        $debitOB = null;
        $creditOB = null;
        $debitObForOb = null;
        $creditObForOb = null;
        $createExpenseDate = null;

        if ($obEexpense) {
            $ExpenseAccountId = $obEexpense->account_no;
            $createExpenseDate = $obEexpense->date;

            // Check if the expense type is 'debit' or 'credit' within the specified date range
            if ($obEexpense->date >= $from_date && $obEexpense->date <= $to_date) {
                if ($obEexpense->type == 'debit') {
                    $debitOB = $obEexpense->opening_balance;
                } elseif ($obEexpense->type == 'credit') {
                    $creditOB = $obEexpense->opening_balance;
                }
            }
            // Check if the expense type is 'debit' or 'credit' within the current year range
            elseif ($obEexpense->date >= $currentYearFirstDate && $obEexpense->date <= $oneDayPreviousDate) {
                if ($obEexpense->type == 'debit') {
                    $debitObForOb = $obEexpense->opening_balance;
                } elseif ($obEexpense->type == 'credit') {
                    $creditObForOb = $obEexpense->opening_balance;
                }
            }
        }


        // dd($ExpenseAccountId,$debitOB,$creditOB);

        $PurchaesInvoice = AdminPurchaesInvoice::where('branch_id', session()->get('selected_branch'))
            // ->where('acc_no', $ExpenseAccountId)
            ->where('date', '>=', $from_date . ' 00:00:00')
            ->where('date', '<=', $to_date . ' 23:59:59')
            ->whereNull('deleted_at')
            ->whereNotNull('discount_amount')
            ->groupBy('invoice_no')
            ->orderBy('invoice_no', 'asc')
            ->get();

            $SaleInvoice = AdminSalesInvoice::where('branch_id', session()->get('selected_branch'))
            ->where('date', '>=', $from_date . ' 00:00:00')
            ->where('date', '<=', $to_date . ' 23:59:59')
            ->whereNull('deleted_at')
            ->whereNotNull('discount')
            ->groupBy('invoice_no')
            ->orderBy('date', 'asc')
            ->get();



        $JournalVoucher = AdminJournalVoucher::where('branch_id', session()->get('selected_branch'))
            ->where('acc_no', $ExpenseAccountId)
            ->where('date', '>=', $from_date . ' 00:00:00')
            ->where('date', '<=', $to_date . ' 23:59:59')
            ->whereNull('deleted_at')
            ->groupBy('invoice_no')
            ->orderBy('date', 'asc')
            ->get();

        $allData = $PurchaesInvoice ->concat($SaleInvoice)->concat($JournalVoucher);

        // dd($allData);

        $ObPurchaesInvoice = AdminPurchaesInvoice::where('branch_id', session()->get('selected_branch'))
        // ->where('acc_no', $ExpenseAccountId)
        ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
        ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
        ->whereNull('deleted_at')
        ->groupBy('invoice_no')
        ->get()
        ->sum('discount_amount');

        $ObSaleInvoice = AdminSalesInvoice::where('branch_id', session()->get('selected_branch'))
            // ->where('acc_no', $ExpenseAccountId)
            ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
            ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
            ->whereNull('deleted_at')
            ->groupBy('invoice_no')
            ->get()
            ->sum('discount');

        $ObJournalVoucherTotalForDebit = AdminJournalVoucher::where('branch_id', session()->get('selected_branch'))
            ->where('acc_no', $ExpenseAccountId)
            ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
            ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
            ->where('type', 'debit')
            ->whereNull('deleted_at')
            ->groupBy('invoice_no')
            ->get()
            ->sum('amount');

        $ObJournalVoucherTotalForCredit = AdminJournalVoucher::where('branch_id', session()->get('selected_branch'))
            ->where('acc_no', $ExpenseAccountId)
            ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
            ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
            ->where('type', 'credit')
            ->whereNull('deleted_at')
            ->groupBy('invoice_no')
            ->get()
            ->sum('amount');

        $opBalanceForDebitSide = $debitObForOb + $ObSaleInvoice + $ObJournalVoucherTotalForDebit;
        $opBalanceForCreditSide = $creditObForOb + $ObPurchaesInvoice + $ObJournalVoucherTotalForCredit;

        $ObDebit = null;
        $ObCredit = null;

        if ($opBalanceForDebitSide > $opBalanceForCreditSide) {
            $ObDebit = $opBalanceForDebitSide - $opBalanceForCreditSide;
        } elseif ($opBalanceForDebitSide < $opBalanceForCreditSide) {
            $ObCredit = $opBalanceForCreditSide - $opBalanceForDebitSide;
        }

          $DebitopeningBalance = $ObDebit;
          $creditOpeningBalance = $ObCredit;

        // dd($DebitopeningBalance,$creditOpeningBalance);

        return view('crusher.reports.discount-ledger-report', compact('from_date', 'to_date', 'allData','debitOB','creditOB','opBalanceForDebitSide','opBalanceForCreditSide','createExpenseDate','DebitopeningBalance','creditOpeningBalance'));
    }
}
