<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use App\Supplier;
use App\Branches;
use App\Customer;

class DocumentExpiryController extends Controller
{
    public function getAllDocumentsExpiry()
    {
        $suppliers = Supplier::where('branch_id', session()->get('selected_branch'))->get();
        $Customers = Customer::where('branch_id', session()->get('selected_branch'))->get();

        $allTableDocuments = $suppliers->concat($Customers);

    $allDocuments = [];

    foreach ($allTableDocuments as $allTableDocument) {
        $documents = [];

        for ($i = 1; $i <= 7; $i++) {
            $docName = $allTableDocument->{"doc_name_$i"};
            $docFile = $allTableDocument->{"doc_file_$i"};
            $docExpiry = $allTableDocument->{"doc_expiry_$i"};

            if ($docName || $docFile || $docExpiry) {
                $documents[] = [
                    'doc_name' => $docName,
                    'doc_file' => $docFile,
                    'doc_expiry' => $docExpiry
                ];
            }
        }

        if (!empty($documents)) {
            $accountName = $allTableDocument->name_of_organisation;
            $allDocuments[$accountName][] = $documents;
        }
    }

        // dd($allDocuments);

        return view('crusher.document_expiry.crusher-document',compact('allDocuments'));
    }
}
