<?php

namespace App\Http\Controllers;

use App\Branches;
use App\Expense;
use Illuminate\Database\Eloquent\SoftDeletes;
use Illuminate\Http\Request;
use App\Http\Requests\StoreExpensesRequest;
use App\Http\Requests\UpdateExpensesRequest;
use App\Permission;
use App\BranchPermission;
use App\AssignedPermission;
use App\ClassOfAccount;
use App\User;
use App\AccountMasterPermission;
use Auth;

class ExpensesMasterController extends Controller
{
    use SoftDeletes;

    public function index()
    {
        // $expenses = Expense::where('branch_id', session()->get('selected_branch'))->orderBy('id', 'desc')
        // ->get();

        //   $permissionTitles = Permission::where('branch_id', session()->get('selected_branch'))->pluck('name')->toArray();

        //   $filteredPermissionTitles = [];
        //   $branchId = session()->get('selected_branch');
        //   foreach ($permissionTitles as $permissionTitle) {
        //       if (Branches::hasBranchPermission($branchId, $permissionTitle)) {
        //           $filteredPermissionTitles[] = $permissionTitle;
        //       }
        //   }

        //   $expenses = Expense::where('branch_id', $branchId)
        //       ->whereIn('account_name', $filteredPermissionTitles)
        //       ->orderBy('id', 'desc')
        //       ->get();


        // $permissionTitles = Permission::where('branch_id', session()->get('selected_branch'))->pluck('name')->toArray();

        // $filteredPermissionTitles = [];
        // $branchId = session()->get('selected_branch');
        // foreach ($permissionTitles as $permissionTitle) {
        //     if (Branches::hasBranchAccountPermission($branchId, $permissionTitle)) {
        //         $filteredPermissionTitles[] = $permissionTitle;
        //     }
        // }

        // $expenses = Expense::where('branch_id', $branchId)
        //     ->orderBy('id', 'desc')
        //     ->get();

        // foreach ($expenses as $expense) {
        //     $expense->account_name = str_replace(' ', '-', $expense->account_name);
        // }

        // $filteredExpenses = $expenses->filter(function ($customer) use ($filteredPermissionTitles) {
        //     return in_array($customer->account_name, $filteredPermissionTitles);
        // });

        $userId = Auth::id();
        // dd($userId);
        $branchId = session('selected_branch');

        $expenseIds = AccountMasterPermission::where([
            ['user_id', $userId],
            ['branch_id', $branchId],
            ['account_master_type', 'expense']
        ])->pluck('account_master_id');

        $expenses = Expense::whereIn('id', $expenseIds)->where('branch_id', $branchId)
            ->orderBy('id', 'desc')
            ->get();

        return view('crusher.expenses_master.index', compact('expenses'));
    }

    public function create()
    {
        $ClassOfAccount = ClassOfAccount::get();
        $subadmins = User::where(['admin_id'=>auth()->id(), 'status'=>1])->get();

        return view('crusher.expenses_master.create',compact('ClassOfAccount','subadmins'));
    }

    function store(StoreExpensesRequest $request)
    {
        // dd($request);
        $masterName = 'expense';
        $latestAccount = Expense::withTrashed()->where('branch_id', session()->get('selected_branch'))
            ->latest('account_no')->first();

        if ($latestAccount) {
            $explodedAccountNo = explode('-', $latestAccount->account_no);
            $lastAccountNumber = end($explodedAccountNo);
            $newAccountNumber = $masterName . '-' . str_pad((int)$lastAccountNumber + 1, 4, '0', STR_PAD_LEFT);
        } else {
            $newAccountNumber = $masterName . '-0001';
        }

        // dd($newAccountNumber);

        try {
            $validatedData = $request->validated();
            $validatedData['branch_id'] = session()->get('selected_branch');
            $validatedData['account_no'] = $newAccountNumber;

            $expense = Expense::create($validatedData);

            // use App\Permission;
            // use App\BranchPermission;
            // use App\AssignedPermission;

            // $name = $request->account_name;

            $name = str_replace(' ', '-', $request->account_name);
            $selectedBranchId = session('selected_branch');

            $current_expense_id = $expense->id;
            $current_expense_account_no = $expense->account_no;

            if(isset($request->show_user)){
                foreach ($request->show_user as $key => $request->show_user) {
                    $account_master_permission = new AccountMasterPermission();
                    $account_master_permission->user_id = $request->show_user;
                    $account_master_permission->branch_id = $selectedBranchId;
                    $account_master_permission->account_master_id = $current_expense_id;
                    $account_master_permission->account_master_no = $current_expense_account_no;
                    $account_master_permission->account_master_type = "expense";
                    $account_master_permission->account_master_name = $name;
                    $account_master_permission->save();
                }
            }

            if(Auth::check() && Auth::user()->role === 'admin')
            {
                $account_master_permission = new AccountMasterPermission();
                $account_master_permission->user_id = Auth::user()->id;
                $account_master_permission->branch_id = $selectedBranchId;
                $account_master_permission->account_master_id = $current_expense_id;
                $account_master_permission->account_master_no = $current_expense_account_no;
                $account_master_permission->account_master_type = "expense";
                $account_master_permission->account_master_name = $name;
                $account_master_permission->save();
            }else{
                $account_master_permission = new AccountMasterPermission();
                $account_master_permission->user_id = Auth::user()->id;
                $account_master_permission->branch_id = $selectedBranchId;
                $account_master_permission->account_master_id = $current_expense_id;
                $account_master_permission->account_master_no = $current_expense_account_no;
                $account_master_permission->account_master_type = "expense";
                $account_master_permission->account_master_name = $name;
                $account_master_permission->save();

                $account_master_permission = new AccountMasterPermission();
                $account_master_permission->user_id = Auth::user()->admin_id;
                $account_master_permission->branch_id = $selectedBranchId;
                $account_master_permission->account_master_id = $current_expense_id;
                $account_master_permission->account_master_no = $current_expense_account_no;
                $account_master_permission->account_master_type = "expense";
                $account_master_permission->account_master_name = $name;
                $account_master_permission->save();
            }

            // $permission = Permission::create([
            //     'name' => $name,
            //     'guard_name' => 'web',
            //     'type' => 'Ledger Expense',
            //     'branch_id' => $selectedBranchId,
            // ]);

            // $BranchPermission = BranchPermission::create([
            //     'branch_id' => $permission->branch_id,
            //     'permission_id' => $permission->id,
            // ]);

            // if (auth()->check() && auth()->user()->role == 'subadmin') {
            //     $subadminId = auth()->user()->id;

            //     AssignedPermission::create([
            //         'subadmin_id' => $subadminId,
            //         'branch_permission_id' => $BranchPermission->id
            //     ]);
            // } else {

            // }

            flash()->addSuccess('Record Created');
            return redirect()->route('software.expense.index');
        } catch (\Throwable $th) {
            flash()->addError($th->getMessage());
            return redirect()->back()->withInput();
        }
    }

    public function edit($expense)
    {
        $subadmins = User::where(['admin_id'=>auth()->id(), 'status'=>1])->get();

        $branchId = session('selected_branch');

        $account_master_permission = AccountMasterPermission::where([
            ['branch_id', $branchId],
            ['account_master_id', $expense],
            ['account_master_type', 'expense']
        ])->pluck('user_id');

        // dd($account_master_permission);
        $expense = Expense::find($expense);
        $ClassOfAccount = ClassOfAccount::get();

        return view('crusher.expenses_master.edit', compact('expense','ClassOfAccount','subadmins','account_master_permission'));
    }

    function update(UpdateExpensesRequest $request, $expense)
    {
        try {
            $validatedData = $request->validated();
            $validatedData['branch_id'] = session()->get('selected_branch');
            $current_expense_id = $expense;

            $expense = Expense::find($expense)->update($validatedData);

            $name = str_replace(' ', '-', $request->account_name);
            $current_expense_account_no = $request->account_no;
            $selectedBranchId = session('selected_branch');

            $account_master_permission = AccountMasterPermission::where([
                ['branch_id', $selectedBranchId],
                ['account_master_id', $current_expense_id],
                ['account_master_type', 'expense']
            ])->get();

            foreach ($account_master_permission as $item) {
                    $item->delete();
            }

            if(isset($request->show_user)){
                foreach ($request->show_user as $key => $request->show_user) {
                    $account_master_permission = new AccountMasterPermission();
                    $account_master_permission->user_id = $request->show_user;
                    $account_master_permission->branch_id = $selectedBranchId;
                    $account_master_permission->account_master_id = $current_expense_id;
                    $account_master_permission->account_master_no = $current_expense_account_no;
                    $account_master_permission->account_master_type = "expense";
                    $account_master_permission->account_master_name = $name;
                    $account_master_permission->save();
                }
            }

            if(Auth::check() && Auth::user()->role === 'admin')
            {
                $account_master_permission = new AccountMasterPermission();
                $account_master_permission->user_id = Auth::user()->id;
                $account_master_permission->branch_id = $selectedBranchId;
                $account_master_permission->account_master_id = $current_expense_id;
                $account_master_permission->account_master_no = $current_expense_account_no;
                $account_master_permission->account_master_type = "expense";
                $account_master_permission->account_master_name = $name;
                $account_master_permission->save();
            }else{
                $account_master_permission = new AccountMasterPermission();
                $account_master_permission->user_id = Auth::user()->id;
                $account_master_permission->branch_id = $selectedBranchId;
                $account_master_permission->account_master_id = $current_expense_id;
                $account_master_permission->account_master_no = $current_expense_account_no;
                $account_master_permission->account_master_type = "expense";
                $account_master_permission->account_master_name = $name;
                $account_master_permission->save();

                $account_master_permission = new AccountMasterPermission();
                $account_master_permission->user_id = Auth::user()->admin_id;
                $account_master_permission->branch_id = $selectedBranchId;
                $account_master_permission->account_master_id = $current_expense_id;
                $account_master_permission->account_master_no = $current_expense_account_no;
                $account_master_permission->account_master_type = "expense";
                $account_master_permission->account_master_name = $name;
                $account_master_permission->save();
            }

            flash()->addSuccess('Record Updated');
            return redirect()->route('software.expense.index');
        } catch (\Throwable $th) {
            flash()->addError($th->getMessage());
            return redirect()->back()->withInput();
        }
    }

    public function show($expense)
    {
        $subadmins = User::where(['admin_id'=>auth()->id(), 'status'=>1])->get();

        $branchId = session('selected_branch');

        $account_master_permission = AccountMasterPermission::where([
            ['branch_id', $branchId],
            ['account_master_id', $expense],
            ['account_master_type', 'expense']
        ])->pluck('user_id');

        // dd($account_master_permission);

        $expense = Expense::find($expense);
        return view('crusher.expenses_master.view', compact('expense','subadmins','account_master_permission'));
    }

    public function softDelete($expense)
    {
        $expense = Expense::findOrFail($expense);
        $expense->delete();
        flash()->addSuccess('Success');
        return redirect()->route('software.expense.index');
    }
}
