<?php

namespace App\Http\Controllers;
use App\MarketingLoginImage;
use App\MarketingDashboardImage;
use Illuminate\Http\Request;

class ImageUploadController extends Controller
{
    public function marketing()
    {
        $loginImage = MarketingLoginImage::find(1);
        $dashboardImage = MarketingDashboardImage::find(1);
        return view('super_admin.superadmin-marketing', compact('loginImage','dashboardImage'));
    }
 
    public function login_image_store(Request $request)
    {
 
        $request->validate([
            'login_image' => 'required|image|mimes:jpeg,png,jpg,gif|max:2048', // Adjust validation rules as needed
        ]);

        if ($request->hasFile('login_image')) {
            $image = $request->file('login_image');
            $imageName = time() . '_' . $image->getClientOriginalName();
            $image->move(public_path('images'), $imageName);
            
            $imageModel = MarketingLoginImage::find(1);

            if ($imageModel) {
                // Update the existing record
                $imageModel->update([
                    'name' => $imageName,
                    'path' => 'images/' . $imageName
                ]);
            } else {
                // Create a new record
                $imageModel = new MarketingLoginImage([
                    'name' => $imageName,
                    'path' => 'images/' . $imageName
                ]);
                $imageModel->save();
            }

            return back()->with('success', 'Image uploaded successfully.');
        }

        return back()->with('error', 'Image upload failed.');
 
    }

    public function login_dashboard_store(Request $request)
    {
        $content = $request->content;
 
        $request->validate([
            'dashboard_image' => 'required|image|mimes:jpeg,png,jpg,gif|max:2048', // Adjust validation rules as needed
        ]);

        if ($request->hasFile('dashboard_image')) {
            $image = $request->file('dashboard_image');
            $imageName = time() . '_' . $image->getClientOriginalName();
            $image->move(public_path('images'), $imageName);
            
            $imageModel = MarketingDashboardImage::find(1);
            if ($imageModel) {
                // Update the existing record
                $imageModel->update([
                    'content' => $content,
                    'path' => 'images/' . $imageName
                ]);
            } else {
                // Create a new record
                $imageModel = new MarketingDashboardImage([
                    'content' => $content,
                    'path' => 'images/' . $imageName
                ]);
                $imageModel->save();
            }

            return back()->with('success', 'Image uploaded successfully.');
        }

        return back()->with('error', 'Image upload failed.');
 
    }
}
    