<?php

namespace App;

use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\SoftDeletes;

class PaymentVoucherExpense extends Model
{
    use SoftDeletes;

    // RELATIONS

    public function voucher()
    {
        return $this->belongsTo(AdminPaymentVoucher::class, 'voucher_id', 'id');
    }

    function account()
    {
        return $this->morphTo();
    }

    function expense()
    {
        return $this->morphTo();
    }
    public function customer()
    {
        return $this->belongsTo(Customer::class, 'account_id', 'id');
    }
    public function supplier()
    {
        return $this->belongsTo(Supplier::class, 'account_id', 'id');
    }
    public function StaffAndSalesman()
    {
        return $this->belongsTo(StaffAndSalesman::class, 'account_id', 'id');
    }
    public function Expenses()
    {
        return $this->belongsTo(Expense::class, 'account_id', 'id');
    }
    public function AdminOtherAccount()
    {
        return $this->belongsTo(AdminOtherAccount::class, 'account_id', 'id');
    }
}
