<?php

namespace App;

use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\SoftDeletes;

class SaleInvoice extends Model
{
    use SoftDeletes;
    /**
     * The table associated with the model.
     *
     * @var string
     */
    protected $table = 'sales_invoices';

    /**
     * The attributes that are mass assignable.
     *
     * @var array
     */
    protected $fillable = [
        'location_id',
        'invoice_no',
        'date',
        'mode_of_payment',
        'purchase_order',
        'lpo_days',
        'warehouse_id',
        'salesman_id',
        'account_id',
        'total_quantity',
        'gross_total',
        'discount',
        'vat_percentage',
        'vat_amount',
        'net_total',
        'amount_in_words',
        'customer_id',
        'narrations',
        'buyer_name',
        'buyer_mobile',
        'buyer_email',
        'buyer_address',
        'buyer_vat_number',
        'is_signed',
        'signature_path'
    ];


    /**
     * The attributes that should be hidden for arrays.
     *
     * @var array
     */
    protected $hidden = [
    ];

    /**
     * The attributes that should be cast to native types.
     *
     * @var array
     */
    protected $casts = [
    ];

    //'foreign_key', 'local_key'
    public function items()
    {
        return $this->hasMany('App\SaleInvoiceItem', 'sales_invoice_id', 'id');
    }

    public function items_cancelled()
    {
        return $this->hasMany('App\SaleInvoiceItem', 'sales_invoice_id', 'id')->withTrashed();
    }

    public function account()
    {
        return $this->belongsTo('App\AccountMaster', 'account_id', 'id');
    }
}
