<?php

namespace App\Services;

use Illuminate\Http\Request;
use App\Customer;
use App\AdminPurchaesInvoice;
use App\Supplier;
use App\StaffAndSalesman;
use App\Expense;
use App\AdminOtherAccount;
use App\AdminSalesInvoice;
use App\AdminJournalVoucher;
use App\AdminReceiptVoucher;
use App\ReceiptVoucherExpense;
use App\PaymentVoucherExpense ;
use App\Company;
use App\DeliveryNote;
use App\CreditNote;
use App\DebitNote;
use App\OpeningBalance;
use App\PurchaseOrder;
use App\Quotation;
use App\ClassOfAccount;
use Carbon\Carbon;
use App\AccountMaster;
use App\AccountMastersAccountsDetail;
use App\Currency;
use App\Http\Controllers\Controller;
use App\PurchaseInvoice;
use App\PurchaseReturnVoucher;
use App\SaleInvoice;
use App\SalesReturnVoucher;
use App\Services\Utils;
use PDF;
use Auth;
use App\WarehouseTransfer;
use App\AdminPaymentVoucher;
use App\AdminTermsAndCondition;
use App\PurchaseInvoiceExpense;
use App\AdminSalesInvoiceExpense;
use App\AdminItemGroup;
use App\ItemName;
use Illuminate\Support\Facades\DB;
use App\Services\StockReportService;
use App\Services\AllAccountsObWithTransactionService;
use App\Services\CashReportService;
use App\Services\VatReportService;
use App\Services\DiscountReportService;
use App\Services\TrialBalanceExpense;
use App\Services\TrialBalanceIncom;

class TrialBalanceOpeningBalanceForBalanceSheetService
{

    protected $stockReportService;
    protected $AllAccountsObWithTransactionService;
    protected $discountReportService;
    protected $vatReportService;
    protected $cashReportService;
    protected $TrialBalanceExpense;
    protected $TrialBalanceIncom;

    public function __construct(
        VatReportService $vatReportService,
        CashReportService $cashReportService,
        DiscountReportService $discountReportService,
        StockReportService $stockReportService,
        AllAccountsObWithTransactionService $AllAccountsObWithTransactionService,
        TrialBalanceExpense $TrialBalanceExpense,
        TrialBalanceIncom $TrialBalanceIncom

        ) {
        $this->vatReportService = $vatReportService;
        $this->cashReportService = $cashReportService;
        $this->discountReportService = $discountReportService;
        $this->stockReportService = $stockReportService;
        $this->AllAccountsObWithTransactionService = $AllAccountsObWithTransactionService;
        $this->TrialBalanceExpense = $TrialBalanceExpense;
        $this->TrialBalanceIncom = $TrialBalanceIncom;

    }

    public function trialBalanceOpeningBalanceForBalanceSheet(Request $request)
    {

        $from_date = $request->to_date;
        $to_date = $request->to_date;


        $currentYearFirstDate = date("2003-01-01");
        $oneDayPreviousDate = date('Y-m-d', strtotime('-1 day', strtotime($from_date)));

        /// -------------------------- All Capital Account Class of Accounts --------------->>>>>>>>>>>>>>>>>>

        list($CapitalAccountDetails,$CapitalAccountTotalDebit,$CapitalAccountTotalCredit, $from_date, $to_date) = $this->AllAccountsObWithTransactionService->AllCapitalAccountClassofAccounts($request, $request->from_date, $request->to_date);

        // dd($CapitalAccountTotalDebit,$CapitalAccountTotalCredit);

        $CADebit = 0;
        $CACredit = 0;

        if ($CapitalAccountTotalDebit > $CapitalAccountTotalCredit) {
            $CADebit = $CapitalAccountTotalDebit - $CapitalAccountTotalCredit;
        } elseif ($CapitalAccountTotalDebit < $CapitalAccountTotalCredit) {
            $CACredit = $CapitalAccountTotalCredit - $CapitalAccountTotalDebit;
        }

        $CapitalAccountTotalDebitBalance = $CADebit;
        $CapitalAccountTotalCreditBalance = $CACredit;

        /// -------------------------- All Loans Account Class of Accounts --------------->>>>>>>>>>>>>>>>>>

        list($LoansAccountDetails,$loansTotalDebit,$loansTotalCredit, $from_date, $to_date) = $this->AllAccountsObWithTransactionService->AllLoansClassofAccounts($request, $request->from_date, $request->to_date);

        // dd($loansTotalDebit,$loansTotalCredit);

        /// -------------------------- All Current Liabilities Account Class of Accounts --------------->>>>>>>>>>>>>>>>>>

        list($CurrentLiabilitiesAccountDetails,$CurrentLiabilitiesTotalDebit,$CurrentLiabilitiesTotalCredit, $from_date, $to_date) = $this->AllAccountsObWithTransactionService->AllCurrentLiabilitiesClassofAccounts($request, $request->from_date, $request->to_date);

        // dd($CurrentLiabilitiesTotalDebit,$CurrentLiabilitiesTotalCredit);

        /// -------------------------- All Sundry Creditors Class of Accounts --------------->>>>>>>>>>>>>>>>>>

        list($SundryCreditorsTotalDebit,$SundryCreditorsTotalCredit, $from_date, $to_date) = $this->AllAccountsObWithTransactionService->AllSundryCreditorsClassofAccountsForTrialBalance($request, $request->from_date, $request->to_date);

        // dd($SundryCreditorsTotalDebit,$SundryCreditorsTotalCredit);

        // Tax & Duties Vat Report Amount --------------------------------

       list($debitVatReportCB,$creditVatReportCB) = $this->vatReportService->vatReportClosingBalance($request, $request->from_date, $request->to_date);

       // dd($debitVatReportCB,$creditVatReportCB);

        /// ---------------- All Tax & Duties Account Class of Accounts --------------->>>>>>>>>>>>>>>>>>

        list($TaxAndDutiesTotalDebit,$TaxAndDutiesTotalCredit, $from_date, $to_date) = $this->AllAccountsObWithTransactionService->AllTaxAndDutiesClassofAccounts($request, $request->from_date, $request->to_date);

        $debitVatReportCB = $debitVatReportCB + $TaxAndDutiesTotalDebit;

        $creditVatReportCB = $creditVatReportCB + $TaxAndDutiesTotalCredit;

    //    dd($debitVatReportCB,$creditVatReportCB);

        $currentLiabilitiesDebit = 0;
        $currentLiabilitiesCredit = 0;

        $currentLiabilitiesDebit = $CurrentLiabilitiesTotalDebit + $debitVatReportCB + $SundryCreditorsTotalDebit;
        $currentLiabilitiesCredit = $CurrentLiabilitiesTotalCredit + $creditVatReportCB + $SundryCreditorsTotalCredit;

        // dd($currentLiabilitiesDebit,$currentLiabilitiesCredit);

        // All Fixed Assets Class of Accounts --------------------------------

        list($fixedTotalClosingBalance) = $this->TrialBalanceIncom->TrialBalanceFixedAssetsForBalanceSheet($request, $request->from_date, $request->to_date);

        $fixedTotalCB = 0;

        foreach ($fixedTotalClosingBalance as $accountName => $closingBalance) {
            $fixedTotalCB += $closingBalance;
        }

        // dd($fixedTotalClosingBalance,$fixedTotalCB);

        // complete stock Opening & Closing Balance

        list($groupedItems, $groups, $from_date, $to_date,$allClosingStock,$allOpeningStock) = $this->stockReportService->completeStockReportClosingBalanceAndOpeningBalance($request, $request->from_date, $request->to_date);

        // dd($allClosingStock,$allOpeningStock);

        /// -------------------------- All Sundry Debtors Class of Accounts --------------->>>>>>>>>>>>>>>>>>

        list($sundryDebtorsTotalDebit,$sundryDebtorsTotalCredit, $from_date, $to_date) = $this->AllAccountsObWithTransactionService->AllSundryDebtorsClassofAccountsForTrialBalance($request, $request->from_date, $request->to_date);

        // dd($sundryDebtorsTotalDebit,$sundryDebtorsTotalCredit);

        /// -------------------------- All Bank Accounts Class of Accounts --------------->>>>>>>>>>>>>>>>>>

        list($bankAccountTotalDebit,$bankAccountTotalCredit, $from_date, $to_date) = $this->AllAccountsObWithTransactionService->AllBankAccountClassofAccountsForTrialBalance($request, $request->from_date, $request->to_date);

        // dd($bankAccountTotalDebit,$bankAccountTotalCredit);

       // Cash Report Data -----------------------------------------------------

       list($debitCashReportCB,$creditCashReportCB) = $this->cashReportService->CashReportServiceClosingBalance($request, $request->from_date, $request->to_date);

        /// -------------------------- All Cash In Hand Account Class of Accounts --------------->>>>>>>>>>>>>>>>>>

        list($CashInHandTotalDebit,$CashInHandTotalCredit, $from_date, $to_date) = $this->AllAccountsObWithTransactionService->AllCashInHandClassofAccounts($request, $request->from_date, $request->to_date);

        // dd($CashInHandTotalDebit,$CashInHandTotalCredit);

        $debitCashReportCB = $debitCashReportCB + $CashInHandTotalDebit;

        $creditCashReportCB = $creditCashReportCB + $CashInHandTotalCredit;

        // dd($debitCashReportCB,$creditCashReportCB);

        // dd($debitCashReportCB,$creditCashReportCB);

        $currentAssetsDebit = 0;
        $currentAssetsCredit = 0;

        $currentAssetsDebit = $debitCashReportCB + $allOpeningStock + $sundryDebtorsTotalDebit + $bankAccountTotalDebit;
        $currentAssetsCredit = $creditCashReportCB + $sundryDebtorsTotalCredit + $bankAccountTotalCredit;

        // dd($currentAssetsDebit,$currentAssetsCredit);


        /// -------------------------- All Advance Account Class of Accounts --------------->>>>>>>>>>>>>>>>>>

        list($AdvanceTotalDebit,$AdvanceTotalCredit, $from_date, $to_date) = $this->AllAccountsObWithTransactionService->AllAdvanceClassofAccounts($request, $request->from_date, $request->to_date);

        // dd($AdvanceTotalDebit,$AdvanceTotalCredit);

        /// -------------------------- All Income Account Class of Accounts --------------->>>>>>>>>>>>>>>>>>

        // list($incomeTotalClosingBalance) = $this->TrialBalanceIncom->TrialBalanceIncoms($request, $request->from_date, $request->to_date);
        list($incomeTotalClosingBalance,$incomeTotalClosingBalanceForTrialBalance) = $this->TrialBalanceIncom->TrialBalanceIncoms($request, $request->from_date, $request->to_date);
        $incomeTotalCB = 0;
        $incomeTotalCBDebit = 0;
        $incomeTotalCBCredit = 0;

        foreach ($incomeTotalClosingBalanceForTrialBalance as $accountName => $balances) {
            $incomeTotalCBDebit += $balances['debit'];
            $incomeTotalCBCredit += $balances['credit'];
        }

        // dd($incomeTotalClosingBalance,$incomeTotalCB);

        // All Purchaes Invoice Totals

        $AllPurchaesInvoice = AdminPurchaesInvoice::where('branch_id', session()->get('selected_branch'))
            ->where('date', '>=', $from_date . ' 00:00:00')
            ->where('date', '<=', $to_date . ' 23:59:59')
            ->groupBy('invoice_no')
            ->get()
            ->sum('total_gross_amount');

        $AllDebitNoteInvoice = DebitNote::where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->groupBy('invoice_no')
                ->get()
                ->sum('total_gross_amount');

        $AllPurchaesTotals = $AllPurchaesInvoice - $AllDebitNoteInvoice;

        // All Sales Invoice Totals

        $AllSaleInvoice = AdminSalesInvoice::where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->groupBy('invoice_no')
                ->get()
                ->sum('total_gross_amount');

        $AllCreditNoteInvoice = CreditNote::where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->groupBy('invoice_no')
                ->get()
                ->sum('total_gross_amount');

        // $AllSaleTotals = $AllSaleInvoice - $AllCreditNoteInvoice;

        $grandTotalDebit = 0;
        $grandTotalCredit = 0;

        if ($AllCreditNoteInvoice > $AllSaleInvoice) {
            $grandTotalDebit = $AllCreditNoteInvoice - $AllSaleInvoice;
        } else {
            $grandTotalCredit = $AllSaleInvoice - $AllCreditNoteInvoice;
        }

        $AllSaleTotalsDebit = $grandTotalDebit;
        $AllSaleTotalsCredit = $grandTotalCredit;

        /// -------------------------- All Expenses Account Class of Accounts --------------->>>>>>>>>>>>>>>>>>

        list($expenseTotalClosingBalance) = $this->TrialBalanceExpense->TrialBalanceExpenses($request, $request->from_date, $request->to_date);

        $expenseTotalCB = 0;

        foreach ($expenseTotalClosingBalance as $accountName => $closingBalance) {
            $expenseTotalCB += $closingBalance;
        }

        // dd($expenseTotalClosingBalance,$expenseTotalCB);

        $DebitBalance = 0;
        $CreditBalance = 0;

        // dd($fixedTotalCB,$currentLiabilitiesDebit,$currentAssetsDebit,$AllSaleTotalsDebit,$AllPurchaesTotals,$expenseTotalCB,$CapitalAccountTotalDebit,$AdvanceTotalDebit,$loansTotalDebit);

        // dd($CapitalAccountTotalCredit,$currentLiabilitiesCredit,$currentAssetsCredit,$incomeTotalCB,$AllSaleTotalsCredit,$AdvanceTotalCredit,$loansTotalCredit);


        $grandTotalDebit = abs($fixedTotalCB) + $currentLiabilitiesDebit + $currentAssetsDebit + $AllSaleTotalsDebit + $AllPurchaesTotals + $expenseTotalCB + $CapitalAccountTotalDebitBalance + $AdvanceTotalDebit + $loansTotalDebit + abs($incomeTotalCBDebit);

        $grandTotalCredit = $CapitalAccountTotalCreditBalance + $currentLiabilitiesCredit + $currentAssetsCredit + $AllSaleTotalsCredit + $AdvanceTotalCredit + $loansTotalCredit + abs($incomeTotalCBCredit);



        // Calculate the balance differences
        if ($grandTotalDebit > $grandTotalCredit) {
            $CreditBalance = $grandTotalDebit - $grandTotalCredit;
        } elseif ($grandTotalCredit > $grandTotalDebit) {
            $DebitBalance = $grandTotalCredit - $grandTotalDebit;
        }

        // dd($DebitBalance,$CreditBalance);

        return [$DebitBalance,$CreditBalance];

    }

}
