<?php

use Illuminate\Database\Migrations\Migration;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Support\Facades\Schema;

class CreatePurchaseSalesTransferStockTracksTable extends Migration
{
    /**
     * Run the migrations.
     *
     * @return void
     */
    public function up()
    {
        Schema::create('purchase_sales_transfer_stock_tracks', function (Blueprint $table) {
            $table->id();
            $table->integer('location_id');
            $table->integer('from_location_id');
            $table->string('warehouse_id');
            $table->integer('item_name_id');
            $table->integer('form_item_name_id')->default(0);
            $table->integer('item_unit_id');
            $table->string('description')->nullable();
            $table->string('color')->nullable();
            $table->string('imei_serial_no');
            $table->string('quantity');
            $table->string('rate_per_quantity');
            $table->string('amount');
            $table->softDeletes();
            $table->timestamps();
        });
    }

    /**
     * Reverse the migrations.
     *
     * @return void
     */
    public function down()
    {
        Schema::dropIfExists('purchase_sales_transfer_stock_tracks');
    }
}
