<?php

use Illuminate\Database\Migrations\Migration;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Support\Facades\Schema;

class CreateDebitNotesTable extends Migration
{
    /**
     * Run the migrations.
     *
     * @return void
     */
    public function up()
    {
        Schema::create('debit_notes', function (Blueprint $table) 
        {
            $table->id();
            $table->bigInteger('branch_id')->nullable();
            $table->string('sales_invoice_no')->nullable(); //FROM ADMIN SALES INVOICE
            $table->string('invoice_no')->nullable();
            $table->date('date')->nullable();
            $table->string('item_description')->nullable();
            $table->bigInteger('quantity')->nullable();
            $table->string('narrations')->nullable();
            $table->double('rate_unit')->nullable();
            $table->float('gross_amount')->nullable();
            $table->float('vat_percentage')->nullable();
            $table->float('vat_amount')->nullable();
            $table->float('net_amount')->nullable();
            $table->float('total_gross_amount')->nullable();
            $table->float('total_vat_amount')->nullable();
            $table->float('total_net_amount')->nullable();
            $table->bigInteger('total_quantity')->nullable();

            $table->nullableMorphs('account'); //belong to App\Customer, App\Supplier, App\Expense, App\AdminOtherAccount

            $table->unsignedBigInteger('item_id')->nullable();
            $table->foreign('item_id')->references('id')->on('item_names')->onDelete('cascade');
            $table->unsignedBigInteger('warehouse_id')->nullable();
            $table->foreign('warehouse_id')->references('id')->on('ware_houses')->onDelete('cascade');
            $table->timestamps();
        });
    }

    /**
     * Reverse the migrations.
     *
     * @return void
     */
    public function down()
    {
        Schema::dropIfExists('debit_notes');
    }
}
