function openRow(selectElement) {
    var selectedValue = selectElement.value;
    var selectedOption = selectElement.options[selectElement.selectedIndex];
    var classOfAccount = selectedOption.getAttribute('data-class-of-account');
    var buyInformationRow = document.getElementById('buyInformationRow');

    // Check if the accountType is 3
    if (classOfAccount === '3') {
        buyInformationRow.style.display = 'block'; // Show the row
    } else {
        buyInformationRow.style.display = 'none'; // Hide the row
    }
}
// Ensure the row is hidden initially
document.getElementById('buyInformationRow').style.display = 'none';




// BUYER MODAL WORK START

// Function to open the modal based on selected value
function openAccountModal(selectElement) {
    var selectedValue = selectElement.value;
    var selectedOption = selectElement.options[selectElement.selectedIndex];
    var classOfAccount = selectedOption.getAttribute('data-class-of-account');

    // Check if the accountType is 1,3
    if (classOfAccount === '3') {
        // Get the invoice_no from the hidden input field
        var invoiceNo = $('#invoice_no').val();

        // Check if the buyer exists
        checkBuyerExists(invoiceNo);
    }
}


// Function to check if a buyer exists
function checkBuyerExists(invoiceNo) {
    // Get CSRF token from the page's meta tag
    var csrfToken = $('meta[name="csrf-token"]').attr('content');

    $.ajax({
        type: 'POST',
        url: '/software/transactions/buyers/exists', // Replace with your API endpoint URL
        headers: {
            'X-CSRF-TOKEN': csrfToken // Add CSRF token to headers
        },
        data: {
            invoice_no: invoiceNo,
            type: $('#type').val()
        },
        success: function(response) {
            if (response.status === true) {
                // Buyer exists, show the modal with ID 'buyer_exists'
                $('#buyer_exists').css('display', 'block');
            } else {
                $('#modal1').modal('show');
                // Buyer does not exist, you can handle this case as needed
                // For example, show a message or perform some other action
            }
        },
        error: function() {
            // Handle AJAX request error here
            alert('Error: An error occurred while checking if the buyer exists.');
        }
    });
}


$(document).ready(function() {
    // Attach a submit event listener to the form
    $('#buyer-form').submit(function(event) {
        event.preventDefault(); // Prevent the default form submission

        // Serialize the form data
        var formData = $(this).serialize();

        // Send an AJAX POST request to the server
        $.ajax({
            type: 'POST',
            url: '/software/transactions/buyers', // Replace with your API endpoint URL
            data: formData,
            success: function(response) {
                if (response.status === true) {
                    // Success: You can handle the success case here
                    // alert('Form submitted successfully!');
                    $('#modal1').modal('hide'); // Close the modal if needed
                } else {
                    // Error: You can handle the error case here
                    alert('Error: ' + response.error);
                }
            },
            error: function() {
                // Handle AJAX request error here
                alert('Error: An error occurred while submitting the form.');
            }
        });
    });

    function callDeleteAPI(invoiceNo) {
        $.ajax({
            type: 'POST',
            url: '/software/transactions/buyers/delete', // Replace with your API endpoint URL
            data: {
                invoice_no: invoiceNo,
                type: $('#type').val()

            },
            success: function(response) {
                // Handle the success case if needed
                console.log('Delete API called successfully.');
            },
            error: function() {
                // Handle AJAX request error here
                console.error('Error: An error occurred while calling the delete API.');
            }
        });
    }

    // Get the invoice_no from the hidden input field
    var invoiceNo = $('#invoice_no').val();

    // Call the delete API on page reload
    callDeleteAPI(invoiceNo);
});
