@extends('layouts.crusher')
@section('content')
    <div class="lds-dual-ring">
        <img class="loader-logo" src="{{ asset('assets/images/ledgematic-blue-logo.svg') }}" height="50" width="100"
            alt="Your Logo">
    </div>
    <div class="row">
        <div class="col-md-12">
            <div class="card">
                <div class="card-body">
                    <div class="row">
                        <div class="col-md-6">
                            <h6 class="card-title mb-4 titlcust">Balance Sheet</h6>
                        </div>
                    </div>
                    <div class="row">
                        <div class="col-md-6">
                            <h6 class="">Date: <span>{{ date('d/m/Y', strtotime($to_date)) }}</span></h6>
                        </div>
                        <div class="col-md-6">
                            <div class="btn-group float-right" role="group" aria-label="Basic example">
                                <a href="" type="button" class="btn btn-outline-primary"><i
                                        class="fas fa-mail-bulk"></i> Email (PDF Formate)</a>
                                <a onclick="printPageArea('printableArea')" class="btn btn-outline-primary"> Print & PDF
                                    Formate</a>
                            </div>
                        </div>
                    </div>


                    <div class="row mt-5">
                        <div class="col-md-6">
                            <div class="table-responsive mb-0" data-pattern="priority-columns">
                                <table id="" class="table table-bordered nowrap"
                                    style="border-collapse: collapse; border-spacing: 0; width: 100%;">
                                    <thead>
                                        <tr class="td-drak-bg">
                                            <th colspan="3"><strong>Libilities</strong></th>
                                        </tr>
                                    </thead>
                                    <tbody>
                                        @foreach ($CapitalAccountDetails as $CapitalAccount)
                                            <tr>
                                                <td>{{ $CapitalAccount['accoun_name'] }}</td>
                                                @php
                                                    $CapitalAccountTB =
                                                        $CapitalAccount['DebitBalance'] -
                                                        $CapitalAccount['CreditBalance'];
                                                @endphp
                                                <td>{{ number_format(abs($CapitalAccountTB), session('branch')->currency_decimal) }}
                                                </td>
                                                <td></td>
                                            </tr>
                                        @endforeach
                                        <tr class="td-drak-bg">
                                            @php
                                                $CapitalAccountBalance =
                                                    $CapitalAccountTotalCredit - $CapitalAccountTotalDebit;
                                            @endphp
                                            <td><strong>Capital Account</strong></td>
                                            <td></td>
                                            <td><strong>
                                                    @if ($CapitalAccountBalance)
                                                        {{ number_format($CapitalAccountBalance, session('branch')->currency_decimal) }}
                                                    @endif
                                                </strong></td>
                                        </tr>
                                        @foreach ($LoansAccountDetails as $LoansAccount)
                                            <tr>
                                                <td>{{ $LoansAccount['accoun_name'] }}</td>
                                                @php
                                                    $LoansAccountTB =
                                                        $LoansAccount['CreditBalance'] - $LoansAccount['DebitBalance'];
                                                @endphp
                                                <td>{{ number_format($LoansAccountTB, session('branch')->currency_decimal) }}
                                                </td>
                                                <td></td>
                                            </tr>
                                        @endforeach
                                        @php
                                            $loansTotalBalance = $loansTotalCredit - $loansTotalDebit;
                                        @endphp
                                        @if ($loansTotalBalance)
                                            <tr class="td-drak-bg">
                                                <td><strong>Loans</strong></td>
                                                <td></td>
                                                <td><strong>
                                                        {{ number_format($loansTotalBalance, session('branch')->currency_decimal) }}
                                                    </strong></td>
                                            </tr>
                                        @endif
                                        @php
                                            $DutiesAndTaxesBalance = $debitVatReportCB - $creditVatReportCB;
                                        @endphp
                                        @if ($DutiesAndTaxesBalance)
                                            <tr>

                                                <td>Duties & Taxes</td>
                                                <td>
                                                    @if ($DutiesAndTaxesBalance)
                                                        {{ number_format(abs($DutiesAndTaxesBalance), session('branch')->currency_decimal) }}
                                                    @endif
                                                </td>
                                                <td></td>
                                            </tr>
                                        @endif
                                        @php
                                            $SundryCreditorsBalanceLibilitiesSide = 0;
                                        @endphp
                                        @if ($SundryCreditorsTotalDebit < $SundryCreditorsTotalCredit)
                                            <tr>
                                                @php

                                                    $SundryCreditorsBalanceLibilitiesSide =
                                                        $SundryCreditorsTotalDebit - $SundryCreditorsTotalCredit;
                                                @endphp
                                                <td>Sundry Creditors</td>
                                                <td>
                                                    @if ($SundryCreditorsBalanceLibilitiesSide)
                                                        {{ number_format(abs($SundryCreditorsBalanceLibilitiesSide), session('branch')->currency_decimal) }}
                                                    @endif
                                                </td>
                                                <td></td>
                                            </tr>
                                        @endif


                                        @foreach ($CurrentLiabilitiesAccountDetails as $CurrentLiabilitiesAccount)
                                            <tr>
                                                <td>{{ $CurrentLiabilitiesAccount['accoun_name'] }}</td>
                                                @php
                                                    $CurrentLiabilitiesAccountTB =
                                                        $CurrentLiabilitiesAccount['CreditBalance'] -
                                                        $CurrentLiabilitiesAccount['DebitBalance'];
                                                @endphp
                                                <td>{{ number_format($CurrentLiabilitiesAccountTB, session('branch')->currency_decimal) }}
                                                </td>
                                                <td></td>
                                            </tr>
                                            @php

                                                $CurrentLiabilitiesACB = 0;
                                                $CurrentLiabilitiesADB = 0;

                                                $CurrentLiabilitiesACB += $CurrentLiabilitiesAccount['CreditBalance'];
                                                $CurrentLiabilitiesADB += $CurrentLiabilitiesAccount['DebitBalance'];

                                                $CLAccountTB = $CurrentLiabilitiesACB - $CurrentLiabilitiesADB;

                                            @endphp
                                        @endforeach

                                        @php
                                            $CurrentLiabilitiesBalanceForLibilitiesSide =
                                                $CurrentLiabilitiesTotalDebit - $CurrentLiabilitiesTotalCredit;
                                        @endphp

                                        @php
                                            $CurrentLiabilitiesTotalBalanceForLibilitiesSide =
                                                $CurrentLiabilitiesBalanceForLibilitiesSide +
                                                $DutiesAndTaxesBalance +
                                                $SundryCreditorsBalanceLibilitiesSide;
                                        @endphp

                                        @if ($CurrentLiabilitiesTotalBalanceForLibilitiesSide)
                                            <tr class="td-drak-bg">
                                                <td><strong>Current Liabilities</strong></td>
                                                <td></td>
                                                <td>
                                                    <strong>{{ number_format(abs($CurrentLiabilitiesTotalBalanceForLibilitiesSide), session('branch')->currency_decimal) }}</strong>
                                                </td>
                                            </tr>
                                        @endif
                                        @php
                                            $ProfitAndLossAccountTotalForLibilitiesSide = 0;
                                        @endphp
                                        @if ($CreditBalance)
                                            <tr>
                                                <td>Opening Balance</td>
                                                <td>
                                                    <strong>{{ number_format($CreditBalance, session('branch')->currency_decimal) }}</strong>
                                                </td>
                                                <td></td>
                                            </tr>
                                            <tr>
                                                <td>Current Period</td>
                                                <td>
                                                    <strong>{{ number_format($netProfit, session('branch')->currency_decimal) }}</strong>
                                                </td>
                                                <td></td>
                                            </tr>
                                            @php
                                                $ProfitAndLossAccountTotalForLibilitiesSide =
                                                    $CreditBalance + $netProfit;
                                            @endphp
                                            <tr class="td-drak-bg mb-5">
                                                <td colspan="2"><strong>Profit & Loss A/C</strong></td>
                                                <td><strong>{{ number_format($ProfitAndLossAccountTotalForLibilitiesSide, session('branch')->currency_decimal) }}</strong>
                                                </td>
                                            </tr>
                                        @endif

                                    </tbody>
                                </table>
                            </div>
                        </div>
                        <div class="col-md-6">
                            <div class="table-responsive mb-0" data-pattern="priority-columns">
                                <table id="" class="table table-bordered nowrap"
                                    style="border-collapse: collapse; border-spacing: 0; width: 100%;">
                                    <thead>
                                        <tr class="td-drak-bg mb-5">
                                            <th colspan="3"><strong>Assets</strong></th>
                                        </tr>
                                    </thead>
                                    <tbody>
                                        @php
                                            $SundryCreditorsBalanceAssetsSide = 0;
                                        @endphp
                                        @if ($SundryCreditorsTotalDebit > $SundryCreditorsTotalCredit)
                                            <tr>
                                                @php
                                                    $SundryCreditorsBalanceAssetsSide =
                                                        $SundryCreditorsTotalDebit - $SundryCreditorsTotalCredit;
                                                @endphp
                                                <td>Sundry Creditors</td>
                                                <td>
                                                    @if ($SundryCreditorsBalanceAssetsSide)
                                                        {{ number_format(abs($SundryCreditorsBalanceAssetsSide), session('branch')->currency_decimal) }}
                                                    @endif
                                                </td>
                                                <td></td>
                                            </tr>
                                        @endif
                                        @php
                                            $CurrentLiabilitiesTotalBalanceForAssetsSide = $SundryCreditorsBalanceAssetsSide;
                                        @endphp
                                        @if ($CurrentLiabilitiesTotalBalanceForAssetsSide)
                                            <tr class="td-drak-bg">
                                                <td><strong>Current Liabilities</strong></td>
                                                <td></td>
                                                <td>
                                                    @if ($CurrentLiabilitiesTotalBalanceForAssetsSide)
                                                        <strong>{{ number_format($CurrentLiabilitiesTotalBalanceForAssetsSide, session('branch')->currency_decimal) }}</strong>
                                                    @endif
                                                </td>
                                            </tr>
                                        @endif
                                        @foreach ($FixedAssetsMergedAccountDetails as $FixedAssetsMergedAccount)
                                            <tr>
                                                <td>{{ $FixedAssetsMergedAccount['accoun_name'] }}</td>
                                                <td>
                                                    @if ($FixedAssetsMergedAccount['DebitBalance'])
                                                        {{ number_format(abs($FixedAssetsMergedAccount['DebitBalance']), session('branch')->currency_decimal) }}
                                                    @endif
                                                </td>
                                                <td>
                                                    @if ($FixedAssetsMergedAccount['CreditBalance'])
                                                        {{ number_format(abs($FixedAssetsMergedAccount['CreditBalance']), session('branch')->currency_decimal) }}
                                                    @endif
                                                </td>
                                            </tr>
                                        @endforeach
                                        @php
                                            $FixedAssetsBalance = $FixedAssetsTotalDebit - $FixedAssetsTotalCredit;
                                        @endphp
                                        @if ($FixedAssetsBalance)
                                            <tr class="td-drak-bg mb-5">
                                                <td><strong>Fixed Assets</strong></td>
                                                <td></td>
                                                <td><strong>
                                                        @if ($FixedAssetsBalance)
                                                            {{ number_format(abs($FixedAssetsBalance), session('branch')->currency_decimal) }}
                                                        @endif
                                                    </strong></td>
                                            </tr>
                                        @endif

                                        @if ($allClosingStock)
                                            <tr>
                                                <td>Closing Stock</td>
                                                <td>{{ number_format(abs($allClosingStock), session('branch')->currency_decimal) }}
                                                </td>
                                                <td></td>
                                            </tr>
                                        @endif
                                        @php
                                            $AdvanceTotalBalance = $AdvanceTotalDebit - $AdvanceTotalCredit;
                                        @endphp
                                        @if ($AdvanceTotalBalance)
                                            <tr>
                                                <td>Advance</td>
                                                <td>{{ number_format(abs($AdvanceTotalBalance), session('branch')->currency_decimal) }}
                                                </td>
                                                <td></td>
                                            </tr>
                                        @endif
                                        @php
                                            $sundryDebtorsBalance =
                                                $sundryDebtorsTotalDebit - $sundryDebtorsTotalCredit;
                                        @endphp
                                        @if ($sundryDebtorsBalance)
                                            <tr>
                                                <td>Sundry Debtors</td>
                                                <td>{{ number_format(abs($sundryDebtorsBalance), session('branch')->currency_decimal) }}
                                                </td>
                                                <td></td>
                                            </tr>
                                        @endif
                                        <tr>
                                            @php
                                                $cashInHandBalance = $debitCashReportCB - $creditCashReportCB;
                                            @endphp
                                            <td>Cash in Hand</td>
                                            <td>{{ number_format($cashInHandBalance, session('branch')->currency_decimal) }}
                                            </td>
                                            <td></td>
                                        </tr>
                                        <tr>
                                            @php
                                                $bankAccountBalance = $bankAccountTotalDebit - $bankAccountTotalCredit;
                                            @endphp
                                            <td>Bank Account</td>
                                            <td>{{ number_format($bankAccountBalance, session('branch')->currency_decimal) }}
                                            </td>
                                            <td></td>
                                        </tr>
                                        <tr class="td-drak-bg mb-5">
                                            @php
                                                $CurrentAssetsTotalBalance =
                                                    $allClosingStock +
                                                    $AdvanceTotalBalance +
                                                    $sundryDebtorsBalance +
                                                    $cashInHandBalance +
                                                    $bankAccountBalance;
                                            @endphp
                                            <td><strong>Current Assets</strong></td>
                                            <td></td>
                                            <td><strong>{{ number_format($CurrentAssetsTotalBalance, session('branch')->currency_decimal) }}</strong>
                                            </td>
                                        </tr>
                                        @php
                                            $ProfitAndLossAccountTotalForAssetsSide = 0;
                                        @endphp
                                        @if ($DebitBalance)
                                            <tr>
                                                <td>Opening Balance</td>
                                                <td class="text-danger">
                                                    <strong>{{ number_format($DebitBalance, session('branch')->currency_decimal) }}</strong>
                                                </td>
                                                <td></td>
                                            </tr>
                                            <tr>
                                                <td>Current Period</td>
                                                <td class="text-danger">
                                                    <strong>{{ number_format($netProfit, session('branch')->currency_decimal) }}</strong>
                                                </td>
                                                <td></td>
                                            </tr>
                                            @php
                                                $ProfitAndLossAccountTotalForAssetsSide =
                                                    $DebitBalance + ($netProfit);
                                            @endphp
                                        @endif

                                        @if ($ProfitAndLossAccountTotalForAssetsSide)
                                            <tr class="td-drak-bg mb-5">
                                                <td colspan="2"><strong>Profit & Loss A/C</strong></td>
                                                <td><strong>{{ number_format($ProfitAndLossAccountTotalForAssetsSide, session('branch')->currency_decimal) }}</strong>
                                                </td>
                                            </tr>
                                        @endif
                                    </tbody>
                                </table>
                            </div>
                        </div>
                        <div class="col-md-12">
                            <div class="table-responsive mb-0" data-pattern="priority-columns">
                                <table id="" class="table table-bordered nowrap"
                                    style="border-collapse: collapse; border-spacing: 0; width: 100%;">
                                    <tbody>
                                        @php
                                            $DebitBalance = 0;
                                            $CreditBalance = 0;

                                            $bSLibilitiesTotal =
                                                $CapitalAccountBalance +
                                                $loansTotalBalance +
                                                abs($CurrentLiabilitiesTotalBalanceForLibilitiesSide) +
                                                $ProfitAndLossAccountTotalForLibilitiesSide;

                                            $bSAssetsTotal =
                                                $CurrentAssetsTotalBalance +
                                                $FixedAssetsBalance +
                                                $CurrentLiabilitiesTotalBalanceForAssetsSide +
                                                $ProfitAndLossAccountTotalForAssetsSide;

                                        @endphp

                                        <?php
                                        // Calculate the balance differences
                                        if ($bSLibilitiesTotal > $bSAssetsTotal) {
                                            $CreditBalance = $bSLibilitiesTotal - $bSAssetsTotal;
                                        } elseif ($bSAssetsTotal > $bSLibilitiesTotal) {
                                            $DebitBalance = $bSAssetsTotal - $bSLibilitiesTotal;
                                        }
                                        ?>

                                        <tr>
                                            <td><strong>Differences</strong></td>
                                            <td style="width: 180px"></td>
                                            <td style="width: 180px"></td>
                                            <td>
                                                {{ number_format($DebitBalance, session('branch')->currency_decimal) }}
                                            </td>
                                            <td><strong>Differences</strong></td>
                                            <td style="width: 180px"></td>
                                            <td style="width: 180px"></td>
                                            <td>
                                                {{ number_format($CreditBalance, session('branch')->currency_decimal) }}
                                            </td>
                                        </tr>

                                        <tr class="td-drak-bg">
                                            <td><strong>Total</strong></td>
                                            <td style="width: 180px"></td>
                                            <td style="width: 180px"></td>
                                            <td>
                                                {{ number_format($bSLibilitiesTotal + $DebitBalance, session('branch')->currency_decimal) }}
                                            </td>
                                            <td><strong>Total</strong></td>
                                            <td style="width: 180px"></td>
                                            <td style="width: 180px"></td>
                                            <td>
                                                {{ number_format($bSAssetsTotal + $CreditBalance, session('branch')->currency_decimal) }}
                                            </td>
                                        </tr>

                                    </tbody>
                                </table>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
    </div>
    <!-- end row -->

    <script>
        document.addEventListener("DOMContentLoaded", function() {
            var detailsViews = document.querySelectorAll(".detailsView");

            detailsViews.forEach(function(detailsView) {
                detailsView.style.display = "none";
            });
        });

        function myFunction() {
            var dropdown = document.getElementById("myDropdown");
            var detailsViews = document.querySelectorAll(".detailsView");

            if (dropdown.value === "hide") {
                detailsViews.forEach(function(detailsView) {
                    detailsView.style.display = "none";
                });
            } else {
                detailsViews.forEach(function(detailsView) {
                    detailsView.style.display = "table-row";
                });
            }
        }
    </script>
@endsection
