@extends('layouts.crusher')
@section('content')





    <div class="row">
        <div class="col-md-12">
            <div class="card">
                <div class="card-body">
                    <div class="row">
                        <div class="col-md-6">
                            <h6 class="card-title mb-4 titlcust">Day Book Report</h6>
                        </div>

                    </div>
                    <!-- <div class="col-4"> -->


                    <div class="row">
                        {{-- <div class="col-md-6">
                        </div> --}}
                        <div class="col-md-6">
                            <h6 class="">Date: <span>{{ date('d/m/Y', strtotime($from_date)) }}
                            </span> To <span>{{ date('d/m/Y', strtotime($to_date)) }}</span>
                            </h6>
                        </div>
                        <div class="col-md-6">
                            <div class="btn-group float-right" role="group" aria-label="Basic example">
                                <a href="" type="button" class="btn btn-outline-primary"><i
                                        class="fas fa-mail-bulk"></i> Email (PDF Formate)</a>
                                <a  class="btn btn-outline-primary" onclick="printPageArea('printableArea')"> Print & PDF
                                    Formate</a>

                            </div>
                        </div>
                    </div>
                    <br>

                    <div id="printableArea" class="table-responsive mb-0" data-pattern="priority-columns">
                        <table  class="table table-bordered dt-responsive nowrap"
                            style="border-collapse: collapse; border-spacing: 0; width: 100%;">
                            <thead>
                                <tr>
                                    <th>Date</th>
                                    <th>Account Name</th>
                                    <th>Voucher Description</th>
                                    <th>Debit</th>
                                    <th>Credit</th>
                                </tr>
                            </thead>

                            <tbody>
                                <?php
                                    $DebitNoteTotal = 0;
                                    $purchasInvoiceTotal = 0;
                                    $ReceiptVoucherExpenseTotal = 0;
                                    $PaymentVoucherExpenseTotal = 0;
                                    $CreditNoteTotal = 0;
                                    $saleInvoiceTotal = 0;
                                    $debitTotal = 0;
                                    $creditTotal = 0;
                                    $JournalVoucherTotal = 0;
                                ?>

                                @foreach ($allDayBookReportData->sortBy('date') as $data)
                                @if (is_object($data))
                                <tr>
                                    <td>
                                        @if ($data instanceof \App\AdminSalesInvoice || $data instanceof \App\CreditNote || $data instanceof \App\AdminPurchaesInvoice ||$data instanceof \App\DebitNote || $data instanceof \App\AdminReceiptVoucher || $data instanceof \App\AdminPaymentVoucher || $data instanceof \App\AdminJournalVoucher)
                                            {{ $data->date }}
                                        @endif
                                    </td>
                                    <td>
                                        @if ($data instanceof \App\AdminSalesInvoice || $data instanceof \App\CreditNote || $data instanceof \App\AdminPurchaesInvoice || $data instanceof \App\DebitNote || $data instanceof \App\AdminReceiptVoucher || $data instanceof \App\AdminPaymentVoucher || $data instanceof \App\AdminJournalVoucher)
                                            {{
                                                $data->customer->name_of_organisation ??
                                                $data->supplier->name_of_organisation ??
                                                $data->staffAndSalesman->first_name ??
                                                $data->account_name ??
                                                $data->adminOtherAccount->account_name ??
                                                ''
                                            }}
                                        @endif
                                    </td>
                                    <td>
                                        @if ($data instanceof \App\AdminSalesInvoice)
                                            <span><strong><a href="{{ route('software.admin_sales_invoice.show', ['admin_sales_invoice' => $data->id]) }}">Sales#
                                                {{ $data->invoice_no }}</a></strong></span>
                                        @elseif ($data instanceof \App\CreditNote)
                                            <span><strong><a href="{{ route('software.credit_notes.show', ['credit_note' => $data->id]) }}">Credit Note#
                                                {{ $data->invoice_no }}</a></strong></span>
                                        @elseif ($data instanceof \App\AdminPurchaesInvoice)
                                        <span><strong><a href="{{ route('software.purchase_invoices.show', ['purchase_invoice' => $data->id]) }}">Purchase#
                                            {{ $data->invoice_no }}</a></strong></span>
                                        @elseif ($data instanceof \App\DebitNote)
                                        <span><strong><a href="{{ route('software.debit_notes.show', ['debit_note' => $data->id]) }}">Debit Note#
                                            {{ $data->invoice_no }}</a></strong></span>
                                        @elseif ($data instanceof \App\AdminReceiptVoucher)
                                        <span><strong><a href="{{ route('software.receipt_vouchers.show', ['receipt_voucher' => $data->id]) }}">Receipt#
                                            {{ $data->invoice_no }}</a></strong></span>
                                        @elseif ($data instanceof \App\AdminPaymentVoucher)
                                            <span><strong><a href="{{ route('software.payment_vouchers.show', ['payment_voucher' => $data->id]) }}">Payment#
                                                {{ $data->invoice_no }}</a></strong></span>
                                        @elseif ($data instanceof \App\AdminJournalVoucher)
                                            <span><strong><a href="{{ route('software.journal_vouchers.show', ['journal_voucher' => $data->id]) }}">Journal#
                                                {{ $data->invoice_no }}</a></strong></span>
                                        @endif
                                    </td>
                                    <td>

                                        @if ($data instanceof \App\DebitNote)
                                            {{ number_format($data->total_net_amount, session('branch')->currency_decimal) }}
                                            @php
                                                $DebitNoteTotal += $data->total_net_amount;
                                            @endphp
                                        @elseif ($data instanceof \App\AdminPaymentVoucher)
                                        @if(isset($data->mergedExpenses))
                                                @foreach($data->mergedExpenses as $expense)
                                                    {{ number_format($expense['total_amount'], session('branch')->currency_decimal) }}
                                                    @php
                                                        $PaymentVoucherExpenseTotal += $expense['total_amount'];
                                                    @endphp
                                                @endforeach
                                            @endif
                                        @elseif ($data instanceof \App\AdminSalesInvoice)
                                        {{ number_format($data->total_net_amount, session('branch')->currency_decimal) }}
                                        @php
                                            $saleInvoiceTotal += $data->total_net_amount;
                                        @endphp
                                        @elseif ($data instanceof \App\AdminJournalVoucher)
                                        {{ number_format($data->amount, session('branch')->currency_decimal) }}
                                        @php
                                            $JournalVoucherTotal += $data->amount;
                                        @endphp
                                        @endif
                                    </td>
                                    <td>
                                        @if ($data instanceof \App\AdminReceiptVoucher)
                                        @if(isset($data->mergedExpenses))
                                        @foreach($data->mergedExpenses as $expense)
                                            {{ number_format($expense['total_amount'], session('branch')->currency_decimal) }}
                                            @php
                                                $ReceiptVoucherExpenseTotal += $expense['total_amount'];
                                            @endphp
                                        @endforeach
                                        @endif
                                        @elseif ($data instanceof \App\AdminPurchaesInvoice)
                                            {{ number_format($data->total_net_amount, session('branch')->currency_decimal) }}
                                            @php
                                                $purchasInvoiceTotal += $data->total_net_amount;
                                            @endphp
                                        @elseif ($data instanceof \App\CreditNote)
                                            {{ number_format($data->total_net_amount, session('branch')->currency_decimal) }}
                                            @php
                                                $CreditNoteTotal += $data->total_net_amount;
                                            @endphp
                                        @endif
                                    </td>
                                </tr>
                                @endif
                                @endforeach

                                @php
                                    $debitTotal = $DebitNoteTotal + $PaymentVoucherExpenseTotal + $JournalVoucherTotal + $saleInvoiceTotal;
                                    $creditTotal = $CreditNoteTotal + $purchasInvoiceTotal + $ReceiptVoucherExpenseTotal;
                                @endphp

                                <tr>
                                    <td colspan="3"><strong>Total</strong></td>
                                    <td><strong>{{ number_format($debitTotal, session('branch')->currency_decimal) }}</strong></td>
                                    <td><strong>{{ number_format($creditTotal, session('branch')->currency_decimal) }}</strong></td>
                                </tr>
                            </tbody>
                        </table>
                    </div>
                </div>
            </div>
        </div>
    </div>
</div>
<!-- end row -->

<script>
    function printPageArea(areaID) {
        var printContent = document.getElementById(areaID).innerHTML;
        var originalContent = document.body.innerHTML;
        document.body.innerHTML = printContent;
        window.print();
        document.body.innerHTML = originalContent;
    }
</script>
@endsection
