@extends('layouts.crusher')
@section('content')
    <div class="row">
        <div class="col-md-12">
            <div class="card">
                <div class="card-body">
                    <div class="row">
                        <div class="col-md-6">
                            <h6 class="card-title mb-4 titlcust">Purchase Report</h6>
                        </div>

                    </div>
                    <!-- <div class="col-4"> -->
                    <form action="#" class="outer-repeater">


                        <div class="row">

                            <div class="col-md-6">
                                <div class="form-group">
                                    <label>From Date</label>
                                    <input class="form-control PeriodClosingDate" type="date" id="fromDate" pattern="\d{4}-\d{2}-\d{2}">
                                </div>
                            </div>

                            <div class="col-md-6">
                                <div class="form-group">
                                    <label>To Date</label>
                                    <input class="form-control PeriodClosingDate" type="date" id="toDate" pattern="\d{4}-\d{2}-\d{2}">
                                </div>
                            </div>

                        </div>



                        <button class="btn btn-cust1" type="submit" id="filterDataBtn"><i class="fas fa-check"></i>
                            Display</button>



                    </form>

                    <br><br><br>

                    <div class="row">
                        <div class="col-md-6">
                        </div>
                        <div class="col-md-6">
                            <div class="btn-group float-right" role="group" aria-label="Basic example">
                                <a href="" type="button" class="btn btn-outline-primary"><i
                                        class="fas fa-mail-bulk"></i> Email (PDF Formate)</a>
                                <a href="" type="button" class="btn btn-outline-primary"> Print & PDF
                                    Formate</a>

                            </div>
                            <!-- <a href="client-add-expenses.html">
                                            <button class="btn btn-cust2 float-right" type="submit">
                                                <i class="fas fa-mail-bulk"></i>Email (PDF Formate)
                                                </button>
                                        </a>
                                        <a href=""><button type="button" class="btn btn-cust2 float-right waves-effect waves-light">
                                             <i class="fas fa-print">Print </i> & <i class="fas fa-file-pdf">PDF Formate</i>
                                        </button></a> -->
                        </div>
                    </div>
                    <br>

                    <div class="table-responsive mb-0" data-pattern="priority-columns">
                        <table class="table table-bordered dt-responsive nowrap"
                            style="border-collapse: collapse; border-spacing: 0; width: 100%;">
                            <thead>
                                <tr>
                                    <th>Date</th>
                                    <th>Particulars</th>
                                    <th>Voucher Description</th>
                                    <th>Debit</th>
                                    <th>Credit</th>
                                </tr>
                            </thead>

                            {{-- <tbody>
                                    <tr>
                                        <td colspan="3">Total Credit</td>
                                        <td></td>
                                        <td>0.000</td>
                                    </tr>
                                    <tr>
                                        <td colspan="3">Total Credit</td>
                                        <td>0.000</td>
                                        <td></td>
                                    </tr>
                                    <tr>
                                        <td colspan="3">Total</td>
                                        <td>0.000</td>
                                        <td></td>
                                    </tr>
                                </tbody> --}}
                            <tbody id="dataBody" style="display: none;">
                                @php
                                    $totalDebits = 0;
                                    $totalCredits = 0;
                                @endphp

                                @foreach ($mergedData as $data)
                                    <tr data-date="{{ \Carbon\Carbon::parse($data->date)->format('Y-m-d') }}">
                                        <td>{{ \Carbon\Carbon::parse($data->date)->format('d/m/Y') }}</td>
                                        <td>
                                            <span>
                                                {{
                                                    optional($data->account)->name_of_organisation ??
                                                    optional($data->account)->account_name ??
                                                    optional($data->account)->first_name . ' ' . optional($data->account)->last_name ??
                                                    ''
                                                }}
                                            </span>
                                        </td>
                                        <td>
                                            @if ($data instanceof \App\AdminPurchaesInvoice)
                                                <span><strong><a href="{{ route('software.purchase_invoices.show', ['purchase_invoice' => $data->id]) }}">Puchase#
                                                    {{ $data->invoice_no }}</a></strong></span>
                                            @elseif ($data instanceof \App\DebitNote)
                                                <span><strong> <a href="{{ route('software.credit_notes.show', ['credit_note' => $data->id]) }}">Debit#
                                                    {{ $data->invoice_no }}</a></strong></span>
                                            @else
                                            @endif
                                        </td>
                                        <td>
                                            @if ($data instanceof \App\AdminPurchaesInvoice)
                                                {{ number_format($data->total_gross_amount, session('branch')->currency_decimal) }}
                                                @php
                                                    $totalDebits += $data->total_gross_amount;
                                                @endphp
                                            @else
                                            @endif
                                        </td>
                                        <td>
                                            @if ($data instanceof \App\DebitNote)
                                                {{ number_format($data->total_gross_amount, session('branch')->currency_decimal) }}
                                                @php
                                                    $totalCredits += $data->total_gross_amount;
                                                @endphp
                                            @else
                                            @endif
                                        </td>
                                    </tr>
                                @endforeach
                                {{-- <tr>
                                    <td colspan="3">Total Credit</td>
                                    <td></td>
                                    <td>{{ $totalCredits }}</td>
                                </tr>
                                <tr>
                                    <td colspan="3">Total Debit</td>
                                    <td>{{ $totalDebits }}</td>
                                    <td></td>
                                </tr>
                                <tr>
                                    <td colspan="4">Total</td>
                                    <td>{{ $totalDebits * $totalCredits }}</td>
                                </tr> --}}


                                <tr id="totalsRow" class="totalsRow">
                                    <td colspan="3">Total</td>
                                    <td id="totalDebit"></td>
                                    <td id="totalCredit"></td>
                                </tr>
                                <tr id="totalsRow" class="totalsRow td-drak-bg" >
                                    <td colspan="3"><strong>Grand Total</strong></td>
                                    <td ><strong id="grandTotalDebit"></strong></td>
                                    <td ><strong id="grandTotalCredit"></strong></td>
                                </tr>

                            </tbody>
                        </table>

                    </div>
                </div>
            </div>
        </div>
    </div>

    </div>
    <!-- end row -->
    <script src="https://code.jquery.com/jquery-3.6.0.min.js"></script>
    <script>
        $(document).ready(function() {
            $('#filterDataBtn').on('click', function(e) {
                e.preventDefault();

                var fromDate = $('#fromDate').val();
                var toDate = $('#toDate').val();

                var rows = $('#dataBody tr');

                rows.sort(function(a, b) {
                    var dateA = $(a).data('date');
                    var dateB = $(b).data('date');
                    return new Date(dateA) - new Date(dateB);
                });

                $('#dataBody').empty().append(rows);

                var totalDebit = 0;
                var totalCredit = 0;

                rows.each(function() {
                    var rowDate = $(this).data('date');

                    if (rowDate >= fromDate && rowDate <= toDate) {
                        $(this).show();

                        var debit = parseFloat($(this).find('td:nth-child(4)').text());
                        var credit = parseFloat($(this).find('td:nth-child(5)').text());

                        if (!isNaN(debit)) {
                            totalDebit += debit;
                        }

                        if (!isNaN(credit)) {
                            totalCredit += credit;
                        }
                    } else {
                        $(this).hide();
                    }
                });

                $('#totalDebit').text(totalDebit.toFixed(3));
                $('#totalCredit').text(totalCredit.toFixed(3));
                // $('#grandTotal').text((totalDebit-totalCredit).toFixed(3));

                // Calculate grand total
                var grandTotalDebit = 0;
                var grandTotalCredit = 0;

                if (totalDebit > totalCredit) {
                    grandTotalDebit = totalDebit - totalCredit;
                    $('#grandTotalDebit').text(grandTotalDebit.toFixed(3));
                } else {
                    grandTotalCredit = totalCredit - totalDebit;
                    $('#grandTotalCredit').text(grandTotalCredit.toFixed(3));
                }

                $('#dataBody').show();
                $('.totalsRow').show();
            });
        });
    </script>
    @php
    use App\Branches;
    use Carbon\Carbon;

    $selectedBranchId = session('selected_branch');

    $branch = Branches::where('id', $selectedBranchId)->first();
@endphp

<script>
    @if (!empty($selectedBranchId))
        document.addEventListener("DOMContentLoaded", function() {
            var periodClosings = <?php echo json_encode($periodClosings); ?>;

            function isBeforePeriodClosing(date) {
                var selectedDate = new Date(date);
                for (var i = 0; i < periodClosings.length; i++) {
                    var closingDate = new Date(periodClosings[i]);
                    if (selectedDate < closingDate) {
                        return true;
                    }
                }
                return false;
            }

            function setColor(dateInput) {
                var selectedDate = dateInput.value;
                if (isBeforePeriodClosing(selectedDate)) {
                    dateInput.style.backgroundColor = 'lightgrey';
                } else {
                    dateInput.style.backgroundColor = '';
                }
            }

            var periodClosingDateInputs = document.querySelectorAll('.PeriodClosingDate');
            periodClosingDateInputs.forEach(function(input) {
                input.addEventListener('change', function() {
                    setColor(this);
                    if (isBeforePeriodClosing(this.value)) {
                        @if (!Branches::hasBranchPermission($selectedBranchId, 'View Report As Per User Credentials'))
                            window.alert("You are trying to enter a closing period. Please contact admin.");
                            this.value = '';
                        @else
                            window.alert("You are trying to enter a closing period.");
                        @endif
                    }
                });
                setColor(input);
            });
        });
    @endif
</script>

@endsection
