@extends('layouts.crusher')
@section('content')
    {{-- MAIN CONTENT --}}


            <div class="row">
                <div class="col-md-12">
                    <div class="card">
                        <div class="card-body">
                            <div class="row">
                                <div class="col-md-6">
                                    <h6 class="card-title mb-4 titlcust">Edit User</h6>
                                </div>

                            </div>
                            <form action="{{ route('software.subadmins.update', ['subadmin'=>$subadmin->id]) }}" class="outer-repeater" method="POST">
                                @csrf
                                @method('put')

                                <div class="row">

                                    <div class="col-md-3">
                                        <div class="form-group">
                                            <label>User Name</label>
                                            <input class="form-control" type="text" placeholder="Enter User Name"
                                                id="example-number-input" name="name"
                                                value="{{ old('name', $subadmin->name) }}">
                                            @if ($errors->has('name'))
                                                <div class="text-danger">{{ $errors->first('name') }}</div>
                                            @endif
                                        </div>
                                    </div>
                                    <div class="col-md-3">
                                        <div class="form-group">
                                            <label>Email</label>
                                            <input class="form-control" type="text" placeholder="Enter Email"
                                                id="example-number-input" name="email"
                                                value="{{ old('email', $subadmin->email) }}">
                                            @if ($errors->has('email'))
                                                <div class="text-danger">{{ $errors->first('email') }}</div>
                                            @endif
                                        </div>
                                    </div>
                                    <div class="col-md-3">
                                        <div class="form-group">
                                            <label>Password</label>
                                            <input class="form-control" type="password" placeholder="Enter Password"
                                                id="example-number-input" name="password" value="{{ old('password') }}">
                                            @if ($errors->has('password'))
                                                <div class="text-danger">{{ $errors->first('password') }}</div>
                                            @endif
                                        </div>
                                    </div>

                                    <div class="col-md-3 custveri">
                                        <div class="custom-control custom-switch mb-2" dir="ltr">
                                            <input type="checkbox" class="custom-control-input" id="customSwitch72"
                                                name="agreed-checkbox"
                                                {{ $subadmin->agreed == 0 ? 'checked' : '' }}
                                                onclick="toggleCheckboxValue(this)">

                                            <input type="hidden" name="agreed" id="agreed-hidden" value="{{ $subadmin->agreed == 0 ? 0 : 1 }}">

                                            <script>
                                                function toggleCheckboxValue(checkbox) {
                                                    var hiddenInput = document.getElementById('agreed-hidden');
                                                    if (checkbox.checked) {
                                                        hiddenInput.value = 0;
                                                    } else {
                                                        hiddenInput.value = 1;
                                                    }
                                                }
                                            </script>

                                            <label class="custom-control-label" for="customSwitch72">Verification
                                                For User</label>
                                            @if ($errors->has('agreed'))
                                                <div class="text-danger">{{ $errors->first('agreed') }}</div>
                                            @endif
                                        </div>
                                    </div>
                                    @foreach ($branches as $branch)
                                        <div class="col-md-12 custveri">
                                            <label>
                                                <input type="checkbox" class="branch-checkbox" value="{{ $branch->id }}"
                                                    onclick="reloadPageWithBranches()">
                                                {{ $branch->company->name }} | {{ $branch->country }} | {{ $branch->name }}
                                            </label>
                                        </div>
                                    @endforeach
                                </div>
                        </div>
                    </div>
                </div>
            </div>
            @if (isset(request()->branch_ids))
            @foreach (request()->branch_ids as $id)
                <div class="row">
                    <div class="col-md-12">
                        <div class="card">
                            <div class="card-body">
                                @php
                                    $permissionTypes = ['Master', 'Report', 'Transactions', 'Others', 'period-closing'];
                                    $branchPermissions = $permissions->where('branch_id', $id)->groupBy('permission.type');
                                @endphp

                                @if ($branchPermissions->isNotEmpty())
                                    <h1 class="text-center mb-3">{{ $branchPermissions->first()->first()->branch->name }}</h1>

                                    <div class="row">
                                        @foreach ($permissionTypes as $type)
                                            <div class="col-md-2">
                                                <div class="custom-control custom-switch mb-2" dir="ltr">
                                                    <input type="checkbox" class="custom-control-input type-checkbox"
                                                        id="{{ $type }}TypeCheckbox{{ $id }}" data-type="{{ $type }}" data-branch="{{ $id }}">
                                                    <label class="custom-control-label titlcust"
                                                        for="{{ $type }}TypeCheckbox{{ $id }}">{{ $type }}
                                                    </label>
                                                </div>

                                                @forelse ($branchPermissions[$type] ?? [] as $permission)
                                                    <div class="custom-control custom-switch mb-2" dir="ltr">
                                                        <input type="checkbox" class="custom-control-input permission-checkbox"
                                                            name="permissions[]" id="customSwitch{{ $permission->id }}"
                                                            value="{{ $permission->id }}" data-branch="{{ $permission->branch_id }}"
                                                            data-type="{{ $type }}"
                                                            @foreach ($subadmin->permissions as $subadminPermission)
                                                                @if ($subadminPermission->branch_permission_id === $permission->id)
                                                                    checked
                                                                    @break
                                                                @endif
                                                            @endforeach>
                                                        <label class="custom-control-label"
                                                            for="customSwitch{{ $permission->id }}">{{ $permission->permission->name }}</label>
                                                    </div>
                                                @empty
                                                @endforelse
                                            </div>
                                        @endforeach
                                    </div>
                                @endif
                            </div>
                        </div>
                    </div>
                </div>
            @endforeach
        @endif

                <button class="btn btn-cust1 float-right" data-toggle="modal" data-target="" type="submit">Update</button>
                </form>
                <!-- end row -->
            </div>
        </div>
        <!-- end row -->

        <!-- end main content-->

        <script src="https://code.jquery.com/jquery-3.5.1.min.js"></script>

        <!-- form repeater js -->
        <script src="assets/libs/jquery.repeater/jquery.repeater.min.js"></script>

        <!-- form repeater init -->
        <script src="assets/js/pages/form-repeater.init.js"></script>

        <script src="assets/js/app.js"></script>
        <script>
            $(".selectall").click(function() {
                $(".apc").prop("checked", $(this).prop("checked"));
            });

            $(".selectallmaster").click(function() {
                $(".master").prop("checked", $(this).prop("checked"));
            });

            $(".selectallreport").click(function() {
                $(".report").prop("checked", $(this).prop("checked"));
            });

            $(".selectalltransaction").click(function() {
                $(".transactions").prop("checked", $(this).prop("checked"));
            });

            $(".selectallother").click(function() {
                $(".other").prop("checked", $(this).prop("checked"));
            });
            $(".selectallother").click(function() {
                if (checkBox.checked == true) {
                    price.style.display = "none";
                } else {
                    price.style.display = "block";
                }
            });

            function myFunction() {
                var checkBox = document.getElementById("myCheck");
                var pricehidden1 = document.getElementById("pricehidden1");
                var pricehidden2 = document.getElementById("pricehidden2");
                var pricehidden3 = document.getElementById("pricehidden3");

                if (checkBox.checked == true) {
                    pricehidden1.style.display = "none";
                    pricehidden2.style.display = "none";
                    pricehidden3.style.display = "none";
                } else {
                    pricehidden1.style.display = "block";
                    pricehidden2.style.display = "block";
                    pricehidden3.style.display = "block";
                }
            }

            // BRANCH CHECKBOX
            // document.addEventListener('DOMContentLoaded', function() {
            //     const params = new URLSearchParams(window.location.search);
            //     const branchIds = params.getAll('branch_ids[]');

            //     branchIds.forEach(function(branchId) {
            //         const checkbox = document.querySelector(`.branch-checkbox[value="${branchId}"]`);
            //         if (checkbox) {
            //             checkbox.checked = true;
            //         }
            //     });
            // });

            // function reloadPageWithBranches() {
            //     const selectedBranches = [];

            //     document.querySelectorAll('.branch-checkbox:checked').forEach(function(checkbox) {
            //         selectedBranches.push(checkbox.value);
            //     });

            //     const queryParams = selectedBranches.length > 0 ? `branch_ids[]=${selectedBranches.join('&branch_ids[]=')}` :
            //         '';
            //     const newUrl = window.location.pathname + '?' + queryParams;

            //     window.location.href = newUrl;
            // }

            document.addEventListener('DOMContentLoaded', function() {
            const params = new URLSearchParams(window.location.search);
            const branchIds = params.getAll('branch_ids[]');

            branchIds.forEach(function(branchId) {
                const checkbox = document.querySelector(`.branch-checkbox[value="${branchId}"]`);
                if (checkbox) {
                    checkbox.checked = true;
                }
            });

            const typeCheckboxes = document.querySelectorAll('.type-checkbox');
            typeCheckboxes.forEach(checkbox => {
                checkbox.addEventListener('change', function() {
                    const type = this.getAttribute('data-type');
                    const branchId = this.getAttribute('data-branch');
                    const permissionCheckboxes = document.querySelectorAll(
                        `.permission-checkbox[data-type="${type}"][data-branch="${branchId}"]`);

                    const isChecked = this.checked;
                    permissionCheckboxes.forEach(permissionCheckbox => {
                        permissionCheckbox.checked = isChecked;
                    });
                });
            });
            });

            function reloadPageWithBranches() {
            const selectedBranches = [];

            document.querySelectorAll('.branch-checkbox:checked').forEach(function(checkbox) {
                selectedBranches.push(checkbox.value);
            });

            const queryParams = selectedBranches.length > 0 ? `branch_ids[]=${selectedBranches.join('&branch_ids[]=')}` : '';
            const newUrl = window.location.pathname + '?' + queryParams;

            window.location.href = newUrl;
            }

            // permission select all
            document.addEventListener('DOMContentLoaded', function() {
                const typeCheckboxes = document.querySelectorAll('.type-checkbox');
                typeCheckboxes.forEach(checkbox => {
                    checkbox.addEventListener('change', function() {
                        const type = this.getAttribute('data-type');
                        const branchId = this.getAttribute('data-branch');
                        const permissionCheckboxes = document.querySelectorAll(
                            `.permission-checkbox[data-type="${type}"][data-branch="${branchId}"]`);

                        const isChecked = this.checked;
                        permissionCheckboxes.forEach(permissionCheckbox => {
                            permissionCheckbox.checked = isChecked;
                        });
                    });
                });
            });
        </script>
    @endsection
