@extends('layouts.superadmin')
@section('content')
    <div class="page-content">

        <!-- start page title -->
        <div class="row">
            <div class="col-12">
                <div class="page-title-box d-flex align-items-center justify-content-between">
                    <h4 class="page-title mb-0 font-size-18">Dashboard</h4>

                    <div class="page-title-right">
                        <ol class="breadcrumb m-0">
                            <h4 class="page-title mb-0 font-size-18">Powered By Ledgematic</h4>
                        </ol>
                    </div>

                </div>
            </div>
        </div>
        <!-- end page title -->

        <!-- end row -->

        <div class="row">
            <div class="col-xl-12">
                <div class="card">
                    <div class="card-body">
                        <div class="row">
                            <div class="col-6">
                                <h6 class="card-title mb-4 titlcust">Branch Masters</h6>
                            </div>
                            <div class="col-6">
                                <a href="{{ url('branch/add') }}">
                                    <button class="btn btn-primary float-right" type="submit">Add New Branch</button>
                                </a>
                            </div>
                        </div>
                        <div class="card-body">
                            <div class="table-responsive mb-0" data-pattern="priority-columns">
                                <table id="datatable" class="table table-bordered nowrap table-striped"
                                    style="border-collapse: collapse; border-spacing: 0; width: 100%;">
                                    <thead>
                                        <tr>
                                            <th>Client Name</th>
                                            <th>Company Name</th>
                                            <th>Branch Name</th>
                                            <th>Software</th>
                                            <th>Country</th>
                                            <th>Issue Date</th>
                                            <th>Expiry Date</th>
                                            <th>Action </th>
                                        </tr>
                                    </thead>

                                    <tbody>
                                        @foreach ($branches as $branch)
                                            @php
                                                $company = App\Company::where('id', $branch->company_id)->first();
                                                $client = App\User::where('id', $company->user_id)->first();
                                            @endphp
                                            <tr>
                                                <td>{{ $client->name ?? '' }}</td>
                                                <td>{{ $company->name }}</td>
                                                <td>{{ $branch->name }}</td>
                                                <td>{{ $branch->software }}</td>
                                                <td>{{ $branch->country }}</td>
                                                <td>{{ \Carbon\Carbon::parse($branch->issue_date)->format('d/m/Y') }}</td>
                                                <td>{{ \Carbon\Carbon::parse($branch->expiry_date)->format('d/m/Y') }}</td>


                                                <td>
                                                    <a
                                                        href="{{ route('superadmin.branches.view', ['branch' => $branch->id]) }}"><i
                                                            class="fas fa-eye custi"></i></a>
                                                    <a
                                                        href="{{ route('superadmin.branches.edit', ['branch' => $branch->id]) }}"><i
                                                            class="fas fa-pencil-alt custi"></i></a>
                                                    @if ($branch->status == 0)
                                                        <form
                                                            action="{{ route('superadmin.branches.block_unblock', ['branch' => $branch->id]) }}"
                                                            method="POST">
                                                            @csrf
                                                            @method('put')
                                                            <button title="Unblock"><i class="fas fa-lock"></i></button>
                                                        </form>
                                                    @else
                                                        <form
                                                            action="{{ route('superadmin.branches.block_unblock', ['branch' => $branch->id]) }}"
                                                            method="POST">
                                                            @csrf
                                                            @method('put')
                                                            <button title="Block"><i class="fas fa-unlock"></i></button>
                                                        </form>
                                                    @endif
                                                </td>
                                            </tr>
                                        @endforeach
                                    </tbody>
                                </table>
                            </div>
                        </div>
                        <!-- end col -->

                        <!-- /.modal1 -->
                        <div class="col-sm-6 col-md-4 col-xl-3">
                            <!-- <div class="my-4 text-center">
                                                    <p class="text-muted">Large modal</p>

                                                    <button type="button" class="btn btn-primary waves-effect waves-light" data-toggle="modal" data-target=".bs-example-modal-lg">Large modal</button>
                                                </div> -->

                            <!--  Modal content for the above example -->
                            <div class="modal fade bs-example-modal-lg" tabindex="-1" role="dialog"
                                aria-labelledby="myLargeModalLabel" aria-hidden="true">
                                <div class="modal-dialog modal-lg">
                                    <div class="modal-content">
                                        <div class="modal-header">
                                            <h5 class="modal-title mt-0" id="myLargeModalLabel">Are you sure
                                                to want to Delete
                                            </h5>
                                            <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                                                <span aria-hidden="true">&times;</span>
                                            </button>
                                        </div>
                                        <div class="modal-body">
                                            <div class="row">
                                                <div class="col-4">
                                                    <h5>Company Name :</h5>
                                                    <h5>Admin :</h5>
                                                    <h5>Expiry :</h5>
                                                    <h5>Status :</h5>
                                                </div>
                                                <div class="col-8">
                                                    <h5>lorem ipsum</h5>
                                                    <h5>lorem ipsum doller</h5>
                                                    <h5>lorem ipsum</h5>
                                                    <h5>lorem ipsum</h5>
                                                </div>
                                            </div>
                                        </div>
                                        <div class="modal-footer">
                                            <button type="button" class="btn btn-primary">Delete</button>
                                            <button type="button" class="btn btn-secondary"
                                                data-dismiss="modal">Close</button>
                                        </div>
                                    </div>
                                    <!-- /.modal-content -->
                                </div>
                                <!-- /.modal-dialog -->
                            </div>
                            <!-- /.modal -->
                        </div>

                    </div>
                    <!-- /.modal-content -->
                </div>
                <!-- /.modal-dialog -->
            </div>
            <!-- /.modal -->
        </div>

        <!-- end row -->

        <!-- end row -->

        <!-- end row -->
    </div>
@endsection
