<?php $__env->startSection('content'); ?>
<?php
    use App\Branches;
    use Carbon\Carbon;

    $selectedBranchId = session('selected_branch');

    $branche = Branches::where('id', $selectedBranchId)->first();

?>
    <div class="row">
        <div class="col-md-12">
            <div class="card">
                <div class="card-body">
                    <div class="row">
                        <div class="col-md-6">
                            <h6 class="card-title mb-4 titlcust">Sales Invoice</h6>
                        </div>
                        <div class="col-md-6">
                            <a href="<?php echo e(route('software.admin_sales_invoice.create')); ?> ">
                                <button class="btn btn-cust1 float-right" type="submit">Create Sales Invoice
                                </button>
                            </a>
                        </div>
                    </div>
                    <div class="table-responsive mb-0" data-pattern="priority-columns">
                        <table id="datatable" class="table table-bordered dt-responsive nowrap"
                            style="border-collapse: collapse; border-spacing: 0; width: 100%;">
                            <thead>
                                <tr>
                                    <th>Date</th>
                                    <th>Sale Voucher Number</th>
                                    <th>Amount</th>
                                    <th>Action</th>
                                </tr>
                            </thead>

                            <tbody>
                                <?php $__empty_1 = true; $__currentLoopData = $salesInvoice; $__env->addLoop($__currentLoopData); foreach($__currentLoopData as $si): $__env->incrementLoopIndices(); $loop = $__env->getLastLoop(); $__empty_1 = false; ?>
                                    
                                    <tr>
                                        <td><?php echo e($si->date); ?></td>
                                        <td><?php echo e($si->invoice_no); ?></td>
                                        
                                        <?php if(!$si->trashed()): ?>
                                        <td><?php echo e(number_format($si->total_gross_amount, session('branch')->currency_decimal)); ?></td>
                                        <?php else: ?>
                                            <td>-</td>
                                        <?php endif; ?>
                                        
                                        <td>
                                            <?php if(
                                                !empty(($branchId = session()->get('selected_branch'))) &&
                                                    Branches::hasBranchPermission($branchId, 'view-print-sales-invoice')): ?>
                                                <a
                                                    href="<?php echo e(route('software.admin_sales_invoice.show', ['admin_sales_invoice' => $si->id])); ?>">
                                                    <i class="far fa-eye cust-icon2"></i></a>
                                            <?php endif; ?>
                                            <?php if(!$si->trashed()): ?>
                                                <?php if(
                                                    !empty(($branchId = session()->get('selected_branch'))) &&
                                                        Branches::hasBranchPermission($branchId, 'edit-sales-invoice')): ?>
                                                    <a
                                                        href="<?php echo e(route('software.admin_sales_invoice.edit', ['admin_sales_invoice' => $si->id])); ?>">
                                                        <i class="far fa-edit cust-icon2"></i></a>
                                                <?php endif; ?>
                                                <?php if(
                                                    !empty(($branchId = session()->get('selected_branch'))) &&
                                                        Branches::hasBranchPermission($branchId, 'cancel-sales-invoice')): ?>
                                                <form
                                                    action="<?php echo e(route('software.sales.invoice.delete', ['sale_invoice' => $si->id])); ?>"
                                                    method="POST" class="d-inline">
                                                    <?php echo csrf_field(); ?>
                                                    <?php echo method_field('DELETE'); ?>
                                                    <button onclick="return confirm('Sure want to delete?')" type="submit"
                                                        class="btn btn-link p-0 m-0 text-danger">
                                                        <i class="far fa-window-close cust-icon2"></i>
                                                    </button>
                                                </form>
                                                <?php endif; ?>

                                                <a href="<?php echo e(route('software.credit_notes.create', ['si' => $si->invoice_no])); ?>"
                                                    class="cust-btn3">
                                                    <button type="button" class="btn btn-outline-primary">Create Credit
                                                        Note</button>
                                                </a>
                                            <?php else: ?>
                                                <span class="text-danger">Deleted</span>
                                            <?php endif; ?>
                                        </td>
                                    </tr>
                                <?php endforeach; $__env->popLoop(); $loop = $__env->getLastLoop(); if ($__empty_1): ?>
                                <?php endif; ?>
                            </tbody>
                        </table>
                    </div>

                </div>
            </div>
        </div>
    </div>
    </div>
    <!-- end row -->
<?php $__env->stopSection(); ?>

<?php echo $__env->make('layouts.crusher', \Illuminate\Support\Arr::except(get_defined_vars(), ['__data', '__path']))->render(); ?><?php /**PATH F:\zampp 2 7.4\htdocs\ledgematic\ledgematic\ledgematic\resources\views/crusher/trans_sale_invoice/index.blade.php ENDPATH**/ ?>