<?php $__env->startSection('content'); ?>
<?php
    use App\Branches;
    use Carbon\Carbon;

    $selectedBranchId = session('selected_branch');

    $branche = Branches::where('id', $selectedBranchId)->first();

?>
    <div class="row">
        <div class="col-md-12">
            <div class="card">
                <div class="card-body">
                    <div class="row">
                        <div class="col-md-6">
                            <h6 class="card-title mb-4 titlcust">Delivery Note</h6>
                        </div>
                        <div class="col-md-6">
                            <a href="<?php echo e(route('software.delivery_notes.create')); ?> ">
                                <button class="btn btn-cust1 float-right" type="submit">Create Delivery Note
                                </button>
                            </a>
                        </div>
                    </div>
                    <div class="table-responsive mb-0" data-pattern="priority-columns">
                        <table id="datatable" class="table table-bordered dt-responsive nowrap"
                            style="border-collapse: collapse; border-spacing: 0; width: 100%;">
                            <thead>
                                <tr>
                                    <th>Date</th>
                                    <th>Delivery Note Number</th>
                                    <th>Quotation Number</th>
                                    <th>Account Name</th>
                                    <th>Action</th>
                                </tr>
                            </thead>
                            <tbody>
                                <?php $__empty_1 = true; $__currentLoopData = $deliveryNotes; $__env->addLoop($__currentLoopData); foreach($__currentLoopData as $deliveryNote): $__env->incrementLoopIndices(); $loop = $__env->getLastLoop(); $__empty_1 = false; ?>
                                    
                                    <tr>
                                        <td><?php echo e($deliveryNote->date); ?></td>
                                        <td><?php echo e($deliveryNote->do_no); ?></td>
                                        <td><?php echo e($deliveryNote->quotation_no); ?></td>
                                        <td>
                                            <?php if($deliveryNote->account_type == 'App\Customer' || $deliveryNote->account_type == 'App\Supplier'): ?>
                                                <?php echo e($deliveryNote->account_type::find($deliveryNote->account_id)->name_of_organisation); ?>

                                            <?php elseif($deliveryNote->account_type == 'App\StaffAndSalesman'): ?>
                                                <?php echo e($deliveryNote->account_type::find($deliveryNote->account_id)->first_name . ' ' . $deliveryNote->account_type::find($deliveryNote->account_id)->last_name); ?>

                                            <?php else: ?>
                                                <?php echo e($deliveryNote->account_type::find($deliveryNote->account_id)->account_name); ?>

                                            <?php endif; ?>
                                        </td>
                                        <td>
                                            <?php if(
                                                !empty(($branchId = session()->get('selected_branch'))) &&
                                                    Branches::hasBranchPermission($branchId, 'view-print-approval-voucher-delivery-notes')): ?>
                                                <a
                                                    href="<?php echo e(route('software.delivery_notes.show', ['delivery_note' => $deliveryNote->id])); ?>">
                                                    <i class="far fa-eye cust-icon2"></i></a>
                                            <?php endif; ?>

                                            <?php if(!$deliveryNote->trashed()): ?>
                                                <?php if(
                                                    !empty(($branchId = session()->get('selected_branch'))) &&
                                                        Branches::hasBranchPermission($branchId, 'edit-approval-voucher-delivery-notes')): ?>
                                                    <a
                                                        href="<?php echo e(route('software.delivery_notes.edit', ['delivery_note' => $deliveryNote->id])); ?>">
                                                        <i class="far fa-edit cust-icon2"></i></a>
                                                <?php endif; ?>

                                                <?php if(
                                                    !empty(($branchId = session()->get('selected_branch'))) &&
                                                        Branches::hasBranchPermission($branchId, 'cancel-approval-voucher-delivery-notes')): ?>
                                                    <form
                                                        action="<?php echo e(route('software.delivery_note.delete', ['delivery_note' => $deliveryNote->id])); ?>"
                                                        method="POST" class="d-inline">
                                                        <?php echo csrf_field(); ?>
                                                        <?php echo method_field('DELETE'); ?>
                                                        <button onclick="return confirm('Sure want to delete?')" type="submit"
                                                            class="btn btn-link p-0 m-0 text-danger">
                                                            <i class="far fa-window-close cust-icon2"></i>
                                                        </button>
                                                    </form>
                                                <?php endif; ?>

                                                <a href="<?php echo e(route('software.admin_sales_invoice.create', ['do_no' => $deliveryNote->do_no])); ?>"
                                                    class="cust-btn3">
                                                    <button type="button" class="btn btn-outline-primary">Create
                                                        Sale Invoice</button>
                                                </a>
                                            <?php else: ?>
                                                <span class="text-danger">Deleted</span>
                                            <?php endif; ?>
                                        </td>
                                    </tr>
                                <?php endforeach; $__env->popLoop(); $loop = $__env->getLastLoop(); if ($__empty_1): ?>
                                <?php endif; ?>
                            </tbody>
                        </table>
                    </div>

                </div>
            </div>
        </div>
    </div>
    </div>
    <!-- end row -->
<?php $__env->stopSection(); ?>

<?php echo $__env->make('layouts.crusher', \Illuminate\Support\Arr::except(get_defined_vars(), ['__data', '__path']))->render(); ?><?php /**PATH F:\zampp 2 7.4\htdocs\ledgematic\ledgematic\ledgematic\resources\views/crusher/trans_delivery_note/index.blade.php ENDPATH**/ ?>