@extends('layouts.crusher')
@section('content')


        <div class="row">
            <div class="col-md-12">
                <div class="card">
                    <div class="card-body">
                        <div class="row">
                            <div class="col-md-6">
                                <h6 class="card-title mb-4 titlcust">Customer Master</h6>
                            </div>
                            <div class="col-md-6">
                                <a href="{{ url('software/master/customer_master/create') }}">
                                    <button class="btn btn-cust1 float-right" type="submit">Add
                                        Customer</button>
                                </a>
                            </div>
                        </div>
                        <!-- <div class="col-4"> -->


                        <div class="table-responsive mb-0" data-pattern="priority-columns">
                            <table id="datatable" class="table table-bordered nowrap"
                                style="border-collapse: collapse; border-spacing: 0; width: 100%;">
                                <thead>
                                    <tr>
                                        <th>Account Name</th>
                                        <th>Contact Person Name</th>
                                        <th>Mobile Number</th>
                                        <th>Email</th>
                                        <th>Action</th>
                                    </tr>
                                </thead>

                                <tbody>
                                    @forelse ($customers as $customer)
                                        <tr>
                                            {{-- <td>{{ $customer->name_of_organisation }}</td> --}}
                                            <td>{{ str_replace('-', ' ', $customer->name_of_organisation) }}</td>
                                            <td>{{ $customer->contact_person_name }}</td>
                                            <td>{{ $customer->mobile }}</td>
                                            <td>{{ $customer->email }}</td>
                                            <td>
                                                <a
                                                    href="{{ route('software.customers.show', ['customer' => $customer->id]) }}">
                                                    <i class="far fa-eye cust-icon2"></i></a>
                                                <a
                                                    href="{{ route('software.customers.edit', ['customer' => $customer->id]) }}">
                                                    <i class="far fa-edit cust-icon2"></i></a>
                                                <form
                                                    action="{{ route('software.customers.delete', ['customer' => $customer->id]) }}"
                                                    method="POST" class="d-inline">
                                                    @csrf
                                                    @method('DELETE')
                                                    <button onclick="return confirm('Sure want to delete?')" type="submit" class="btn btn-link p-0 m-0 text-danger">
                                                        <i class="far fa-window-close cust-icon2"></i>
                                                    </button>
                                                </form>
                                            </td>
                                        </tr>
                                    @empty
                                    @endforelse
                                </tbody>
                            </table>
                        </div>


                    </div>
                </div>
            </div>
        </div>
    </div>
    <!-- end row -->
@endsection
