@extends('layouts.crusher')
@section('content')
    @php
        use App\Branches;
        use Carbon\Carbon;

        $selectedBranchId = session('selected_branch');

        $branche = Branches::where('id', $selectedBranchId)->first();

    @endphp
    <div class="row">
        <div class="col-md-12">
            <div class="card">
                <div class="card-body">
                    <div class="row">
                        <div class="col-md-6">
                            <h6 class="card-title mb-4 titlcust">Document Expiry
                            </h6>
                        </div>

                    </div>
                    <div class="table-responsive mb-0" data-pattern="priority-columns">
                        @foreach ($allDocuments as $accountName => $documentsGroup)
                            <h6>Account Name: {{ $accountName }}</h6>

                            @foreach ($documentsGroup as $documents)
                                <table class="table">
                                    <thead>
                                        <tr>
                                            <th>Document</th>
                                            <th>Expiry Date</th>
                                            <th>Action</th>
                                        </tr>
                                    </thead>
                                    <tbody>
                                        @foreach ($documents as $document)
                                            <tr>
                                                <td>{{ $document['doc_name'] }}</td>
                                                <td>{{ $document['doc_expiry'] }}</td>
                                                <td>
                                                    @if ($document['doc_file'])
                                                        <a href="{{ asset('/storage/app/public/' . $document['doc_file']) }}"
                                                            class="btn btn-outline-primary"
                                                            download>Download Document</a>

                                                    @else
                                                        <span>No File Available</span>
                                                    @endif
                                                </td>
                                            </tr>
                                        @endforeach
                                    </tbody>
                                </table>
                            @endforeach
                        @endforeach
                    </div>
                </div>
            </div>
        </div>
    </div>
@endsection
