@extends('layouts.crusher')
@section('content')


        <div class="row">
            <div class="col-md-12">
                <div class="card">
                    <div class="card-body">
                        <div class="row">
                            <div class="col-md-6">
                                <h6 class="card-title mb-4 titlcust">Edit Expense Master</h6>
                            </div>
                        </div>
                        <form method="POST" action="{{ route('software.expense.update', ['expense' => $expense->id]) }}"
                            class="outer-repeater">

                            @csrf
                            @method('put')
                            <div class="row">
                                <input class="form-control" type="hidden" name="account_no"
                                value="{{ $expense->account_no }}">


                                <div class="col-md-3">
                                    <div class="form-group">
                                        <label>Account Opening Balance</label>
                                        @if (auth()->user()->role=='subadmin')
                                            <input class="form-control" type="text" name="opening_balance"
                                            value="{{ $expense->opening_balance }}" placeholder="Account Opening Balance"
                                            id="example-password-input" disabled>
                                        @else
                                            <input class="form-control" type="text" name="opening_balance"
                                            value="{{ $expense->opening_balance }}" placeholder="Account Opening Balance"
                                            id="example-password-input">
                                        @endif
                                    </div>
                                </div>

                                <div class="col-md-3">
                                    <div class="form-group">
                                        <label class="control-label">Debit/Credit</label>
                                        <select class="form-control select2" name="type">
                                            <option value="">Select Debit/Credit</option>
                                            <option value="debit" @if (isset($expense) && $expense->type == 'debit') selected @endif>Debit
                                            </option>
                                            <option value="credit" @if (isset($expense) && $expense->type == 'credit') selected @endif>Credit
                                            </option>
                                        </select>
                                    </div>
                                </div>



                                <div class="col-md-6">
                                    <div class="form-group">
                                        <label>Date</label>
                                        <input class="form-control" name="date" value="{{ $expense->date }}"
                                            type="date" pattern="\d{4}-\d{2}-\d{2}">
                                    </div>
                                </div>

                                <div class="col-md-4">
                                    <div class="form-group">
                                        <label>Account Name</label>
                                        <input class="form-control" type="text" name="account_name"
                                            value="{{ $expense->account_name }}" placeholder="Enter Account Name"
                                            id="example-text-input">
                                            @if ($errors->has('account_name'))
                                            <div class="text-danger">{{ $errors->first('account_name') }}</div>
                                        @endif
                                    </div>
                                </div>

                                <div class="col-md-4">
                                    <div class="form-group">
                                        <label class="control-label">Class Of Account</label>
                                        <select class="form-control select2" name="class_of_account_id">
                                            <option name="">Select Class of Account</option>
                                            @foreach ($ClassOfAccount as $COA)
                                            <option value="{{ $COA->id }}" {{ $expense->class_of_account_id == $COA->id ? 'selected' : '' }}>
                                                {{ $COA->name }}
                                            </option>
                                            @endforeach
                                        </select>
                                        @if ($errors->has('class_of_account_id'))
                                            <div class="text-danger">{{ $errors->first('class_of_account_id') }}</div>
                                        @endif
                                    </div>
                                </div>

                                <div class="col-md-4">
                                    <div class="form-group">
                                        <label class="control-label">Show User</label>
                                        <select class="select2 form-control select2-multiple" name="show_user[]" multiple="multiple" data-placeholder="Select User ...">

                                            @foreach ($subadmins as $user)
                                                <option value="{{$user->id}}"
                                                    @foreach ($account_master_permission as $item)
                                                        @if ($item == $user->id) selected="selected" @endif
                                                    @endforeach
                                                    >{{$user->name}}
                                                </option>
                                            @endforeach
                                        </select>


                                    </div>
                                </div>


                                {{-- <div class="col-md-3">
                                    <div class="form-group">
                                        <label class="control-label">Maintain Account</label>
                                        <select class="form-control select2">
                                            <option>select</option>
                                            <option>lorem</option>
                                            <option>Lorem</option>
                                        </select>
                                    </div>
                                </div> --}}

                                <div class="col-md-12">
                                    <div class="form-group">
                                        <label>Description</label>
                                        <textarea class="form-control" rows="4" type="text" name="description" placeholder="Enter Address"
                                            id="example-textarea-input">{{ $expense->description }}</textarea>
                                    </div>
                                </div>

                            </div>


                            <button class="btn btn-cust1 float-right" type="submit">Edit Expense</button>



                        </form>

                    </div>
                </div>
            </div>
        </div>
    </div>
    <!-- end row -->



    <div class="modal fade bs-example-modal-center1" tabindex="-1" role="dialog" aria-labelledby="mySmallModalLabel"
        aria-hidden="true">
        <div class="modal-dialog modal-dialog-centered">
            <div class="modal-content">
                <div class="modal-body">
                    <div class="col-md-12 text-center">
                        <div class="pt-4 pb-4">
                            <i class="fas fa-check checkp "></i>
                            <h4 class="card-title font-size-18">Successfully Recorded
                            </h4>
                        </div>
                    </div>
                </div>

            </div>
            <!-- /.modal-content -->
        </div>
        <!-- /.modal-dialog -->
    </div>
    <!-- /.modal -->


    <div class="modal fade bs-example-modal-center2" tabindex="-2" role="dialog" aria-labelledby="mySmallModalLabel"
        aria-hidden="true">
        <div class="modal-dialog modal-dialog-centered">
            <div class="modal-content">
                <div class="modal-body">
                    <div class="col-md-12 text-center">
                        <div class="pt-4 pb-4">
                            <i class="fas fa-times crossp "></i>
                            <h4 class="card-title font-size-18">Submission Failed
                            </h4>
                        </div>
                    </div>
                </div>

            </div>
            <!-- /.modal-content -->
        </div>
        <!-- /.modal-dialog -->
    </div>
    <!-- /.modal -->
@endsection
