@extends('layouts.crusher')
@section('content')
        <div class="row">
            <div class="col-md-12">
                <div class="card">
                    <div class="card-body">
                        <div class="row">
                            <div class="col-md-6">
                                <h6 class="card-title mb-4 titlcust">Statement of Accounts

                                </h6>
                            </div>

                        </div>
                        <div class="row">
                            <div class="col-md-6">
                                {{-- <h6 class="">{{ $matchedAccount->name_of_organisation }}</h6> --}}
                                <h6 class="">Date: <span>{{ $from_date }}</span> To <span>{{ $to_date }}</span></h6>
                            </div>
                            <div class="col-md-6">
                                <div class="btn-group float-right" role="group" aria-label="Basic example">
                                    <a href="" type="button" class="btn btn-outline-primary"><i
                                            class="fas fa-mail-bulk"></i> Email (PDF Formate)</a>
                                    <a onclick="printPageArea('printableArea')" class="btn btn-outline-primary"> Print & PDF
                                        Formate</a>

                                </div>
                            </div>
                        </div>
                        <br>
                            <div id="printableArea" class="table-responsive mb-0" data-pattern="priority-columns">
                                <table class="table table-bordered dt-responsive nowrap"
                                    style="border-collapse: collapse; border-spacing: 0; width: 100%;">
                                    <thead>
                                        <tr>
                                            <th>Date</th>
                                            <th>Voucher Description</th>
                                            <th>Amount</th>
                                            <th>Invoice Due Date</th>
                                            <th>Over Due By Days</th>
                                        </tr>
                                    </thead>

                                    <tbody>
                                        @foreach ($allData->sortBy('date') as $data)
                                        @if (is_object($data))
                                        <tr>
                                            <td>
                                                @if ($data instanceof \App\AdminSalesInvoice)
                                                    {{ $data->date }}
                                                @elseif ($data instanceof \App\AdminPurchaesInvoice)
                                                    {{ $data->date }}
                                                @endif
                                            </td>
                                            <td>
                                                @if ($data instanceof \App\AdminSalesInvoice)
                                                    <span><strong><a href="{{ route('software.admin_sales_invoice.show', ['admin_sales_invoice' => $data->id]) }}">Sales#
                                                        {{ $data->invoice_no }}</a></strong></span>
                                                @elseif ($data instanceof \App\AdminPurchaesInvoice)
                                                    <span><strong><a href="{{ route('software.purchase_invoices.show', ['purchase_invoice' => $data->id]) }}">Purchase#
                                                        {{ $data->invoice_no }}</a></strong></span>
                                                @endif
                                            </td>
                                            <td>
                                                @if ($data instanceof \App\AdminSalesInvoice)
                                                    {{ number_format($data->total_net_amount, session('branch')->currency_decimal) }}
                                                @elseif ($data instanceof \App\AdminPurchaesInvoice)
                                                    {{ number_format($data->total_net_amount, session('branch')->currency_decimal) }}
                                                @endif
                                            </td>
                                            <td>
                                                @if ($data instanceof \App\AdminSalesInvoice || $data instanceof \App\AdminPurchaesInvoice)
                                                    {{ $data->lpo_days }}
                                                @endif
                                            </td>
                                            {{-- <td>
                                                @if ($data instanceof \App\AdminSalesInvoice || $data instanceof \App\AdminPurchaesInvoice)
                                                    @php
                                                        $dueDate = \Carbon\Carbon::parse($data->date)->addDays($data->lpo_days);
                                                        $overDueDays = \Carbon\Carbon::now()->diffInDays($dueDate, false);
                                                        $overDueDays = $overDueDays > 0 ? 0 : abs($overDueDays);
                                                    @endphp
                                                    {{ $overDueDays }}
                                                @endif
                                            </td> --}}
                                            <td>
                                                @if ($data instanceof \App\AdminSalesInvoice || $data instanceof \App\AdminPurchaesInvoice)
                                                    @php
                                                        $invoiceDate = \Carbon\Carbon::parse($data->date);
                                                        $dueDate = \Carbon\Carbon::parse($data->lpo_days);

                                                        // Calculate the difference in days
                                                        $overDueDays = $invoiceDate->diffInDays($dueDate, false); // false indicates that it returns negative if overdue

                                                        // Determine status and overdue days
                                                        if ($overDueDays < 0) {
                                                            $status = 'Overdue';
                                                            $overDueDays = abs($overDueDays);
                                                        } else {
                                                            $status = 'On Time';
                                                            $overDueDays = 0; // Not overdue if due date hasn't passed
                                                        }
                                                    @endphp
                                                    {{ $overDueDays }} days - {{ $status }}
                                                @endif
                                            </td>


                                        </tr>
                                        @endif
                                        @endforeach
                                    </tbody>
                                </table>
                            </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
    <script>
        function printPageArea(areaID) {
            var printContent = document.getElementById(areaID).innerHTML;
            var originalContent = document.body.innerHTML;
            document.body.innerHTML = printContent;
            window.print();
            document.body.innerHTML = originalContent;
        }
    </script>
@endsection
