@extends('layouts.crusher')
@section('content')


    <div class="row">
        <div class="col-md-12">
            <div class="card">
                <div class="card-body">
                    <div class="row">
                        <div class="col-md-6">
                            <h6 class="card-title mb-4 titlcust">Debit Note(Purchase Return)</h6>
                        </div>

                    </div>
                    <!-- <div class="col-4"> -->
                    <form action="{{ route('software.debit_notes.store') }}" class="outer-repeater" method="POST">
                        @csrf


                        <div class="row">

                            <div class="col-md-3">
                                <div class="form-group">
                                    <label>Debit Note #</label>
                                    <input class="form-control" readonly placeholder="" id="example-password-input"
                                        value="{{ $newCn }}" name="invoice_no">
                                </div>
                            </div>

                            <div class="col-md-6">

                            </div>

                        </div>

                        <div class="row">

                            <div class="col-md-3">
                                <div class="form-group">
                                    <label>Date</label>
                                    <input name="date" class="form-control PeriodClosingDate" type="date" pattern="\d{4}-\d{2}-\d{2}"
                                        value="{{ date('Y-m-d') }}">
                                </div>
                            </div>

                            <div class="col-md-6">

                            </div>

                        </div>

                        <div class="row">
                            <div class="col-md-3 float-right">
                                <div class="form-group">
                                    <label class="control-label">Select Sale Invoice Number</label>
                                    <select class="form-control select2" name="sales_invoice_no">
                                        <option value="">Select Purchase Invoice Number</option>
                                        @forelse ($adminSales->sortBy('invoice_no') as $sale)
                                            <option value="{{ $sale->invoice_no }}"
                                                @if (request()->has('pi_no') && request()->get('pi_no') == $sale->invoice_no) selected @endif>
                                                {{ $sale->invoice_no }}
                                            </option>
                                        @empty
                                        @endforelse
                                    </select>
                                </div>
                            </div>


                            <div class="col-md-6">

                            </div>

                        </div>

                        <div class="row">

                            <div class="col-md-3 float-right">

                            </div>

                            <div class="col-md-6">

                            </div>

                        </div>


                        <div class="row">
                            <div class="col-md-12">
                                <div class="form-group">
                                    <label for="account">Account Name:</label>
                                    <select id="account" class="form-control select2" onchange="openRow(this)" name="account_id"
                                    >
                                        <option value="" selected disabled>Select Account</option>

                                        {{-- Loop through the merged $accounts collection --}}
                                        @forelse ($accounts as $account)
                                            <option value="{{ $account->id }}"
                                                {{ old('account_id') == $account->id || ($debits && $debits->count() > 0 && $debits[0]->account_id == $account->id) ? 'selected' : '' }}
                                                data-account-type="{{ $account->table_name }}" data-account-name="{{ $account->account_name }}" data-acc-no="{{ $account->account_no }}" data-class-of-account="{{ $account->class_of_account }}">
                                                {{ $account->account_name }}

                                            </option>
                                        @empty
                                            <option value="" selected disabled>No accounts available</option>
                                        @endforelse
                                    </select>
                                    <span id="buyer_exists" style="color: red; display:none;">Buyer against this invoice no
                                        is already exists can not create more</span>
                                    <input type="hidden" name="account_type" id="account_type">
                                    <input type="hidden" name="account_name" class="account_name">
                                    <input type="hidden" class="acc_no" name="acc_no" id="acc_no">
                                    @error('account_id')
                                        <div class="text-danger">{{ $message }}</div>
                                    @enderror
                                </div>

                            </div>

                            <div class="table-responsive mb-0" data-pattern="priority-columns">
                                <table class="table table-bordered dt-responsive nowrap"
                                    style="border-collapse: collapse; border-spacing: 0; width: 100%;">
                                    <thead>
                                        <tr>
                                            <th>Item Name</th>
                                            <th>Item Description</th>
                                            <th>Warehouse</th>
                                            <th>Quantity</th>
                                            <th>Rate / Unit</th>
                                            <th>Item / Unit</th>
                                            <th>Gross Amount</th>
                                            <th>VAT %</th>
                                            <th>VAT Amount</th>
                                            <th>Net Amount</th>
                                            <th>Delete</th>
                                        </tr>
                                    </thead>

                                    <tbody id="table-body">
                                        @forelse ($debits as $debit)
                                                <tr>
                                                    <div class="inner-repeater mb-12">
                                                        <div data-repeater-list="inner-group" class="inner form-group">
                                                            <td>
                                                                <div class="form-group">
                                                                    <select style="width:100%" class="form-control selectItem select2 itemDropdown" name="item_id[]">
                                                                        <option value="" disabled>Select Item</option>
                                                                        @foreach ($items as $item)
                                                                            <option value="{{ $item->id }}" @if($debit->item_id == $item->id) selected @endif>
                                                                                {{ $item->name }}
                                                                            </option>
                                                                        @endforeach
                                                                    </select>

                                                                </div>
                                                            </td>

                                                            <td>
                                                                <div class="form-group">
                                                                    <textarea class="form-control" rows="1" type="text" cols="50" placeholder="Item Description" id="example-textarea-input"
                                                                        name="item_description[]">{{ $debit->item_description }}</textarea>
                                                                </div>
                                                            </td>

                                                            <td>
                                                                <div class="form-group">
                                                                    <select style="width:100%" class="form-control selectWarehouse select2"
                                                                        name="warehouse_id[]">
                                                                        <option value="" selected disabled>Select
                                                                            Warehouse
                                                                        </option>
                                                                        @foreach ($warehouses as $warehouse)
                                                                            <option value="{{ $warehouse->id }}">
                                                                                {{ $warehouse->name }}</option>
                                                                        @endforeach
                                                                    </select>
                                                                </div>
                                                            </td>

                                                            <td>
                                                                <div class="form-group">
                                                                    <input class="form-control quantity" type="text" oninput="this.value = this.value.replace(/[^0-9.]/g, '');"
                                                                        placeholder="Quantity" id="quantity"
                                                                        name="quantity[]" value="{{ $debit->quantity }}">
                                                                </div>
                                                            </td>
                                                            <td>
                                                                <div class="form-group">
                                                                    <input class="form-control rate_unit" type="text" oninput="this.value = this.value.replace(/[^0-9.]/g, '');"
                                                                        placeholder="Rate/Unit" id="rate_unit"
                                                                        name="rate_unit[]" value="{{ $debit->rate_unit }}">
                                                                </div>
                                                            </td>
                                                            <td>
                                                                <div class="form-group">
                                                                    <input type="text" class="form-control unitInput" name="item_unit[]" readonly placeholder="Item unit" value="{{ $debit->item_unit }}">
                                                                </div>
                                                            </td>

                                                        </div>

                                                    </div>

                                                    <td>
                                                        <div class="form-group">
                                                            <input class="form-control gross_amount" type="text" oninput="this.value = this.value.replace(/[^0-9.]/g, '');"
                                                                placeholder="Gross Amount" id="gross_amount"
                                                                name="gross_amount[]" value="{{ $debit->gross_amount }}">
                                                        </div>
                                                    </td>
                                                    <td>
                                                        <div class="form-group">
                                                            <input class="form-control vat_percentage" type="text" oninput="this.value = this.value.replace(/[^0-9.]/g, '');"
                                                                placeholder="VAT %" id="vat_percentage"
                                                                name="vat_percentage[]"
                                                                value="{{ $debit->vat_percentage }}">
                                                        </div>
                                                    </td>
                                                    <td>
                                                        <div class="form-group">
                                                            <input class="form-control vat_amount" type="float"
                                                                placeholder="VAT Amount" id="vat_amount"
                                                                name="vat_amount[]" value="{{ $debit->vat_amount }}">
                                                        </div>
                                                    </td>
                                                    <td>
                                                        <div class="form-group">
                                                            <p><input type="text" oninput="this.value = this.value.replace(/[^0-9.]/g, '');" class="form-control net_amount"
                                                                    id="net_amount" name="net_amount[]"
                                                                    value="{{ $debit->net_amount }}" readonly>
                                                            </p>
                                                        </div>
                                                    </td>

                                                    <td>
                                                        <a href="" class="delete-row-btn"> <i
                                                                class="fas fa-trash-alt inner"></i></a>
                                                    </td>


                                                </tr>
                                                @empty
                                                <tr>
                                                    <div class="inner-repeater mb-12">
                                                        <div data-repeater-list="inner-group" class="inner form-group">
                                                            <td>
                                                                <div class="form-group">
                                                                    <select style="width:100%" class="form-control selectItem select2 itemDropdown" name="item_id[]">
                                                                        <option value="" disabled selected>Select Item</option>
                                                                        @foreach ($items as $item)
                                                                            <option value="{{ $item->id }}" data-unit="{{ $item->unit->unit }}">{{ $item->name }}</option>
                                                                        @endforeach
                                                                    </select>
                                                                </div>
                                                            </td>

                                                            <td>
                                                                <div class="form-group">
                                                                    <textarea class="form-control" rows="1" type="text" placeholder="Item Description"
                                                                        name="item_description[]">
                                                                    </textarea>
                                                                </div>
                                                            </td>

                                                            <td>
                                                                <div class="form-group">
                                                                    <select style="width:100%" class="form-control selectWarehouse select2"
                                                                        name="warehouse_id[]">
                                                                        <option value="" selected disabled>Select
                                                                            Warehouse
                                                                        </option>
                                                                        @foreach ($warehouses as $warehouse)
                                                                            <option value="{{ $warehouse->id }}">
                                                                                {{ $warehouse->name }}</option>
                                                                        @endforeach
                                                                    </select>
                                                                </div>
                                                            </td>

                                                            <td>
                                                                <div class="form-group">
                                                                    {{-- <input class="form-control quantity" type="text" oninput="this.value = this.value.replace(/[^0-9.]/g, '');"
                                                                        placeholder="Quantity" id="quantity"
                                                                        name="quantity[]"> --}}

                                                                        <input class="form-control quantity" type="text" oninput="this.value = this.value.replace(/[^0-9.]/g, ''); checkStockAvailability(this);" placeholder="Quantity" id="quantity" name="quantity[]">
                                                                    <p class="out-of-stock-message" style="color: red;"></p>
                                                                </div>
                                                            </td>
                                                            <td>
                                                                <div class="form-group">
                                                                    <input class="form-control rate_unit" type="text" oninput="this.value = this.value.replace(/[^0-9.]/g, '');"
                                                                        placeholder="Rate/Unit" id="rate_unit"
                                                                        name="rate_unit[]">
                                                                </div>
                                                            </td>
                                                            <td>
                                                                <div class="form-group">
                                                                    <input type="text" class="form-control unitInput" name="item_unit[]" readonly placeholder="Item unit">
                                                                </div>
                                                            </td>

                                                        </div>

                                                    </div>

                                                    <td>
                                                        <div class="form-group">
                                                            <input class="form-control gross_amount" type="text" oninput="this.value = this.value.replace(/[^0-9.]/g, '');"
                                                                placeholder="Gross Amount" id="gross_amount"
                                                                name="gross_amount[]">
                                                        </div>
                                                    </td>
                                                    <td>
                                                        <div class="form-group">
                                                            <input class="form-control vat_percentage" type="text" oninput="this.value = this.value.replace(/[^0-9.]/g, '');"
                                                                placeholder="VAT %" id="vat_percentage"
                                                                name="vat_percentage[]">
                                                        </div>
                                                    </td>
                                                    <td>
                                                        <div class="form-group">
                                                            <input class="form-control vat_amount" type="text" oninput="this.value = this.value.replace(/[^0-9.]/g, '');"
                                                                placeholder="VAT Amount" id="vat_amount"
                                                                name="vat_amount[]">
                                                        </div>
                                                    </td>
                                                    <td>
                                                        <div class="form-group">
                                                            <p><input type="text" oninput="this.value = this.value.replace(/[^0-9.]/g, '');" class="form-control net_amount"
                                                                    id="net_amount" name="net_amount[]" readonly></p>
                                                        </div>
                                                    </td>

                                                    <td>
                                                        <a href="" class="delete-row-btn"> <i
                                                                class="fas fa-trash-alt inner"></i></a>
                                                    </td>

                                                </tr>
                                            @endforelse
                                    </tbody>
                                </table>
                            </div>
                        </div>

                        <div class="row">
                            <div class="col-md-8">
                                {{-- <a id="add-more-btn" class="btn btn-outline-primary">Add
                                    more</a> --}}
                                @if (!request()->has('pi_no'))
                                <a id="add-more-btn" class="btn btn-outline-primary">Add more</a>
                                @endif
                            </div>
                            <div class="col-md-4">
                                <!-- <h5>QTY Total: 0</h5> -->
                            </div>
                        </div>
                        <br>

                        <div class="row my-5" id="buyInformationRow">
                            <div class="col-md-4">
                                <h2 class="my-2">Buy Information</h2>
                                <div class="form-group">
                                    <label>Name :</label>
                                    <input class="form-control" type="text" placeholder="Enter Name"
                                        id="example-password-input" name="name" id="name">
                                    <input type="hidden" name="type" value="debit_note" id="type">
                                </div>
                                <div class="form-group">
                                    <label>Phone # :</label>
                                    <input class="form-control" type="text" oninput="this.value = this.value.replace(/[^0-9.]/g, '');" placeholder="Enter Phone #"
                                        id="example-password-input" name="phone" id="phone">
                                </div>
                                <div class="form-group">
                                    <label>Email :</label>
                                    <input class="form-control" type="text" placeholder="Enter Email"
                                        id="example-password-input" name="email" id="email">
                                </div>
                                <div class="form-group">
                                    <label>Vat Number :</label>
                                    <input class="form-control" type="text" placeholder="Vat Number"
                                        id="example-password-input" name="vat_number">
                                </div>
                                <div class="form-group">
                                    <label>Description :</label>
                                    <input class="form-control" type="text" placeholder="Description"
                                        id="example-password-input" name="description">
                                </div>
                                <div class="form-group">
                                    <label>Address :</label>
                                    <textarea class="form-control" rows="3" type="text" placeholder="Enter Address"
                                        id="example-textarea-input" name="address" id="address">
                                    </textarea>
                                </div>
                            </div>
                        </div>

                        <br>

                        <div class="row">
                            <div class="col-md-8">
                            </div>
                            <div class="col-md-4">
                                <strong>
                                    <label>Total Quantity :</label>
                                    <span><input type="text" class="custin" id="total_quantity" name="total_quantity"
                                            readonly></span>
                                </strong>
                            </div>
                            <div class="col-md-8">
                            </div>
                            <div class="col-md-4">
                                <strong>
                                    <label>Total Gross Amount : </label>
                                    <span><input type="text" class="custin" id="total_gross_amount"
                                            name="total_gross_amount" readonly></span>
                                </strong>
                            </div>
                            <div class="col-md-8">
                            </div>
                            <div class="col-md-4">
                                <strong>
                                    <label>Total Vat amount : </label>
                                    <span><input type="text" class="custin" id="total_vat_amount"
                                            name="total_vat_amount" readonly></span>
                                </strong>
                            </div>
                            <div class="col-md-8">
                            </div>


                            <div class="col-md-8">
                            </div>
                            <br>
                            <div class="col-md-4">
                                <strong>
                                    <label>Total net amount : </label>
                                    <span><input type="text" class="custin" id="total_net_amount"
                                            name="total_net_amount" readonly></span>
                                </strong>
                            </div>
                            {{-- <div class="col-md-4">
                                    <strong>
                                        <label>Amount in Words : </label>
                                        <span><input type="text" class="custin" value=" "
                                                id="total_net_amount_words" name="amount_in_words" readonly
                                                style="overflow:visible;"></span>
                                    </strong>
                                </div> --}}
                            <div class="col-md-6">
                                <div class="row">
                                    <div class="col-4">
                                        <strong>
                                            <label for="total_net_amount_words">Amount in Words :</label>
                                        </strong>
                                    </div>
                                    <div class="col-8">
                                        <input type="text" class="custin" id="total_net_amount_words"
                                            name="AmountInWords" readonly style="width: 120%;margin-left: -3.5rem;">
                                    </div>
                                </div>
                            </div>


                        </div>

                        <div class="row">

                            <div class="col-md-6">
                                <div class="form-group">
                                    <label>Term & Conditions</label>
                                    <p>{{ $tnc->description ?? '' }}</p>
                                </div>
                            </div>
                            <div class="col-md-6">
                                <div class="form-group">
                                    <label for="narrations">Narrations</label>
                                    <textarea class="form-control{{ $errors->has('narrations') ? ' is-invalid' : '' }}" rows="4"
                                        placeholder="Enter Narrations" id="example-textarea-input" name="narrations">
                                        {{ collect($debits)->count() > 0 ? collect($debits)->first()->narrations : '' }}
                              </textarea>

                                    @if ($errors->has('narrations'))
                                        <div class="invalid-feedback">{{ $errors->first('narrations') }}</div>
                                    @endif
                                </div>
                            </div>


                        </div>


                        <button class="btn btn-cust1 float-right" type="submit">Create Debit Note</button>
                    </form>
                </div>
            </div>
        </div>
    </div>
    </div>
    <!-- end row -->


    <!-- Modals -->
    <div id="modal1" class="modal fade" tabindex="-1" role="dialog" aria-labelledby="myModalLabel"
        aria-hidden="true">
        <div class="modal-dialog">
            <form id="buyer-form">
                @csrf
                <div class="modal-content">
                    <div class="modal-header">
                        <h5 class="modal-title mt-0" id="myModalLabel">Buyer Information :</h5>
                        <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                            <span aria-hidden="true">&times;</span>
                        </button>
                    </div>
                    <div class="modal-body">
                        <div class="col-md-12">
                            <div class="form-group">
                                <label>Name :</label>
                                <input class="form-control" type="text" placeholder="Enter Name"
                                    id="example-password-input" name="name" id="name">
                            </div>
                        </div>
                        <div class="col-md-12">
                            <div class="form-group">
                                <label>Phone # :</label>
                                <input class="form-control" type="text" oninput="this.value = this.value.replace(/[^0-9.]/g, '');" placeholder="Enter Phone #"
                                    id="example-password-input" name="phone" id="phone">
                            </div>
                        </div>
                        <div class="col-md-12">
                            <div class="form-group">
                                <label>Email :</label>
                                <input class="form-control" type="text" placeholder="Enter Email"
                                    id="example-password-input" name="email" id="email">
                            </div>
                        </div>
                        <div class="col-md-12">
                            <div class="form-group">
                                <label>Vat Number :</label>
                                <input class="form-control" type="text" placeholder="Vat Number"
                                    id="example-password-input" name="vat_number" name="vat_number">
                            </div>
                        </div>
                        <div class="col-md-12">
                            <div class="form-group">
                                <label>Description :</label>
                                <input class="form-control" type="text" placeholder="Description"
                                    id="example-password-input" name="description">
                            </div>
                        </div>
                        <div class="col-md-12">
                            <div class="form-group">
                                <label>Address :</label>
                                <textarea class="form-control" rows="3" type="text" placeholder="Enter Address"
                                    id="example-textarea-input" name="address" id="address">
                        </textarea>
                            </div>
                        </div>
                    </div>
                    <div class="modal-footer">
                        <input type="hidden" name="invoice_no" value="{{ $newCn }}" id="invoice_no">
                        <input type="hidden" name="type" value="sales_invoice" id="type">
                        <button type="button" class="btn btn-secondary waves-effect" data-dismiss="modal">Close</button>
                        <button type="submit" class="btn btn-primary waves-effect waves-light">Save</button>
                    </div>
            </form>
        </div>
        <!-- /.modal-content -->
    </div>

    <!-- Modal for Buyer Information -->
    <div id="modal1" class="modal fade" tabindex="-1" role="dialog" aria-labelledby="buyerModalLabel" aria-hidden="true">
        <div class="modal-dialog">
            <div class="modal-content">
                <div class="modal-header">
                    <h5 class="modal-title" id="buyerModalLabel">Buyer Information:</h5>
                    <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                        <span aria-hidden="true">&times;</span>
                    </button>
                </div>
                <div class="modal-body">
                    <div class="col-md-12">
                        <div class="form-group">
                            <label>Name :</label>
                            <input class="form-control" type="text" placeholder="Enter Name"
                                id="example-password-input" name="name" id="name">
                        </div>
                    </div>
                    <div class="col-md-12">
                        <div class="form-group">
                            <label>Phone # :</label>
                            <input class="form-control" type="text" oninput="this.value = this.value.replace(/[^0-9.]/g, '');" placeholder="Enter Phone #"
                                id="example-password-input" name="phone" id="phone">
                        </div>
                    </div>
                    <div class="col-md-12">
                        <div class="form-group">
                            <label>Email :</label>
                            <input class="form-control" type="text" placeholder="Enter Email"
                                id="example-password-input" name="email" id="email">
                        </div>
                    </div>
                    <div class="col-md-12">
                        <div class="form-group">
                            <label>Vat Number :</label>
                            <input class="form-control" type="text" placeholder="Vat Number"
                                id="example-password-input" name="vat_number" name="vat_number">
                        </div>
                    </div>
                    <div class="col-md-12">
                        <div class="form-group">
                            <label>Description :</label>
                            <input class="form-control" type="text" placeholder="Description"
                                id="example-password-input" name="description">
                        </div>
                    </div>
                    <div class="col-md-12">
                        <div class="form-group">
                            <label>Address :</label>
                            <textarea class="form-control" rows="3" type="text" placeholder="Enter Address"
                                id="example-textarea-input" name="address" id="address">
                    </textarea>
                        </div>
                    </div>
                </div>
                <div class="modal-footer">
                    <input type="hidden" name="invoice_no" value="{{ $newCn }}" id="invoice_no">
                    <input type="hidden" name="type" value="sales_invoice" id="type">
                    <button type="button" class="btn btn-secondary waves-effect" data-dismiss="modal">Close</button>
                    <button type="button" class="btn btn-primary waves-effect waves-light">Save</button>
                </div>
            </div>
        </div>
    </div>

    <!-- /.modal-dialog -->
    </div>
    <script src="https://code.jquery.com/jquery-3.7.0.js" integrity="sha256-JlqSTELeR4TLqP0OG9dxM7yDPqX1ox/HfgiSLBj8+kM="
        crossorigin="anonymous"></script>
        <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
        {{-- <script src="https://cdnjs.cloudflare.com/ajax/libs/number-to-words/1.2.4/numberToWords.min.js"></script> --}}

        <script>
            function checkStockAvailability(inputField) {
                var row = $(inputField).closest('tr');
                var itemId = row.find('.selectItem').val();
                var quantity = row.find('.quantity').val();

                var csrfToken = $('meta[name="csrf-token"]').attr('content');

                $.ajax({
                    url: '/check-stock',
                    method: 'POST',
                    headers: {
                        'X-CSRF-TOKEN': csrfToken
                    },
                    data: {itemId: itemId, quantity: quantity},
                    success: function(response) {
                        // Handle response
                        if (response.outOfStock) {
                            row.find('.out-of-stock-message').remove();
                            row.find('.quantity').after('<p class="out-of-stock-message" style="color: red;">Out of stock!</p>');
                        } else {
                            row.find('.out-of-stock-message').remove();
                        }
                    },
                    error: function(xhr, status, error) {
                        console.error(xhr.responseText);
                    }
                });
            }
        </script>



        <script>
            $(document).ready(function() {
                $('.selectItem, .quantity').on('change', function() {
                    checkStockAvailability();
                });
            });
        </script>
    <script>
        function myFunction() {
            var dropdown = document.getElementById("myDropdown");
            var pricehidden1 = document.getElementById("pricehidden1");
            var pricehidden2 = document.getElementById("pricehidden2");
            var pricehidden3 = document.getElementById("pricehidden3");

            if (dropdown.value === "hide") {
                pricehidden1.style.display = "none";
                pricehidden2.style.display = "none";
                pricehidden3.style.display = "none";
            } else {
                pricehidden1.style.display = "block";
                pricehidden2.style.display = "block";
                pricehidden3.style.display = "block";
            }
        }
    </script>
    <script>
        document.getElementById('addLedgerButton').addEventListener('click', function() {
            cloneRow();
        });

        function cloneRow() {
            const repeaterRow = document.querySelector('.repeater-row');
            if (repeaterRow) {
                const clonedRow = repeaterRow.cloneNode(true);

                const selectElement = clonedRow.querySelector('select');
                const inputElement = clonedRow.querySelector('input');
                if (selectElement) {
                    selectElement.selectedIndex = 0;
                }
                if (inputElement) {
                    inputElement.value = '';
                }

                // Remove the cloned button from the cloned row
                const clonedButton = clonedRow.querySelector('#addLedgerButton');
                if (clonedButton) {
                    clonedButton.remove();
                }

                repeaterRow.parentNode.appendChild(clonedRow);
            }
        }

        function deleteRow(button) {
            const row = button.closest('.repeater-row');
            if (row && !row.isSameNode(document.querySelector('.repeater-row'))) {
                row.remove();
            }
        }
    </script>

    {{-- <script>
        function myFunction() {
            var dropdown = document.getElementById("myDropdown");
            var pricehidden1 = document.getElementById("pricehidden1");
            var pricehidden2 = document.getElementById("pricehidden2");
            var pricehidden3 = document.getElementById("pricehidden3");

            if (dropdown.value === "hide") {
                pricehidden1.style.display = "none";
                pricehidden2.style.display = "none";
                pricehidden3.style.display = "none";
            } else {
                pricehidden1.style.display = "block";
                pricehidden2.style.display = "block";
                pricehidden3.style.display = "block";
            }
        }
    </script> --}}

    <!-- modal script -->

    <script>
        document.getElementById("modalSelect").addEventListener("change", function() {
            var selectedModal = this.value;

            // Close any open modals
            $('.modal').modal('hide');

            // Open the selected modal
            $('#' + selectedModal).modal('show');
        });
    </script>

    {{-- CALCULATION --}}
    <script>
        $(document).ready(function() {

            function calculateRow(row) {
                var quantity = parseFloat(row.find('.quantity').val()) || 0;
                var rateUnit = parseFloat(row.find('.rate_unit').val()) || 0;
                var vatPercentage = parseFloat(row.find('.vat_percentage').val()) || 0;

                var grossAmount = quantity * rateUnit;
                var vatAmount = grossAmount * (vatPercentage / 100);
                var netAmount = grossAmount + vatAmount;

                row.find('.gross_amount').val(grossAmount.toFixed({{session()->get('branch')->currency_decimal}}));
                row.find('.vat_amount').val(vatAmount.toFixed({{session()->get('branch')->currency_decimal}}));
                row.find('.net_amount').val(netAmount.toFixed({{session()->get('branch')->currency_decimal}}));
            }

            // Calculate for existing rows (initial row and dynamically generated rows)
            $('#table-body tr').each(function() {
                calculateRow($(this));
            });

            // Event delegation for dynamically added rows
            $('#table-body').on('input', '.quantity, .rate_unit, .vat_percentage', function() {
                calculateRow($(this).closest('tr'));
                calculateTotalQuantity();
                calculateTotalGross();
                calculateTotalVatAmount();
                calculateTotalNetAmount();
                // convertTotalNetAmountToWords();
            });

            // Event listener for changes in sub_account_amount
            $(document).ready(function() {
                // Initial calculation when the page loads
                calculateTotalNetAmount();

                // Event listener for changes in 'sub_account_amount' inputs
                $(document).on('input', '.sub_account_amount', function() {
                    calculateTotalNetAmount();
                });
            });

            $('#add-more-btn').on('click', function() {
                var newRow = `
                <tr>
                   <td>
                        <div class="form-group">
                            <select style="width:100%" class="form-control selectItem select2 itemDropdown" name="item_id[]">
                                <option value="" disabled selected>Select Item</option>
                                @foreach ($items as $item)
                                    <option value="{{ $item->id }}" data-unit="{{ $item->unit->unit }}">{{ $item->name }}</option>
                                @endforeach
                            </select>
                        </div>
                    </td>
                    <td>
                        <div class="form-group">
                            <textarea class="form-control item_desc" rows="1" type="text" cols="50" placeholder="Item Description" name="item_description[]"></textarea>
                        </div>
                    </td>
                    <td>
                        <div class="form-group">
                            <select style="width:100%" class="form-control selectWarehouse select2" name="warehouse_id[]">
                                <option value="" selected disabled>Select Warehouse</option>
                                @foreach ($warehouses as $warehouse)
                                    <option value="{{ $warehouse->id }}">{{ $warehouse->name }}</option>
                                @endforeach
                            </select>
                        </div>
                    </td>
                    <td>
                        <div class="form-group">
                            <input class="form-control quantity" type="text" oninput="this.value = this.value.replace(/[^0-9.]/g, '');" placeholder="Quantity" name="quantity[]">
                        </div>
                    </td>
                    <td>
                        <div class="form-group">
                            <input class="form-control rate_unit" type="text" oninput="this.value = this.value.replace(/[^0-9.]/g, '');" placeholder="Rate/Unit" name="rate_unit[]">
                        </div>
                    </td>
                    <td>
                        <div class="form-group">
                            <input type="text" class="form-control unitInput" name="item_unit[]" readonly placeholder="Item unit">
                        </div>
                    </td>
                    <td>
                        <div class="form-group">
                            <input class="form-control gross_amount" type="text" oninput="this.value = this.value.replace(/[^0-9.]/g, '');" placeholder="Gross Amount" name="gross_amount[]" readonly>
                        </div>
                    </td>
                    <td>
                        <div class="form-group">
                            <input class="form-control vat_percentage" type="text" oninput="this.value = this.value.replace(/[^0-9.]/g, '');" placeholder="VAT %" name="vat_percentage[]">
                        </div>
                    </td>
                    <td>
                        <div class="form-group">
                            <input class="form-control vat_amount" type="text" oninput="this.value = this.value.replace(/[^0-9.]/g, '');" placeholder="VAT Amount" name="vat_amount[]">
                        </div>
                    </td>
                    <td>
                        <div class="form-group">
                            <input class="form-control net_amount form-control" type="text" oninput="this.value = this.value.replace(/[^0-9.]/g, '');" placeholder="Net Amount" name="net_amount[]" readonly>
                        </div>
                    </td>
                    <td>
                        <a href="#" class="delete-row-btn"><i class="fas fa-trash-alt"></i></a>
                    </td>
                </tr>`;

                $('#table-body').append(newRow);
                $('#table-body tr:last .select2').select2();

                // Initialize calculation for the new row
                calculateRow($('#table-body tr:last'));
                calculateTotalQuantity();
                calculateTotalGross();
                calculateTotalVatAmount();
                calculateTotalNetAmount();
                // convertTotalNetAmountToWords();
            });


            // Event delegation for delete button
            $('#table-body').on('click', '.delete-row-btn', function() {
                $(this).closest('tr').remove();
                calculateTotalQuantity();
                calculateTotalGross();
                calculateTotalVatAmount();
                calculateTotalNetAmount();
                // convertTotalNetAmountToWords();
            });

            // Calculate and update total quantity
            function calculateTotalQuantity() {
                var totalQuantity = 0;
                $('.quantity').each(function() {
                    totalQuantity += parseFloat($(this).val()) || 0;
                });
                $('#total_quantity').val(totalQuantity);
            }
            // Calculate and update total gross amount
            function calculateTotalGross() {
                var totalGross = 0;
                $('.gross_amount').each(function() {
                    totalGross += parseFloat($(this).val()) || 0;
                });
                $('#total_gross_amount').val(totalGross.toFixed({{session()->get('branch')->currency_decimal}}));
            }
            // Calculate and update total VAT amount
            function calculateTotalVatAmount() {
                var totalVatAmount = 0;
                $('.vat_amount').each(function() {
                    totalVatAmount += parseFloat($(this).val()) || 0;
                });
                $('#total_vat_amount').val(totalVatAmount.toFixed({{session()->get('branch')->currency_decimal}}));
            }
            // Calculate and update total net amount
            function calculateTotalNetAmount() {
                var totalSubAccountAmount = 0;
                var totalNetAmount = 0;

                // Loop through all elements with the class 'sub_account_amount'
                $('.sub_account_amount').each(function() {
                    var inputValue = parseFloat($(this).val()) || 0;
                    totalSubAccountAmount += inputValue;
                });

                // Loop through all elements with the class 'net_amount'
                $('.net_amount').each(function() {
                    var inputValue = parseFloat($(this).val()) || 0;
                    totalNetAmount += inputValue;
                });

                // Update the total net amount field
                $('#total_net_amount').val((totalSubAccountAmount + totalNetAmount).toFixed({{session()->get('branch')->currency_decimal}}));

                // Convert total net amount to words and update the corresponding field

                var dec = {{session()->get('branch')->currency_decimal}};
                var front = dec_function(0, dec);

                var net_total_inc_vat = totalSubAccountAmount + totalNetAmount;

                if (net_total_inc_vat) {
                    net_total_inc_vat = dec_function(net_total_inc_vat, dec);
                }

                var totalNetAmountWords = numberToWords(net_total_inc_vat);
                $('#total_net_amount_words').val(totalNetAmountWords);

                // var totalNetAmountWords = numberToWords(totalSubAccountAmount + totalNetAmount);
                // $('#total_net_amount_words').val(totalNetAmountWords);
            }

            // Initial calculation for total quantity and total gross
            calculateTotalQuantity();
            calculateTotalGross();
            calculateTotalVatAmount();
            calculateTotalNetAmount();
            // convertTotalNetAmountToWords();
        });
    </script>

    <script>
        $(document).ready(function() {
            // Event handler for the add-clone-btn click
            $(document).on('click', '.add-clone-btn', function(e) {
                e.preventDefault();

                // Get the parent <tr> element
                var parentTr = $(this).closest('tr');

                // Clone the parent <tr> element
                var clonedTr = parentTr.clone();

                // Append the cloned <tr> after the parent <tr>
                parentTr.after(clonedTr);
            });
        });

        $(document).ready(function() {
            // $('#add-more-btn').click(function (e) {
            //     e.preventDefault();

            //     // Clone the existing row
            //     var newRow = $('#table-body tr').first().clone();

            //     // Clear input fields and select values in the cloned row
            //     newRow.find('input, textarea').val('');
            //     newRow.find('select').prop('selectedIndex', 0);

            //     // Append the cloned row to the table
            //     $('#table-body').append(newRow);
            // });

            $('#add-clone-btn').click(function(e) {
                e.preventDefault();

                // Clone the existing row
                var newRow = $('#table-body tr').first().clone();

                // Clear input fields and select values in the cloned row
                newRow.find('input, textarea').val('');
                newRow.find('select').prop('selectedIndex', 0);

                // Append the cloned row to the table
                $('#table-body').append(newRow);
            });

            // Handle delete button click event
            $(document).on('click', '.delete-row-btn', function(e) {
                e.preventDefault();

                // Get the parent row and remove it
                var row = $(this).closest('tr');
                row.remove();
            });
        });
    </script>

    <script>
        // JavaScript to update the hidden input field when the dropdown selection changes
        $(document).ready(function() {
            function updateAccountType() {
                var selectedOption = $('#account option:selected'); // Use jQuery to get selected option
                var accountType = selectedOption.data('account-type');
                var accountName = selectedOption.data('account-name');
                var accNo = selectedOption.data('acc-no');
                $('#account_type').val(accountType);
                $('.account_name').val(accountName);
                $('.acc_no').val(accNo);

            }

            // Run the function once when the page is ready
            updateAccountType();

            // Add an event listener to update the hidden input when the selection changes
            $('#account').change(updateAccountType);

            // EXPENSE TYPE

            function updateExpenseType() {
                var selectedOption = $('.expense option:selected'); // Use jQuery to get selected option
                var expenseType = selectedOption.data('expense-type');
                $('.expense-type').val(expenseType);

            }

            // Run the function once when the page is ready
            updateExpenseType();

            // Add an event listener to update the hidden input when the selection changes
            $('.expense').change(updateExpenseType);
        });
    </script>

<script>
    $(document).ready(function(){
        // Attach change event listener to all itemDropdown elements
        $(document).on('change', '.itemDropdown', function(){
            var selectedUnit = $(this).find(':selected').data('unit');
            // Find the corresponding unitInput in the same row and update its value
            $(this).closest('tr').find('.unitInput').val(selectedUnit);
        });
    });
</script>

@php
    use App\Branches;
    use Carbon\Carbon;

    $selectedBranchId = session('selected_branch');

    $branch = Branches::where('id', $selectedBranchId)->first();
@endphp

<script>
    @if (!empty($selectedBranchId))
        document.addEventListener("DOMContentLoaded", function() {
            var periodClosings = <?php echo json_encode($periodClosings); ?>;

            function isBeforePeriodClosing(date) {
                var selectedDate = new Date(date);
                for (var i = 0; i < periodClosings.length; i++) {
                    var closingDate = new Date(periodClosings[i]);
                    if (selectedDate < closingDate) {
                        return true;
                    }
                }
                return false;
            }

            function setColor(dateInput) {
                var selectedDate = dateInput.value;
                if (isBeforePeriodClosing(selectedDate)) {
                    dateInput.style.backgroundColor = 'lightgrey';
                } else {
                    dateInput.style.backgroundColor = '';
                }
            }

            var periodClosingDateInputs = document.querySelectorAll('.PeriodClosingDate');
            periodClosingDateInputs.forEach(function(input) {
                input.addEventListener('change', function() {
                    setColor(this);
                    if (isBeforePeriodClosing(this.value)) {
                        @if (!Branches::hasBranchPermission($selectedBranchId, 'Back Dated Entry As Per User Credentials'))
                            window.alert("Do you want to enter a closing period? Please contact admin.");
                            this.value = '';
                        @else
                            window.alert("Do you want to enter a closing period?");
                        @endif
                    }
                });
                setColor(input);
            });
        });
    @endif
</script>


@endsection
