@extends('layouts.crusher')
@section('content')


        <div class="row">
            <div class="col-md-12">
                <div class="card">
                    <div class="card-body">
                        <div class="row">
                            <div class="col-md-6">
                                <h6 class="card-title mb-4 titlcust">Edit Journal Voucher</h6>
                            </div>
                        </div>

                        <!-- <div class="col-4"> -->
                        <form
                            action="{{ route('software.journal_vouchers.update', ['journal_voucher' => $journalVouchers[0]->id]) }}"
                            class="outer-repeater" method="POST">
                            @csrf
                            @method('put')

                            <div class="row">

                                <div class="col-md-3">
                                    <div class="form-group">
                                        <label>Voucher #</label>
                                        <input class="form-control" readonly placeholder="" id="example-password-input"
                                            value="{{ $journalVouchers[0]->invoice_no }}" name="invoice_no">
                                    </div>
                                </div>

                                <div class="col-md-6">

                                </div>

                                <div class="col-md-3">
                                    <div class="form-group">
                                        <label>Date</label>
                                        <input class="form-control PeriodClosingDate" type="date" pattern="\d{4}-\d{2}-\d{2}"
                                            name="date" value="{{ $journalVouchers[0]->date }}">
                                    </div>
                                </div>
                            </div>


                            <div class="row">

                                <div class="table-responsive mb-0" data-pattern="priority-columns">
                                    <table class="table table-bordered dt-responsive nowrap"
                                        style="border-collapse: collapse; border-spacing: 0; width: 100%;">
                                        <thead>
                                            <tr>
                                                <th>Account Name</th>
                                                <th>Narrations</th>
                                                <th>Debit/Credit</th>
                                                <th>Amount</th>
                                                <th>Delete</th>
                                            </tr>
                                        </thead>

                                        <tbody id="table-body">
                                            @forelse ($journalVouchers as $jv)
                                                <tr>
                                                    <div class="inner-repeater mb-12">
                                                        <div data-repeater-list="inner-group" class="inner form-group">

                                                            <td>
                                                                <div class="form-group">
                                                                    <select id="account" class="form-control"
                                                                        name="account_id[]">
                                                                        <option>Select Account</option>
                                                                        @foreach ($accounts as $account)
                                                                            <option value="{{ $account->id }}" {{$jv->acc_no==$account->account_no?'selected':''}}
                                                                                data-account-type="{{ $account->table_name }}" data-account-name="{{ $account->account_name }}" data-acc-no="{{ $account->account_no }}">
                                                                                {{ $account->account_name }}
                                                                            </option>
                                                                        @endforeach
                                                                    </select>
                                                                </div>
                                                                <input type="hidden" class="account_type" name="account_type[]" id="account_type" value="{{$jv->account_type}}">
                                                                <input type="hidden" class="account_name" name="account_name[]" id="account_type" value="{{$jv->account_name}}">
                                                                <input type="hidden" class="acc_no" name="acc_no[]" id="acc_no" value="{{$jv->acc_no}}">

                                                            </td>
                                                            <td>
                                                                <div class="form-group">
                                                                    <textarea class="form-control" rows="1" type="text" placeholder="Narrations" id="example-textarea-input"
                                                                        name="narration[]">{{$jv->narration}}
                                                        </textarea>
                                                                </div>
                                                            </td>
                                                            <td>
                                                                <div class="form-group">
                                                                    <select style="width: 100%" class="form-control select2" name="type[]">
                                                                        <option>Select Debit/Credit</option>
                                                                        <option value="debit" {{$jv->type=='debit'?'selected':''}}>Debit</option>
                                                                        <option value="credit" {{$jv->type=='credit'?'selected':''}}>Credit</option>
                                                                    </select>
                                                                </div>
                                                            </td>
                                                        </div>
                                                    </div>
                                                    <td>
                                                        <div class="form-group">
                                                            <input class="form-control" type="text" oninput="this.value = this.value.replace(/[^0-9.]/g, '');" placeholder="0"
                                                                id="example-password-input" name="amount[]" value="{{$jv->amount}}">
                                                        </div>
                                                    </td>

                                                    <td>
                                                        <a href="" class="delete-row-btn"> <i
                                                                class="fas fa-trash-alt inner"></i></a>
                                                    </td>


                                                </tr>
                                            @empty
                                            @endforelse

                                        </tbody>
                                    </table>
                                </div>
                            </div>

                            <div class="row">
                                <div class="col-md-8">
                                    <button id="add-more-btn" class="btn btn-outline-primary">Add
                                        more</button>
                                </div>
                                <div class="col-md-4">
                                    <!-- <h5>QTY Total: 0</h5> -->
                                </div>
                            </div>
                            <br>

                            <br>

                            <div class="row">
                                <div class="col-md-8">
                                </div>
                                <div class="col-md-4">
                                    <strong>
                                        <label>Debit Amount:</label>
                                        <span id="total-debit">0.000
                                        </span>
                                    </strong>
                                    <input type="hidden" id="total-debit-val" name="debit_amount">
                                </div>
                                <div class="col-md-8">
                                </div>
                                <div class="col-md-4">
                                    <strong>
                                        <label>Credit Amount :</label>
                                        <span id="total-credit">0.000
                                        </span>
                                    </strong>
                                    <input type="hidden" id="total-credit-val" name="credit_amount">
                                </div>
                                <div class="col-md-8">
                                </div>
                                <div class="col-md-4">
                                    <strong>
                                        <label>Difference :</label>
                                        <span id="difference">0.000
                                        </span>
                                    </strong>
                                </div>
                                <div class="col-md-8">
                                </div>
                                <div class="col-md-4">

                                </div>
                            </div>
                            <button class="btn btn-cust1 float-right" type="submit">Update
                                Journal Voucher</button>
                        </form>


                    </div>
                </div>
            </div>
        </div>
    </div>
    <!-- end row -->


    <!-- Modals -->
    <div id="modal1" class="modal fade" tabindex="-1" role="dialog" aria-labelledby="modal1Label" aria-hidden="true">
        <div class="modal-dialog" role="document">
            <div class="modal-content">
                <div class="modal-header">
                    <h5 class="modal-title" id="modal1Label">Add New Account</h5>
                    <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                        <span aria-hidden="true">&times;</span>
                    </button>
                </div>
                <div class="modal-body">
                    <p>Form Will Be visible</p>
                </div>
                <div class="modal-footer">
                    <button type="button" class="btn btn-secondary" data-dismiss="modal">Close</button>
                </div>
            </div>
        </div>
    </div>

    <div id="modal2" class="modal fade" tabindex="-1" role="dialog" aria-labelledby="modal2Label"
        aria-hidden="true">
        <div class="modal-dialog" role="document">
            <div class="modal-content">
                <div class="modal-header">
                    <h5 class="modal-title" id="modal2Label">Modal 2</h5>
                    <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                        <span aria-hidden="true">&times;</span>
                    </button>
                </div>
                <div class="modal-body">
                    <p>This is Modal 2</p>
                </div>
                <div class="modal-footer">
                    <button type="button" class="btn btn-secondary" data-dismiss="modal">Close</button>
                </div>
            </div>
        </div>
    </div>

    <div id="modal3" class="modal fade" tabindex="-1" role="dialog" aria-labelledby="modal3Label"
        aria-hidden="true">
        <div class="modal-dialog" role="document">
            <div class="modal-content">
                <div class="modal-header">
                    <h5 class="modal-title" id="modal3Label">Modal 3</h5>
                    <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                        <span aria-hidden="true">&times;</span>
                    </button>
                </div>
                <div class="modal-body">
                    <p>This is Modal 3</p>
                </div>
                <div class="modal-footer">
                    <button type="button" class="btn btn-secondary" data-dismiss="modal">C lose</button>
                </div>
            </div>
        </div>
    </div>

    <script src="https://code.jquery.com/jquery-3.7.0.js" integrity="sha256-JlqSTELeR4TLqP0OG9dxM7yDPqX1ox/HfgiSLBj8+kM="
        crossorigin="anonymous"></script>

    <script>
        $(document).ready(function() {
            // Event handler for the add-clone-btn click
            $(document).on('click', '.add-clone-btn', function(e) {
                e.preventDefault();

                // Get the parent <tr> element
                var parentTr = $(this).closest('tr');

                // Clone the parent <tr> element
                var clonedTr = parentTr.clone();

                // Append the cloned <tr> after the parent <tr>
                parentTr.after(clonedTr);
            });
        });

        $(document).ready(function() {
            // $('#add-more-btn').click(function(e) {
            //     e.preventDefault();

            //     // Clone the existing row
            //     var newRow = $('#table-body tr').first().clone();

            //     // Clear input fields and select values in the cloned row
            //     newRow.find('input, textarea').val('');
            //     newRow.find('select').prop('selectedIndex', 0);

            //     // Append the cloned row to the table
            //     $('#table-body').append(newRow);
            // });

            // $('#add-clone-btn').click(function(e) {
            //     e.preventDefault();

            //     // Clone the existing row
            //     var newRow = $('#table-body tr').first().clone();

            //     // Clear input fields and select values in the cloned row
            //     newRow.find('input, textarea').val('');
            //     newRow.find('select').prop('selectedIndex', 0);

            //     // Append the cloned row to the table
            //     $('#table-body').append(newRow);
            // });

            // Handle delete button click event
            $(document).on('click', '.delete-row-btn', function(e) {
                e.preventDefault();

                // Get the parent row and remove it
                var row = $(this).closest('tr');
                row.remove();
            });
        });
    </script>

    <!-- modal script -->

    <script>
        document.getElementById("modalSelect").addEventListener("change", function() {
            var selectedModal = this.value;

            // Close any open modals
            $('.modal').modal('hide');

            // Open the selected modal
            $('#' + selectedModal).modal('show');
        });
    </script>

    <script>
        // Function to update calculation values
        function updateCalculation() {
            var totalDebit = 0;
            var totalCredit = 0;

            $('select[name="type[]"]').each(function() {
                var selectedType = $(this).val();
                var amount = parseFloat($(this).closest('tr').find('input[name="amount[]"]').val());

                if (!isNaN(amount)) {
                    if (selectedType === 'debit') {
                        totalDebit += amount;
                    } else if (selectedType === 'credit') {
                        totalCredit += amount;
                    }
                }
            });

            var difference = totalDebit - totalCredit;

            $('#total-debit').text(totalDebit.toFixed({{session()->get('branch')->currency_decimal}}));
            $('#total-credit').text(totalCredit.toFixed({{session()->get('branch')->currency_decimal}}));

            $('#total-debit-val').val(totalDebit.toFixed({{session()->get('branch')->currency_decimal}}));
            $('#total-credit-val').val(totalCredit.toFixed({{session()->get('branch')->currency_decimal}}));

            $('#difference').text(difference.toFixed({{session()->get('branch')->currency_decimal}}));

            // Check if difference is not 0
            if (difference !== 0) {
                $('#difference-error').text('Difference is not 0. Form submission prevented.');
                $('#create-button').hide(); // Hide the button
            } else {
                $('#difference-error').text('');
                $('#create-button').show(); // Show the button
            }

            return difference === 0; // Return whether the form can be submitted
        }

        function attachListenersToNewRow(row) {
            row.find('select[name="type[]"], input[name="amount[]"]').on('change input', function() {
                updateCalculation();
            });

            row.find('select[name="account_id[]"]').on('change', function() {
                var selectedOption = $(this).find('option:selected');
                var accountType = selectedOption.data('account-type');
                var accountName = selectedOption.data('account-name');
                var accNo = selectedOption.data('acc-no');
                var hiddenInputAccountType = $(this).closest('tr').find('.account_type');
                if (hiddenInputAccountType.length) {
                    hiddenInputAccountType.val(accountType);
                }
                var hiddenInputAccountName = $(this).closest('tr').find('.account_name');
                if (hiddenInputAccountName.length) {
                    hiddenInputAccountName.val(accountName);
                }
                var hiddenInputAccountNo = $(this).closest('tr').find('.acc_no');
                if (hiddenInputAccountNo.length) {
                    hiddenInputAccountNo.val(accNo);
                }

            });

        }

        $(document).ready(function() {
            // Attach event listener to the form submission
            $('form.outer-repeater').submit(function(event) {
                if (!updateCalculation()) {
                    alert("The difference between debit and credit amounts is not zero.");
                    event.preventDefault(); // Prevent form submission
                }
            });

            // Initial calculation on page load
            updateCalculation();

            // Event listeners for input changes in the initial row
            attachListenersToNewRow($('#table-body tr').first());

            // Event listeners for adding new rows
            $('#add-more-btn').click(function(e) {
                e.preventDefault();

                // Clone the existing row
                var newRow = $('#table-body tr').first().clone();

                // Clear input fields and select values in the cloned row
                newRow.find('input, textarea').val('');
                newRow.find('select').prop('selectedIndex', 0);

                // Append the cloned row to the table
                $('#table-body').append(newRow);

                // Attach listeners to the new row
                attachListenersToNewRow(newRow);
            });

            // Event listener for delete button
            $(document).on('click', '.delete-row-btn', function(e) {
                e.preventDefault();

                // Get the parent row and remove it
                var row = $(this).closest('tr');
                row.remove();

                // Update calculation after deleting a row
                updateCalculation();
            });
        });
    </script>

    {{-- <script>
        document.addEventListener('DOMContentLoaded', function() {
            document.querySelectorAll('select[name="account_id[]"]').forEach(function(select) {
                select.addEventListener('change', function() {
                    var selectedOption = this.options[this.selectedIndex];
                    var accountType = selectedOption.getAttribute('data-account-type');
                    var hiddenInput = this.parentNode.nextElementSibling.querySelector(
                        '.account_type');
                    console.log(hiddenInput); // Debugging: Check if hiddenInput is null
                    if (hiddenInput) {
                        hiddenInput.value = accountType;
                    }
                });
            });
        });
    </script> --}}

    @php
    use App\Branches;
    use Carbon\Carbon;

    $selectedBranchId = session('selected_branch');

    $branch = Branches::where('id', $selectedBranchId)->first();
@endphp

<script>
    @if (!empty($selectedBranchId))
        document.addEventListener("DOMContentLoaded", function() {
            var periodClosings = <?php echo json_encode($periodClosings); ?>;

            function isBeforePeriodClosing(date) {
                var selectedDate = new Date(date);
                for (var i = 0; i < periodClosings.length; i++) {
                    var closingDate = new Date(periodClosings[i]);
                    if (selectedDate < closingDate) {
                        return true;
                    }
                }
                return false;
            }

            function setColor(dateInput) {
                var selectedDate = dateInput.value;
                if (isBeforePeriodClosing(selectedDate)) {
                    dateInput.style.backgroundColor = 'lightgrey';
                } else {
                    dateInput.style.backgroundColor = '';
                }
            }

            var periodClosingDateInputs = document.querySelectorAll('.PeriodClosingDate');
            periodClosingDateInputs.forEach(function(input) {
                input.addEventListener('change', function() {
                    setColor(this);
                    if (isBeforePeriodClosing(this.value)) {
                        @if (!Branches::hasBranchPermission($selectedBranchId, 'Back Dated Entry As Per User Credentials'))
                            window.alert("Do you want to enter a closing period? Please contact admin.");
                            this.value = '';
                        @else
                            window.alert("Do you want to enter a closing period?");
                        @endif
                    }
                });
                setColor(input);
            });
        });
    @endif
</script>

@endsection
