@extends('layouts.crusher')
@section('content')
    <div class="row">
        <div class="col-md-12">
            <div class="row mt-4 mb-1">
                <div class="col-md-6">
                    <h6 class="card-title mb-4 titlcust">View Warehouse Transfer</h6>
                </div>
                <div class="col-md-6">
                    <a href="">
                        <button class="btn btn-outline-primary float-right cust-btn1" onclick="printPageArea('printableArea')"
                            type="submit">Print Document
                        </button>
                    </a>
                </div>
            </div>
            <div class="card" id="printableArea">
                <div class="card-body">

                    <h6 class="card-title mb-1 text-center font-size-20">Warehouse Transfer</h6>
                    <br>


                    @if (!empty(($companyLogo = auth()->user()->company_logo)))
                        <div class="col-md-12 d-flex align-items-center justify-content-center">
                            <img src="{{ asset('storage/app/public/' . $companyLogo) }}" class="img-fluid" alt="logo"
                                width="270px">
                        </div>
                    @else
                        {{-- <div class="col-md-12 d-flex align-items-center justify-content-center mb-3">
                            <img src="{{ asset('assets/images/acp-logo.svg') }}" class="img-fluid" alt="logo"
                                width="270px">
                        </div> --}}
                    @endif

                    <div class="row">
                        <div class="col-md-9 pt-2"
                            style="border-top: solid;border-bottom: solid;border-left: solid;border-color: black;padding: 0;">
                            <p class="text-dark font-weight-bold" style="padding: 5px;margin:0"><strong>Company Name:
                                </strong> {{ $company->name }}</p>
                            <p class="text-dark font-weight-bold" style="padding: 5px;margin:0"><strong>Branch Name:
                                </strong> {{ session()->get('branch')->name }}</p>
                            <p class="text-dark font-weight-bold" style="padding: 5px;margin:0"><strong>Branch
                                    Address</strong> {{ session()->get('branch')->address }}</p>
                            <p class="text-dark font-weight-bold" style="padding: 5px;margin:0"><strong>Company
                                    Country</strong> {{ $company->country }}</p>
                            <p class="text-dark font-weight-bold" style="padding: 5px;margin:0"><strong>Company CR
                                    Number</strong> {{ $company->cr_number }}</p>
                            <p class="text-dark font-weight-bold" style="padding: 5px;margin:0"><strong>Company VAT
                                    Number</strong> {{ $company->vat_number }}</p>
                        </div>
                        <div class="col-md-3 pt-2"
                            style="border-top: solid;border-right: solid;border-bottom: solid;border-left: solid;border-color: black;padding: 0;">
                            <p class="text-dark font-weight-bold"
                                style="border-bottom: solid;border-color: black;padding: 5px;margin:0;"><strong>Date :
                                </strong> {{ date('d/m/Y', strtotime($warehouseTransfer[0]->date)) }}</p>
                            <p class="text-dark font-weight-bold"
                                style="border-bottom: solid;border-color: black;padding: 5px;margin:0;"><strong>Warehouse
                                    Transfer # : </strong> {{ $warehouseTransfer[0]->invoice_no }}</p>
                            {{-- <p class="text-dark font-weight-bold" style="border-bottom: solid;border-color: black;padding: 5px;margin:0;"><strong>Mode/Term of Payment : </strong> {{ $warehouseTransfer[0]->term_of_payment }}</p> --}}
                            {{-- <p class="text-dark font-weight-bold" style="border-bottom: solid;border-color: black;padding: 5px;margin:0;"><strong>LPO Number(Supplier) : </strong> {{ $warehouseTransfer[0]->lpo_no }}</p> --}}
                            {{-- <p class="text-dark font-weight-bold" style="border-bottom: solid;border-color: black;padding: 5px;margin:0;"><strong>Warehouse Transfer : </strong> {{ $warehouseTransfer[0]->po_no ?? '' }}</p> --}}
                            {{-- <p class="text-dark font-weight-bold" style="border-bottom: solid;border-color: black;padding: 5px;margin:0;"><strong>LPO(DUE DAYS) : </strong> {{ $warehouseTransfer[0]->lpo_days }}</p> --}}
                        </div>
                    </div>
                    <div class="row">
                        <div class="table-responsive mb-0 pb-0">
                            <table class="table table-striped table-bordered dt-responsive nowrap mb-0"
                                style="border-bottom: solid;border-left: solid;border-right: solid;border-left: solid;border-color: black;padding: 0;">
                                <thead>
                                    <tr style="background-color: lightgray;color:black;border-color: black">
                                        <th style="border: none">S No.</th>
                                        <th style="border: none">Item Name</th>
                                        <th style="border: none">Form Warehouse</th>
                                        <th style="border: none">To Warehouse</th>
                                    </tr>
                                </thead>
                                <tbody id="table-body">

                                    @forelse ($warehouseTransfer as $key=>$wt)
                                        <tr>
                                            <td class="border border-dark">{{ $key + 1 }}</td>
                                            <td class="border border-dark">{{ $wt->item->name }}</td>
                                            <td class="border border-dark">{{ $wt->warehouseFrom->name }}</td>
                                            <td class="border border-dark">{{ $wt->warehouseTo->name }}</td>
                                        </tr>
                                    @empty
                                    @endforelse
                                </tbody>
                            </table>
                        </div>
                    </div>

                    <div class="row">
                        <div class="col-md-6 pt-2 d-flex flex-column justify-content-end"
                            style="border-bottom: solid; border-left: solid; border-color: black; padding: 0; height: 150px;">
                            <p class="text-dark font-weight-bold text-left" style="padding: 5px; margin: 0;"><strong>Client
                                    Signature & Stamp</strong></p>
                        </div>


                        <div class="col-md-6 pt-2 d-flex flex-column justify-content-end"
                            style="border-bottom: solid;border-right: solid;border-color: black;padding: 0;height: 150px;">
                            <p class="text-dark font-weight-bold mt-5 text-right" style="padding: 5px;margin:0">
                                <strong>{{ $company->name }}</strong></p>
                        </div>
                    </div>
                    <div class="row">
                        <div class="col-md-12 pt-2 d-flex flex-column justify-content-center alien-item-center">
                            <p class="text-dark font-weight-bold text-center" style="padding: 5px; margin: 0;">
                                <strong>Generated by Ledgematic.com</strong></p>
                        </div>
                    </div>


                    {{-- <div class="row border1">
                            @if (!empty(($companyLogo = auth()->user()->company_logo)))
                                <div class="col-md-2 d-flex align-items-center justify-content-center">
                                    <img src="{{ asset('storage/app/public/' . $companyLogo) }}" class="img-fluid"
                                        alt="logo" width="180px">
                                </div>
                            @else
                                <div class="col-md-2 d-flex align-items-center justify-content-center">
                                    <img src="{{ asset('assets/images/acp-logo.png') }}" class="img-fluid" alt="logo"
                                        width="180px">
                                </div>
                            @endif
                            <div class="col-md-6">
                                <div class="row border1">
                                    <div class="pading1">
                                        <div class="col-md-12 ">
                                            <span>{{ $company->name }}</span>
                                        </div>
                                        <div class="col-md-12 ">
                                            <span>{{ $company->country }}</span>
                                        </div>
                                        <div class="col-md-12">
                                            <label>Branch Name :</label>
                                            <span>{{ session()->get('branch')->name }}</span>
                                        </div>
                                        <div class="col-md-12">
                                            <label>Branch Address :</label>
                                            <span>{{ session()->get('branch')->address }}</span>
                                        </div>
                                        <div class="col-md-12">
                                            <label>Cr Number :</label>
                                            <span>{{ $company->cr_number }}</span>
                                        </div>
                                        <div class="col-md-12">
                                            <label>VAT Number :</label>
                                            <span>{{ $company->vat_number }}</span>
                                        </div>

                                    </div>
                                </div>
                            </div>
                            <div class="col-md-4">
                                <div class="row border1">
                                    <div class="pading1">
                                        <div class="col-md-12">
                                            <label>WST # :</label>
                                            <span>{{ $warehouseTransfer[0]->invoice_no }}</span>
                                        </div>
                                        <div class="col-md-12">
                                            <label>Date :</label>
                                            <span>{{ $warehouseTransfer[0]->date }}</span>
                                        </div>
                                    </div>
                                </div>
                            </div>
                        </div> --}}


                    {{-- <div class="table-responsive mb-0" data-pattern="priority-columns">
                            <table class="table table-bordered dt-responsive nowrap">
                                <tr>
                                    <td>
                                        <table class="table table-bordered dt-responsive nowrap">
                                            <tr>
                                                <td>
                                                    @if (!empty(($companyLogo = auth()->user()->company_logo)))
                                                    <div class="col-md-12 d-flex align-items-center justify-content-center">
                                                        <img src="{{ asset('storage/app/public/' . $companyLogo) }}" class="img-fluid"
                                                            alt="logo" width="700px">
                                                        </div>
                                                    @else
                                                        <div class="col-md-12 d-flex align-items-center justify-content-center">
                                                            <img src="{{ asset('assets/images/acp-logo.png') }}" class="img-fluid" alt="logo"
                                                                width="700px">
                                                        </div>
                                                    @endif
                                                </td>
                                                <td colspan="2">
                                                    <div class="row">
                                                        <div class="col-md-12 ">
                                                            <label>Company Name :</label>
                                                            <span>{{ $company->name }}</span>
                                                        </div>
                                                        <div class="col-md-12">
                                                            <label>Branch Name :</label>
                                                            <span>{{ session()->get('branch')->name }}</span>
                                                        </div>
                                                        <div class="col-md-12">
                                                            <label>Branch Address :</label>
                                                            <span>{{ session()->get('branch')->address }}</span>
                                                        </div>
                                                        <div class="col-md-12">
                                                            <label>Company Country :</label>
                                                            <span>{{ $company->country }}</span>
                                                        </div>
                                                        <div class="col-md-12">
                                                            <label>Company CR Number :</label>
                                                            <span>{{ $company->cr_number }}</span>
                                                        </div>
                                                        <div class="col-md-12">
                                                            <label>Company Vat Number :</label>
                                                            <span>{{ $company->vat_number }}</span>
                                                        </div>
                                                    </div>
                                                </td>
                                            </tr>

                                        </table>
                                    </td>
                                    <td>
                                        <table class="table table-bordered dt-responsive nowrap">
                                            <tr>
                                                <td>
                                                    <div class="row">
                                                        <div class="col-md-12">
                                                            <label>WST # :</label>
                                                            <span>{{ $warehouseTransfer[0]->invoice_no }}</span>
                                                        </div>
                                                        <div class="col-md-12">
                                                            <label>Date :</label>
                                                            <span>{{ $warehouseTransfer[0]->date }}</span>
                                                        </div>
                                                    </div>
                                                </td>
                                            </tr>

                                    </table>
                                    </td>
                                </tr>
                            </table>
                        </div>

                        <br> --}}


                    {{-- <div class="row">
                            <div class="table-responsive mb-0" data-pattern="priority-columns">
                                <table class="table table-bordered dt-responsive nowrap"
                                    style="border-collapse: collapse; border-spacing: 0; width: 100%;">
                                    <thead>
                                        <tr>
                                            <th>S No.</th>
                                            <th>Item Name</th>
                                            <th>Form Warehouse</th>
                                            <th>To Warehouse</th>
                                        </tr>
                                    </thead>

                                    <tbody id="table-body">
                                        @forelse ($warehouseTransfer as $key=>$wt)
                                            <tr>
                                                <td>{{ $key + 1 }}</td>
                                                <td>
                                                    <p>{{ $wt->item->name }}</p>
                                                </td>
                                                <td>
                                                    <p>{{ $wt->warehouseFrom->name }}</p>
                                                </td>
                                                <td>
                                                    <p>{{ $wt->warehouseTo->name }}</p>
                                                </td>
                                            </tr>
                                        @empty
                                        @endforelse
                                    </tbody>
                                </table>
                            </div>
                        </div>
                        </form> --}}

                </div>
            </div>
        </div>
    </div>
    {{-- </div> --}}
    <!-- end row -->


    <script>
        function printPageArea(areaID) {
            var printContent = document.getElementById(areaID).innerHTML;
            var originalContent = document.body.innerHTML;
            document.body.innerHTML = printContent;
            window.print();
            document.body.innerHTML = originalContent;
        }
    </script>
@endsection
