<?php

namespace App\Services;
use Illuminate\Http\Request;
use App\ClassOfAccount;
use App\Customer;
use App\Supplier;
use App\Expense;
use App\AdminOtherAccount;
use App\AdminPurchaesInvoice;
use App\AdminSalesInvoice;
use App\ReceiptVoucherExpense;
use App\PaymentVoucherExpense;
use App\AdminJournalVoucher;
use App\StaffAndSalesman;
use App\CreditNote;
use App\DebitNote;
use Illuminate\Support\Facades\DB;

class AllAccountsObWithTransactionService
{

     // -----   Capital Account   ------------------------------------------------------------- >>>>>>>>>>>>>>>>>>

     public function AllCapitalAccountClassofAccounts($request, $from_date, $to_date)
     {

         $from_date = $request->from_date;
         $to_date = $request->to_date;

         $currentYearFirstDate = date("2003-01-01");
         $oneDayPreviousDate = date('Y-m-d', strtotime('-1 day', strtotime($from_date)));

         $opcustomers = Customer::where('branch_id', session()->get('selected_branch'))
             ->where('class_of_account_id', 2)
             ->get(['id', 'class_of_account_id','name_of_organisation as account_name','opening_balance','type','date']);

         $opsuppliers = Supplier::where('branch_id', session()->get('selected_branch'))
             ->where('class_of_account_id', 2)
             ->get(['id', 'class_of_account_id','name_of_organisation as account_name','opening_balance','type','date']);

         $opexpenses = Expense::where('branch_id', session()->get('selected_branch'))
             ->where('class_of_account_id',2)
             ->get(['id', 'class_of_account_id','account_name','opening_balance','type','date']);

         $opadminOtherAccounts = AdminOtherAccount::where('branch_id', session()->get('selected_branch'))
             ->where('class_of_account_id', 2)
             ->get(['id', 'class_of_account_id','account_name','opening_balance','type','date']);

         $opstaffAndSalesman = StaffAndSalesman::where('branch_id', session()->get('selected_branch'))
             ->where('class_of_account_id', 2)
             ->selectRaw('id, class_of_account_id, CONCAT(first_name, " ", last_name) as account_name,date_of_joining as date')
             ->get();

         $opAllAccounts = $opcustomers->concat($opsuppliers)->concat($opexpenses)->concat($opadminOtherAccounts)->concat($opstaffAndSalesman);

         // dd($opAllAccounts);

         $opAccountDetails = [];

         foreach ($opAllAccounts as $opAccount) {
             $opDebitOBalance = 0;
             $opCreditOBalance = 0;
             $opCreateDebitOpeningBalance = 0;
             $opCreateCreditOpeningBalance = 0;
             $debitAllAccountsDate = 0;
             $creditAllAccountsDate = 0;

             if (($opAccount->type === 'Debit' || $opAccount->type === 'debit') && $opAccount->date >= $currentYearFirstDate && $opAccount->date <= $oneDayPreviousDate) {
                 $debitAllAccountsDate = $opAccount->date;
                 $opCreateDebitOpeningBalance = $opAccount->opening_balance;

             } elseif (($opAccount->type === 'Credit' || $opAccount->type === 'credit') && $opAccount->date >= $currentYearFirstDate && $opAccount->date <= $oneDayPreviousDate) {
                 $creditAllAccountsDate = $opAccount->date;
                 $opCreateCreditOpeningBalance = $opAccount->opening_balance;

             }

          // dd($DebitOB,$CreditOB,$debitAllAccountsDate,$creditAllAccountsDate);

          $opPurchaesInvoiceTotalNetAmount = AdminPurchaesInvoice::where('account_name', $opAccount->account_name)
              ->where('branch_id', session()->get('selected_branch'))
              ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
              ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
              ->whereNull('deleted_at')
              ->groupBy('invoice_no')
              ->get()
              ->sum('total_net_amount');

          $opSaleInvoiceTotalNetAmount = AdminSalesInvoice::where('account_name', $opAccount->account_name)
              ->where('branch_id', session()->get('selected_branch'))
              ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
              ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
              ->whereNull('deleted_at')
              ->groupBy('invoice_no')
              ->get()
              ->sum('total_net_amount');

          $opReceiptVoucherTotalNetAmountForCash = ReceiptVoucherExpense::where('account_name', $opAccount->account_name)
              ->where('branch_id', session()->get('selected_branch'))
             //  ->where('payment_method','cash')
              ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
              ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
              ->whereNull('deleted_at')
              ->groupBy('invoice_no')
              ->get()
              ->sum('amount');
          $opReceiptVoucherTotalNetAmountForBank = ReceiptVoucherExpense::
               where('bank_name', $opAccount->account_name)
              ->where('branch_id', session()->get('selected_branch'))
             //  ->where('payment_method','bank')
              ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
              ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
              ->whereNull('deleted_at')
              ->groupBy('invoice_no')
              ->get()
              ->sum('amount');

          $opPaymentVoucherTotalNetAmountForBank = PaymentVoucherExpense::
               where('bank_name', $opAccount->account_name)
              ->where('branch_id', session()->get('selected_branch'))
             //  ->where('payment_method','bank')
              ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
              ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
              ->whereNull('deleted_at')
              ->groupBy('invoice_no')
              ->get()
              ->sum(function ($voucher) {
                  return $voucher->amount + $voucher->new_vat_amount;
              });
          $opPaymentVoucherTotalNetAmountForCash = PaymentVoucherExpense::where('account_name', $opAccount->account_name)
              ->where('branch_id', session()->get('selected_branch'))
             //  ->where('payment_method','cash')
              ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
              ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
              ->whereNull('deleted_at')
              ->groupBy('invoice_no')
              ->get()
              ->sum(function ($voucher) {
                  return $voucher->amount + $voucher->new_vat_amount;
              });

              // dd($PaymentVoucherTotalNetAmountForBank,$PaymentVoucherTotalNetAmountForCash);

          $opCreditNoteTotalNetAmount = CreditNote::where('account_name', $opAccount->account_name)
              ->where('branch_id', session()->get('selected_branch'))
              ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
              ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
              ->groupBy('invoice_no')
              ->sum('total_net_amount');

          $opDebitNoteTotalNetAmount = DebitNote::where('account_name', $opAccount->account_name)
              ->where('branch_id', session()->get('selected_branch'))
              ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
              ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
              ->groupBy('invoice_no')
              ->sum('total_net_amount');

          $opJournalVoucherNetAmountForDebit = AdminJournalVoucher::where('account_name', $opAccount->account_name)
              ->where('branch_id', session()->get('selected_branch'))
              ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
              ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
              ->where('type','debit')
              ->groupBy('invoice_no')
              ->get()
              ->sum('amount');
          $opJournalVoucherNetAmountForCredit = AdminJournalVoucher::where('account_name', $opAccount->account_name)
              ->where('branch_id', session()->get('selected_branch'))
              ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
              ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
              ->where('type','credit')
              ->groupBy('invoice_no')
              ->get()
              ->sum('amount');

          $opDebitOBalance += $opCreateDebitOpeningBalance + $opSaleInvoiceTotalNetAmount + $opDebitNoteTotalNetAmount + $opPaymentVoucherTotalNetAmountForCash + $opJournalVoucherNetAmountForDebit + $opReceiptVoucherTotalNetAmountForBank;

          $opCreditOBalance += $opCreateCreditOpeningBalance + $opPurchaesInvoiceTotalNetAmount + $opCreditNoteTotalNetAmount + $opJournalVoucherNetAmountForCredit + $opReceiptVoucherTotalNetAmountForCash + $opPaymentVoucherTotalNetAmountForBank;


          $opAccountDetails[$opAccount->class_of_account_id][] = [
              'account_id' => $opAccount->id,
              'accoun_name' => $opAccount->name_of_organisation ?? $opAccount->account_name,
              'type' => $opAccount->type,
              'class_of_account_id' => $opAccount->class_of_account_id,
              'DebitBalance' => $opDebitOBalance,
              'CreditBalance' => $opCreditOBalance,
          ];
          }

         // from_date to to_date - date range data


         $customers = Customer::where('branch_id', session()->get('selected_branch'))
         ->where('class_of_account_id', 2)
         ->get(['id', 'class_of_account_id', 'name_of_organisation as account_name', 'opening_balance', 'type', 'date']);



         $suppliers = Supplier::where('branch_id', session()->get('selected_branch'))
             ->where('class_of_account_id', 2)
             ->get(['id', 'class_of_account_id','name_of_organisation as account_name','opening_balance','type','date']);

         $expenses = Expense::where('branch_id', session()->get('selected_branch'))
             ->where('class_of_account_id', 2)
             ->get(['id', 'class_of_account_id','account_name','opening_balance','type','date']);

         $adminOtherAccounts = AdminOtherAccount::where('branch_id', session()->get('selected_branch'))
             ->where('class_of_account_id', 2)
             ->get(['id', 'class_of_account_id','account_name','opening_balance','type','date']);

         $staffAndSalesman = StaffAndSalesman::where('branch_id', session()->get('selected_branch'))
             ->where('class_of_account_id', 2)
             ->selectRaw('id, class_of_account_id, CONCAT(first_name, " ", last_name) as account_name,date_of_joining as date,type')
             ->get();


         // $halfFirstAccounts = $customers->concat($suppliers)->concat($expenses);
         // $halfSecondAccounts = $adminOtherAccounts->concat($staffAndSalesman);

         $allAccounts = $customers->concat($suppliers)->concat($expenses)->concat($adminOtherAccounts)->concat($staffAndSalesman);


         // from_date to to_date - date range data

         $accountDetails = [];

         foreach ($allAccounts as $account) {
             $DebitOB = 0;
             $CreditOB = 0;
             $CreateDebitOpeningBalance = 0;
             $CreateCreditOpeningBalance = 0;
             $debitAllAccountsDate = 0;
             $creditAllAccountsDate = 0;

             if (($account->type === 'Debit' || $account->type === 'debit') && $account->date >= $from_date && $account->date <= $to_date) {
                 $debitAllAccountsDate = $account->date;
                 $CreateDebitOpeningBalance = $account->opening_balance;

             } elseif (($account->type === 'Credit' || $account->type === 'credit') && $account->date >= $from_date && $account->date <= $to_date) {
                 $creditAllAccountsDate = $account->date;
                 $CreateCreditOpeningBalance = $account->opening_balance;

             }

             $ReceiptVoucherTotalNetAmountForCash = ReceiptVoucherExpense::where('account_name', $account->account_name)
                 ->where('branch_id', session()->get('selected_branch'))
                 ->where('date', '>=', $from_date . ' 00:00:00')
                 ->where('date', '<=', $to_date . ' 23:59:59')
                 ->whereNull('deleted_at')
                 ->groupBy('invoice_no')
                 ->get()
                 ->sum('amount');

             $ReceiptVoucherTotalNetAmountForBank = ReceiptVoucherExpense::where('bank_name', $account->account_name)
                 ->where('branch_id', session()->get('selected_branch'))
                 ->where('date', '>=', $from_date . ' 00:00:00')
                 ->where('date', '<=', $to_date . ' 23:59:59')
                 ->whereNull('deleted_at')
                 ->groupBy('invoice_no')
                 ->get()
                 ->sum('amount');

             $PurchaesInvoiceTotalNetAmount = AdminPurchaesInvoice::where('account_name', $account->account_name)
                 ->where('branch_id', session()->get('selected_branch'))
                 ->where('date', '>=', $from_date . ' 00:00:00')
                 ->where('date', '<=', $to_date . ' 23:59:59')
                 ->whereNull('deleted_at')
                 ->groupBy('invoice_no')
                 ->get()
                 ->sum('total_net_amount');

             $SaleInvoiceTotalNetAmount = AdminSalesInvoice::where('account_name', $account->account_name)
                 ->where('branch_id', session()->get('selected_branch'))
                 ->where('date', '>=', $from_date . ' 00:00:00')
                 ->where('date', '<=', $to_date . ' 23:59:59')
                 ->whereNull('deleted_at')
                 ->groupBy('invoice_no')
                 ->get()
                 ->sum('total_net_amount');



             $PaymentVoucherTotalNetAmountForBank = PaymentVoucherExpense::where(function($query) use ($account) {
                 $query->where('bank_name', $account->account_name);
                 })
                 ->where('branch_id', session()->get('selected_branch'))
                 ->where('date', '>=', $from_date . ' 00:00:00')
                 ->where('date', '<=', $to_date . ' 23:59:59')
                 ->whereNull('deleted_at')
                 ->groupBy('invoice_no')
                 ->get()
                 ->sum(function ($voucher) {
                     return $voucher->amount + $voucher->new_vat_amount;
                 });
             $PaymentVoucherTotalNetAmountForCash = PaymentVoucherExpense::where(function($query) use ($account) {
                 $query->where('account_name', $account->account_name);
                 })
                 ->where('branch_id', session()->get('selected_branch'))
                 ->where('date', '>=', $from_date . ' 00:00:00')
                 ->where('date', '<=', $to_date . ' 23:59:59')
                 ->whereNull('deleted_at')
                 ->groupBy('invoice_no')
                 ->get()
                 ->sum(function ($voucher) {
                     return $voucher->amount + $voucher->new_vat_amount;
                 });

                 // dd($PaymentVoucherTotalNetAmountForBank,$PaymentVoucherTotalNetAmountForCash);

             $CreditNoteTotalNetAmount = CreditNote::where('account_name', $account->account_name)
                 ->where('branch_id', session()->get('selected_branch'))
                 ->where('date', '>=', $from_date . ' 00:00:00')
                 ->where('date', '<=', $to_date . ' 23:59:59')
                 ->groupBy('invoice_no')
                 ->get()
                 ->sum('total_net_amount');
             // dd($CreditNoteTotalNetAmount);
             $DebitNoteTotalNetAmount = DebitNote::where('account_name', $account->account_name)
                 ->where('branch_id', session()->get('selected_branch'))
                 ->where('date', '>=', $from_date . ' 00:00:00')
                 ->where('date', '<=', $to_date . ' 23:59:59')
                 ->groupBy('invoice_no')
                 ->sum('total_net_amount');

             $JournalVoucherNetAmountForDebit = AdminJournalVoucher::where('account_name', $account->account_name)
                 ->where('branch_id', session()->get('selected_branch'))
                 ->where('date', '>=', $from_date . ' 00:00:00')
                 ->where('date', '<=', $to_date . ' 23:59:59')
                 ->where('type','debit')
                 ->whereNull('deleted_at')
                 ->groupBy('invoice_no')
                 ->get()
                 ->sum('amount');
             $JournalVoucherNetAmountForCredit = AdminJournalVoucher::where('account_name', $account->account_name)
                 ->where('branch_id', session()->get('selected_branch'))
                 ->where('date', '>=', $from_date . ' 00:00:00')
                 ->where('date', '<=', $to_date . ' 23:59:59')
                 ->where('type','credit')
                 ->whereNull('deleted_at')
                 ->groupBy('invoice_no')
                 ->get()
                 ->sum('amount');

                 // dd($ReceiptVoucherTotalNetAmountForCash,$ReceiptVoucherTotalNetAmountForBank);

             // dd($JournalVoucherNetAmountForDebit,$JournalVoucherNetAmountForCredit);

             $DebitOB += $CreateDebitOpeningBalance +  $SaleInvoiceTotalNetAmount + $DebitNoteTotalNetAmount + $PaymentVoucherTotalNetAmountForCash  + $JournalVoucherNetAmountForDebit + $ReceiptVoucherTotalNetAmountForBank;

             $CreditOB += $CreateCreditOpeningBalance + $PurchaesInvoiceTotalNetAmount + $CreditNoteTotalNetAmount + $JournalVoucherNetAmountForCredit + $ReceiptVoucherTotalNetAmountForCash + $PaymentVoucherTotalNetAmountForBank;



             $accountDetails[$account->class_of_account_id][] = [
                 'account_id' => $account->id,
                 'accoun_name' => $account->name_of_organisation ?? $account->account_name,
                 'type' => $account->type,
                 'class_of_account_id' => $account->class_of_account_id,
                 'DebitBalance' => $DebitOB,
                 'CreditBalance' => $CreditOB,
             ];
             }

            //  $CapitalAccountDetails = [];

            //  foreach ($opAccountDetails as $classId => $accounts) {
            //      foreach ($accounts as $account) {
            //          $CapitalAccountDetails[$account['account_id']] = $account;
            //      }
            //  }

            //  foreach ($accountDetails as $classId => $accounts) {
            //      foreach ($accounts as $account) {
            //          $CapitalAccountDetails[$account['account_id']] = $account;
            //      }
            //  }

            //  foreach ($CapitalAccountDetails as &$account) {
            //      $netBalance = $account['DebitBalance'] - $account['CreditBalance'];

            //      if ($netBalance > 0) {
            //          $account['DebitBalance'] = $netBalance;
            //          $account['CreditBalance'] = 0;
            //      } else {
            //          $account['CreditBalance'] = abs($netBalance);
            //          $account['DebitBalance'] = 0;
            //      }
            //  }

            $CapitalAccountDetails = [];

            // Merging accountDetails into mergedAccountDetails
            foreach ($accountDetails as $classId => $accounts) {
             foreach ($accounts as $account) {
                 $accountName = $account['accoun_name'];
                 if (!isset($CapitalAccountDetails[$accountName])) {
                     $CapitalAccountDetails[$accountName] = $account;
                 } else {
                     // Sum the DebitBalance and CreditBalance
                     $CapitalAccountDetails[$accountName]['DebitBalance'] += $account['DebitBalance'];
                     $CapitalAccountDetails[$accountName]['CreditBalance'] += $account['CreditBalance'];
                 }
             }
         }

         // Merging opAccountDetails into mergedAccountDetails
         foreach ($opAccountDetails as $classId => $accounts) {
             foreach ($accounts as $account) {
                 $accountName = $account['accoun_name'];
                 if (!isset($CapitalAccountDetails[$accountName])) {
                     $CapitalAccountDetails[$accountName] = $account;
                 } else {
                     // Sum the DebitBalance and CreditBalance
                     $CapitalAccountDetails[$accountName]['DebitBalance'] += $account['DebitBalance'];
                     $CapitalAccountDetails[$accountName]['CreditBalance'] += $account['CreditBalance'];
                 }
             }
         }



         // Calculate the difference between DebitBalance and CreditBalance for each account
         foreach ($CapitalAccountDetails as &$account) {
             $account['BalanceDifference'] = $account['DebitBalance'] - $account['CreditBalance'];
         }
         unset($account); // Unset reference to avoid potential bugs

         // dd($mergedAccountDetails);

             $CapitalAccountTotalDebit = array_sum(array_column($CapitalAccountDetails, 'DebitBalance'));
             $CapitalAccountTotalCredit = array_sum(array_column($CapitalAccountDetails, 'CreditBalance'));

            //  dd([
            //      'CapitalAccountTotalDebit' => $CapitalAccountTotalDebit,
            //      'CapitalAccountTotalCredit' => $CapitalAccountTotalCredit
            //  ]);

             return [$CapitalAccountDetails,$CapitalAccountTotalDebit,$CapitalAccountTotalCredit,$from_date, $to_date,];

     }

    // -----   Syndry Debtors ------------------------------------------------------------- >>>>>>>>>>>>>>>>>>

    public function AllSundryDebtorsClassofAccounts($request, $from_date, $to_date)
    {

        $from_date = $request->from_date;
        $to_date = $request->to_date;

        $currentYearFirstDate = date("2003-01-01");
        $oneDayPreviousDate = date('Y-m-d', strtotime('-1 day', strtotime($from_date)));

        $opcustomers = Customer::where('branch_id', session()->get('selected_branch'))
            ->where('class_of_account_id', 16)
            ->get(['id', 'class_of_account_id','name_of_organisation as account_name','opening_balance','type','date']);

        $opsuppliers = Supplier::where('branch_id', session()->get('selected_branch'))
            ->where('class_of_account_id', 16)
            ->get(['id', 'class_of_account_id','name_of_organisation as account_name','opening_balance','type','date']);

        $opexpenses = Expense::where('branch_id', session()->get('selected_branch'))
            ->where('class_of_account_id',16)
            ->get(['id', 'class_of_account_id','account_name','opening_balance','type','date']);

        $opadminOtherAccounts = AdminOtherAccount::where('branch_id', session()->get('selected_branch'))
            ->where('class_of_account_id', 16)
            ->get(['id', 'class_of_account_id','account_name','opening_balance','type','date']);

        $opstaffAndSalesman = StaffAndSalesman::where('branch_id', session()->get('selected_branch'))
            ->where('class_of_account_id', 16)
            ->selectRaw('id, class_of_account_id, CONCAT(first_name, " ", last_name) as account_name,date_of_joining as date')
            ->get();

        $opAllAccounts = $opcustomers->concat($opsuppliers)->concat($opexpenses)->concat($opadminOtherAccounts)->concat($opstaffAndSalesman);

        // dd($opAllAccounts);

        $opAccountDetails = [];

        foreach ($opAllAccounts as $opAccount) {
            $opDebitOBalance = 0;
            $opCreditOBalance = 0;
            $opCreateDebitOpeningBalance = 0;
            $opCreateCreditOpeningBalance = 0;
            $debitAllAccountsDate = 0;
            $creditAllAccountsDate = 0;

            if (($opAccount->type === 'Debit' || $opAccount->type === 'debit') && $opAccount->date >= $currentYearFirstDate && $opAccount->date <= $oneDayPreviousDate) {
                $debitAllAccountsDate = $opAccount->date;
                $opCreateDebitOpeningBalance = $opAccount->opening_balance;

            } elseif (($opAccount->type === 'Credit' || $opAccount->type === 'credit') && $opAccount->date >= $currentYearFirstDate && $opAccount->date <= $oneDayPreviousDate) {
                $creditAllAccountsDate = $opAccount->date;
                $opCreateCreditOpeningBalance = $opAccount->opening_balance;

            }

         // dd($DebitOB,$CreditOB,$debitAllAccountsDate,$creditAllAccountsDate);

         $opPurchaesInvoiceTotalNetAmount = AdminPurchaesInvoice::where('account_name', $opAccount->account_name)
             ->where('branch_id', session()->get('selected_branch'))
             ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
             ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
             ->whereNull('deleted_at')
             ->groupBy('invoice_no')
             ->get()
             ->sum('total_net_amount');

         $opSaleInvoiceTotalNetAmount = AdminSalesInvoice::where('account_name', $opAccount->account_name)
             ->where('branch_id', session()->get('selected_branch'))
             ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
             ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
             ->whereNull('deleted_at')
             ->groupBy('invoice_no')
             ->get()
             ->sum('total_net_amount');

         $opReceiptVoucherTotalNetAmountForCash = ReceiptVoucherExpense::where('account_name', $opAccount->account_name)
             ->where('branch_id', session()->get('selected_branch'))
            //  ->where('payment_method','cash')
             ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
             ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
             ->whereNull('deleted_at')
             ->groupBy('invoice_no')
             ->get()
             ->sum('amount');
         $opReceiptVoucherTotalNetAmountForBank = ReceiptVoucherExpense::
              where('bank_name', $opAccount->account_name)
             ->where('branch_id', session()->get('selected_branch'))
            //  ->where('payment_method','bank')
             ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
             ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
             ->whereNull('deleted_at')
             ->groupBy('invoice_no')
             ->get()
             ->sum('amount');

         $opPaymentVoucherTotalNetAmountForBank = PaymentVoucherExpense::
              where('bank_name', $opAccount->account_name)
             ->where('branch_id', session()->get('selected_branch'))
             ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
             ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
             ->groupBy('invoice_no')
             ->get()
             ->sum(function ($voucher) {
                 return $voucher->amount + $voucher->new_vat_amount;
             });
         $opPaymentVoucherTotalNetAmountForCash = PaymentVoucherExpense::where('account_name', $opAccount->account_name)
             ->where('branch_id', session()->get('selected_branch'))
             ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
             ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
             ->groupBy('invoice_no')
             ->get()
             ->sum(function ($voucher) {
                 return $voucher->amount + $voucher->new_vat_amount;
             });

            //  dd($opPaymentVoucherTotalNetAmountForCash,$opPaymentVoucherTotalNetAmountForBank);

         $opCreditNoteTotalNetAmount = CreditNote::where('account_name', $opAccount->account_name)
             ->where('branch_id', session()->get('selected_branch'))
             ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
             ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
             ->groupBy('invoice_no')
             ->get()
             ->sum('total_net_amount');

         $opDebitNoteTotalNetAmount = DebitNote::where('account_name', $opAccount->account_name)
             ->where('branch_id', session()->get('selected_branch'))
             ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
             ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
             ->groupBy('invoice_no')
             ->sum('total_net_amount');

         $opJournalVoucherNetAmountForDebit = AdminJournalVoucher::where('account_name', $opAccount->account_name)
             ->where('branch_id', session()->get('selected_branch'))
             ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
             ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
             ->where('type','debit')
             ->groupBy('invoice_no')
             ->get()
             ->sum('amount');
         $opJournalVoucherNetAmountForCredit = AdminJournalVoucher::where('account_name', $opAccount->account_name)
             ->where('branch_id', session()->get('selected_branch'))
             ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
             ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
             ->where('type','credit')
             ->groupBy('invoice_no')
             ->get()
             ->sum('amount');

         $opDebitOBalance += $opCreateDebitOpeningBalance + $opSaleInvoiceTotalNetAmount + $opDebitNoteTotalNetAmount + $opPaymentVoucherTotalNetAmountForCash + $opJournalVoucherNetAmountForDebit + $opReceiptVoucherTotalNetAmountForBank;

         $opCreditOBalance += $opCreateCreditOpeningBalance + $opPurchaesInvoiceTotalNetAmount + $opCreditNoteTotalNetAmount + $opJournalVoucherNetAmountForCredit + $opReceiptVoucherTotalNetAmountForCash + $opPaymentVoucherTotalNetAmountForBank;


         $opAccountDetails[$opAccount->class_of_account_id][] = [
             'account_id' => $opAccount->id,
             'accoun_name' => $opAccount->name_of_organisation ?? $opAccount->account_name,
             'type' => $opAccount->type,
             'class_of_account_id' => $opAccount->class_of_account_id,
             'DebitBalance' => $opDebitOBalance,
             'CreditBalance' => $opCreditOBalance,
         ];
         }

        // from_date to to_date - date range data


        $customers = Customer::where('branch_id', session()->get('selected_branch'))
        ->where('class_of_account_id', 16)
        ->get(['id', 'class_of_account_id', 'name_of_organisation as account_name', 'opening_balance', 'type', 'date']);



        $suppliers = Supplier::where('branch_id', session()->get('selected_branch'))
            ->where('class_of_account_id', 16)
            ->get(['id', 'class_of_account_id','name_of_organisation as account_name','opening_balance','type','date']);

        $expenses = Expense::where('branch_id', session()->get('selected_branch'))
            ->where('class_of_account_id', 16)
            ->get(['id', 'class_of_account_id','account_name','opening_balance','type','date']);

        $adminOtherAccounts = AdminOtherAccount::where('branch_id', session()->get('selected_branch'))
            ->where('class_of_account_id', 16)
            ->get(['id', 'class_of_account_id','account_name','opening_balance','type','date']);

        $staffAndSalesman = StaffAndSalesman::where('branch_id', session()->get('selected_branch'))
            ->where('class_of_account_id', 16)
            ->selectRaw('id, class_of_account_id, CONCAT(first_name, " ", last_name) as account_name,date_of_joining as date,type')
            ->get();


        // $halfFirstAccounts = $customers->concat($suppliers)->concat($expenses);
        // $halfSecondAccounts = $adminOtherAccounts->concat($staffAndSalesman);

        $allAccounts = $customers->concat($suppliers)->concat($expenses)->concat($adminOtherAccounts)->concat($staffAndSalesman);


        // from_date to to_date - date range data

        $accountDetails = [];

        foreach ($allAccounts as $account) {
            $DebitOB = 0;
            $CreditOB = 0;
            $CreateDebitOpeningBalance = 0;
            $CreateCreditOpeningBalance = 0;
            $debitAllAccountsDate = 0;
            $creditAllAccountsDate = 0;

            if (($account->type === 'Debit' || $account->type === 'debit') && $account->date >= $from_date && $account->date <= $to_date) {
                $debitAllAccountsDate = $account->date;
                $CreateDebitOpeningBalance = $account->opening_balance;
            }
             elseif (($account->type === 'Credit' || $account->type === 'credit') && $account->date >= $from_date && $account->date <= $to_date) {
                $creditAllAccountsDate = $account->date;
                $CreateCreditOpeningBalance = $account->opening_balance;

            }

            $ReceiptVoucherTotalNetAmountForCash = ReceiptVoucherExpense::where('account_name', $account->account_name)
                ->where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->whereNull('deleted_at')
                ->groupBy('invoice_no')
                ->get()
                ->sum('amount');

            $ReceiptVoucherTotalNetAmountForBank = ReceiptVoucherExpense::where('bank_name', $account->account_name)
                ->where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->whereNull('deleted_at')
                ->groupBy('invoice_no')
                ->get()
                ->sum('amount');

            $PurchaesInvoiceTotalNetAmount = AdminPurchaesInvoice::where('account_name', $account->account_name)
                ->where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->whereNull('deleted_at')
                ->groupBy('invoice_no')
                ->get()
                ->sum('total_net_amount');

            $SaleInvoiceTotalNetAmount = AdminSalesInvoice::where('account_name', $account->account_name)
                ->where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->whereNull('deleted_at')
                ->groupBy('invoice_no')
                ->get()
                ->sum('total_net_amount');



            $PaymentVoucherTotalNetAmountForBank = PaymentVoucherExpense::where(function($query) use ($account) {
                $query->where('bank_name', $account->account_name);
                })
                ->where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->whereNull('deleted_at')
                ->groupBy('invoice_no')
                ->get()
                ->sum(function ($voucher) {
                    return $voucher->amount + $voucher->new_vat_amount;
                });
            $PaymentVoucherTotalNetAmountForCash = PaymentVoucherExpense::where(function($query) use ($account) {
                $query->where('account_name', $account->account_name);
                })
                ->where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->whereNull('deleted_at')
                ->groupBy('invoice_no')
                ->get()
                ->sum(function ($voucher) {
                    return $voucher->amount + $voucher->new_vat_amount;
                });

                // dd($PaymentVoucherTotalNetAmountForBank,$PaymentVoucherTotalNetAmountForCash);

            $CreditNoteTotalNetAmount = CreditNote::where('account_name', $account->account_name)
                ->where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->groupBy('invoice_no')
                ->get()
                ->sum('total_net_amount');
            // dd($CreditNoteTotalNetAmount);
            $DebitNoteTotalNetAmount = DebitNote::where('account_name', $account->account_name)
                ->where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->groupBy('invoice_no')
                ->sum('total_net_amount');

            $JournalVoucherNetAmountForDebit = AdminJournalVoucher::where('account_name', $account->account_name)
                ->where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->where('type','debit')
                ->whereNull('deleted_at')
                ->groupBy('invoice_no')
                ->get()
                ->sum('amount');
            $JournalVoucherNetAmountForCredit = AdminJournalVoucher::where('account_name', $account->account_name)
                ->where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->where('type','credit')
                ->whereNull('deleted_at')
                ->groupBy('invoice_no')
                ->get()
                ->sum('amount');

                // dd($ReceiptVoucherTotalNetAmountForCash,$ReceiptVoucherTotalNetAmountForBank);

            // dd($JournalVoucherNetAmountForDebit,$JournalVoucherNetAmountForCredit);

            $DebitOB += $CreateDebitOpeningBalance + $SaleInvoiceTotalNetAmount + $DebitNoteTotalNetAmount + $PaymentVoucherTotalNetAmountForCash  + $JournalVoucherNetAmountForDebit + $ReceiptVoucherTotalNetAmountForBank;

            $CreditOB += $CreateCreditOpeningBalance + $PurchaesInvoiceTotalNetAmount + $CreditNoteTotalNetAmount + $JournalVoucherNetAmountForCredit + $ReceiptVoucherTotalNetAmountForCash + $PaymentVoucherTotalNetAmountForBank;



            $accountDetails[$account->class_of_account_id][] = [
                'account_id' => $account->id,
                'accoun_name' => $account->name_of_organisation ?? $account->account_name,
                'type' => $account->type,
                'class_of_account_id' => $account->class_of_account_id,
                'DebitBalance' => $DebitOB,
                'CreditBalance' => $CreditOB,
            ];
            }

            // $mergedAccountDetails = [];

            // foreach ($opAccountDetails as $classId => $accounts) {
            //     foreach ($accounts as $account) {
            //         $mergedAccountDetails[$account['account_id']] = $account;
            //     }
            // }

            // foreach ($accountDetails as $classId => $accounts) {
            //     foreach ($accounts as $account) {
            //         $mergedAccountDetails[$account['account_id']] = $account;
            //     }
            // }

            // foreach ($mergedAccountDetails as &$account) {
            //     $netBalance = $account['DebitBalance'] - $account['CreditBalance'];

            //     if ($netBalance > 0) {
            //         $account['DebitBalance'] = $netBalance;
            //         $account['CreditBalance'] = 0;
            //     } else {
            //         $account['CreditBalance'] = abs($netBalance);
            //         $account['DebitBalance'] = 0;
            //     }
            // }

            // dd($accountDetails,$opAccountDetails);

            $mergedAccountDetails = [];

               // Merging accountDetails into mergedAccountDetails
               foreach ($accountDetails as $classId => $accounts) {
                foreach ($accounts as $account) {
                    $accountName = $account['accoun_name'];
                    if (!isset($mergedAccountDetails[$accountName])) {
                        $mergedAccountDetails[$accountName] = $account;
                    } else {
                        // Sum the DebitBalance and CreditBalance
                        $mergedAccountDetails[$accountName]['DebitBalance'] += $account['DebitBalance'];
                        $mergedAccountDetails[$accountName]['CreditBalance'] += $account['CreditBalance'];
                    }
                }
            }

            // Merging opAccountDetails into mergedAccountDetails
            foreach ($opAccountDetails as $classId => $accounts) {
                foreach ($accounts as $account) {
                    $accountName = $account['accoun_name'];
                    if (!isset($mergedAccountDetails[$accountName])) {
                        $mergedAccountDetails[$accountName] = $account;
                    } else {
                        // Sum the DebitBalance and CreditBalance
                        $mergedAccountDetails[$accountName]['DebitBalance'] += $account['DebitBalance'];
                        $mergedAccountDetails[$accountName]['CreditBalance'] += $account['CreditBalance'];
                    }
                }
            }



            // Calculate the difference between DebitBalance and CreditBalance for each account
            foreach ($mergedAccountDetails as &$account) {
                $account['BalanceDifference'] = $account['DebitBalance'] - $account['CreditBalance'];
            }
            unset($account); // Unset reference to avoid potential bugs

            // dd($mergedAccountDetails);

            $sundryDebtorsTotalDebit = array_sum(array_column($mergedAccountDetails, 'DebitBalance'));
            $sundryDebtorsTotalCredit = array_sum(array_column($mergedAccountDetails, 'CreditBalance'));

            // dd([
            //     'sundryDebtorsTotalDebit' => $sundryDebtorsTotalDebit,
            //     'sundryDebtorsTotalCredit' => $sundryDebtorsTotalCredit
            // ]);


            return [$sundryDebtorsTotalDebit,$sundryDebtorsTotalCredit,$from_date, $to_date,];


            // dd($accountDetails,$opAccountDetails);

                // $mergedAccountDetails = [];

                // foreach ($opAccountDetails as $classId => $accounts) {
                //     foreach ($accounts as $account) {
                //         $mergedAccountDetails[$account['account_id']] = $account;
                //     }
                // }

                // foreach ($accountDetails as $classId => $accounts) {
                //     foreach ($accounts as $account) {
                //         $mergedAccountDetails[$account['account_id']] = $account;
                //     }
                // }

                // foreach ($mergedAccountDetails as $account) {
                //     $totalDebit = array_sum(array_column($mergedAccountDetails, 'DebitBalance'));
                //     $totalCredit = array_sum(array_column($mergedAccountDetails, 'CreditBalance'));
                // }

                // foreach ($mergedAccountDetails as &$account) {
                //     $netBalance = $account['DebitBalance'] - $account['CreditBalance'];

                //     if ($netBalance > 0) {
                //         $account['DebitBalance'] = $netBalance;
                //         $account['CreditBalance'] = 0;
                //     } else {
                //         $account['CreditBalance'] = abs($netBalance);
                //         $account['DebitBalance'] = 0;
                //     }
                // }
                // dd($mergedAccountDetails);





                // // Step 1: Retrieve ClassOfAccount details from the database
                // $classOfAccountDetails = ClassOfAccount::all()->keyBy('id');

                // // Step 2: Initialize mergedAccountDetails and populate it
                // $mergedAccountDetails = [];

                // foreach ($opAccountDetails as $classId => $accounts) {
                //     foreach ($accounts as $account) {
                //         $mergedAccountDetails[$account['account_id']] = $account;
                //     }
                // }

                // foreach ($accountDetails as $classId => $accounts) {
                //     foreach ($accounts as $account) {
                //         $mergedAccountDetails[$account['account_id']] = $account;
                //     }
                // }

                // // Step 3: Group by class of account name
                // $groupedAccountDetails = [];

                // foreach ($mergedAccountDetails as $account) {
                //     $classId = $account['class_of_account_id'];
                //     $className = $classOfAccountDetails[$classId]->name ?? 'Unknown';

                //     if (!isset($groupedAccountDetails[$className])) {
                //         $groupedAccountDetails[$className] = [];
                //     }
                //     $groupedAccountDetails[$className][] = $account;
                // }

                // // Step 4: Adjust balances within each group
                // foreach ($groupedAccountDetails as &$group) {
                //     foreach ($group as &$account) {
                //         $netBalance = $account['DebitBalance'] - $account['CreditBalance'];

                //         if ($netBalance > 0) {
                //             $account['DebitBalance'] = $netBalance;
                //             $account['CreditBalance'] = 0;
                //         } else {
                //             $account['CreditBalance'] = abs($netBalance);
                //             $account['DebitBalance'] = 0;
                //         }
                //     }
                // }

                // dd($groupedAccountDetails);

            // return [$groupedAccountDetails,$from_date, $to_date,];

    }
    // -----   Syndry Debtors For Trial Balance ------------------------------------------------------------- >>>>>>>>>>>>>>>>>>

    public function AllSundryDebtorsClassofAccountsForTrialBalance($request, $from_date, $to_date)
    {

        $from_date = $request->to_date;
        $to_date = $request->to_date;

        $currentYearFirstDate = date("2003-01-01");
        $oneDayPreviousDate = date('Y-m-d', strtotime('-1 day', strtotime($from_date)));

        $opcustomers = Customer::where('branch_id', session()->get('selected_branch'))
            ->where('class_of_account_id', 16)
            ->get(['id', 'class_of_account_id','name_of_organisation as account_name','opening_balance','type','date']);

        $opsuppliers = Supplier::where('branch_id', session()->get('selected_branch'))
            ->where('class_of_account_id', 16)
            ->get(['id', 'class_of_account_id','name_of_organisation as account_name','opening_balance','type','date']);

        $opexpenses = Expense::where('branch_id', session()->get('selected_branch'))
            ->where('class_of_account_id',16)
            ->get(['id', 'class_of_account_id','account_name','opening_balance','type','date']);

        $opadminOtherAccounts = AdminOtherAccount::where('branch_id', session()->get('selected_branch'))
            ->where('class_of_account_id', 16)
            ->get(['id', 'class_of_account_id','account_name','opening_balance','type','date']);

        $opstaffAndSalesman = StaffAndSalesman::where('branch_id', session()->get('selected_branch'))
            ->where('class_of_account_id', 16)
            ->selectRaw('id, class_of_account_id, CONCAT(first_name, " ", last_name) as account_name,date_of_joining as date')
            ->get();

        $opAllAccounts = $opcustomers->concat($opsuppliers)->concat($opexpenses)->concat($opadminOtherAccounts)->concat($opstaffAndSalesman);

        // dd($opAllAccounts);

        $opAccountDetails = [];

        foreach ($opAllAccounts as $opAccount) {
            $opDebitOBalance = 0;
            $opCreditOBalance = 0;
            $opCreateDebitOpeningBalance = 0;
            $opCreateCreditOpeningBalance = 0;
            $debitAllAccountsDate = 0;
            $creditAllAccountsDate = 0;

            if (($opAccount->type === 'Debit' || $opAccount->type === 'debit') && $opAccount->date >= $currentYearFirstDate && $opAccount->date <= $oneDayPreviousDate ) {
                // $debitAllAccountsDate = $opAccount->date;
                $opCreateDebitOpeningBalance = $opAccount->opening_balance;

            } elseif (($opAccount->type === 'Credit' || $opAccount->type === 'credit') && $opAccount->date >= $currentYearFirstDate && $opAccount->date <= $oneDayPreviousDate ) {
                // $creditAllAccountsDate = $opAccount->date;
                $opCreateCreditOpeningBalance = $opAccount->opening_balance;

            }

         // dd($DebitOB,$CreditOB,$debitAllAccountsDate,$creditAllAccountsDate);

         $opPurchaesInvoiceTotalNetAmount = AdminPurchaesInvoice::where('account_name', $opAccount->account_name)
             ->where('branch_id', session()->get('selected_branch'))
             ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
             ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
             ->whereNull('deleted_at')
             ->groupBy('invoice_no')
             ->get()
             ->sum('total_net_amount');

         $opSaleInvoiceTotalNetAmount = AdminSalesInvoice::where('account_name', $opAccount->account_name)
             ->where('branch_id', session()->get('selected_branch'))
             ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
             ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
             ->whereNull('deleted_at')
             ->groupBy('invoice_no')
             ->get()
             ->sum('total_net_amount');

         $opReceiptVoucherTotalNetAmountForCash = ReceiptVoucherExpense::where('account_name', $opAccount->account_name)
             ->where('branch_id', session()->get('selected_branch'))
             ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
             ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
             ->whereNull('deleted_at')
             ->groupBy('invoice_no')
             ->get()
             ->sum('amount');

         $opReceiptVoucherTotalNetAmountForBank = ReceiptVoucherExpense::
              where('bank_name', $opAccount->account_name)
             ->where('branch_id', session()->get('selected_branch'))
             ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
             ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
             ->whereNull('deleted_at')
             ->groupBy('invoice_no')
             ->get()
             ->sum('amount');

         $opPaymentVoucherTotalNetAmountForBank = PaymentVoucherExpense::
              where('bank_name', $opAccount->account_name)
             ->where('branch_id', session()->get('selected_branch'))
             ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
             ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
             ->whereNull('deleted_at')
             ->groupBy('invoice_no')
             ->get()
             ->sum('amount');

         $opPaymentVoucherTotalNetAmountForCash = PaymentVoucherExpense::where('account_name', $opAccount->account_name)
             ->where('branch_id', session()->get('selected_branch'))
             ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
             ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
             ->whereNull('deleted_at')
             ->groupBy('invoice_no')
             ->get()
             ->sum('amount');

             // dd($PaymentVoucherTotalNetAmountForBank,$PaymentVoucherTotalNetAmountForCash);

         $opCreditNoteTotalNetAmount = CreditNote::where('account_name', $opAccount->account_name)
             ->where('branch_id', session()->get('selected_branch'))
             ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
             ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
             ->groupBy('invoice_no')
             ->get()
             ->sum('total_net_amount');

         $opDebitNoteTotalNetAmount = DebitNote::where('account_name', $opAccount->account_name)
             ->where('branch_id', session()->get('selected_branch'))
             ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
             ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
             ->groupBy('invoice_no')
             ->sum('total_net_amount');

         $opJournalVoucherNetAmountForDebit = AdminJournalVoucher::where('account_name', $opAccount->account_name)
             ->where('branch_id', session()->get('selected_branch'))
             ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
             ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
             ->where('type','debit')
             ->groupBy('invoice_no')
             ->get()
             ->sum('amount');


         $opJournalVoucherNetAmountForCredit = AdminJournalVoucher::where('account_name', $opAccount->account_name)
             ->where('branch_id', session()->get('selected_branch'))
             ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
             ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
             ->where('type','credit')
             ->groupBy('invoice_no')
             ->get()
             ->sum('amount');

         $opDebitOBalance = $opCreateDebitOpeningBalance + $opSaleInvoiceTotalNetAmount + $opDebitNoteTotalNetAmount + $opPaymentVoucherTotalNetAmountForCash + $opJournalVoucherNetAmountForDebit + $opReceiptVoucherTotalNetAmountForBank;

         $opCreditOBalance = $opCreateCreditOpeningBalance + $opPurchaesInvoiceTotalNetAmount + $opCreditNoteTotalNetAmount + $opJournalVoucherNetAmountForCredit + $opReceiptVoucherTotalNetAmountForCash + $opPaymentVoucherTotalNetAmountForBank;

        //  dd($opCreateDebitOpeningBalance ,$opSaleInvoiceTotalNetAmount , $opDebitNoteTotalNetAmount , $opPaymentVoucherTotalNetAmountForCash , $opJournalVoucherNetAmountForDebit , $opReceiptVoucherTotalNetAmountForBank);

        //  dd($opCreateCreditOpeningBalance , $opPurchaesInvoiceTotalNetAmount , $opCreditNoteTotalNetAmount , $opJournalVoucherNetAmountForCredit ,$opReceiptVoucherTotalNetAmountForCash, $opPaymentVoucherTotalNetAmountForBank);

         $opAccountDetails[$opAccount->class_of_account_id][] = [
             'account_id' => $opAccount->id,
             'accoun_name' => $opAccount->name_of_organisation ?? $opAccount->account_name,
             'type' => $opAccount->type,
             'class_of_account_id' => $opAccount->class_of_account_id,
             'DebitBalance' => $opDebitOBalance,
             'CreditBalance' => $opCreditOBalance,
         ];
         }

        // from_date to to_date - date range data


        $customers = Customer::where('branch_id', session()->get('selected_branch'))
        ->where('class_of_account_id', 16)
        ->get(['id', 'class_of_account_id', 'name_of_organisation as account_name', 'opening_balance', 'type', 'date']);



        $suppliers = Supplier::where('branch_id', session()->get('selected_branch'))
            ->where('class_of_account_id', 16)
            ->get(['id', 'class_of_account_id','name_of_organisation as account_name','opening_balance','type','date']);

        $expenses = Expense::where('branch_id', session()->get('selected_branch'))
            ->where('class_of_account_id', 16)
            ->get(['id', 'class_of_account_id','account_name','opening_balance','type','date']);

        $adminOtherAccounts = AdminOtherAccount::where('branch_id', session()->get('selected_branch'))
            ->where('class_of_account_id', 16)
            ->get(['id', 'class_of_account_id','account_name','opening_balance','type','date']);

        $staffAndSalesman = StaffAndSalesman::where('branch_id', session()->get('selected_branch'))
            ->where('class_of_account_id', 16)
            ->selectRaw('id, class_of_account_id, CONCAT(first_name, " ", last_name) as account_name,date_of_joining as date,type')
            ->get();


        // $halfFirstAccounts = $customers->concat($suppliers)->concat($expenses);
        // $halfSecondAccounts = $adminOtherAccounts->concat($staffAndSalesman);

        $allAccounts = $customers->concat($suppliers)->concat($expenses)->concat($adminOtherAccounts)->concat($staffAndSalesman);


        // from_date to to_date - date range data

        $accountDetails = [];

        foreach ($allAccounts as $account) {
            $DebitOB = 0;
            $CreditOB = 0;
            $CreateDebitOpeningBalance = 0;
            $CreateCreditOpeningBalance = 0;
            $debitAllAccountsDate = 0;
            $creditAllAccountsDate = 0;

            if (($account->type === 'Debit' || $account->type === 'debit') && $account->date >= $from_date && $account->date <= $to_date ) {
                // $debitAllAccountsDate = $account->date;
                $CreateDebitOpeningBalance = $account->opening_balance;

            } elseif (($account->type === 'Credit' || $account->type === 'credit') && $account->date >= $from_date && $account->date <= $to_date ) {
                // $creditAllAccountsDate = $account->date;
                $CreateCreditOpeningBalance = $account->opening_balance;

            }

            $ReceiptVoucherTotalNetAmountForCash = ReceiptVoucherExpense::where('account_name', $account->account_name)
                ->where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->whereNull('deleted_at')
                ->groupBy('invoice_no')
                ->get()
                ->sum('amount');

            $ReceiptVoucherTotalNetAmountForBank = ReceiptVoucherExpense::where('bank_name', $account->account_name)
                ->where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->whereNull('deleted_at')
                ->groupBy('invoice_no')
                ->get()
                ->sum('amount');

            $PurchaesInvoiceTotalNetAmount = AdminPurchaesInvoice::where('account_name', $account->account_name)
                ->where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->whereNull('deleted_at')
                ->groupBy('invoice_no')
                ->get()
                ->sum('total_net_amount');

            $SaleInvoiceTotalNetAmount = AdminSalesInvoice::where('account_name', $account->account_name)
                ->where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->whereNull('deleted_at')
                ->groupBy('invoice_no')
                ->get()
                ->sum('total_net_amount');



            $PaymentVoucherTotalNetAmountForBank = PaymentVoucherExpense::where(function($query) use ($account) {
                $query->where('bank_name', $account->account_name);
                })
                ->where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->whereNull('deleted_at')
                ->groupBy('invoice_no')
                ->get()
                ->sum('amount');
            $PaymentVoucherTotalNetAmountForCash = PaymentVoucherExpense::where(function($query) use ($account) {
                $query->where('account_name', $account->account_name);
                })
                ->where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->whereNull('deleted_at')
                ->groupBy('invoice_no')
                ->get()
                ->sum('amount');

                // dd($PaymentVoucherTotalNetAmountForBank,$PaymentVoucherTotalNetAmountForCash);

            $CreditNoteTotalNetAmount = CreditNote::where('account_name', $account->account_name)
                ->where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->groupBy('invoice_no')
                ->get()
                ->sum('total_net_amount');
            // dd($CreditNoteTotalNetAmount);
            $DebitNoteTotalNetAmount = DebitNote::where('account_name', $account->account_name)
                ->where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->groupBy('invoice_no')
                ->get()
                ->sum('total_net_amount');

            $JournalVoucherNetAmountForDebit = AdminJournalVoucher::where('account_name', $account->account_name)
                ->where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->where('type','debit')
                ->whereNull('deleted_at')
                ->groupBy('invoice_no')
                ->get()
                ->sum('amount');
            $JournalVoucherNetAmountForCredit = AdminJournalVoucher::where('account_name', $account->account_name)
                ->where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->where('type','credit')
                ->whereNull('deleted_at')
                ->groupBy('invoice_no')
                ->get()
                ->sum('amount');

                // dd($ReceiptVoucherTotalNetAmountForCash,$ReceiptVoucherTotalNetAmountForBank);

            // dd($JournalVoucherNetAmountForDebit,$JournalVoucherNetAmountForCredit);


            // $obTotalDebitValue = $TotalSaleInvoice + $obTotalPaymentVoucherForCash + $obTotalDebitNote + $TotalobJournalVoucherForDebit + $TotalobReceiptVoucherForBank;

            // $obTotalCreditValue = $TotalPurchaesInvoice  + $TotalobReceiptVoucherForCash + $TotalCreditNote + $TotalobJournalVoucherForCredit + $obTotalPaymentVoucherForBank;


            $DebitOB = $CreateDebitOpeningBalance +  $SaleInvoiceTotalNetAmount + $DebitNoteTotalNetAmount + $PaymentVoucherTotalNetAmountForCash  + $JournalVoucherNetAmountForDebit + $ReceiptVoucherTotalNetAmountForBank;

            $CreditOB = $CreateCreditOpeningBalance + $PurchaesInvoiceTotalNetAmount + $CreditNoteTotalNetAmount + $JournalVoucherNetAmountForCredit + $ReceiptVoucherTotalNetAmountForCash + $PaymentVoucherTotalNetAmountForBank;

            // dd($CreateDebitOpeningBalance ,  $SaleInvoiceTotalNetAmount , $DebitNoteTotalNetAmount , $PaymentVoucherTotalNetAmountForBank  ,$JournalVoucherNetAmountForDebit , $ReceiptVoucherTotalNetAmountForBank);

            // dd($CreateCreditOpeningBalance , $PurchaesInvoiceTotalNetAmount , $CreditNoteTotalNetAmount , $JournalVoucherNetAmountForCredit , $ReceiptVoucherTotalNetAmountForCash , $$PaymentVoucherTotalNetAmountForCash);

            $accountDetails[$account->class_of_account_id][] = [
                'account_id' => $account->id,
                'accoun_name' => $account->name_of_organisation ?? $account->account_name,
                'type' => $account->type,
                'class_of_account_id' => $account->class_of_account_id,
                'DebitBalance' => $DebitOB,
                'CreditBalance' => $CreditOB,
            ];
            }


            $mergedAccountDetails = [];

            // Merging accountDetails into mergedAccountDetails
            foreach ($accountDetails as $classId => $accounts) {
             foreach ($accounts as $account) {
                 $accountName = $account['accoun_name'];
                 if (!isset($mergedAccountDetails[$accountName])) {
                     $mergedAccountDetails[$accountName] = $account;
                 } else {
                     // Sum the DebitBalance and CreditBalance
                     $mergedAccountDetails[$accountName]['DebitBalance'] += $account['DebitBalance'];
                     $mergedAccountDetails[$accountName]['CreditBalance'] += $account['CreditBalance'];
                 }
             }
         }

         // Merging opAccountDetails into mergedAccountDetails
         foreach ($opAccountDetails as $classId => $accounts) {
             foreach ($accounts as $account) {
                 $accountName = $account['accoun_name'];
                 if (!isset($mergedAccountDetails[$accountName])) {
                     $mergedAccountDetails[$accountName] = $account;
                 } else {
                     // Sum the DebitBalance and CreditBalance
                     $mergedAccountDetails[$accountName]['DebitBalance'] += $account['DebitBalance'];
                     $mergedAccountDetails[$accountName]['CreditBalance'] += $account['CreditBalance'];
                 }
             }
         }

         $sundryDebtorsTotalDebit = 0;
         $sundryDebtorsTotalCredit = 0;

         foreach ($mergedAccountDetails as $accountName => $account) {

             $netBalance = $account['DebitBalance'] - $account['CreditBalance'];

             if ($netBalance >= 0) {
                 $sundryDebtorsTotalDebit += $netBalance;
             }
             if ($netBalance < 0) {
                 $sundryDebtorsTotalCredit += abs($netBalance);
             }
         }

            // dd([
            //     'mergedAccountDetails' => $mergedAccountDetails,
            //     'sundryDebtorsTotalDebit' => $sundryDebtorsTotalDebit,
            //     'sundryDebtorsTotalCredit' => $sundryDebtorsTotalCredit
            // ]);

            return [$sundryDebtorsTotalDebit,$sundryDebtorsTotalCredit,$from_date, $to_date,];


            // dd($accountDetails,$opAccountDetails);

                // $mergedAccountDetails = [];

                // foreach ($opAccountDetails as $classId => $accounts) {
                //     foreach ($accounts as $account) {
                //         $mergedAccountDetails[$account['account_id']] = $account;
                //     }
                // }

                // foreach ($accountDetails as $classId => $accounts) {
                //     foreach ($accounts as $account) {
                //         $mergedAccountDetails[$account['account_id']] = $account;
                //     }
                // }

                // foreach ($mergedAccountDetails as $account) {
                //     $totalDebit = array_sum(array_column($mergedAccountDetails, 'DebitBalance'));
                //     $totalCredit = array_sum(array_column($mergedAccountDetails, 'CreditBalance'));
                // }

                // foreach ($mergedAccountDetails as &$account) {
                //     $netBalance = $account['DebitBalance'] - $account['CreditBalance'];

                //     if ($netBalance > 0) {
                //         $account['DebitBalance'] = $netBalance;
                //         $account['CreditBalance'] = 0;
                //     } else {
                //         $account['CreditBalance'] = abs($netBalance);
                //         $account['DebitBalance'] = 0;
                //     }
                // }
                // dd($mergedAccountDetails);





                // // Step 1: Retrieve ClassOfAccount details from the database
                // $classOfAccountDetails = ClassOfAccount::all()->keyBy('id');

                // // Step 2: Initialize mergedAccountDetails and populate it
                // $mergedAccountDetails = [];

                // foreach ($opAccountDetails as $classId => $accounts) {
                //     foreach ($accounts as $account) {
                //         $mergedAccountDetails[$account['account_id']] = $account;
                //     }
                // }

                // foreach ($accountDetails as $classId => $accounts) {
                //     foreach ($accounts as $account) {
                //         $mergedAccountDetails[$account['account_id']] = $account;
                //     }
                // }

                // // Step 3: Group by class of account name
                // $groupedAccountDetails = [];

                // foreach ($mergedAccountDetails as $account) {
                //     $classId = $account['class_of_account_id'];
                //     $className = $classOfAccountDetails[$classId]->name ?? 'Unknown';

                //     if (!isset($groupedAccountDetails[$className])) {
                //         $groupedAccountDetails[$className] = [];
                //     }
                //     $groupedAccountDetails[$className][] = $account;
                // }

                // // Step 4: Adjust balances within each group
                // foreach ($groupedAccountDetails as &$group) {
                //     foreach ($group as &$account) {
                //         $netBalance = $account['DebitBalance'] - $account['CreditBalance'];

                //         if ($netBalance > 0) {
                //             $account['DebitBalance'] = $netBalance;
                //             $account['CreditBalance'] = 0;
                //         } else {
                //             $account['CreditBalance'] = abs($netBalance);
                //             $account['DebitBalance'] = 0;
                //         }
                //     }
                // }

                // dd($groupedAccountDetails);

            // return [$groupedAccountDetails,$from_date, $to_date,];

    }
    // -----   Bank Accounts ------------------------------------------------------------- >>>>>>>>>>>>>>>>>>

    public function AllBankAccountClassofAccounts($request, $from_date, $to_date)
    {

        $from_date = $request->from_date;
        $to_date = $request->to_date;

        $currentYearFirstDate = date("2003-01-01");
        $oneDayPreviousDate = date('Y-m-d', strtotime('-1 day', strtotime($from_date)));

        $opcustomers = Customer::where('branch_id', session()->get('selected_branch'))
            ->where('class_of_account_id', 1)
            ->get(['id', 'class_of_account_id','name_of_organisation as account_name','opening_balance','type','date']);

        $opsuppliers = Supplier::where('branch_id', session()->get('selected_branch'))
            ->where('class_of_account_id', 1)
            ->get(['id', 'class_of_account_id','name_of_organisation as account_name','opening_balance','type','date']);

        $opexpenses = Expense::where('branch_id', session()->get('selected_branch'))
            ->where('class_of_account_id',1)
            ->get(['id', 'class_of_account_id','account_name','opening_balance','type','date']);

        $opadminOtherAccounts = AdminOtherAccount::where('branch_id', session()->get('selected_branch'))
            ->where('class_of_account_id', 1)
            ->get(['id', 'class_of_account_id','account_name','opening_balance','type','date']);

        $opstaffAndSalesman = StaffAndSalesman::where('branch_id', session()->get('selected_branch'))
            ->where('class_of_account_id', 1)
            ->selectRaw('id, class_of_account_id, CONCAT(first_name, " ", last_name) as account_name,date_of_joining as date')
            ->get();

        $opAllAccounts = $opcustomers->concat($opsuppliers)->concat($opexpenses)->concat($opadminOtherAccounts)->concat($opstaffAndSalesman);

        // dd($opAllAccounts);

        $opAccountDetails = [];

        foreach ($opAllAccounts as $opAccount) {
            $opDebitOBalance = 0;
            $opCreditOBalance = 0;
            $opCreateDebitOpeningBalance = 0;
            $opCreateCreditOpeningBalance = 0;
            $debitAllAccountsDate = 0;
            $creditAllAccountsDate = 0;

            if (($opAccount->type === 'Debit' || $opAccount->type === 'debit') && $opAccount->date >= $currentYearFirstDate && $opAccount->date <= $oneDayPreviousDate) {
                $debitAllAccountsDate = $opAccount->date;
                $opCreateDebitOpeningBalance = $opAccount->opening_balance;

            } elseif (($opAccount->type === 'Credit' || $opAccount->type === 'credit') && $opAccount->date >= $currentYearFirstDate && $opAccount->date <= $oneDayPreviousDate) {
                $creditAllAccountsDate = $opAccount->date;
                $opCreateCreditOpeningBalance = $opAccount->opening_balance;
            }

         // dd($DebitOB,$CreditOB,$debitAllAccountsDate,$creditAllAccountsDate);

         $opPurchaesInvoiceTotalNetAmount = AdminPurchaesInvoice::where('account_name', $opAccount->account_name)
             ->where('branch_id', session()->get('selected_branch'))
             ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
             ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
             ->whereNull('deleted_at')
             ->groupBy('invoice_no')
             ->get()
             ->sum('total_net_amount');

         $opSaleInvoiceTotalNetAmount = AdminSalesInvoice::where('account_name', $opAccount->account_name)
             ->where('branch_id', session()->get('selected_branch'))
             ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
             ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
             ->whereNull('deleted_at')
             ->groupBy('invoice_no')
             ->get()
             ->sum('total_net_amount');

         $opReceiptVoucherTotalNetAmountForCash = ReceiptVoucherExpense::where('account_name', $opAccount->account_name)
             ->where('branch_id', session()->get('selected_branch'))
            //  ->where('payment_method','cash')
             ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
             ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
             ->whereNull('deleted_at')
             ->groupBy('invoice_no')
             ->get()
             ->sum('amount');
         $opReceiptVoucherTotalNetAmountForBank = ReceiptVoucherExpense::
              where('bank_name', $opAccount->account_name)
             ->where('branch_id', session()->get('selected_branch'))
            //  ->where('payment_method','bank')
             ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
             ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
             ->whereNull('deleted_at')
             ->groupBy('invoice_no')
             ->get()
             ->sum('amount');

         $opPaymentVoucherTotalNetAmountForBank = PaymentVoucherExpense::
              where('bank_name', $opAccount->account_name)
             ->where('branch_id', session()->get('selected_branch'))
            //  ->where('payment_method','bank')
             ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
             ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
             ->whereNull('deleted_at')
             ->groupBy('invoice_no')
             ->get()
             ->sum(function ($voucher) {
                 return $voucher->amount + $voucher->new_vat_amount;
             });
         $opPaymentVoucherTotalNetAmountForCash = PaymentVoucherExpense::where('account_name', $opAccount->account_name)
             ->where('branch_id', session()->get('selected_branch'))
            //  ->where('payment_method','cash')
             ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
             ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
             ->whereNull('deleted_at')
             ->groupBy('invoice_no')
             ->get()
             ->sum(function ($voucher) {
                 return $voucher->amount + $voucher->new_vat_amount;
             });

             // dd($PaymentVoucherTotalNetAmountForBank,$PaymentVoucherTotalNetAmountForCash);

         $opCreditNoteTotalNetAmount = CreditNote::where('account_name', $opAccount->account_name)
             ->where('branch_id', session()->get('selected_branch'))
             ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
             ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
             ->groupBy('invoice_no')
             ->sum('total_net_amount');

         $opDebitNoteTotalNetAmount = DebitNote::where('account_name', $opAccount->account_name)
             ->where('branch_id', session()->get('selected_branch'))
             ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
             ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
             ->groupBy('invoice_no')
             ->sum('total_net_amount');

         $opJournalVoucherNetAmountForDebit = AdminJournalVoucher::where('account_name', $opAccount->account_name)
             ->where('branch_id', session()->get('selected_branch'))
             ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
             ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
             ->where('type','debit')
             ->groupBy('invoice_no')
             ->get()
             ->sum('amount');
         $opJournalVoucherNetAmountForCredit = AdminJournalVoucher::where('account_name', $opAccount->account_name)
             ->where('branch_id', session()->get('selected_branch'))
             ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
             ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
             ->where('type','credit')
             ->groupBy('invoice_no')
             ->get()
             ->sum('amount');

         $opDebitOBalance += $opCreateDebitOpeningBalance + $opSaleInvoiceTotalNetAmount + $opDebitNoteTotalNetAmount + $opPaymentVoucherTotalNetAmountForCash + $opJournalVoucherNetAmountForDebit + $opReceiptVoucherTotalNetAmountForBank;

         $opCreditOBalance += $opCreateCreditOpeningBalance + $opPurchaesInvoiceTotalNetAmount + $opCreditNoteTotalNetAmount + $opJournalVoucherNetAmountForCredit + $opReceiptVoucherTotalNetAmountForCash + $opPaymentVoucherTotalNetAmountForBank;


         $opAccountDetails[$opAccount->class_of_account_id][] = [
             'account_id' => $opAccount->id,
             'accoun_name' => $opAccount->name_of_organisation ?? $opAccount->account_name,
             'type' => $opAccount->type,
             'class_of_account_id' => $opAccount->class_of_account_id,
             'DebitBalance' => $opDebitOBalance,
             'CreditBalance' => $opCreditOBalance,
         ];
         }

        // from_date to to_date - date range data


        $customers = Customer::where('branch_id', session()->get('selected_branch'))
        ->where('class_of_account_id', 1)
        ->get(['id', 'class_of_account_id', 'name_of_organisation as account_name', 'opening_balance', 'type', 'date']);



        $suppliers = Supplier::where('branch_id', session()->get('selected_branch'))
            ->where('class_of_account_id', 1)
            ->get(['id', 'class_of_account_id','name_of_organisation as account_name','opening_balance','type','date']);

        $expenses = Expense::where('branch_id', session()->get('selected_branch'))
            ->where('class_of_account_id', 1)
            ->get(['id', 'class_of_account_id','account_name','opening_balance','type','date']);

        $adminOtherAccounts = AdminOtherAccount::where('branch_id', session()->get('selected_branch'))
            ->where('class_of_account_id', 1)
            ->get(['id', 'class_of_account_id','account_name','opening_balance','type','date']);

        $staffAndSalesman = StaffAndSalesman::where('branch_id', session()->get('selected_branch'))
            ->where('class_of_account_id', 1)
            ->selectRaw('id, class_of_account_id, CONCAT(first_name, " ", last_name) as account_name,date_of_joining as date,type')
            ->get();


        // $halfFirstAccounts = $customers->concat($suppliers)->concat($expenses);
        // $halfSecondAccounts = $adminOtherAccounts->concat($staffAndSalesman);

        $allAccounts = $customers->concat($suppliers)->concat($expenses)->concat($adminOtherAccounts)->concat($staffAndSalesman);


        // from_date to to_date - date range data

        $accountDetails = [];

        foreach ($allAccounts as $account) {
            $DebitOB = 0;
            $CreditOB = 0;
            $CreateDebitOpeningBalance = 0;
            $CreateCreditOpeningBalance = 0;
            $debitAllAccountsDate = 0;
            $creditAllAccountsDate = 0;

            if (($account->type === 'Debit' || $account->type === 'debit') && $account->date >= $from_date && $account->date <= $to_date) {
                $debitAllAccountsDate = $account->date;
                $CreateDebitOpeningBalance = $account->opening_balance;

            } elseif (($account->type === 'Credit' || $account->type === 'credit') && $account->date >= $from_date && $account->date <= $to_date) {
                $creditAllAccountsDate = $account->date;
                $CreateCreditOpeningBalance = $account->opening_balance;

            }

            $ReceiptVoucherTotalNetAmountForCash = ReceiptVoucherExpense::where('account_name', $account->account_name)
                ->where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->whereNull('deleted_at')
                ->groupBy('invoice_no')
                ->get()
                ->sum('amount');

            $ReceiptVoucherTotalNetAmountForBank = ReceiptVoucherExpense::where('bank_name', $account->account_name)
                ->where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->whereNull('deleted_at')
                ->groupBy('invoice_no')
                ->get()
                ->sum('amount');

            $PurchaesInvoiceTotalNetAmount = AdminPurchaesInvoice::where('account_name', $account->account_name)
                ->where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->whereNull('deleted_at')
                ->groupBy('invoice_no')
                ->get()
                ->sum('total_net_amount');

            $SaleInvoiceTotalNetAmount = AdminSalesInvoice::where('account_name', $account->account_name)
                ->where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->whereNull('deleted_at')
                ->groupBy('invoice_no')
                ->get()
                ->sum('total_net_amount');



            $PaymentVoucherTotalNetAmountForBank = PaymentVoucherExpense::where(function($query) use ($account) {
                $query->where('bank_name', $account->account_name);
                })
                ->where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->whereNull('deleted_at')
                ->groupBy('invoice_no')
                ->get()
                ->sum(function ($voucher) {
                    return $voucher->amount + $voucher->new_vat_amount;
                });
            $PaymentVoucherTotalNetAmountForCash = PaymentVoucherExpense::where(function($query) use ($account) {
                $query->where('account_name', $account->account_name);
                })
                ->where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->whereNull('deleted_at')
                ->groupBy('invoice_no')
                ->get()
                ->sum(function ($voucher) {
                    return $voucher->amount + $voucher->new_vat_amount;
                });

                // dd($PaymentVoucherTotalNetAmountForBank,$PaymentVoucherTotalNetAmountForCash);

            $CreditNoteTotalNetAmount = CreditNote::where('account_name', $account->account_name)
                ->where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->groupBy('invoice_no')
                ->get()
                ->sum('total_net_amount');
            // dd($CreditNoteTotalNetAmount);
            $DebitNoteTotalNetAmount = DebitNote::where('account_name', $account->account_name)
                ->where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->groupBy('invoice_no')
                ->sum('total_net_amount');

            $JournalVoucherNetAmountForDebit = AdminJournalVoucher::where('account_name', $account->account_name)
                ->where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->where('type','debit')
                ->whereNull('deleted_at')
                ->groupBy('invoice_no')
                ->get()
                ->sum('amount');
            $JournalVoucherNetAmountForCredit = AdminJournalVoucher::where('account_name', $account->account_name)
                ->where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->where('type','credit')
                ->whereNull('deleted_at')
                ->groupBy('invoice_no')
                ->get()
                ->sum('amount');

                // dd($ReceiptVoucherTotalNetAmountForCash,$ReceiptVoucherTotalNetAmountForBank);

            // dd($JournalVoucherNetAmountForDebit,$JournalVoucherNetAmountForCredit);

            $DebitOB += $CreateDebitOpeningBalance +  $SaleInvoiceTotalNetAmount + $DebitNoteTotalNetAmount + $PaymentVoucherTotalNetAmountForCash  + $JournalVoucherNetAmountForDebit + $ReceiptVoucherTotalNetAmountForBank;

            $CreditOB += $CreateCreditOpeningBalance + $PurchaesInvoiceTotalNetAmount + $CreditNoteTotalNetAmount + $JournalVoucherNetAmountForCredit + $ReceiptVoucherTotalNetAmountForCash + $PaymentVoucherTotalNetAmountForBank;



            $accountDetails[$account->class_of_account_id][] = [
                'account_id' => $account->id,
                'accoun_name' => $account->name_of_organisation ?? $account->account_name,
                'type' => $account->type,
                'class_of_account_id' => $account->class_of_account_id,
                'DebitBalance' => $DebitOB,
                'CreditBalance' => $CreditOB,
            ];
            }

            // $mergedAccountDetails = [];

            // foreach ($opAccountDetails as $classId => $accounts) {
            //     foreach ($accounts as $account) {
            //         $mergedAccountDetails[$account['account_id']] = $account;
            //     }
            // }

            // foreach ($accountDetails as $classId => $accounts) {
            //     foreach ($accounts as $account) {
            //         $mergedAccountDetails[$account['account_id']] = $account;
            //     }
            // }

            // foreach ($mergedAccountDetails as &$account) {
            //     $netBalance = $account['DebitBalance'] - $account['CreditBalance'];

            //     if ($netBalance > 0) {
            //         $account['DebitBalance'] = $netBalance;
            //         $account['CreditBalance'] = 0;
            //     } else {
            //         $account['CreditBalance'] = abs($netBalance);
            //         $account['DebitBalance'] = 0;
            //     }
            // }


            $mergedAccountDetails = [];

            // Merging accountDetails into mergedAccountDetails
            foreach ($accountDetails as $classId => $accounts) {
             foreach ($accounts as $account) {
                 $accountName = $account['accoun_name'];
                 if (!isset($mergedAccountDetails[$accountName])) {
                     $mergedAccountDetails[$accountName] = $account;
                 } else {
                     // Sum the DebitBalance and CreditBalance
                     $mergedAccountDetails[$accountName]['DebitBalance'] += $account['DebitBalance'];
                     $mergedAccountDetails[$accountName]['CreditBalance'] += $account['CreditBalance'];
                 }
             }
         }

         // Merging opAccountDetails into mergedAccountDetails
         foreach ($opAccountDetails as $classId => $accounts) {
             foreach ($accounts as $account) {
                 $accountName = $account['accoun_name'];
                 if (!isset($mergedAccountDetails[$accountName])) {
                     $mergedAccountDetails[$accountName] = $account;
                 } else {
                     // Sum the DebitBalance and CreditBalance
                     $mergedAccountDetails[$accountName]['DebitBalance'] += $account['DebitBalance'];
                     $mergedAccountDetails[$accountName]['CreditBalance'] += $account['CreditBalance'];
                 }
             }
         }



         // Calculate the difference between DebitBalance and CreditBalance for each account
         foreach ($mergedAccountDetails as &$account) {
             $account['BalanceDifference'] = $account['DebitBalance'] - $account['CreditBalance'];
         }
         unset($account); // Unset reference to avoid potential bugs

         // dd($mergedAccountDetails);

            $bankAccountTotalDebit = array_sum(array_column($mergedAccountDetails, 'DebitBalance'));
            $bankAccountTotalCredit = array_sum(array_column($mergedAccountDetails, 'CreditBalance'));

            // dd([
            //     'bankAccountTotalDebit' => $bankAccountTotalDebit,
            //     'bankAccountTotalCredit' => $bankAccountTotalCredit
            // ]);

            return [$bankAccountTotalDebit,$bankAccountTotalCredit,$from_date, $to_date,];


            // dd($accountDetails,$opAccountDetails);

                // $mergedAccountDetails = [];

                // foreach ($opAccountDetails as $classId => $accounts) {
                //     foreach ($accounts as $account) {
                //         $mergedAccountDetails[$account['account_id']] = $account;
                //     }
                // }

                // foreach ($accountDetails as $classId => $accounts) {
                //     foreach ($accounts as $account) {
                //         $mergedAccountDetails[$account['account_id']] = $account;
                //     }
                // }

                // foreach ($mergedAccountDetails as $account) {
                //     $totalDebit = array_sum(array_column($mergedAccountDetails, 'DebitBalance'));
                //     $totalCredit = array_sum(array_column($mergedAccountDetails, 'CreditBalance'));
                // }

                // foreach ($mergedAccountDetails as &$account) {
                //     $netBalance = $account['DebitBalance'] - $account['CreditBalance'];

                //     if ($netBalance > 0) {
                //         $account['DebitBalance'] = $netBalance;
                //         $account['CreditBalance'] = 0;
                //     } else {
                //         $account['CreditBalance'] = abs($netBalance);
                //         $account['DebitBalance'] = 0;
                //     }
                // }
                // dd($mergedAccountDetails);





                // // Step 1: Retrieve ClassOfAccount details from the database
                // $classOfAccountDetails = ClassOfAccount::all()->keyBy('id');

                // // Step 2: Initialize mergedAccountDetails and populate it
                // $mergedAccountDetails = [];

                // foreach ($opAccountDetails as $classId => $accounts) {
                //     foreach ($accounts as $account) {
                //         $mergedAccountDetails[$account['account_id']] = $account;
                //     }
                // }

                // foreach ($accountDetails as $classId => $accounts) {
                //     foreach ($accounts as $account) {
                //         $mergedAccountDetails[$account['account_id']] = $account;
                //     }
                // }

                // // Step 3: Group by class of account name
                // $groupedAccountDetails = [];

                // foreach ($mergedAccountDetails as $account) {
                //     $classId = $account['class_of_account_id'];
                //     $className = $classOfAccountDetails[$classId]->name ?? 'Unknown';

                //     if (!isset($groupedAccountDetails[$className])) {
                //         $groupedAccountDetails[$className] = [];
                //     }
                //     $groupedAccountDetails[$className][] = $account;
                // }

                // // Step 4: Adjust balances within each group
                // foreach ($groupedAccountDetails as &$group) {
                //     foreach ($group as &$account) {
                //         $netBalance = $account['DebitBalance'] - $account['CreditBalance'];

                //         if ($netBalance > 0) {
                //             $account['DebitBalance'] = $netBalance;
                //             $account['CreditBalance'] = 0;
                //         } else {
                //             $account['CreditBalance'] = abs($netBalance);
                //             $account['DebitBalance'] = 0;
                //         }
                //     }
                // }

                // dd($groupedAccountDetails);

            // return [$groupedAccountDetails,$from_date, $to_date,];

    }
    // -----   Bank Accounts For Trial Balance ------------------------------------------------------------- >>>>>>>>>>>>>>>>>>

    public function AllBankAccountClassofAccountsForTrialBalance($request, $from_date, $to_date)
    {

        $from_date = $request->to_date;
        $to_date = $request->to_date;

        $currentYearFirstDate = date("2003-01-01");
        $oneDayPreviousDate = date('Y-m-d', strtotime('-1 day', strtotime($from_date)));

        $opcustomers = Customer::where('branch_id', session()->get('selected_branch'))
            ->where('class_of_account_id', 1)
            ->get(['id', 'class_of_account_id','name_of_organisation as account_name','opening_balance','type','date']);

        $opsuppliers = Supplier::where('branch_id', session()->get('selected_branch'))
            ->where('class_of_account_id', 1)
            ->get(['id', 'class_of_account_id','name_of_organisation as account_name','opening_balance','type','date']);

        $opexpenses = Expense::where('branch_id', session()->get('selected_branch'))
            ->where('class_of_account_id',1)
            ->get(['id', 'class_of_account_id','account_name','opening_balance','type','date']);

        $opadminOtherAccounts = AdminOtherAccount::where('branch_id', session()->get('selected_branch'))
            ->where('class_of_account_id', 1)
            ->get(['id', 'class_of_account_id','account_name','opening_balance','type','date']);

        $opstaffAndSalesman = StaffAndSalesman::where('branch_id', session()->get('selected_branch'))
            ->where('class_of_account_id', 1)
            ->selectRaw('id, class_of_account_id, CONCAT(first_name, " ", last_name) as account_name,date_of_joining as date')
            ->get();

        $opAllAccounts = $opcustomers->concat($opsuppliers)->concat($opexpenses)->concat($opadminOtherAccounts)->concat($opstaffAndSalesman);

        // dd($opAllAccounts);

        $opAccountDetails = [];

        foreach ($opAllAccounts as $opAccount) {
            $opDebitOBalance = 0;
            $opCreditOBalance = 0;
            $opCreateDebitOpeningBalance = 0;
            $opCreateCreditOpeningBalance = 0;
            $debitAllAccountsDate = 0;
            $creditAllAccountsDate = 0;

            if (($opAccount->type === 'Debit' || $opAccount->type === 'debit') && $opAccount->date >= $currentYearFirstDate && $opAccount->date <= $oneDayPreviousDate ) {
                // $debitAllAccountsDate = $opAccount->date;
                $opCreateDebitOpeningBalance = $opAccount->opening_balance;

            } elseif (($opAccount->type === 'Credit' || $opAccount->type === 'credit') && $opAccount->date >= $currentYearFirstDate && $opAccount->date <= $oneDayPreviousDate ) {
                // $creditAllAccountsDate = $opAccount->date;
                $opCreateCreditOpeningBalance = $opAccount->opening_balance;

            }

         // dd($DebitOB,$CreditOB,$debitAllAccountsDate,$creditAllAccountsDate);

         $opPurchaesInvoiceTotalNetAmount = AdminPurchaesInvoice::where('account_name', $opAccount->account_name)
             ->where('branch_id', session()->get('selected_branch'))
             ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
             ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
             ->whereNull('deleted_at')
             ->groupBy('invoice_no')
             ->get()
             ->sum('total_net_amount');

         $opSaleInvoiceTotalNetAmount = AdminSalesInvoice::where('account_name', $opAccount->account_name)
             ->where('branch_id', session()->get('selected_branch'))
             ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
             ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
             ->whereNull('deleted_at')
             ->groupBy('invoice_no')
             ->get()
             ->sum('total_net_amount');

         $opReceiptVoucherTotalNetAmountForCash = ReceiptVoucherExpense::where('account_name', $opAccount->account_name)
             ->where('branch_id', session()->get('selected_branch'))
             ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
             ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
             ->whereNull('deleted_at')
             ->groupBy('invoice_no')
             ->get()
             ->sum('amount');

         $opReceiptVoucherTotalNetAmountForBank = ReceiptVoucherExpense::
              where('bank_name', $opAccount->account_name)
             ->where('branch_id', session()->get('selected_branch'))
             ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
             ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
             ->whereNull('deleted_at')
             ->groupBy('invoice_no')
             ->get()
             ->sum('amount');

         $opPaymentVoucherTotalNetAmountForBank = PaymentVoucherExpense::
              where('bank_name', $opAccount->account_name)
             ->where('branch_id', session()->get('selected_branch'))
             ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
             ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
             ->whereNull('deleted_at')
             ->groupBy('invoice_no')
             ->get()
             ->sum(function ($voucher) {
                 return $voucher->amount + $voucher->new_vat_amount;
             });

         $opPaymentVoucherTotalNetAmountForCash = PaymentVoucherExpense::where('account_name', $opAccount->account_name)
             ->where('branch_id', session()->get('selected_branch'))
             ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
             ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
             ->whereNull('deleted_at')
             ->groupBy('invoice_no')
             ->get()
             ->sum(function ($voucher) {
                 return $voucher->amount + $voucher->new_vat_amount;
             });

             // dd($PaymentVoucherTotalNetAmountForBank,$PaymentVoucherTotalNetAmountForCash);

         $opCreditNoteTotalNetAmount = CreditNote::where('account_name', $opAccount->account_name)
             ->where('branch_id', session()->get('selected_branch'))
             ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
             ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
             ->groupBy('invoice_no')
             ->sum('total_net_amount');

         $opDebitNoteTotalNetAmount = DebitNote::where('account_name', $opAccount->account_name)
             ->where('branch_id', session()->get('selected_branch'))
             ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
             ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
             ->groupBy('invoice_no')
             ->sum('total_net_amount');

         $opJournalVoucherNetAmountForDebit = AdminJournalVoucher::where('account_name', $opAccount->account_name)
             ->where('branch_id', session()->get('selected_branch'))
             ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
             ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
             ->where('type','debit')
             ->groupBy('invoice_no')
             ->get()
             ->sum('amount');


         $opJournalVoucherNetAmountForCredit = AdminJournalVoucher::where('account_name', $opAccount->account_name)
             ->where('branch_id', session()->get('selected_branch'))
             ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
             ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
             ->where('type','credit')
             ->groupBy('invoice_no')
             ->get()
             ->sum('amount');

         $opDebitOBalance = $opCreateDebitOpeningBalance + $opSaleInvoiceTotalNetAmount + $opDebitNoteTotalNetAmount + $opPaymentVoucherTotalNetAmountForCash + $opJournalVoucherNetAmountForDebit + $opReceiptVoucherTotalNetAmountForBank;

         $opCreditOBalance = $opCreateCreditOpeningBalance + $opPurchaesInvoiceTotalNetAmount + $opCreditNoteTotalNetAmount + $opJournalVoucherNetAmountForCredit + $opReceiptVoucherTotalNetAmountForCash + $opPaymentVoucherTotalNetAmountForBank;

        //  dd($opCreateDebitOpeningBalance ,$opSaleInvoiceTotalNetAmount , $opDebitNoteTotalNetAmount , $opPaymentVoucherTotalNetAmountForCash , $opJournalVoucherNetAmountForDebit , $opReceiptVoucherTotalNetAmountForBank);

        //  dd($opCreateCreditOpeningBalance , $opPurchaesInvoiceTotalNetAmount , $opCreditNoteTotalNetAmount , $opJournalVoucherNetAmountForCredit ,$opReceiptVoucherTotalNetAmountForCash, $opPaymentVoucherTotalNetAmountForBank);

         $opAccountDetails[$opAccount->class_of_account_id][] = [
             'account_id' => $opAccount->id,
             'accoun_name' => $opAccount->name_of_organisation ?? $opAccount->account_name,
             'type' => $opAccount->type,
             'class_of_account_id' => $opAccount->class_of_account_id,
             'DebitBalance' => $opDebitOBalance,
             'CreditBalance' => $opCreditOBalance,
         ];
         }

        // from_date to to_date - date range data


        $customers = Customer::where('branch_id', session()->get('selected_branch'))
        ->where('class_of_account_id', 1)
        ->get(['id', 'class_of_account_id', 'name_of_organisation as account_name', 'opening_balance', 'type', 'date']);



        $suppliers = Supplier::where('branch_id', session()->get('selected_branch'))
            ->where('class_of_account_id', 1)
            ->get(['id', 'class_of_account_id','name_of_organisation as account_name','opening_balance','type','date']);

        $expenses = Expense::where('branch_id', session()->get('selected_branch'))
            ->where('class_of_account_id', 1)
            ->get(['id', 'class_of_account_id','account_name','opening_balance','type','date']);

        $adminOtherAccounts = AdminOtherAccount::where('branch_id', session()->get('selected_branch'))
            ->where('class_of_account_id', 1)
            ->get(['id', 'class_of_account_id','account_name','opening_balance','type','date']);

        $staffAndSalesman = StaffAndSalesman::where('branch_id', session()->get('selected_branch'))
            ->where('class_of_account_id', 1)
            ->selectRaw('id, class_of_account_id, CONCAT(first_name, " ", last_name) as account_name,date_of_joining as date,type')
            ->get();


        // $halfFirstAccounts = $customers->concat($suppliers)->concat($expenses);
        // $halfSecondAccounts = $adminOtherAccounts->concat($staffAndSalesman);

        $allAccounts = $customers->concat($suppliers)->concat($expenses)->concat($adminOtherAccounts)->concat($staffAndSalesman);


        // from_date to to_date - date range data

        $accountDetails = [];

        foreach ($allAccounts as $account) {
            $DebitOB = 0;
            $CreditOB = 0;
            $CreateDebitOpeningBalance = 0;
            $CreateCreditOpeningBalance = 0;
            $debitAllAccountsDate = 0;
            $creditAllAccountsDate = 0;

            if (($account->type === 'Debit' || $account->type === 'debit') && $account->date >= $from_date && $account->date <= $to_date ) {
                // $debitAllAccountsDate = $account->date;
                $CreateDebitOpeningBalance = $account->opening_balance;

            } elseif (($account->type === 'Credit' || $account->type === 'credit') && $account->date >= $from_date && $account->date <= $to_date ) {
                // $creditAllAccountsDate = $account->date;
                $CreateCreditOpeningBalance = $account->opening_balance;

            }

            $ReceiptVoucherTotalNetAmountForCash = ReceiptVoucherExpense::where('account_name', $account->account_name)
                ->where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->whereNull('deleted_at')
                ->groupBy('invoice_no')
                ->get()
                ->sum('amount');

            $ReceiptVoucherTotalNetAmountForBank = ReceiptVoucherExpense::where('bank_name', $account->account_name)
                ->where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->whereNull('deleted_at')
                ->groupBy('invoice_no')
                ->get()
                ->sum('amount');

            $PurchaesInvoiceTotalNetAmount = AdminPurchaesInvoice::where('account_name', $account->account_name)
                ->where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->whereNull('deleted_at')
                ->groupBy('invoice_no')
                ->get()
                ->sum('total_net_amount');

            $SaleInvoiceTotalNetAmount = AdminSalesInvoice::where('account_name', $account->account_name)
                ->where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->whereNull('deleted_at')
                ->groupBy('invoice_no')
                ->get()
                ->sum('total_net_amount');



            $PaymentVoucherTotalNetAmountForBank = PaymentVoucherExpense::where(function($query) use ($account) {
                $query->where('bank_name', $account->account_name);
                })
                ->where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->whereNull('deleted_at')
                ->groupBy('invoice_no')
                ->get()
                ->sum(function ($voucher) {
                    return $voucher->amount + $voucher->new_vat_amount;
                });
            $PaymentVoucherTotalNetAmountForCash = PaymentVoucherExpense::where(function($query) use ($account) {
                $query->where('account_name', $account->account_name);
                })
                ->where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->whereNull('deleted_at')
                ->groupBy('invoice_no')
                ->get()
                ->sum(function ($voucher) {
                    return $voucher->amount + $voucher->new_vat_amount;
                });

                // dd($PaymentVoucherTotalNetAmountForBank,$PaymentVoucherTotalNetAmountForCash);

            $CreditNoteTotalNetAmount = CreditNote::where('account_name', $account->account_name)
                ->where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->groupBy('invoice_no')
                ->get()
                ->sum('total_net_amount');
            // dd($CreditNoteTotalNetAmount);
            $DebitNoteTotalNetAmount = DebitNote::where('account_name', $account->account_name)
                ->where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->groupBy('invoice_no')
                ->get()
                ->sum('total_net_amount');

            $JournalVoucherNetAmountForDebit = AdminJournalVoucher::where('account_name', $account->account_name)
                ->where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->where('type','debit')
                ->whereNull('deleted_at')
                ->groupBy('invoice_no')
                ->get()
                ->sum('amount');
            $JournalVoucherNetAmountForCredit = AdminJournalVoucher::where('account_name', $account->account_name)
                ->where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->where('type','credit')
                ->whereNull('deleted_at')
                ->groupBy('invoice_no')
                ->get()
                ->sum('amount');

                // dd($ReceiptVoucherTotalNetAmountForCash,$ReceiptVoucherTotalNetAmountForBank);

            // dd($JournalVoucherNetAmountForDebit,$JournalVoucherNetAmountForCredit);


            // $obTotalDebitValue = $TotalSaleInvoice + $obTotalPaymentVoucherForCash + $obTotalDebitNote + $TotalobJournalVoucherForDebit + $TotalobReceiptVoucherForBank;

            // $obTotalCreditValue = $TotalPurchaesInvoice  + $TotalobReceiptVoucherForCash + $TotalCreditNote + $TotalobJournalVoucherForCredit + $obTotalPaymentVoucherForBank;


            $DebitOB = $CreateDebitOpeningBalance +  $SaleInvoiceTotalNetAmount + $DebitNoteTotalNetAmount + $PaymentVoucherTotalNetAmountForCash  + $JournalVoucherNetAmountForDebit + $ReceiptVoucherTotalNetAmountForBank;

            $CreditOB = $CreateCreditOpeningBalance + $PurchaesInvoiceTotalNetAmount + $CreditNoteTotalNetAmount + $JournalVoucherNetAmountForCredit + $ReceiptVoucherTotalNetAmountForCash + $PaymentVoucherTotalNetAmountForBank;

            // dd($CreateDebitOpeningBalance ,  $SaleInvoiceTotalNetAmount , $DebitNoteTotalNetAmount , $PaymentVoucherTotalNetAmountForBank  ,$JournalVoucherNetAmountForDebit , $ReceiptVoucherTotalNetAmountForBank);

            // dd($CreateCreditOpeningBalance , $PurchaesInvoiceTotalNetAmount , $CreditNoteTotalNetAmount , $JournalVoucherNetAmountForCredit , $ReceiptVoucherTotalNetAmountForCash , $$PaymentVoucherTotalNetAmountForCash);

            $accountDetails[$account->class_of_account_id][] = [
                'account_id' => $account->id,
                'accoun_name' => $account->name_of_organisation ?? $account->account_name,
                'type' => $account->type,
                'class_of_account_id' => $account->class_of_account_id,
                'DebitBalance' => $DebitOB,
                'CreditBalance' => $CreditOB,
            ];
            }


            $mergedAccountDetails = [];

            // Merging accountDetails into mergedAccountDetails
            foreach ($accountDetails as $classId => $accounts) {
             foreach ($accounts as $account) {
                 $accountName = $account['accoun_name'];
                 if (!isset($mergedAccountDetails[$accountName])) {
                     $mergedAccountDetails[$accountName] = $account;
                 } else {
                     // Sum the DebitBalance and CreditBalance
                     $mergedAccountDetails[$accountName]['DebitBalance'] += $account['DebitBalance'];
                     $mergedAccountDetails[$accountName]['CreditBalance'] += $account['CreditBalance'];
                 }
             }
         }

         // Merging opAccountDetails into mergedAccountDetails
         foreach ($opAccountDetails as $classId => $accounts) {
             foreach ($accounts as $account) {
                 $accountName = $account['accoun_name'];
                 if (!isset($mergedAccountDetails[$accountName])) {
                     $mergedAccountDetails[$accountName] = $account;
                 } else {
                     // Sum the DebitBalance and CreditBalance
                     $mergedAccountDetails[$accountName]['DebitBalance'] += $account['DebitBalance'];
                     $mergedAccountDetails[$accountName]['CreditBalance'] += $account['CreditBalance'];
                 }
             }
         }

         $bankAccountTotalDebit = 0;
         $bankAccountTotalCredit = 0;

         foreach ($mergedAccountDetails as $accountName => $account) {
             $netBalance = $account['DebitBalance'] - $account['CreditBalance'];
             if ($netBalance > 0) {
                 // Positive balance goes to debit side
                 $bankAccountTotalDebit += $netBalance;
             } else {
                 // Negative balance goes to credit side
                 $bankAccountTotalCredit += abs($netBalance);
             }
         }






            // dd([
            //     'mergedAccountDetails' => $mergedAccountDetails,
            //     'bankAccountTotalDebit' => $bankAccountTotalDebit,
            //     'bankAccountTotalCredit' => $bankAccountTotalCredit
            // ]);

            return [$bankAccountTotalDebit,$bankAccountTotalCredit,$from_date, $to_date,];

    }
    // -----   Sundry Creditors ------------------------------------------------------------- >>>>>>>>>>>>>>>>>>

    public function AllSundryCreditorsClassofAccounts($request, $from_date, $to_date)
    {

        $from_date = $request->from_date;
        $to_date = $request->to_date;

        $currentYearFirstDate = date("2003-01-01");
        $oneDayPreviousDate = date('Y-m-d', strtotime('-1 day', strtotime($from_date)));

        $opcustomers = Customer::where('branch_id', session()->get('selected_branch'))
            ->where('class_of_account_id', 15)
            ->get(['id', 'class_of_account_id','name_of_organisation as account_name','opening_balance','type','date']);

        $opsuppliers = Supplier::where('branch_id', session()->get('selected_branch'))
            ->where('class_of_account_id', 15)
            ->get(['id', 'class_of_account_id','name_of_organisation as account_name','opening_balance','type','date']);

        $opexpenses = Expense::where('branch_id', session()->get('selected_branch'))
            ->where('class_of_account_id',15)
            ->get(['id', 'class_of_account_id','account_name','opening_balance','type','date']);

        $opadminOtherAccounts = AdminOtherAccount::where('branch_id', session()->get('selected_branch'))
            ->where('class_of_account_id', 15)
            ->get(['id', 'class_of_account_id','account_name','opening_balance','type','date']);

        $opstaffAndSalesman = StaffAndSalesman::where('branch_id', session()->get('selected_branch'))
            ->where('class_of_account_id', 15)
            ->selectRaw('id, class_of_account_id, CONCAT(first_name, " ", last_name) as account_name,date_of_joining as date')
            ->get();

        $opAllAccounts = $opcustomers->concat($opsuppliers)->concat($opexpenses)->concat($opadminOtherAccounts)->concat($opstaffAndSalesman);

        // dd($opAllAccounts);

        $opAccountDetails = [];

        foreach ($opAllAccounts as $opAccount) {
            $opDebitOBalance = 0;
            $opCreditOBalance = 0;
            $opCreateDebitOpeningBalance = 0;
            $opCreateCreditOpeningBalance = 0;
            $debitAllAccountsDate = 0;
            $creditAllAccountsDate = 0;

            if (($opAccount->type === 'Debit' || $opAccount->type === 'debit') && $opAccount->date >= $currentYearFirstDate && $opAccount->date <= $oneDayPreviousDate) {
                $debitAllAccountsDate = $opAccount->date;
                $opCreateDebitOpeningBalance = $opAccount->opening_balance;

            } elseif (($opAccount->type === 'Credit' || $opAccount->type === 'credit') && $opAccount->date >= $currentYearFirstDate && $opAccount->date <= $oneDayPreviousDate) {
                $creditAllAccountsDate = $opAccount->date;
                $opCreateCreditOpeningBalance = $opAccount->opening_balance;

            }

         // dd($DebitOB,$CreditOB,$debitAllAccountsDate,$creditAllAccountsDate);

         $opPurchaesInvoiceTotalNetAmount = AdminPurchaesInvoice::where('account_name', $opAccount->account_name)
             ->where('branch_id', session()->get('selected_branch'))
             ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
             ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
             ->whereNull('deleted_at')
             ->groupBy('invoice_no')
             ->get()
             ->sum('total_net_amount');

         $opSaleInvoiceTotalNetAmount = AdminSalesInvoice::where('account_name', $opAccount->account_name)
             ->where('branch_id', session()->get('selected_branch'))
             ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
             ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
             ->whereNull('deleted_at')
             ->groupBy('invoice_no')
             ->get()
             ->sum('total_net_amount');

         $opReceiptVoucherTotalNetAmountForCash = ReceiptVoucherExpense::where('account_name', $opAccount->account_name)
             ->where('branch_id', session()->get('selected_branch'))
            //  ->where('payment_method','cash')
             ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
             ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
             ->whereNull('deleted_at')
             ->groupBy('invoice_no')
             ->get()
             ->sum('amount');
         $opReceiptVoucherTotalNetAmountForBank = ReceiptVoucherExpense::
              where('bank_name', $opAccount->account_name)
             ->where('branch_id', session()->get('selected_branch'))
            //  ->where('payment_method','bank')
             ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
             ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
             ->whereNull('deleted_at')
             ->groupBy('invoice_no')
             ->get()
             ->sum('amount');

         $opPaymentVoucherTotalNetAmountForBank = PaymentVoucherExpense::
              where('bank_name', $opAccount->account_name)
             ->where('branch_id', session()->get('selected_branch'))
             ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
             ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
             ->groupBy('invoice_no')
             ->get()
             ->sum(function ($voucher) {
                 return $voucher->amount + $voucher->new_vat_amount;
             });
         $opPaymentVoucherTotalNetAmountForCash = PaymentVoucherExpense::where('account_name', $opAccount->account_name)
             ->where('branch_id', session()->get('selected_branch'))
             ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
             ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
             ->groupBy('invoice_no')
             ->get()
             ->sum(function ($voucher) {
                 return $voucher->amount + $voucher->new_vat_amount;
             });

            //  dd($opPaymentVoucherTotalNetAmountForCash,$opPaymentVoucherTotalNetAmountForBank);

         $opCreditNoteTotalNetAmount = CreditNote::where('account_name', $opAccount->account_name)
             ->where('branch_id', session()->get('selected_branch'))
             ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
             ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
             ->groupBy('invoice_no')
             ->sum('total_net_amount');

         $opDebitNoteTotalNetAmount = DebitNote::where('account_name', $opAccount->account_name)
             ->where('branch_id', session()->get('selected_branch'))
             ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
             ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
             ->groupBy('invoice_no')
             ->sum('total_net_amount');

         $opJournalVoucherNetAmountForDebit = AdminJournalVoucher::where('account_name', $opAccount->account_name)
             ->where('branch_id', session()->get('selected_branch'))
             ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
             ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
             ->where('type','debit')
             ->groupBy('invoice_no')
             ->get()
             ->sum('amount');
         $opJournalVoucherNetAmountForCredit = AdminJournalVoucher::where('account_name', $opAccount->account_name)
             ->where('branch_id', session()->get('selected_branch'))
             ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
             ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
             ->where('type','credit')
             ->groupBy('invoice_no')
             ->get()
             ->sum('amount');

         $opDebitOBalance += $opCreateDebitOpeningBalance + $opSaleInvoiceTotalNetAmount + $opDebitNoteTotalNetAmount + $opPaymentVoucherTotalNetAmountForCash + $opJournalVoucherNetAmountForDebit + $opReceiptVoucherTotalNetAmountForBank;

         $opCreditOBalance += $opCreateCreditOpeningBalance + $opPurchaesInvoiceTotalNetAmount + $opCreditNoteTotalNetAmount + $opJournalVoucherNetAmountForCredit + $opReceiptVoucherTotalNetAmountForCash + $opPaymentVoucherTotalNetAmountForBank;


         $opAccountDetails[$opAccount->class_of_account_id][] = [
             'account_id' => $opAccount->id,
             'accoun_name' => $opAccount->name_of_organisation ?? $opAccount->account_name,
             'type' => $opAccount->type,
             'class_of_account_id' => $opAccount->class_of_account_id,
             'DebitBalance' => $opDebitOBalance,
             'CreditBalance' => $opCreditOBalance,
         ];
         }

        // from_date to to_date - date range data


        $customers = Customer::where('branch_id', session()->get('selected_branch'))
        ->where('class_of_account_id', 15)
        ->get(['id', 'class_of_account_id', 'name_of_organisation as account_name', 'opening_balance', 'type', 'date']);



        $suppliers = Supplier::where('branch_id', session()->get('selected_branch'))
            ->where('class_of_account_id', 15)
            ->get(['id', 'class_of_account_id','name_of_organisation as account_name','opening_balance','type','date']);

        $expenses = Expense::where('branch_id', session()->get('selected_branch'))
            ->where('class_of_account_id', 15)
            ->get(['id', 'class_of_account_id','account_name','opening_balance','type','date']);

        $adminOtherAccounts = AdminOtherAccount::where('branch_id', session()->get('selected_branch'))
            ->where('class_of_account_id', 15)
            ->get(['id', 'class_of_account_id','account_name','opening_balance','type','date']);

        $staffAndSalesman = StaffAndSalesman::where('branch_id', session()->get('selected_branch'))
            ->where('class_of_account_id', 15)
            ->selectRaw('id, class_of_account_id, CONCAT(first_name, " ", last_name) as account_name,date_of_joining as date,type')
            ->get();


        // $halfFirstAccounts = $customers->concat($suppliers)->concat($expenses);
        // $halfSecondAccounts = $adminOtherAccounts->concat($staffAndSalesman);

        $allAccounts = $customers->concat($suppliers)->concat($expenses)->concat($adminOtherAccounts)->concat($staffAndSalesman);


        // from_date to to_date - date range data

        $accountDetails = [];

        foreach ($allAccounts as $account) {
            $DebitOB = 0;
            $CreditOB = 0;
            $CreateDebitOpeningBalance = 0;
            $CreateCreditOpeningBalance = 0;
            $debitAllAccountsDate = 0;
            $creditAllAccountsDate = 0;

            if (($account->type === 'Debit' || $account->type === 'debit') && $account->date >= $from_date && $account->date <= $to_date) {
                $debitAllAccountsDate = $account->date;
                $CreateDebitOpeningBalance = $account->opening_balance;
            }
             elseif (($account->type === 'Credit' || $account->type === 'credit') && $account->date >= $from_date && $account->date <= $to_date) {
                $creditAllAccountsDate = $account->date;
                $CreateCreditOpeningBalance = $account->opening_balance;

            }

            $ReceiptVoucherTotalNetAmountForCash = ReceiptVoucherExpense::where('account_name', $account->account_name)
                ->where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->whereNull('deleted_at')
                ->groupBy('invoice_no')
                ->get()
                ->sum('amount');

            $ReceiptVoucherTotalNetAmountForBank = ReceiptVoucherExpense::where('bank_name', $account->account_name)
                ->where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->whereNull('deleted_at')
                ->groupBy('invoice_no')
                ->get()
                ->sum('amount');

            $PurchaesInvoiceTotalNetAmount = AdminPurchaesInvoice::where('account_name', $account->account_name)
                ->where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->whereNull('deleted_at')
                ->groupBy('invoice_no')
                ->get()
                ->sum('total_net_amount');

            $SaleInvoiceTotalNetAmount = AdminSalesInvoice::where('account_name', $account->account_name)
                ->where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->whereNull('deleted_at')
                ->groupBy('invoice_no')
                ->get()
                ->sum('total_net_amount');



            $PaymentVoucherTotalNetAmountForBank = PaymentVoucherExpense::where(function($query) use ($account) {
                $query->where('bank_name', $account->account_name);
                })
                ->where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->whereNull('deleted_at')
                ->groupBy('invoice_no')
                ->get()
                ->sum(function ($voucher) {
                    return $voucher->amount + $voucher->new_vat_amount;
                });
            $PaymentVoucherTotalNetAmountForCash = PaymentVoucherExpense::where(function($query) use ($account) {
                $query->where('account_name', $account->account_name);
                })
                ->where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->whereNull('deleted_at')
                ->groupBy('invoice_no')
                ->get()
                ->sum(function ($voucher) {
                    return $voucher->amount + $voucher->new_vat_amount;
                });

                // dd($PaymentVoucherTotalNetAmountForBank,$PaymentVoucherTotalNetAmountForCash);

            $CreditNoteTotalNetAmount = CreditNote::where('account_name', $account->account_name)
                ->where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->groupBy('invoice_no')
                ->get()
                ->sum('total_net_amount');
            // dd($CreditNoteTotalNetAmount);
            $DebitNoteTotalNetAmount = DebitNote::where('account_name', $account->account_name)
                ->where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->groupBy('invoice_no')
                ->sum('total_net_amount');

            $JournalVoucherNetAmountForDebit = AdminJournalVoucher::where('account_name', $account->account_name)
                ->where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->where('type','debit')
                ->whereNull('deleted_at')
                ->groupBy('invoice_no')
                ->get()
                ->sum('amount');
            $JournalVoucherNetAmountForCredit = AdminJournalVoucher::where('account_name', $account->account_name)
                ->where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->where('type','credit')
                ->whereNull('deleted_at')
                ->groupBy('invoice_no')
                ->get()
                ->sum('amount');

                // dd($ReceiptVoucherTotalNetAmountForCash,$ReceiptVoucherTotalNetAmountForBank);

            // dd($JournalVoucherNetAmountForDebit,$JournalVoucherNetAmountForCredit);

            $DebitOB += $CreateDebitOpeningBalance + $SaleInvoiceTotalNetAmount + $DebitNoteTotalNetAmount + $PaymentVoucherTotalNetAmountForCash  + $JournalVoucherNetAmountForDebit + $ReceiptVoucherTotalNetAmountForBank;

            $CreditOB += $CreateCreditOpeningBalance + $PurchaesInvoiceTotalNetAmount + $CreditNoteTotalNetAmount + $JournalVoucherNetAmountForCredit + $ReceiptVoucherTotalNetAmountForCash + $PaymentVoucherTotalNetAmountForBank;



            $accountDetails[$account->class_of_account_id][] = [
                'account_id' => $account->id,
                'accoun_name' => $account->name_of_organisation ?? $account->account_name,
                'type' => $account->type,
                'class_of_account_id' => $account->class_of_account_id,
                'DebitBalance' => $DebitOB,
                'CreditBalance' => $CreditOB,
            ];
            }

            $mergedAccountDetails = [];

            // Merging opAccountDetails into mergedAccountDetails
            foreach ($opAccountDetails as $classId => $accounts) {
                foreach ($accounts as $account) {
                    $accountName = $account['accoun_name'];
                    if (!isset($mergedAccountDetails[$accountName])) {
                        $mergedAccountDetails[$accountName] = $account;
                    } else {
                        // Sum the DebitBalance and CreditBalance
                        $mergedAccountDetails[$accountName]['DebitBalance'] += $account['DebitBalance'];
                        $mergedAccountDetails[$accountName]['CreditBalance'] += $account['CreditBalance'];
                    }
                }
            }

            // Merging accountDetails into mergedAccountDetails
            foreach ($accountDetails as $classId => $accounts) {
                foreach ($accounts as $account) {
                    $accountName = $account['accoun_name'];
                    if (!isset($mergedAccountDetails[$accountName])) {
                        $mergedAccountDetails[$accountName] = $account;
                    } else {
                        // Sum the DebitBalance and CreditBalance
                        $mergedAccountDetails[$accountName]['DebitBalance'] += $account['DebitBalance'];
                        $mergedAccountDetails[$accountName]['CreditBalance'] += $account['CreditBalance'];
                    }
                }
            }

            // Calculate the difference between DebitBalance and CreditBalance for each account
            foreach ($mergedAccountDetails as &$account) {
                $account['BalanceDifference'] = $account['DebitBalance'] - $account['CreditBalance'];
            }
            unset($account); // Unset reference to avoid potential bugs

            // dd($mergedAccountDetails);





            // // dd($accountDetails,$opAccountDetails);

            // foreach ($mergedAccountDetails as &$account) {
            //     $netBalance = $account['DebitBalance'] - $account['CreditBalance'];

            //     if ($netBalance > 0) {
            //         $account['DebitBalance'] = $netBalance;
            //         $account['CreditBalance'] = 0;
            //     } else {
            //         $account['CreditBalance'] = abs($netBalance);
            //         $account['DebitBalance'] = 0;
            //     }
            // }

            // dd($mergedAccountDetails);

            $SundryCreditorsTotalDebit = array_sum(array_column($mergedAccountDetails, 'DebitBalance'));
            $SundryCreditorsTotalCredit = array_sum(array_column($mergedAccountDetails, 'CreditBalance'));

            // dd([
            //     'mergedAccountDetails' => $mergedAccountDetails,
            //     'SundryCreditorsTotalDebit' => $SundryCreditorsTotalDebit,
            //     'SundryCreditorsTotalCredit' => $SundryCreditorsTotalCredit
            // ]);

            return [$SundryCreditorsTotalDebit,$SundryCreditorsTotalCredit,$from_date, $to_date,];

    }
    // -----   Sundry Creditors For Trial Balance ------------------------------------------------------------- >>>>>>>>>>>>>>>>>>

    public function AllSundryCreditorsClassofAccountsForTrialBalance($request, $from_date, $to_date)
    {

        $from_date = $request->to_date;
        $to_date = $request->to_date;

        $currentYearFirstDate = date("2003-01-01");
        $oneDayPreviousDate = date('Y-m-d', strtotime('-1 day', strtotime($from_date)));

        $opcustomers = Customer::where('branch_id', session()->get('selected_branch'))
            ->where('class_of_account_id', 15)
            ->get(['id', 'class_of_account_id','name_of_organisation as account_name','opening_balance','type','date']);

        $opsuppliers = Supplier::where('branch_id', session()->get('selected_branch'))
            ->where('class_of_account_id', 15)
            ->get(['id', 'class_of_account_id','name_of_organisation as account_name','opening_balance','type','date']);

        $opexpenses = Expense::where('branch_id', session()->get('selected_branch'))
            ->where('class_of_account_id',15)
            ->get(['id', 'class_of_account_id','account_name','opening_balance','type','date']);

        $opadminOtherAccounts = AdminOtherAccount::where('branch_id', session()->get('selected_branch'))
            ->where('class_of_account_id', 15)
            ->get(['id', 'class_of_account_id','account_name','opening_balance','type','date']);

        $opstaffAndSalesman = StaffAndSalesman::where('branch_id', session()->get('selected_branch'))
            ->where('class_of_account_id', 15)
            ->selectRaw('id, class_of_account_id, CONCAT(first_name, " ", last_name) as account_name,date_of_joining as date')
            ->get();

        $opAllAccounts = $opcustomers->concat($opsuppliers)->concat($opexpenses)->concat($opadminOtherAccounts)->concat($opstaffAndSalesman);

        // dd($opAllAccounts);

        $opAccountDetails = [];

        foreach ($opAllAccounts as $opAccount) {
            $opDebitOBalance = 0;
            $opCreditOBalance = 0;
            $opCreateDebitOpeningBalance = 0;
            $opCreateCreditOpeningBalance = 0;
            $debitAllAccountsDate = 0;
            $creditAllAccountsDate = 0;

            if (($opAccount->type === 'Debit' || $opAccount->type === 'debit') && $opAccount->date >= $currentYearFirstDate && $opAccount->date <= $oneDayPreviousDate ) {
                // $debitAllAccountsDate = $opAccount->date;
                $opCreateDebitOpeningBalance = $opAccount->opening_balance;

            } elseif (($opAccount->type === 'Credit' || $opAccount->type === 'credit') && $opAccount->date >= $currentYearFirstDate && $opAccount->date <= $oneDayPreviousDate ) {
                // $creditAllAccountsDate = $opAccount->date;
                $opCreateCreditOpeningBalance = $opAccount->opening_balance;

            }

         // dd($DebitOB,$CreditOB,$debitAllAccountsDate,$creditAllAccountsDate);

         $opPurchaesInvoiceTotalNetAmount = AdminPurchaesInvoice::where('account_name', $opAccount->account_name)
             ->where('branch_id', session()->get('selected_branch'))
             ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
             ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
             ->whereNull('deleted_at')
             ->groupBy('invoice_no')
             ->get()
             ->sum('total_net_amount');

         $opSaleInvoiceTotalNetAmount = AdminSalesInvoice::where('account_name', $opAccount->account_name)
             ->where('branch_id', session()->get('selected_branch'))
             ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
             ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
             ->whereNull('deleted_at')
             ->groupBy('invoice_no')
             ->get()
             ->sum('total_net_amount');

         $opReceiptVoucherTotalNetAmountForCash = ReceiptVoucherExpense::where('account_name', $opAccount->account_name)
             ->where('branch_id', session()->get('selected_branch'))
             ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
             ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
             ->whereNull('deleted_at')
             ->groupBy('invoice_no')
             ->get()
             ->sum('amount');

         $opReceiptVoucherTotalNetAmountForBank = ReceiptVoucherExpense::
              where('bank_name', $opAccount->account_name)
             ->where('branch_id', session()->get('selected_branch'))
             ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
             ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
             ->whereNull('deleted_at')
             ->groupBy('invoice_no')
             ->get()
             ->sum('amount');

         $opPaymentVoucherTotalNetAmountForBank = PaymentVoucherExpense::
              where('bank_name', $opAccount->account_name)
             ->where('branch_id', session()->get('selected_branch'))
             ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
             ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
             ->whereNull('deleted_at')
             ->groupBy('invoice_no')
             ->get()
             ->sum(function ($voucher) {
                 return $voucher->amount + $voucher->new_vat_amount;
             });

         $opPaymentVoucherTotalNetAmountForCash = PaymentVoucherExpense::where('account_name', $opAccount->account_name)
             ->where('branch_id', session()->get('selected_branch'))
             ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
             ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
             ->whereNull('deleted_at')
             ->groupBy('invoice_no')
             ->get()
             ->sum(function ($voucher) {
                 return $voucher->amount + $voucher->new_vat_amount;
             });

             // dd($PaymentVoucherTotalNetAmountForBank,$PaymentVoucherTotalNetAmountForCash);

         $opCreditNoteTotalNetAmount = CreditNote::where('account_name', $opAccount->account_name)
             ->where('branch_id', session()->get('selected_branch'))
             ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
             ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
             ->groupBy('invoice_no')
             ->sum('total_net_amount');

         $opDebitNoteTotalNetAmount = DebitNote::where('account_name', $opAccount->account_name)
             ->where('branch_id', session()->get('selected_branch'))
             ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
             ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
             ->groupBy('invoice_no')
             ->sum('total_net_amount');

         $opJournalVoucherNetAmountForDebit = AdminJournalVoucher::where('account_name', $opAccount->account_name)
             ->where('branch_id', session()->get('selected_branch'))
             ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
             ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
             ->where('type','debit')
             ->groupBy('invoice_no')
             ->get()
             ->sum('amount');


         $opJournalVoucherNetAmountForCredit = AdminJournalVoucher::where('account_name', $opAccount->account_name)
             ->where('branch_id', session()->get('selected_branch'))
             ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
             ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
             ->where('type','credit')
             ->groupBy('invoice_no')
             ->get()
             ->sum('amount');

         $opDebitOBalance = $opCreateDebitOpeningBalance + $opSaleInvoiceTotalNetAmount + $opDebitNoteTotalNetAmount + $opPaymentVoucherTotalNetAmountForCash + $opJournalVoucherNetAmountForDebit + $opReceiptVoucherTotalNetAmountForBank;

         $opCreditOBalance = $opCreateCreditOpeningBalance + $opPurchaesInvoiceTotalNetAmount + $opCreditNoteTotalNetAmount + $opJournalVoucherNetAmountForCredit + $opReceiptVoucherTotalNetAmountForCash + $opPaymentVoucherTotalNetAmountForBank;

        //  dd($opCreateDebitOpeningBalance ,$opSaleInvoiceTotalNetAmount , $opDebitNoteTotalNetAmount , $opPaymentVoucherTotalNetAmountForCash , $opJournalVoucherNetAmountForDebit , $opReceiptVoucherTotalNetAmountForBank);

        //  dd($opCreateCreditOpeningBalance , $opPurchaesInvoiceTotalNetAmount , $opCreditNoteTotalNetAmount , $opJournalVoucherNetAmountForCredit ,$opReceiptVoucherTotalNetAmountForCash, $opPaymentVoucherTotalNetAmountForBank);

         $opAccountDetails[$opAccount->class_of_account_id][] = [
             'account_id' => $opAccount->id,
             'accoun_name' => $opAccount->name_of_organisation ?? $opAccount->account_name,
             'type' => $opAccount->type,
             'class_of_account_id' => $opAccount->class_of_account_id,
             'DebitBalance' => $opDebitOBalance,
             'CreditBalance' => $opCreditOBalance,
         ];
         }

        // from_date to to_date - date range data


        $customers = Customer::where('branch_id', session()->get('selected_branch'))
        ->where('class_of_account_id', 15)
        ->get(['id', 'class_of_account_id', 'name_of_organisation as account_name', 'opening_balance', 'type', 'date']);



        $suppliers = Supplier::where('branch_id', session()->get('selected_branch'))
            ->where('class_of_account_id', 15)
            ->get(['id', 'class_of_account_id','name_of_organisation as account_name','opening_balance','type','date']);

        $expenses = Expense::where('branch_id', session()->get('selected_branch'))
            ->where('class_of_account_id', 15)
            ->get(['id', 'class_of_account_id','account_name','opening_balance','type','date']);

        $adminOtherAccounts = AdminOtherAccount::where('branch_id', session()->get('selected_branch'))
            ->where('class_of_account_id', 15)
            ->get(['id', 'class_of_account_id','account_name','opening_balance','type','date']);

        $staffAndSalesman = StaffAndSalesman::where('branch_id', session()->get('selected_branch'))
            ->where('class_of_account_id', 15)
            ->selectRaw('id, class_of_account_id, CONCAT(first_name, " ", last_name) as account_name,date_of_joining as date,type')
            ->get();


        // $halfFirstAccounts = $customers->concat($suppliers)->concat($expenses);
        // $halfSecondAccounts = $adminOtherAccounts->concat($staffAndSalesman);

        $allAccounts = $customers->concat($suppliers)->concat($expenses)->concat($adminOtherAccounts)->concat($staffAndSalesman);


        // from_date to to_date - date range data

        $accountDetails = [];

        foreach ($allAccounts as $account) {
            $DebitOB = 0;
            $CreditOB = 0;
            $CreateDebitOpeningBalance = 0;
            $CreateCreditOpeningBalance = 0;
            $debitAllAccountsDate = 0;
            $creditAllAccountsDate = 0;

            if (($account->type === 'Debit' || $account->type === 'debit') && $account->date >= $from_date && $account->date <= $to_date ) {
                // $debitAllAccountsDate = $account->date;
                $CreateDebitOpeningBalance = $account->opening_balance;

            } elseif (($account->type === 'Credit' || $account->type === 'credit') && $account->date >= $from_date && $account->date <= $to_date ) {
                // $creditAllAccountsDate = $account->date;
                $CreateCreditOpeningBalance = $account->opening_balance;

            }

            $ReceiptVoucherTotalNetAmountForCash = ReceiptVoucherExpense::where('account_name', $account->account_name)
                ->where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->whereNull('deleted_at')
                ->groupBy('invoice_no')
                ->get()
                ->sum('amount');

            $ReceiptVoucherTotalNetAmountForBank = ReceiptVoucherExpense::where('bank_name', $account->account_name)
                ->where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->whereNull('deleted_at')
                ->groupBy('invoice_no')
                ->get()
                ->sum('amount');

            $PurchaesInvoiceTotalNetAmount = AdminPurchaesInvoice::where('account_name', $account->account_name)
                ->where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->whereNull('deleted_at')
                ->groupBy('invoice_no')
                ->get()
                ->sum('total_net_amount');

            $SaleInvoiceTotalNetAmount = AdminSalesInvoice::where('account_name', $account->account_name)
                ->where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->whereNull('deleted_at')
                ->groupBy('invoice_no')
                ->get()
                ->sum('total_net_amount');



            $PaymentVoucherTotalNetAmountForBank = PaymentVoucherExpense::where(function($query) use ($account) {
                $query->where('bank_name', $account->account_name);
                })
                ->where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->whereNull('deleted_at')
                ->groupBy('invoice_no')
                ->get()
                ->sum(function ($voucher) {
                    return $voucher->amount + $voucher->new_vat_amount;
                });
            $PaymentVoucherTotalNetAmountForCash = PaymentVoucherExpense::where(function($query) use ($account) {
                $query->where('account_name', $account->account_name);
                })
                ->where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->whereNull('deleted_at')
                ->groupBy('invoice_no')
                ->get()
                ->sum(function ($voucher) {
                    return $voucher->amount + $voucher->new_vat_amount;
                });

                // dd($PaymentVoucherTotalNetAmountForBank,$PaymentVoucherTotalNetAmountForCash);

            $CreditNoteTotalNetAmount = CreditNote::where('account_name', $account->account_name)
                ->where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->groupBy('invoice_no')
                ->get()
                ->sum('total_net_amount');
            // dd($CreditNoteTotalNetAmount);
            $DebitNoteTotalNetAmount = DebitNote::where('account_name', $account->account_name)
                ->where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->groupBy('invoice_no')
                ->get()
                ->sum('total_net_amount');

            $JournalVoucherNetAmountForDebit = AdminJournalVoucher::where('account_name', $account->account_name)
                ->where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->where('type','debit')
                ->whereNull('deleted_at')
                ->groupBy('invoice_no')
                ->get()
                ->sum('amount');
            $JournalVoucherNetAmountForCredit = AdminJournalVoucher::where('account_name', $account->account_name)
                ->where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->where('type','credit')
                ->whereNull('deleted_at')
                ->groupBy('invoice_no')
                ->get()
                ->sum('amount');

                // dd($ReceiptVoucherTotalNetAmountForCash,$ReceiptVoucherTotalNetAmountForBank);

            // dd($JournalVoucherNetAmountForDebit,$JournalVoucherNetAmountForCredit);


            // $obTotalDebitValue = $TotalSaleInvoice + $obTotalPaymentVoucherForCash + $obTotalDebitNote + $TotalobJournalVoucherForDebit + $TotalobReceiptVoucherForBank;

            // $obTotalCreditValue = $TotalPurchaesInvoice  + $TotalobReceiptVoucherForCash + $TotalCreditNote + $TotalobJournalVoucherForCredit + $obTotalPaymentVoucherForBank;


            $DebitOB = $CreateDebitOpeningBalance +  $SaleInvoiceTotalNetAmount + $DebitNoteTotalNetAmount + $PaymentVoucherTotalNetAmountForCash  + $JournalVoucherNetAmountForDebit + $ReceiptVoucherTotalNetAmountForBank;

            $CreditOB = $CreateCreditOpeningBalance + $PurchaesInvoiceTotalNetAmount + $CreditNoteTotalNetAmount + $JournalVoucherNetAmountForCredit + $ReceiptVoucherTotalNetAmountForCash + $PaymentVoucherTotalNetAmountForBank;

            // dd($CreateDebitOpeningBalance ,  $SaleInvoiceTotalNetAmount , $DebitNoteTotalNetAmount , $PaymentVoucherTotalNetAmountForBank  ,$JournalVoucherNetAmountForDebit , $ReceiptVoucherTotalNetAmountForBank);

            // dd($CreateCreditOpeningBalance , $PurchaesInvoiceTotalNetAmount , $CreditNoteTotalNetAmount , $JournalVoucherNetAmountForCredit , $ReceiptVoucherTotalNetAmountForCash , $$PaymentVoucherTotalNetAmountForCash);

            $accountDetails[$account->class_of_account_id][] = [
                'account_id' => $account->id,
                'accoun_name' => $account->name_of_organisation ?? $account->account_name,
                'type' => $account->type,
                'class_of_account_id' => $account->class_of_account_id,
                'DebitBalance' => $DebitOB,
                'CreditBalance' => $CreditOB,
            ];
            }


            $mergedAccountDetails = [];

            // Merging accountDetails into mergedAccountDetails
            foreach ($accountDetails as $classId => $accounts) {
             foreach ($accounts as $account) {
                 $accountName = $account['accoun_name'];
                 if (!isset($mergedAccountDetails[$accountName])) {
                     $mergedAccountDetails[$accountName] = $account;
                 } else {
                     // Sum the DebitBalance and CreditBalance
                     $mergedAccountDetails[$accountName]['DebitBalance'] += $account['DebitBalance'];
                     $mergedAccountDetails[$accountName]['CreditBalance'] += $account['CreditBalance'];
                 }
             }
         }

         // Merging opAccountDetails into mergedAccountDetails
         foreach ($opAccountDetails as $classId => $accounts) {
             foreach ($accounts as $account) {
                 $accountName = $account['accoun_name'];
                 if (!isset($mergedAccountDetails[$accountName])) {
                     $mergedAccountDetails[$accountName] = $account;
                 } else {
                     // Sum the DebitBalance and CreditBalance
                     $mergedAccountDetails[$accountName]['DebitBalance'] += $account['DebitBalance'];
                     $mergedAccountDetails[$accountName]['CreditBalance'] += $account['CreditBalance'];
                 }
             }
         }

         $SundryCreditorsTotalDebit = 0;
         $SundryCreditorsTotalCredit = 0;

         foreach ($mergedAccountDetails as $accountName => $account) {
             $netBalance = $account['DebitBalance'] - $account['CreditBalance'];
             if ($netBalance > 0) {
                 // Positive balance goes to debit side
                 $SundryCreditorsTotalDebit += $netBalance;
             } else {
                 // Negative balance goes to credit side
                 $SundryCreditorsTotalCredit += abs($netBalance);
             }
         }

            // dd([
            //     'SundryCreditorsTotalDebit' => $SundryCreditorsTotalDebit,
            //     'SundryCreditorsTotalCredit' => $SundryCreditorsTotalCredit
            // ]);

            return [$SundryCreditorsTotalDebit,$SundryCreditorsTotalCredit,$from_date, $to_date,];


            // dd($accountDetails,$opAccountDetails);

                // $mergedAccountDetails = [];

                // foreach ($opAccountDetails as $classId => $accounts) {
                //     foreach ($accounts as $account) {
                //         $mergedAccountDetails[$account['account_id']] = $account;
                //     }
                // }

                // foreach ($accountDetails as $classId => $accounts) {
                //     foreach ($accounts as $account) {
                //         $mergedAccountDetails[$account['account_id']] = $account;
                //     }
                // }

                // foreach ($mergedAccountDetails as $account) {
                //     $totalDebit = array_sum(array_column($mergedAccountDetails, 'DebitBalance'));
                //     $totalCredit = array_sum(array_column($mergedAccountDetails, 'CreditBalance'));
                // }

                // foreach ($mergedAccountDetails as &$account) {
                //     $netBalance = $account['DebitBalance'] - $account['CreditBalance'];

                //     if ($netBalance > 0) {
                //         $account['DebitBalance'] = $netBalance;
                //         $account['CreditBalance'] = 0;
                //     } else {
                //         $account['CreditBalance'] = abs($netBalance);
                //         $account['DebitBalance'] = 0;
                //     }
                // }
                // dd($mergedAccountDetails);





                // // Step 1: Retrieve ClassOfAccount details from the database
                // $classOfAccountDetails = ClassOfAccount::all()->keyBy('id');

                // // Step 2: Initialize mergedAccountDetails and populate it
                // $mergedAccountDetails = [];

                // foreach ($opAccountDetails as $classId => $accounts) {
                //     foreach ($accounts as $account) {
                //         $mergedAccountDetails[$account['account_id']] = $account;
                //     }
                // }

                // foreach ($accountDetails as $classId => $accounts) {
                //     foreach ($accounts as $account) {
                //         $mergedAccountDetails[$account['account_id']] = $account;
                //     }
                // }

                // // Step 3: Group by class of account name
                // $groupedAccountDetails = [];

                // foreach ($mergedAccountDetails as $account) {
                //     $classId = $account['class_of_account_id'];
                //     $className = $classOfAccountDetails[$classId]->name ?? 'Unknown';

                //     if (!isset($groupedAccountDetails[$className])) {
                //         $groupedAccountDetails[$className] = [];
                //     }
                //     $groupedAccountDetails[$className][] = $account;
                // }

                // // Step 4: Adjust balances within each group
                // foreach ($groupedAccountDetails as &$group) {
                //     foreach ($group as &$account) {
                //         $netBalance = $account['DebitBalance'] - $account['CreditBalance'];

                //         if ($netBalance > 0) {
                //             $account['DebitBalance'] = $netBalance;
                //             $account['CreditBalance'] = 0;
                //         } else {
                //             $account['CreditBalance'] = abs($netBalance);
                //             $account['DebitBalance'] = 0;
                //         }
                //     }
                // }

                // dd($groupedAccountDetails);

            // return [$groupedAccountDetails,$from_date, $to_date,];

    }
    // -----   Current Liabilities   ------------------------------------------------------------- >>>>>>>>>>>>>>>>>>

    public function AllCurrentLiabilitiesClassofAccounts($request, $from_date, $to_date)
    {

        $from_date = $request->from_date;
        $to_date = $request->to_date;

        $currentYearFirstDate = date("2003-01-01");
        $oneDayPreviousDate = date('Y-m-d', strtotime('-1 day', strtotime($from_date)));

        $opcustomers = Customer::where('branch_id', session()->get('selected_branch'))
            ->where('class_of_account_id', 5)
            ->get(['id', 'class_of_account_id','name_of_organisation as account_name','opening_balance','type','date']);

        $opsuppliers = Supplier::where('branch_id', session()->get('selected_branch'))
            ->where('class_of_account_id', 5)
            ->get(['id', 'class_of_account_id','name_of_organisation as account_name','opening_balance','type','date']);

        $opexpenses = Expense::where('branch_id', session()->get('selected_branch'))
            ->where('class_of_account_id',5)
            ->get(['id', 'class_of_account_id','account_name','opening_balance','type','date']);

        $opadminOtherAccounts = AdminOtherAccount::where('branch_id', session()->get('selected_branch'))
            ->where('class_of_account_id', 5)
            ->get(['id', 'class_of_account_id','account_name','opening_balance','type','date']);

        $opstaffAndSalesman = StaffAndSalesman::where('branch_id', session()->get('selected_branch'))
            ->where('class_of_account_id', 5)
            ->selectRaw('id, class_of_account_id, CONCAT(first_name, " ", last_name) as account_name,date_of_joining as date')
            ->get();

        $opAllAccounts = $opcustomers->concat($opsuppliers)->concat($opexpenses)->concat($opadminOtherAccounts)->concat($opstaffAndSalesman);

        // dd($opAllAccounts);

        $opAccountDetails = [];

        foreach ($opAllAccounts as $opAccount) {
            $opDebitOBalance = 0;
            $opCreditOBalance = 0;
            $opCreateDebitOpeningBalance = 0;
            $opCreateCreditOpeningBalance = 0;
            $debitAllAccountsDate = 0;
            $creditAllAccountsDate = 0;

            if (($opAccount->type === 'Debit' || $opAccount->type === 'debit') && $opAccount->date >= $currentYearFirstDate && $opAccount->date <= $oneDayPreviousDate) {
                $debitAllAccountsDate = $opAccount->date;
                $opCreateDebitOpeningBalance = $opAccount->opening_balance;

            } elseif (($opAccount->type === 'Credit' || $opAccount->type === 'credit') && $opAccount->date >= $currentYearFirstDate && $opAccount->date <= $oneDayPreviousDate) {
                $creditAllAccountsDate = $opAccount->date;
                $opCreateCreditOpeningBalance = $opAccount->opening_balance;

            }

         // dd($DebitOB,$CreditOB,$debitAllAccountsDate,$creditAllAccountsDate);

         $opPurchaesInvoiceTotalNetAmount = AdminPurchaesInvoice::where('account_name', $opAccount->account_name)
             ->where('branch_id', session()->get('selected_branch'))
             ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
             ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
             ->whereNull('deleted_at')
             ->groupBy('invoice_no')
             ->get()
             ->sum('total_net_amount');

         $opSaleInvoiceTotalNetAmount = AdminSalesInvoice::where('account_name', $opAccount->account_name)
             ->where('branch_id', session()->get('selected_branch'))
             ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
             ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
             ->whereNull('deleted_at')
             ->groupBy('invoice_no')
             ->get()
             ->sum('total_net_amount');

         $opReceiptVoucherTotalNetAmountForCash = ReceiptVoucherExpense::where('account_name', $opAccount->account_name)
             ->where('branch_id', session()->get('selected_branch'))
            //  ->where('payment_method','cash')
             ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
             ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
             ->whereNull('deleted_at')
             ->groupBy('invoice_no')
             ->get()
             ->sum('amount');
         $opReceiptVoucherTotalNetAmountForBank = ReceiptVoucherExpense::
              where('bank_name', $opAccount->account_name)
             ->where('branch_id', session()->get('selected_branch'))
            //  ->where('payment_method','bank')
             ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
             ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
             ->whereNull('deleted_at')
             ->groupBy('invoice_no')
             ->get()
             ->sum('amount');

         $opPaymentVoucherTotalNetAmountForBank = PaymentVoucherExpense::
              where('bank_name', $opAccount->account_name)
             ->where('branch_id', session()->get('selected_branch'))
            //  ->where('payment_method','bank')
             ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
             ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
             ->whereNull('deleted_at')
             ->groupBy('invoice_no')
             ->get()
             ->sum(function ($voucher) {
                 return $voucher->amount + $voucher->new_vat_amount;
             });
         $opPaymentVoucherTotalNetAmountForCash = PaymentVoucherExpense::where('account_name', $opAccount->account_name)
             ->where('branch_id', session()->get('selected_branch'))
            //  ->where('payment_method','cash')
             ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
             ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
             ->whereNull('deleted_at')
             ->groupBy('invoice_no')
             ->get()
             ->sum(function ($voucher) {
                 return $voucher->amount + $voucher->new_vat_amount;
             });

             // dd($PaymentVoucherTotalNetAmountForBank,$PaymentVoucherTotalNetAmountForCash);

         $opCreditNoteTotalNetAmount = CreditNote::where('account_name', $opAccount->account_name)
             ->where('branch_id', session()->get('selected_branch'))
             ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
             ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
             ->groupBy('invoice_no')
             ->sum('total_net_amount');

         $opDebitNoteTotalNetAmount = DebitNote::where('account_name', $opAccount->account_name)
             ->where('branch_id', session()->get('selected_branch'))
             ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
             ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
             ->groupBy('invoice_no')
             ->sum('total_net_amount');

         $opJournalVoucherNetAmountForDebit = AdminJournalVoucher::where('account_name', $opAccount->account_name)
             ->where('branch_id', session()->get('selected_branch'))
             ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
             ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
             ->where('type','debit')
             ->groupBy('invoice_no')
             ->get()
             ->sum('amount');
         $opJournalVoucherNetAmountForCredit = AdminJournalVoucher::where('account_name', $opAccount->account_name)
             ->where('branch_id', session()->get('selected_branch'))
             ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
             ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
             ->where('type','credit')
             ->groupBy('invoice_no')
             ->get()
             ->sum('amount');

         $opDebitOBalance += $opCreateDebitOpeningBalance + $opSaleInvoiceTotalNetAmount + $opDebitNoteTotalNetAmount + $opPaymentVoucherTotalNetAmountForCash + $opJournalVoucherNetAmountForDebit + $opReceiptVoucherTotalNetAmountForBank;

         $opCreditOBalance += $opCreateCreditOpeningBalance + $opPurchaesInvoiceTotalNetAmount + $opCreditNoteTotalNetAmount + $opJournalVoucherNetAmountForCredit + $opReceiptVoucherTotalNetAmountForCash + $opPaymentVoucherTotalNetAmountForBank;


         $opAccountDetails[$opAccount->class_of_account_id][] = [
             'account_id' => $opAccount->id,
             'accoun_name' => $opAccount->name_of_organisation ?? $opAccount->account_name,
             'type' => $opAccount->type,
             'class_of_account_id' => $opAccount->class_of_account_id,
             'DebitBalance' => $opDebitOBalance,
             'CreditBalance' => $opCreditOBalance,
         ];
         }

        // from_date to to_date - date range data


        $customers = Customer::where('branch_id', session()->get('selected_branch'))
        ->where('class_of_account_id', 5)
        ->get(['id', 'class_of_account_id', 'name_of_organisation as account_name', 'opening_balance', 'type', 'date']);



        $suppliers = Supplier::where('branch_id', session()->get('selected_branch'))
            ->where('class_of_account_id', 5)
            ->get(['id', 'class_of_account_id','name_of_organisation as account_name','opening_balance','type','date']);

        $expenses = Expense::where('branch_id', session()->get('selected_branch'))
            ->where('class_of_account_id', 5)
            ->get(['id', 'class_of_account_id','account_name','opening_balance','type','date']);

        $adminOtherAccounts = AdminOtherAccount::where('branch_id', session()->get('selected_branch'))
            ->where('class_of_account_id', 5)
            ->get(['id', 'class_of_account_id','account_name','opening_balance','type','date']);

        $staffAndSalesman = StaffAndSalesman::where('branch_id', session()->get('selected_branch'))
            ->where('class_of_account_id', 5)
            ->selectRaw('id, class_of_account_id, CONCAT(first_name, " ", last_name) as account_name,date_of_joining as date,type')
            ->get();


        // $halfFirstAccounts = $customers->concat($suppliers)->concat($expenses);
        // $halfSecondAccounts = $adminOtherAccounts->concat($staffAndSalesman);

        $allAccounts = $customers->concat($suppliers)->concat($expenses)->concat($adminOtherAccounts)->concat($staffAndSalesman);


        // from_date to to_date - date range data

        $accountDetails = [];

        foreach ($allAccounts as $account) {
            $DebitOB = 0;
            $CreditOB = 0;
            $CreateDebitOpeningBalance = 0;
            $CreateCreditOpeningBalance = 0;
            $debitAllAccountsDate = 0;
            $creditAllAccountsDate = 0;

            if ($account->type === 'Debit' || $account->type === 'debit' && $account->date >= $from_date && $account->date <= $to_date) {
                $debitAllAccountsDate = $account->date;
                $CreateDebitOpeningBalance = $account->opening_balance;

            } elseif ($account->type === 'Credit' || $account->type === 'credit' && $account->date >= $from_date && $account->date <= $to_date) {
                $creditAllAccountsDate = $account->date;
                $CreateCreditOpeningBalance = $account->opening_balance;

            }

            $ReceiptVoucherTotalNetAmountForCash = ReceiptVoucherExpense::where('account_name', $account->account_name)
                ->where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->whereNull('deleted_at')
                ->groupBy('invoice_no')
                ->get()
                ->sum('amount');

            $ReceiptVoucherTotalNetAmountForBank = ReceiptVoucherExpense::where('bank_name', $account->account_name)
                ->where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->whereNull('deleted_at')
                ->groupBy('invoice_no')
                ->get()
                ->sum('amount');

            $PurchaesInvoiceTotalNetAmount = AdminPurchaesInvoice::where('account_name', $account->account_name)
                ->where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->whereNull('deleted_at')
                ->groupBy('invoice_no')
                ->get()
                ->sum('total_net_amount');

            $SaleInvoiceTotalNetAmount = AdminSalesInvoice::where('account_name', $account->account_name)
                ->where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->whereNull('deleted_at')
                ->groupBy('invoice_no')
                ->get()
                ->sum('total_net_amount');



            $PaymentVoucherTotalNetAmountForBank = PaymentVoucherExpense::where(function($query) use ($account) {
                $query->where('bank_name', $account->account_name);
                })
                ->where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->whereNull('deleted_at')
                ->groupBy('invoice_no')
                ->get()
                ->sum(function ($voucher) {
                    return $voucher->amount + $voucher->new_vat_amount;
                });
            $PaymentVoucherTotalNetAmountForCash = PaymentVoucherExpense::where(function($query) use ($account) {
                $query->where('account_name', $account->account_name);
                })
                ->where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->whereNull('deleted_at')
                ->groupBy('invoice_no')
                ->get()
                ->sum(function ($voucher) {
                    return $voucher->amount + $voucher->new_vat_amount;
                });

                // dd($PaymentVoucherTotalNetAmountForBank,$PaymentVoucherTotalNetAmountForCash);

            $CreditNoteTotalNetAmount = CreditNote::where('account_name', $account->account_name)
                ->where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->groupBy('invoice_no')
                ->get()
                ->sum('total_net_amount');
            // dd($CreditNoteTotalNetAmount);
            $DebitNoteTotalNetAmount = DebitNote::where('account_name', $account->account_name)
                ->where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->groupBy('invoice_no')
                ->sum('total_net_amount');

            $JournalVoucherNetAmountForDebit = AdminJournalVoucher::where('account_name', $account->account_name)
                ->where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->where('type','debit')
                ->whereNull('deleted_at')
                ->groupBy('invoice_no')
                ->get()
                ->sum('amount');
            $JournalVoucherNetAmountForCredit = AdminJournalVoucher::where('account_name', $account->account_name)
                ->where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->where('type','credit')
                ->whereNull('deleted_at')
                ->groupBy('invoice_no')
                ->get()
                ->sum('amount');

                // dd($ReceiptVoucherTotalNetAmountForCash,$ReceiptVoucherTotalNetAmountForBank);

            // dd($JournalVoucherNetAmountForDebit,$JournalVoucherNetAmountForCredit);

            $DebitOB += $CreateDebitOpeningBalance +  $SaleInvoiceTotalNetAmount + $DebitNoteTotalNetAmount + $PaymentVoucherTotalNetAmountForCash  + $JournalVoucherNetAmountForDebit + $ReceiptVoucherTotalNetAmountForBank;

            $CreditOB += $CreateCreditOpeningBalance + $PurchaesInvoiceTotalNetAmount + $CreditNoteTotalNetAmount + $JournalVoucherNetAmountForCredit + $ReceiptVoucherTotalNetAmountForCash + $PaymentVoucherTotalNetAmountForBank;



            $accountDetails[$account->class_of_account_id][] = [
                'account_id' => $account->id,
                'accoun_name' => $account->name_of_organisation ?? $account->account_name,
                'type' => $account->type,
                'class_of_account_id' => $account->class_of_account_id,
                'DebitBalance' => $DebitOB,
                'CreditBalance' => $CreditOB,
            ];
            }

            // $CurrentLiabilitiesAccountDetails = [];

            // foreach ($opAccountDetails as $classId => $accounts) {
            //     foreach ($accounts as $account) {
            //         $CurrentLiabilitiesAccountDetails[$account['account_id']] = $account;
            //     }
            // }

            // foreach ($accountDetails as $classId => $accounts) {
            //     foreach ($accounts as $account) {
            //         $CurrentLiabilitiesAccountDetails[$account['account_id']] = $account;
            //     }
            // }

            // foreach ($CurrentLiabilitiesAccountDetails as &$account) {
            //     $netBalance = $account['DebitBalance'] - $account['CreditBalance'];

            //     if ($netBalance > 0) {
            //         $account['DebitBalance'] = $netBalance;
            //         $account['CreditBalance'] = 0;
            //     } else {
            //         $account['CreditBalance'] = abs($netBalance);
            //         $account['DebitBalance'] = 0;
            //     }
            // }

            $CurrentLiabilitiesAccountDetails = [];

            // Merging accountDetails into mergedAccountDetails
            foreach ($accountDetails as $classId => $accounts) {
             foreach ($accounts as $account) {
                 $accountName = $account['accoun_name'];
                 if (!isset($CurrentLiabilitiesAccountDetails[$accountName])) {
                     $CurrentLiabilitiesAccountDetails[$accountName] = $account;
                 } else {
                     // Sum the DebitBalance and CreditBalance
                     $CurrentLiabilitiesAccountDetails[$accountName]['DebitBalance'] += $account['DebitBalance'];
                     $CurrentLiabilitiesAccountDetails[$accountName]['CreditBalance'] += $account['CreditBalance'];
                 }
             }
         }

         // Merging opAccountDetails into mergedAccountDetails
         foreach ($opAccountDetails as $classId => $accounts) {
             foreach ($accounts as $account) {
                 $accountName = $account['accoun_name'];
                 if (!isset($CurrentLiabilitiesAccountDetails[$accountName])) {
                     $CurrentLiabilitiesAccountDetails[$accountName] = $account;
                 } else {
                     // Sum the DebitBalance and CreditBalance
                     $CurrentLiabilitiesAccountDetails[$accountName]['DebitBalance'] += $account['DebitBalance'];
                     $CurrentLiabilitiesAccountDetails[$accountName]['CreditBalance'] += $account['CreditBalance'];
                 }
             }
         }



         // Calculate the difference between DebitBalance and CreditBalance for each account
         foreach ($CurrentLiabilitiesAccountDetails as &$account) {
             $account['BalanceDifference'] = $account['DebitBalance'] - $account['CreditBalance'];
         }
         unset($account); // Unset reference to avoid potential bugs

         // dd($mergedAccountDetails);

            $CurrentLiabilitiesTotalDebit = array_sum(array_column($CurrentLiabilitiesAccountDetails, 'DebitBalance'));
            $CurrentLiabilitiesTotalCredit = array_sum(array_column($CurrentLiabilitiesAccountDetails, 'CreditBalance'));

            // dd([
            //     'bankAccountTotalDebit' => $bankAccountTotalDebit,
            //     'bankAccountTotalCredit' => $bankAccountTotalCredit
            // ]);

            return [$CurrentLiabilitiesAccountDetails,$CurrentLiabilitiesTotalDebit,$CurrentLiabilitiesTotalCredit,$from_date, $to_date,];

    }
    // -----   Advance   ------------------------------------------------------------- >>>>>>>>>>>>>>>>>>

    public function AllAdvanceClassofAccounts($request, $from_date, $to_date)
    {

        $from_date = $request->from_date;
        $to_date = $request->to_date;

        $currentYearFirstDate = date("2003-01-01");
        $oneDayPreviousDate = date('Y-m-d', strtotime('-1 day', strtotime($from_date)));

        $opcustomers = Customer::where('branch_id', session()->get('selected_branch'))
            ->where('class_of_account_id', 10)
            ->get(['id', 'class_of_account_id','name_of_organisation as account_name','opening_balance','type','date']);

        $opsuppliers = Supplier::where('branch_id', session()->get('selected_branch'))
            ->where('class_of_account_id', 10)
            ->get(['id', 'class_of_account_id','name_of_organisation as account_name','opening_balance','type','date']);

        $opexpenses = Expense::where('branch_id', session()->get('selected_branch'))
            ->where('class_of_account_id',10)
            ->get(['id', 'class_of_account_id','account_name','opening_balance','type','date']);

        $opadminOtherAccounts = AdminOtherAccount::where('branch_id', session()->get('selected_branch'))
            ->where('class_of_account_id', 10)
            ->get(['id', 'class_of_account_id','account_name','opening_balance','type','date']);

        $opstaffAndSalesman = StaffAndSalesman::where('branch_id', session()->get('selected_branch'))
            ->where('class_of_account_id', 10)
            ->selectRaw('id, class_of_account_id, CONCAT(first_name, " ", last_name) as account_name,date_of_joining as date,opening_balance,type')
            ->get();

        $opAllAccounts = $opcustomers->concat($opsuppliers)->concat($opexpenses)->concat($opadminOtherAccounts)->concat($opstaffAndSalesman);

        // dd($opAllAccounts);

        $opAccountDetails = [];

        foreach ($opAllAccounts as $opAccount) {
            $opDebitOBalance = null;
            $opCreditOBalance = null;
            $opCreateDebitOpeningBalance = null;
            $opCreateCreditOpeningBalance = null;
            $debitAllAccountsDate = null;
            $creditAllAccountsDate = null;

            if ($opAccount->type === 'Debit' || $opAccount->type === 'debit' ) {
                $debitAllAccountsDate = $opAccount->date;
                $opCreateDebitOpeningBalance = $opAccount->opening_balance;

            } elseif ($opAccount->type === 'Credit' || $opAccount->type === 'credit' ) {
                $creditAllAccountsDate = $opAccount->date;
                $opCreateCreditOpeningBalance = $opAccount->opening_balance;

            }

         // dd($DebitOB,$CreditOB,$debitAllAccountsDate,$creditAllAccountsDate);

         $opPurchaesInvoiceTotalNetAmount = AdminPurchaesInvoice::where('account_name', $opAccount->account_name)
             ->where('branch_id', session()->get('selected_branch'))
             ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
             ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
             ->whereNull('deleted_at')
             ->groupBy('invoice_no')
             ->get()
             ->sum('total_net_amount');

         $opSaleInvoiceTotalNetAmount = AdminSalesInvoice::where('account_name', $opAccount->account_name)
             ->where('branch_id', session()->get('selected_branch'))
             ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
             ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
             ->whereNull('deleted_at')
             ->groupBy('invoice_no')
             ->get()
             ->sum('total_net_amount');

         $opReceiptVoucherTotalNetAmountForCash = ReceiptVoucherExpense::where('account_name', $opAccount->account_name)
             ->where('branch_id', session()->get('selected_branch'))
            //  ->where('payment_method','cash')
             ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
             ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
             ->whereNull('deleted_at')
             ->groupBy('invoice_no')
             ->get()
             ->sum('amount');
         $opReceiptVoucherTotalNetAmountForBank = ReceiptVoucherExpense::
              where('bank_name', $opAccount->account_name)
             ->where('branch_id', session()->get('selected_branch'))
            //  ->where('payment_method','bank')
             ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
             ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
             ->whereNull('deleted_at')
             ->groupBy('invoice_no')
             ->get()
             ->sum('amount');

         $opPaymentVoucherTotalNetAmountForBank = PaymentVoucherExpense::
              where('bank_name', $opAccount->account_name)
             ->where('branch_id', session()->get('selected_branch'))
            //  ->where('payment_method','bank')
             ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
             ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
             ->whereNull('deleted_at')
             ->groupBy('invoice_no')
             ->get()
             ->sum(function ($voucher) {
                 return $voucher->amount + $voucher->new_vat_amount;
             });
         $opPaymentVoucherTotalNetAmountForCash = PaymentVoucherExpense::where('account_name', $opAccount->account_name)
             ->where('branch_id', session()->get('selected_branch'))
            //  ->where('payment_method','cash')
             ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
             ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
             ->whereNull('deleted_at')
             ->groupBy('invoice_no')
             ->get()
             ->sum(function ($voucher) {
                 return $voucher->amount + $voucher->new_vat_amount;
             });

             // dd($PaymentVoucherTotalNetAmountForBank,$PaymentVoucherTotalNetAmountForCash);

         $opCreditNoteTotalNetAmount = CreditNote::where('account_name', $opAccount->account_name)
             ->where('branch_id', session()->get('selected_branch'))
             ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
             ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
             ->groupBy('invoice_no')
             ->sum('total_net_amount');

         $opDebitNoteTotalNetAmount = DebitNote::where('account_name', $opAccount->account_name)
             ->where('branch_id', session()->get('selected_branch'))
             ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
             ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
             ->groupBy('invoice_no')
             ->sum('total_net_amount');

         $opJournalVoucherNetAmountForDebit = AdminJournalVoucher::where('account_name', $opAccount->account_name)
             ->where('branch_id', session()->get('selected_branch'))
             ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
             ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
             ->where('type','debit')
             ->groupBy('invoice_no')
             ->get()
             ->sum('amount');
         $opJournalVoucherNetAmountForCredit = AdminJournalVoucher::where('account_name', $opAccount->account_name)
             ->where('branch_id', session()->get('selected_branch'))
             ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
             ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
             ->where('type','credit')
             ->groupBy('invoice_no')
             ->get()
             ->sum('amount');


         $opDebitOBalance += $opCreateDebitOpeningBalance + $opSaleInvoiceTotalNetAmount + $opDebitNoteTotalNetAmount + $opPaymentVoucherTotalNetAmountForCash + $opJournalVoucherNetAmountForDebit + $opReceiptVoucherTotalNetAmountForBank;

         $opCreditOBalance += $opCreateCreditOpeningBalance + $opPurchaesInvoiceTotalNetAmount + $opCreditNoteTotalNetAmount + $opJournalVoucherNetAmountForCredit + $opReceiptVoucherTotalNetAmountForCash + $opPaymentVoucherTotalNetAmountForBank;


         $opAccountDetails[$opAccount->class_of_account_id][] = [
             'account_id' => $opAccount->id,
             'accoun_name' => $opAccount->name_of_organisation ?? $opAccount->account_name,
             'type' => $opAccount->type,
             'class_of_account_id' => $opAccount->class_of_account_id,
             'DebitBalance' => $opDebitOBalance,
             'CreditBalance' => $opCreditOBalance,
         ];
         }

        // from_date to to_date - date range data


        $customers = Customer::where('branch_id', session()->get('selected_branch'))
        ->where('class_of_account_id', 10)
        ->get(['id', 'class_of_account_id', 'name_of_organisation as account_name', 'opening_balance', 'type', 'date']);



        $suppliers = Supplier::where('branch_id', session()->get('selected_branch'))
            ->where('class_of_account_id', 10)
            ->get(['id', 'class_of_account_id','name_of_organisation as account_name','opening_balance','type','date']);

        $expenses = Expense::where('branch_id', session()->get('selected_branch'))
            ->where('class_of_account_id', 10)
            ->get(['id', 'class_of_account_id','account_name','opening_balance','type','date']);

        $adminOtherAccounts = AdminOtherAccount::where('branch_id', session()->get('selected_branch'))
            ->where('class_of_account_id', 10)
            ->get(['id', 'class_of_account_id','account_name','opening_balance','type','date']);

        $staffAndSalesman = StaffAndSalesman::where('branch_id', session()->get('selected_branch'))
            ->where('class_of_account_id', 10)
            ->selectRaw('id, class_of_account_id, CONCAT(first_name, " ", last_name) as account_name,date_of_joining as date,type')
            ->get();


        // $halfFirstAccounts = $customers->concat($suppliers)->concat($expenses);
        // $halfSecondAccounts = $adminOtherAccounts->concat($staffAndSalesman);

        $allAccounts = $customers->concat($suppliers)->concat($expenses)->concat($adminOtherAccounts)->concat($staffAndSalesman);


        // from_date to to_date - date range data

        $accountDetails = [];

        foreach ($allAccounts as $account) {
            $DebitOB = null;
            $CreditOB = null;
            $CreateDebitOpeningBalance = null;
            $CreateCreditOpeningBalance = null;
            $debitAllAccountsDate = null;
            $creditAllAccountsDate = null;

            if ($account->type === 'Debit' || $account->type === 'debit' ) {
                $debitAllAccountsDate = $account->date;
                $CreateDebitOpeningBalance = $account->opening_balance;

            } elseif ($account->type === 'Credit' || $account->type === 'credit' ) {
                $creditAllAccountsDate = $account->date;
                $CreateCreditOpeningBalance = $account->opening_balance;

            }

            $ReceiptVoucherTotalNetAmountForCash = ReceiptVoucherExpense::where('account_name', $account->account_name)
                ->where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->whereNull('deleted_at')
                ->groupBy('invoice_no')
                ->get()
                ->sum('amount');

            $ReceiptVoucherTotalNetAmountForBank = ReceiptVoucherExpense::where('bank_name', $account->account_name)
                ->where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->whereNull('deleted_at')
                ->groupBy('invoice_no')
                ->get()
                ->sum('amount');

            $PurchaesInvoiceTotalNetAmount = AdminPurchaesInvoice::where('account_name', $account->account_name)
                ->where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->whereNull('deleted_at')
                ->groupBy('invoice_no')
                ->get()
                ->sum('total_net_amount');

            $SaleInvoiceTotalNetAmount = AdminSalesInvoice::where('account_name', $account->account_name)
                ->where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->whereNull('deleted_at')
                ->groupBy('invoice_no')
                ->get()
                ->sum('total_net_amount');



            $PaymentVoucherTotalNetAmountForBank = PaymentVoucherExpense::where(function($query) use ($account) {
                $query->where('bank_name', $account->account_name);
                })
                ->where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->whereNull('deleted_at')
                ->groupBy('invoice_no')
                ->get()
                ->sum(function ($voucher) {
                    return $voucher->amount + $voucher->new_vat_amount;
                });
            $PaymentVoucherTotalNetAmountForCash = PaymentVoucherExpense::where(function($query) use ($account) {
                $query->where('account_name', $account->account_name);
                })
                ->where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->whereNull('deleted_at')
                ->groupBy('invoice_no')
                ->get()
                ->sum(function ($voucher) {
                    return $voucher->amount + $voucher->new_vat_amount;
                });

                // dd($PaymentVoucherTotalNetAmountForBank,$PaymentVoucherTotalNetAmountForCash);

            $CreditNoteTotalNetAmount = CreditNote::where('account_name', $account->account_name)
                ->where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->groupBy('invoice_no')
                ->get()
                ->sum('total_net_amount');
            // dd($CreditNoteTotalNetAmount);
            $DebitNoteTotalNetAmount = DebitNote::where('account_name', $account->account_name)
                ->where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->groupBy('invoice_no')
                ->sum('total_net_amount');

            $JournalVoucherNetAmountForDebit = AdminJournalVoucher::where('account_name', $account->account_name)
                ->where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->where('type','debit')
                ->whereNull('deleted_at')
                ->groupBy('invoice_no')
                ->get()
                ->sum('amount');
            $JournalVoucherNetAmountForCredit = AdminJournalVoucher::where('account_name', $account->account_name)
                ->where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->where('type','credit')
                ->whereNull('deleted_at')
                ->groupBy('invoice_no')
                ->get()
                ->sum('amount');

                // dd($ReceiptVoucherTotalNetAmountForCash,$ReceiptVoucherTotalNetAmountForBank);

            // dd($JournalVoucherNetAmountForDebit,$JournalVoucherNetAmountForCredit);

            $DebitOB += $CreateDebitOpeningBalance +  $SaleInvoiceTotalNetAmount + $DebitNoteTotalNetAmount + $PaymentVoucherTotalNetAmountForCash  + $JournalVoucherNetAmountForDebit + $ReceiptVoucherTotalNetAmountForBank;

            $CreditOB += $CreateCreditOpeningBalance + $PurchaesInvoiceTotalNetAmount + $CreditNoteTotalNetAmount + $JournalVoucherNetAmountForCredit + $ReceiptVoucherTotalNetAmountForCash + $PaymentVoucherTotalNetAmountForBank;



            $accountDetails[$account->class_of_account_id][] = [
                'account_id' => $account->id,
                'accoun_name' => $account->name_of_organisation ?? $account->account_name,
                'type' => $account->type,
                'class_of_account_id' => $account->class_of_account_id,
                'DebitBalance' => $DebitOB,
                'CreditBalance' => $CreditOB,
            ];
            }

           // Initialize the mergedAccountDetails array
            $mergedAccountDetails = [];

            // Merge and sum balances from $opAccountDetails
            foreach ($opAccountDetails as $classId => $accounts) {
                foreach ($accounts as $account) {
                    if (!isset($mergedAccountDetails[$account['account_id']])) {
                        $mergedAccountDetails[$account['account_id']] = $account;
                    } else {
                        $mergedAccountDetails[$account['account_id']]['DebitBalance'] += $account['DebitBalance'];
                        $mergedAccountDetails[$account['account_id']]['CreditBalance'] += $account['CreditBalance'];
                    }
                }
            }

            // Merge and sum balances from $accountDetails
            foreach ($accountDetails as $classId => $accounts) {
                foreach ($accounts as $account) {
                    if (!isset($mergedAccountDetails[$account['account_id']])) {
                        $mergedAccountDetails[$account['account_id']] = $account;
                    } else {
                        $mergedAccountDetails[$account['account_id']]['DebitBalance'] += $account['DebitBalance'];
                        $mergedAccountDetails[$account['account_id']]['CreditBalance'] += $account['CreditBalance'];
                    }
                }
            }

            // Adjust the balances to have either a DebitBalance or CreditBalance but not both
            foreach ($mergedAccountDetails as &$account) {
                $netBalance = $account['DebitBalance'] - $account['CreditBalance'];

                if ($netBalance > 0) {
                    $account['DebitBalance'] = $netBalance;
                    $account['CreditBalance'] = 0;
                } else {
                    $account['CreditBalance'] = abs($netBalance);
                    $account['DebitBalance'] = 0;
                }
            }

            // Calculate the total Debit and Credit balances
            $AdvanceTotalDebit = array_sum(array_column($mergedAccountDetails, 'DebitBalance'));
            $AdvanceTotalCredit = array_sum(array_column($mergedAccountDetails, 'CreditBalance'));

            // // Output the results
            // dd([
            //     'mergedAccountDetails' => $mergedAccountDetails,
            //     'AdvanceTotalDebit' => $AdvanceTotalDebit,
            //     'AdvanceTotalCredit' => $AdvanceTotalCredit
            // ]);

            return [$AdvanceTotalDebit,$AdvanceTotalCredit,$from_date, $to_date,];


            // dd($accountDetails,$opAccountDetails);

                // $mergedAccountDetails = [];

                // foreach ($opAccountDetails as $classId => $accounts) {
                //     foreach ($accounts as $account) {
                //         $mergedAccountDetails[$account['account_id']] = $account;
                //     }
                // }

                // foreach ($accountDetails as $classId => $accounts) {
                //     foreach ($accounts as $account) {
                //         $mergedAccountDetails[$account['account_id']] = $account;
                //     }
                // }

                // foreach ($mergedAccountDetails as $account) {
                //     $totalDebit = array_sum(array_column($mergedAccountDetails, 'DebitBalance'));
                //     $totalCredit = array_sum(array_column($mergedAccountDetails, 'CreditBalance'));
                // }

                // foreach ($mergedAccountDetails as &$account) {
                //     $netBalance = $account['DebitBalance'] - $account['CreditBalance'];

                //     if ($netBalance > 0) {
                //         $account['DebitBalance'] = $netBalance;
                //         $account['CreditBalance'] = 0;
                //     } else {
                //         $account['CreditBalance'] = abs($netBalance);
                //         $account['DebitBalance'] = 0;
                //     }
                // }
                // dd($mergedAccountDetails);





                // // Step 1: Retrieve ClassOfAccount details from the database
                // $classOfAccountDetails = ClassOfAccount::all()->keyBy('id');

                // // Step 2: Initialize mergedAccountDetails and populate it
                // $mergedAccountDetails = [];

                // foreach ($opAccountDetails as $classId => $accounts) {
                //     foreach ($accounts as $account) {
                //         $mergedAccountDetails[$account['account_id']] = $account;
                //     }
                // }

                // foreach ($accountDetails as $classId => $accounts) {
                //     foreach ($accounts as $account) {
                //         $mergedAccountDetails[$account['account_id']] = $account;
                //     }
                // }

                // // Step 3: Group by class of account name
                // $groupedAccountDetails = [];

                // foreach ($mergedAccountDetails as $account) {
                //     $classId = $account['class_of_account_id'];
                //     $className = $classOfAccountDetails[$classId]->name ?? 'Unknown';

                //     if (!isset($groupedAccountDetails[$className])) {
                //         $groupedAccountDetails[$className] = [];
                //     }
                //     $groupedAccountDetails[$className][] = $account;
                // }

                // // Step 4: Adjust balances within each group
                // foreach ($groupedAccountDetails as &$group) {
                //     foreach ($group as &$account) {
                //         $netBalance = $account['DebitBalance'] - $account['CreditBalance'];

                //         if ($netBalance > 0) {
                //             $account['DebitBalance'] = $netBalance;
                //             $account['CreditBalance'] = 0;
                //         } else {
                //             $account['CreditBalance'] = abs($netBalance);
                //             $account['DebitBalance'] = 0;
                //         }
                //     }
                // }

                // dd($groupedAccountDetails);

            // return [$groupedAccountDetails,$from_date, $to_date,];

    }
    // -----   Loans   ------------------------------------------------------------- >>>>>>>>>>>>>>>>>>

    public function AllLoansClassofAccounts($request, $from_date, $to_date)
    {

        $from_date = $request->from_date;
        $to_date = $request->to_date;

        $currentYearFirstDate = date("2003-01-01");
        $oneDayPreviousDate = date('Y-m-d', strtotime('-1 day', strtotime($from_date)));

        $opcustomers = Customer::where('branch_id', session()->get('selected_branch'))
            ->where('class_of_account_id', 9)
            ->get(['id', 'class_of_account_id','name_of_organisation as account_name','opening_balance','type','date']);

        $opsuppliers = Supplier::where('branch_id', session()->get('selected_branch'))
            ->where('class_of_account_id', 9)
            ->get(['id', 'class_of_account_id','name_of_organisation as account_name','opening_balance','type','date']);

        $opexpenses = Expense::where('branch_id', session()->get('selected_branch'))
            ->where('class_of_account_id',9)
            ->get(['id', 'class_of_account_id','account_name','opening_balance','type','date']);

        $opadminOtherAccounts = AdminOtherAccount::where('branch_id', session()->get('selected_branch'))
            ->where('class_of_account_id',9)
            ->get(['id', 'class_of_account_id','account_name','opening_balance','type','date']);

        $opstaffAndSalesman = StaffAndSalesman::where('branch_id', session()->get('selected_branch'))
            ->where('class_of_account_id',9)
            ->selectRaw('id, class_of_account_id, CONCAT(first_name, " ", last_name) as account_name,date_of_joining as date')
            ->get();

        $opAllAccounts = $opcustomers->concat($opsuppliers)->concat($opexpenses)->concat($opadminOtherAccounts)->concat($opstaffAndSalesman);

        // dd($opAllAccounts);

        $opAccountDetails = [];

        foreach ($opAllAccounts as $opAccount) {
            $opDebitOBalance = 0;
            $opCreditOBalance = 0;
            $opCreateDebitOpeningBalance = 0;
            $opCreateCreditOpeningBalance = 0;
            $debitAllAccountsDate = 0;
            $creditAllAccountsDate = 0;

            if ($opAccount->type === 'Debit' || $opAccount->type === 'debit' ) {
                $debitAllAccountsDate = $opAccount->date;
                $opCreateDebitOpeningBalance = $opAccount->opening_balance;

            } elseif ($opAccount->type === 'Credit' || $opAccount->type === 'credit' ) {
                $creditAllAccountsDate = $opAccount->date;
                $opCreateCreditOpeningBalance = $opAccount->opening_balance;

            }

         // dd($DebitOB,$CreditOB,$debitAllAccountsDate,$creditAllAccountsDate);

         $opPurchaesInvoiceTotalNetAmount = AdminPurchaesInvoice::where('account_name', $opAccount->account_name)
             ->where('branch_id', session()->get('selected_branch'))
             ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
             ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
             ->whereNull('deleted_at')
             ->groupBy('invoice_no')
             ->get()
             ->sum('total_net_amount');

         $opSaleInvoiceTotalNetAmount = AdminSalesInvoice::where('account_name', $opAccount->account_name)
             ->where('branch_id', session()->get('selected_branch'))
             ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
             ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
             ->whereNull('deleted_at')
             ->groupBy('invoice_no')
             ->get()
             ->sum('total_net_amount');

         $opReceiptVoucherTotalNetAmountForCash = ReceiptVoucherExpense::where('account_name', $opAccount->account_name)
             ->where('branch_id', session()->get('selected_branch'))
            //  ->where('payment_method','cash')
             ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
             ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
             ->whereNull('deleted_at')
             ->groupBy('invoice_no')
             ->get()
             ->sum('amount');
         $opReceiptVoucherTotalNetAmountForBank = ReceiptVoucherExpense::
              where('bank_name', $opAccount->account_name)
             ->where('branch_id', session()->get('selected_branch'))
            //  ->where('payment_method','bank')
             ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
             ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
             ->whereNull('deleted_at')
             ->groupBy('invoice_no')
             ->get()
             ->sum('amount');

         $opPaymentVoucherTotalNetAmountForBank = PaymentVoucherExpense::
              where('bank_name', $opAccount->account_name)
             ->where('branch_id', session()->get('selected_branch'))
            //  ->where('payment_method','bank')
             ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
             ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
             ->whereNull('deleted_at')
             ->groupBy('invoice_no')
             ->get()
             ->sum(function ($voucher) {
                 return $voucher->amount + $voucher->new_vat_amount;
             });
         $opPaymentVoucherTotalNetAmountForCash = PaymentVoucherExpense::where('account_name', $opAccount->account_name)
             ->where('branch_id', session()->get('selected_branch'))
            //  ->where('payment_method','cash')
             ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
             ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
             ->whereNull('deleted_at')
             ->groupBy('invoice_no')
             ->get()
             ->sum(function ($voucher) {
                 return $voucher->amount + $voucher->new_vat_amount;
             });

             // dd($PaymentVoucherTotalNetAmountForBank,$PaymentVoucherTotalNetAmountForCash);

         $opCreditNoteTotalNetAmount = CreditNote::where('account_name', $opAccount->account_name)
             ->where('branch_id', session()->get('selected_branch'))
             ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
             ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
             ->groupBy('invoice_no')
             ->sum('total_net_amount');

         $opDebitNoteTotalNetAmount = DebitNote::where('account_name', $opAccount->account_name)
             ->where('branch_id', session()->get('selected_branch'))
             ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
             ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
             ->groupBy('invoice_no')
             ->sum('total_net_amount');

         $opJournalVoucherNetAmountForDebit = AdminJournalVoucher::where('account_name', $opAccount->account_name)
             ->where('branch_id', session()->get('selected_branch'))
             ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
             ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
             ->where('type','debit')
             ->groupBy('invoice_no')
             ->get()
             ->sum('amount');
         $opJournalVoucherNetAmountForCredit = AdminJournalVoucher::where('account_name', $opAccount->account_name)
             ->where('branch_id', session()->get('selected_branch'))
             ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
             ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
             ->where('type','credit')
             ->groupBy('invoice_no')
             ->get()
             ->sum('amount');


         $opDebitOBalance += $opCreateDebitOpeningBalance + $opSaleInvoiceTotalNetAmount + $opDebitNoteTotalNetAmount + $opPaymentVoucherTotalNetAmountForCash + $opJournalVoucherNetAmountForDebit + $opReceiptVoucherTotalNetAmountForBank;

         $opCreditOBalance += $opCreateCreditOpeningBalance + $opPurchaesInvoiceTotalNetAmount + $opCreditNoteTotalNetAmount + $opJournalVoucherNetAmountForCredit + $opReceiptVoucherTotalNetAmountForCash + $opPaymentVoucherTotalNetAmountForBank;


         $opAccountDetails[$opAccount->class_of_account_id][] = [
             'account_id' => $opAccount->id,
             'accoun_name' => $opAccount->name_of_organisation ?? $opAccount->account_name,
             'type' => $opAccount->type,
             'class_of_account_id' => $opAccount->class_of_account_id,
             'DebitBalance' => $opDebitOBalance,
             'CreditBalance' => $opCreditOBalance,
         ];
         }

        // from_date to to_date - date range data


        $customers = Customer::where('branch_id', session()->get('selected_branch'))
        ->where('class_of_account_id', 9)
        ->get(['id', 'class_of_account_id', 'name_of_organisation as account_name', 'opening_balance', 'type', 'date']);

        $suppliers = Supplier::where('branch_id', session()->get('selected_branch'))
            ->where('class_of_account_id', 9)
            ->get(['id', 'class_of_account_id','name_of_organisation as account_name','opening_balance','type','date']);

        $expenses = Expense::where('branch_id', session()->get('selected_branch'))
            ->where('class_of_account_id', 9)
            ->get(['id', 'class_of_account_id','account_name','opening_balance','type','date']);

        $adminOtherAccounts = AdminOtherAccount::where('branch_id', session()->get('selected_branch'))
            ->where('class_of_account_id', 9)
            ->get(['id', 'class_of_account_id','account_name','opening_balance','type','date']);

        $staffAndSalesman = StaffAndSalesman::where('branch_id', session()->get('selected_branch'))
            ->where('class_of_account_id', 9)
            ->selectRaw('id, class_of_account_id, CONCAT(first_name, " ", last_name) as account_name,date_of_joining as date,type')
            ->get();


        // $halfFirstAccounts = $customers->concat($suppliers)->concat($expenses);
        // $halfSecondAccounts = $adminOtherAccounts->concat($staffAndSalesman);

        $allAccounts = $customers->concat($suppliers)->concat($expenses)->concat($adminOtherAccounts)->concat($staffAndSalesman);


        // from_date to to_date - date range data

        $accountDetails = [];

        foreach ($allAccounts as $account) {
            $DebitOB = 0;
            $CreditOB = 0;
            $CreateDebitOpeningBalance = 0;
            $CreateCreditOpeningBalance = 0;
            $debitAllAccountsDate = 0;
            $creditAllAccountsDate = 0;

            if ($account->type === 'Debit' || $account->type === 'debit' ) {
                $debitAllAccountsDate = $account->date;
                $CreateDebitOpeningBalance = $account->opening_balance;

            } elseif ($account->type === 'Credit' || $account->type === 'credit' ) {
                $creditAllAccountsDate = $account->date;
                $CreateCreditOpeningBalance = $account->opening_balance;

            }

            $ReceiptVoucherTotalNetAmountForCash = ReceiptVoucherExpense::where('account_name', $account->account_name)
                ->where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->whereNull('deleted_at')
                ->groupBy('invoice_no')
                ->get()
                ->sum('amount');

            $ReceiptVoucherTotalNetAmountForBank = ReceiptVoucherExpense::where('bank_name', $account->account_name)
                ->where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->whereNull('deleted_at')
                ->groupBy('invoice_no')
                ->get()
                ->sum('amount');

            $PurchaesInvoiceTotalNetAmount = AdminPurchaesInvoice::where('account_name', $account->account_name)
                ->where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->whereNull('deleted_at')
                ->groupBy('invoice_no')
                ->get()
                ->sum('total_net_amount');

            $SaleInvoiceTotalNetAmount = AdminSalesInvoice::where('account_name', $account->account_name)
                ->where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->whereNull('deleted_at')
                ->groupBy('invoice_no')
                ->get()
                ->sum('total_net_amount');



            $PaymentVoucherTotalNetAmountForBank = PaymentVoucherExpense::where(function($query) use ($account) {
                $query->where('bank_name', $account->account_name);
                })
                ->where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->whereNull('deleted_at')
                ->groupBy('invoice_no')
                ->get()
                ->sum(function ($voucher) {
                    return $voucher->amount + $voucher->new_vat_amount;
                });
            $PaymentVoucherTotalNetAmountForCash = PaymentVoucherExpense::where(function($query) use ($account) {
                $query->where('account_name', $account->account_name);
                })
                ->where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->whereNull('deleted_at')
                ->groupBy('invoice_no')
                ->get()
                ->sum(function ($voucher) {
                    return $voucher->amount + $voucher->new_vat_amount;
                });

                // dd($PaymentVoucherTotalNetAmountForBank,$PaymentVoucherTotalNetAmountForCash);

            $CreditNoteTotalNetAmount = CreditNote::where('account_name', $account->account_name)
                ->where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->groupBy('invoice_no')
                ->get()
                ->sum('total_net_amount');
            // dd($CreditNoteTotalNetAmount);
            $DebitNoteTotalNetAmount = DebitNote::where('account_name', $account->account_name)
                ->where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->groupBy('invoice_no')
                ->sum('total_net_amount');

            $JournalVoucherNetAmountForDebit = AdminJournalVoucher::where('account_name', $account->account_name)
                ->where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->where('type','debit')
                ->whereNull('deleted_at')
                ->groupBy('invoice_no')
                ->get()
                ->sum('amount');
            $JournalVoucherNetAmountForCredit = AdminJournalVoucher::where('account_name', $account->account_name)
                ->where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->where('type','credit')
                ->whereNull('deleted_at')
                ->groupBy('invoice_no')
                ->get()
                ->sum('amount');

                // dd($ReceiptVoucherTotalNetAmountForCash,$ReceiptVoucherTotalNetAmountForBank);

            // dd($JournalVoucherNetAmountForDebit,$JournalVoucherNetAmountForCredit);

            $DebitOB += $CreateDebitOpeningBalance +  $SaleInvoiceTotalNetAmount + $DebitNoteTotalNetAmount + $PaymentVoucherTotalNetAmountForCash  + $JournalVoucherNetAmountForDebit + $ReceiptVoucherTotalNetAmountForBank;

            $CreditOB += $CreateCreditOpeningBalance + $PurchaesInvoiceTotalNetAmount + $CreditNoteTotalNetAmount + $JournalVoucherNetAmountForCredit + $ReceiptVoucherTotalNetAmountForCash + $PaymentVoucherTotalNetAmountForBank;



            $accountDetails[$account->class_of_account_id][] = [
                'account_id' => $account->id,
                'accoun_name' => $account->name_of_organisation ?? $account->account_name,
                'type' => $account->type,
                'class_of_account_id' => $account->class_of_account_id,
                'DebitBalance' => $DebitOB,
                'CreditBalance' => $CreditOB,
            ];
            }

            $LoansAccountDetails = [];

            foreach ($opAccountDetails as $classId => $accounts) {
                foreach ($accounts as $account) {
                    $LoansAccountDetails[$account['account_id']] = $account;
                }
            }

            foreach ($accountDetails as $classId => $accounts) {
                foreach ($accounts as $account) {
                    $LoansAccountDetails[$account['account_id']] = $account;
                }
            }

            foreach ($LoansAccountDetails as &$account) {
                $netBalance = $account['DebitBalance'] - $account['CreditBalance'];

                if ($netBalance > 0) {
                    $account['DebitBalance'] = $netBalance;
                    $account['CreditBalance'] = 0;
                } else {
                    $account['CreditBalance'] = abs($netBalance);
                    $account['DebitBalance'] = 0;
                }
            }

            // Calculate the total Debit and Credit balances
            $loansTotalDebit = array_sum(array_column($LoansAccountDetails, 'DebitBalance'));
            $loansTotalCredit = array_sum(array_column($LoansAccountDetails, 'CreditBalance'));

            // // Output the results
            // dd([
            //     'mergedAccountDetails' => $mergedAccountDetails,
            //     'AdvanceTotalDebit' => $AdvanceTotalDebit,
            //     'AdvanceTotalCredit' => $AdvanceTotalCredit
            // ]);

            return [$LoansAccountDetails,$loansTotalDebit,$loansTotalCredit,$from_date, $to_date,];

    }
    // -----   Fixed Assets   ------------------------------------------------------------- >>>>>>>>>>>>>>>>>>

    public function AllFixedAssetsClassofAccounts($request, $from_date, $to_date)
    {

        $from_date = $request->from_date;
        $to_date = $request->to_date;

        $currentYearFirstDate = date("2003-01-01");
        $oneDayPreviousDate = date('Y-m-d', strtotime('-1 day', strtotime($from_date)));

        $opcustomers = Customer::where('branch_id', session()->get('selected_branch'))
            ->where('class_of_account_id', 8)
            ->get(['id', 'class_of_account_id','name_of_organisation as account_name','opening_balance','type','date']);

        $opsuppliers = Supplier::where('branch_id', session()->get('selected_branch'))
            ->where('class_of_account_id', 8)
            ->get(['id', 'class_of_account_id','name_of_organisation as account_name','opening_balance','type','date']);

        $opexpenses = Expense::where('branch_id', session()->get('selected_branch'))
            ->where('class_of_account_id',8)
            ->get(['id', 'class_of_account_id','account_name','opening_balance','type','date']);

        $opadminOtherAccounts = AdminOtherAccount::where('branch_id', session()->get('selected_branch'))
            ->where('class_of_account_id',8)
            ->get(['id', 'class_of_account_id','account_name','opening_balance','type','date']);

        $opstaffAndSalesman = StaffAndSalesman::where('branch_id', session()->get('selected_branch'))
            ->where('class_of_account_id',8)
            ->selectRaw('id, class_of_account_id, CONCAT(first_name, " ", last_name) as account_name,date_of_joining as date')
            ->get();

        $opAllAccounts = $opcustomers->concat($opsuppliers)->concat($opexpenses)->concat($opadminOtherAccounts)->concat($opstaffAndSalesman);

        // dd($opAllAccounts);

        $opAccountDetails = [];

        foreach ($opAllAccounts as $opAccount) {
            $opDebitOBalance = 0;
            $opCreditOBalance = 0;
            $opCreateDebitOpeningBalance = 0;
            $opCreateCreditOpeningBalance = 0;
            $debitAllAccountsDate = 0;
            $creditAllAccountsDate = 0;

            if ($opAccount->type === 'Debit' || $opAccount->type === 'debit' ) {
                $debitAllAccountsDate = $opAccount->date;
                $opCreateDebitOpeningBalance = $opAccount->opening_balance;

            } elseif ($opAccount->type === 'Credit' || $opAccount->type === 'credit' ) {
                $creditAllAccountsDate = $opAccount->date;
                $opCreateCreditOpeningBalance = $opAccount->opening_balance;

            }

         // dd($DebitOB,$CreditOB,$debitAllAccountsDate,$creditAllAccountsDate);

         $opPurchaesInvoiceTotalNetAmount = AdminPurchaesInvoice::where('account_name', $opAccount->account_name)
             ->where('branch_id', session()->get('selected_branch'))
             ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
             ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
             ->whereNull('deleted_at')
             ->groupBy('invoice_no')
             ->get()
             ->sum('total_net_amount');

         $opSaleInvoiceTotalNetAmount = AdminSalesInvoice::where('account_name', $opAccount->account_name)
             ->where('branch_id', session()->get('selected_branch'))
             ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
             ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
             ->whereNull('deleted_at')
             ->groupBy('invoice_no')
             ->get()
             ->sum('total_net_amount');

         $opReceiptVoucherTotalNetAmountForCash = ReceiptVoucherExpense::where('account_name', $opAccount->account_name)
             ->where('branch_id', session()->get('selected_branch'))
            //  ->where('payment_method','cash')
             ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
             ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
             ->whereNull('deleted_at')
             ->groupBy('invoice_no')
             ->get()
             ->sum('amount');
         $opReceiptVoucherTotalNetAmountForBank = ReceiptVoucherExpense::
              where('bank_name', $opAccount->account_name)
             ->where('branch_id', session()->get('selected_branch'))
            //  ->where('payment_method','bank')
             ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
             ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
             ->whereNull('deleted_at')
             ->groupBy('invoice_no')
             ->get()
             ->sum('amount');

         $opPaymentVoucherTotalNetAmountForBank = PaymentVoucherExpense::
              where('bank_name', $opAccount->account_name)
             ->where('branch_id', session()->get('selected_branch'))
            //  ->where('payment_method','bank')
             ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
             ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
             ->whereNull('deleted_at')
             ->groupBy('invoice_no')
             ->get()
             ->sum(function ($voucher) {
                 return $voucher->amount + $voucher->new_vat_amount;
             });
         $opPaymentVoucherTotalNetAmountForCash = PaymentVoucherExpense::where('account_name', $opAccount->account_name)
             ->where('branch_id', session()->get('selected_branch'))
            //  ->where('payment_method','cash')
             ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
             ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
             ->whereNull('deleted_at')
             ->groupBy('invoice_no')
             ->get()
             ->sum(function ($voucher) {
                 return $voucher->amount + $voucher->new_vat_amount;
             });

             // dd($PaymentVoucherTotalNetAmountForBank,$PaymentVoucherTotalNetAmountForCash);

         $opCreditNoteTotalNetAmount = CreditNote::where('account_name', $opAccount->account_name)
             ->where('branch_id', session()->get('selected_branch'))
             ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
             ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
             ->groupBy('invoice_no')
             ->sum('total_net_amount');

         $opDebitNoteTotalNetAmount = DebitNote::where('account_name', $opAccount->account_name)
             ->where('branch_id', session()->get('selected_branch'))
             ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
             ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
             ->groupBy('invoice_no')
             ->sum('total_net_amount');

         $opJournalVoucherNetAmountForDebit = AdminJournalVoucher::where('account_name', $opAccount->account_name)
             ->where('branch_id', session()->get('selected_branch'))
             ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
             ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
             ->where('type','debit')
             ->groupBy('invoice_no')
             ->get()
             ->sum('amount');
         $opJournalVoucherNetAmountForCredit = AdminJournalVoucher::where('account_name', $opAccount->account_name)
             ->where('branch_id', session()->get('selected_branch'))
             ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
             ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
             ->where('type','credit')
             ->groupBy('invoice_no')
             ->get()
             ->sum('amount');


         $opDebitOBalance += $opCreateDebitOpeningBalance + $opSaleInvoiceTotalNetAmount + $opDebitNoteTotalNetAmount + $opPaymentVoucherTotalNetAmountForCash + $opJournalVoucherNetAmountForDebit + $opReceiptVoucherTotalNetAmountForBank;

         $opCreditOBalance += $opCreateCreditOpeningBalance + $opPurchaesInvoiceTotalNetAmount + $opCreditNoteTotalNetAmount + $opJournalVoucherNetAmountForCredit + $opReceiptVoucherTotalNetAmountForCash + $opPaymentVoucherTotalNetAmountForBank;


         $opAccountDetails[$opAccount->class_of_account_id][] = [
             'account_id' => $opAccount->id,
             'accoun_name' => $opAccount->name_of_organisation ?? $opAccount->account_name,
             'type' => $opAccount->type,
             'class_of_account_id' => $opAccount->class_of_account_id,
             'DebitBalance' => $opDebitOBalance,
             'CreditBalance' => $opCreditOBalance,
         ];
         }

        // from_date to to_date - date range data


        $customers = Customer::where('branch_id', session()->get('selected_branch'))
        ->where('class_of_account_id', 8)
        ->get(['id', 'class_of_account_id', 'name_of_organisation as account_name', 'opening_balance', 'type', 'date']);

        $suppliers = Supplier::where('branch_id', session()->get('selected_branch'))
            ->where('class_of_account_id', 8)
            ->get(['id', 'class_of_account_id','name_of_organisation as account_name','opening_balance','type','date']);

        $expenses = Expense::where('branch_id', session()->get('selected_branch'))
            ->where('class_of_account_id', 8)
            ->get(['id', 'class_of_account_id','account_name','opening_balance','type','date']);

        $adminOtherAccounts = AdminOtherAccount::where('branch_id', session()->get('selected_branch'))
            ->where('class_of_account_id', 8)
            ->get(['id', 'class_of_account_id','account_name','opening_balance','type','date']);

        $staffAndSalesman = StaffAndSalesman::where('branch_id', session()->get('selected_branch'))
            ->where('class_of_account_id', 8)
            ->selectRaw('id, class_of_account_id, CONCAT(first_name, " ", last_name) as account_name,date_of_joining as date,type')
            ->get();


        // $halfFirstAccounts = $customers->concat($suppliers)->concat($expenses);
        // $halfSecondAccounts = $adminOtherAccounts->concat($staffAndSalesman);

        $allAccounts = $customers->concat($suppliers)->concat($expenses)->concat($adminOtherAccounts)->concat($staffAndSalesman);

        // dd($allAccounts);

        // from_date to to_date - date range data

        $accountDetails = [];

        foreach ($allAccounts as $account) {
            $DebitOB = 0;
            $CreditOB = 0;
            $CreateDebitOpeningBalance = 0;
            $CreateCreditOpeningBalance = 0;
            $debitAllAccountsDate = 0;
            $creditAllAccountsDate = 0;

            if ($account->type === 'Debit' || $account->type === 'debit' ) {
                $debitAllAccountsDate = $account->date;
                $CreateDebitOpeningBalance = $account->opening_balance;

            } elseif ($account->type === 'Credit' || $account->type === 'credit' ) {
                $creditAllAccountsDate = $account->date;
                $CreateCreditOpeningBalance = $account->opening_balance;

            }

            $ReceiptVoucherTotalNetAmountForCash = ReceiptVoucherExpense::where('account_name', $account->account_name)
                ->where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->whereNull('deleted_at')
                ->groupBy('invoice_no')
                ->get()
                ->sum('amount');

            $ReceiptVoucherTotalNetAmountForBank = ReceiptVoucherExpense::where('bank_name', $account->account_name)
                ->where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->whereNull('deleted_at')
                ->groupBy('invoice_no')
                ->get()
                ->sum('amount');

            $PurchaesInvoiceTotalNetAmount = AdminPurchaesInvoice::where('account_name', $account->account_name)
                ->where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->whereNull('deleted_at')
                ->groupBy('invoice_no')
                ->get()
                ->sum('total_net_amount');

            $SaleInvoiceTotalNetAmount = AdminSalesInvoice::where('account_name', $account->account_name)
                ->where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->whereNull('deleted_at')
                ->groupBy('invoice_no')
                ->get()
                ->sum('total_net_amount');



            $PaymentVoucherTotalNetAmountForBank = PaymentVoucherExpense::where(function($query) use ($account) {
                $query->where('bank_name', $account->account_name);
                })
                ->where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->whereNull('deleted_at')
                ->groupBy('invoice_no')
                ->get()
                ->sum(function ($voucher) {
                    return $voucher->amount + $voucher->new_vat_amount;
                });
            $PaymentVoucherTotalNetAmountForCash = PaymentVoucherExpense::where(function($query) use ($account) {
                $query->where('account_name', $account->account_name);
                })
                ->where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->whereNull('deleted_at')
                ->groupBy('invoice_no')
                ->get()
                ->sum(function ($voucher) {
                    return $voucher->amount + $voucher->new_vat_amount;
                });

                // dd($PaymentVoucherTotalNetAmountForBank,$PaymentVoucherTotalNetAmountForCash);

            $CreditNoteTotalNetAmount = CreditNote::where('account_name', $account->account_name)
                ->where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->groupBy('invoice_no')
                ->get()
                ->sum('total_net_amount');
            // dd($CreditNoteTotalNetAmount);
            $DebitNoteTotalNetAmount = DebitNote::where('account_name', $account->account_name)
                ->where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->groupBy('invoice_no')
                ->sum('total_net_amount');

            $JournalVoucherNetAmountForDebit = AdminJournalVoucher::where('account_name', $account->account_name)
                ->where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->where('type','debit')
                ->whereNull('deleted_at')
                ->groupBy('invoice_no')
                ->get()
                ->sum('amount');
            $JournalVoucherNetAmountForCredit = AdminJournalVoucher::where('account_name', $account->account_name)
                ->where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->where('type','credit')
                ->whereNull('deleted_at')
                ->groupBy('invoice_no')
                ->get()
                ->sum('amount');

                // dd($ReceiptVoucherTotalNetAmountForCash,$ReceiptVoucherTotalNetAmountForBank);

            // dd($JournalVoucherNetAmountForDebit,$JournalVoucherNetAmountForCredit);

            $DebitOB += $CreateDebitOpeningBalance +  $SaleInvoiceTotalNetAmount + $DebitNoteTotalNetAmount + $PaymentVoucherTotalNetAmountForCash  + $JournalVoucherNetAmountForDebit + $ReceiptVoucherTotalNetAmountForBank;

            $CreditOB += $CreateCreditOpeningBalance + $PurchaesInvoiceTotalNetAmount + $CreditNoteTotalNetAmount + $JournalVoucherNetAmountForCredit + $ReceiptVoucherTotalNetAmountForCash + $PaymentVoucherTotalNetAmountForBank;

            $accountDetails[$account->class_of_account_id][] = [
                'account_id' => $account->id,
                'accoun_name' => $account->name_of_organisation ?? $account->account_name,
                'type' => $account->type,
                'class_of_account_id' => $account->class_of_account_id,
                'DebitBalance' => $DebitOB,
                'CreditBalance' => $CreditOB,
            ];
            }

            $FixedAssetsMergedAccountDetails = [];

            foreach ($opAccountDetails as $classId => $accounts) {
                foreach ($accounts as $account) {
                    $FixedAssetsMergedAccountDetails[$account['account_id']] = $account;
                }
            }

            foreach ($accountDetails as $classId => $accounts) {
                foreach ($accounts as $account) {
                    $FixedAssetsMergedAccountDetails[$account['account_id']] = $account;
                }
            }

            foreach ($FixedAssetsMergedAccountDetails as &$account) {
                $netBalance = $account['DebitBalance'] - $account['CreditBalance'];

                if ($netBalance > 0) {
                    $account['DebitBalance'] = $netBalance;
                    $account['CreditBalance'] = 0;
                } else {
                    $account['CreditBalance'] = abs($netBalance);
                    $account['DebitBalance'] = 0;
                }
            }

            // Calculate the total Debit and Credit balances
            $FixedAssetsTotalDebit = array_sum(array_column($FixedAssetsMergedAccountDetails, 'DebitBalance'));
            $FixedAssetsTotalCredit = array_sum(array_column($FixedAssetsMergedAccountDetails, 'CreditBalance'));

            // // Output the results

            // dd([
            //     'FixedAssetsMergedAccountDetails' => $FixedAssetsMergedAccountDetails,
            //     'FixedAssetsTotalDebit' => $FixedAssetsTotalDebit,
            //     'FixedAssetsTotalCredit' => $FixedAssetsTotalCredit
            // ]);

            return [$FixedAssetsMergedAccountDetails,$FixedAssetsTotalDebit,$FixedAssetsTotalCredit,$from_date, $to_date,];




    }

    public function AllAccountsCreateOpeningBalanceWithTransactionAmountsService($request, $from_date, $to_date)
    {

        // $from_date = $request->from_date;
        // $to_date = $request->to_date;

        // $currentYearFirstDate = date("2003-01-01");
        // $oneDayPreviousDate = date('Y-m-d', strtotime('-1 day', strtotime($from_date)));

        // $customers = Customer::where('branch_id', session()->get('selected_branch'))
        // ->where('class_of_account_id',16)
        // ->get(['id', 'class_of_account_id', 'name_of_organisation as account_name', 'opening_balance', 'type', 'date']);

        // $suppliers = Supplier::where('branch_id', session()->get('selected_branch'))
        //     ->where('class_of_account_id', 16)
        //     ->get(['id', 'class_of_account_id','name_of_organisation as account_name','opening_balance','type','date']);

        // $expenses = Expense::where('branch_id', session()->get('selected_branch'))
        //     ->where('class_of_account_id', 16)
        //     ->get(['id', 'class_of_account_id','account_name','opening_balance','type','date']);

        // $adminOtherAccounts = AdminOtherAccount::where('branch_id', session()->get('selected_branch'))
        //     ->where('class_of_account_id', 16)
        //     ->get(['id', 'class_of_account_id','account_name','opening_balance','type','date']);

        // $staffAndSalesman = StaffAndSalesman::where('branch_id', session()->get('selected_branch'))
        //     ->where('class_of_account_id',16)
        //     ->selectRaw('id, class_of_account_id, CONCAT(first_name, " ", last_name) as account_name,date_of_joining as date,type')
        //     ->get();

        // $allAccounts = $customers->concat($suppliers)->concat($expenses)->concat($adminOtherAccounts)->concat($staffAndSalesman);

        // // from_date to to_date - date range data

        // $accountDetails = [];

        // foreach ($allAccounts as $account) {
        //     $DebitOB = 0;
        //     $CreditOB = 0;
        //     $CreateDebitOpeningBalance = 0;
        //     $CreateCreditOpeningBalance = 0;
        //     $debitAllAccountsDate = 0;
        //     $creditAllAccountsDate = 0;

        //     if ($account->type === 'Debit' || $account->type === 'debit' ) {
        //         $debitAllAccountsDate = $account->date;
        //         $CreateDebitOpeningBalance = $account->opening_balance;

        //     } elseif ($account->type === 'Credit' || $account->type === 'credit' ) {
        //         $creditAllAccountsDate = $account->date;
        //         $CreateCreditOpeningBalance = $account->opening_balance;

        //     }

        //     $ReceiptVoucherTotalNetAmountForCash = ReceiptVoucherExpense::where('account_name', $account->account_name)
        //         ->where('branch_id', session()->get('selected_branch'))
        //         ->where('date', '>=', $from_date . ' 00:00:00')
        //         ->where('date', '<=', $to_date . ' 23:59:59')
        //         ->whereNull('deleted_at')
        //         ->groupBy('invoice_no')
        //         ->get()
        //         ->sum('amount');

        //     $ReceiptVoucherTotalNetAmountForBank = ReceiptVoucherExpense::where('bank_name', $account->account_name)
        //         ->where('branch_id', session()->get('selected_branch'))
        //         ->where('date', '>=', $from_date . ' 00:00:00')
        //         ->where('date', '<=', $to_date . ' 23:59:59')
        //         ->whereNull('deleted_at')
        //         ->groupBy('invoice_no')
        //         ->get()
        //         ->sum('amount');

        //     $PurchaesInvoiceTotalNetAmount = AdminPurchaesInvoice::where('account_name', $account->account_name)
        //         ->where('branch_id', session()->get('selected_branch'))
        //         ->where('date', '>=', $from_date . ' 00:00:00')
        //         ->where('date', '<=', $to_date . ' 23:59:59')
        //         ->whereNull('deleted_at')
        //         ->groupBy('invoice_no')
        //         ->get()
        //         ->sum('total_purchase_amount_with_cf');

        //     $SaleInvoiceTotalNetAmount = AdminSalesInvoice::where('account_name', $account->account_name)
        //         ->where('branch_id', session()->get('selected_branch'))
        //         ->where('date', '>=', $from_date . ' 00:00:00')
        //         ->where('date', '<=', $to_date . ' 23:59:59')
        //         ->whereNull('deleted_at')
        //         ->groupBy('invoice_no')
        //         ->get()
        //         ->sum('total_net_amount');

        //     $PaymentVoucherTotalNetAmountForBank = PaymentVoucherExpense::where(function($query) use ($account) {
        //         $query->where('bank_name', $account->account_name);
        //         })
        //         ->where('branch_id', session()->get('selected_branch'))
        //         ->where('date', '>=', $from_date . ' 00:00:00')
        //         ->where('date', '<=', $to_date . ' 23:59:59')
        //         ->whereNull('deleted_at')
        //         ->groupBy('invoice_no')
        //         ->get()
        //         ->sum(function ($voucher) {
        //             return $voucher->amount + $voucher->new_vat_amount;
        //         });
        //     $PaymentVoucherTotalNetAmountForCash = PaymentVoucherExpense::where(function($query) use ($account) {
        //         $query->where('account_name', $account->account_name);
        //         })
        //         ->where('branch_id', session()->get('selected_branch'))
        //         ->where('date', '>=', $from_date . ' 00:00:00')
        //         ->where('date', '<=', $to_date . ' 23:59:59')
        //         ->whereNull('deleted_at')
        //         ->groupBy('invoice_no')
        //         ->get()
        //         ->sum(function ($voucher) {
        //             return $voucher->amount + $voucher->new_vat_amount;
        //         });

        //     $CreditNoteTotalNetAmount = CreditNote::where('account_name', $account->account_name)
        //         ->where('branch_id', session()->get('selected_branch'))
        //         ->where('date', '>=', $from_date . ' 00:00:00')
        //         ->where('date', '<=', $to_date . ' 23:59:59')
        //         ->groupBy('invoice_no')
        //         ->get()
        //         ->sum('total_net_amount');
        //     $DebitNoteTotalNetAmount = DebitNote::where('account_name', $account->account_name)
        //         ->where('branch_id', session()->get('selected_branch'))
        //         ->where('date', '>=', $from_date . ' 00:00:00')
        //         ->where('date', '<=', $to_date . ' 23:59:59')
        //         ->groupBy('invoice_no')
        //         ->sum('total_net_amount');

        //     $JournalVoucherNetAmountForDebit = AdminJournalVoucher::where('account_name', $account->account_name)
        //         ->where('branch_id', session()->get('selected_branch'))
        //         ->where('date', '>=', $from_date . ' 00:00:00')
        //         ->where('date', '<=', $to_date . ' 23:59:59')
        //         ->where('type','debit')
        //         ->whereNull('deleted_at')
        //         ->groupBy('invoice_no')
        //         ->get()
        //         ->sum('amount');
        //     $JournalVoucherNetAmountForCredit = AdminJournalVoucher::where('account_name', $account->account_name)
        //         ->where('branch_id', session()->get('selected_branch'))
        //         ->where('date', '>=', $from_date . ' 00:00:00')
        //         ->where('date', '<=', $to_date . ' 23:59:59')
        //         ->where('type','credit')
        //         ->whereNull('deleted_at')
        //         ->groupBy('invoice_no')
        //         ->get()
        //         ->sum('amount');

        //     $DebitOB += $CreateDebitOpeningBalance +  $SaleInvoiceTotalNetAmount + $DebitNoteTotalNetAmount + $PaymentVoucherTotalNetAmountForCash  + $JournalVoucherNetAmountForDebit + $ReceiptVoucherTotalNetAmountForBank;

        //     $CreditOB += $CreateCreditOpeningBalance + $PurchaesInvoiceTotalNetAmount + $CreditNoteTotalNetAmount + $JournalVoucherNetAmountForCredit + $ReceiptVoucherTotalNetAmountForCash + $PaymentVoucherTotalNetAmountForBank;



        //     $accountDetails[$account->class_of_account_id][] = [
        //         'account_id' => $account->id,
        //         'accoun_name' => $account->name_of_organisation ?? $account->account_name,
        //         'type' => $account->type,
        //         'class_of_account_id' => $account->class_of_account_id,
        //         'DebitBalance' => $DebitOB,
        //         'CreditBalance' => $CreditOB,
        //     ];
        //     }

        //     // dd($accountDetails);

        //     // Initialize total debit and credit balances for each class of account
        //     $totalDebitBalanceByClass = [];
        //     $totalCreditBalanceByClass = [];

        //     // Calculate total debit and credit balances for each class of account
        //     foreach ($accountDetails as $classId => $accounts) {
        //         $totalDebitBalance = 0;
        //         $totalCreditBalance = 0;

        //         foreach ($accounts as $account) {
        //             $totalDebitBalance += $account['DebitBalance'];
        //             $totalCreditBalance += $account['CreditBalance'];
        //         }

        //         // Store total debit and credit balances for each class of account
        //         $totalDebitBalanceByClass[$classId] = $totalDebitBalance;
        //         $totalCreditBalanceByClass[$classId] = $totalCreditBalance;
        //     }

        //     // Debug total debit and credit balances for each class of account
        //     dd($totalDebitBalanceByClass, $totalCreditBalanceByClass);

        $from_date = $request->from_date;
        $to_date = $request->to_date;

        $currentYearFirstDate = date("2003-01-01");
        $oneDayPreviousDate = date('Y-m-d', strtotime('-1 day', strtotime($from_date)));

        $ClassOfAccount = ClassOfAccount::get();

        // currentYearFirstDate to oneDayPreviousDate - date range data

        $opcustomers = Customer::where('branch_id', session()->get('selected_branch'))
            // ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
            // ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
            ->whereIn('class_of_account_id', $ClassOfAccount->pluck('id'))
            ->get(['id', 'class_of_account_id','name_of_organisation as account_name','opening_balance','type','date']);

        $opsuppliers = Supplier::where('branch_id', session()->get('selected_branch'))
            // ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
            // ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
            ->whereIn('class_of_account_id', $ClassOfAccount->pluck('id'))
            ->get(['id', 'class_of_account_id','name_of_organisation as account_name','opening_balance','type','date']);

        $opexpenses = Expense::where('branch_id', session()->get('selected_branch'))
            // ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
            // ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
            ->whereIn('class_of_account_id', $ClassOfAccount->pluck('id'))
            ->get(['id', 'class_of_account_id','account_name','opening_balance','type','date']);

        $opadminOtherAccounts = AdminOtherAccount::where('branch_id', session()->get('selected_branch'))
            // ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
            // ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
            ->whereIn('class_of_account_id', $ClassOfAccount->pluck('id'))
            ->get(['id', 'class_of_account_id','account_name','opening_balance','type','date']);

        $opstaffAndSalesman = StaffAndSalesman::where('branch_id', session()->get('selected_branch'))
            // ->where('date_of_joining', '>=', $currentYearFirstDate . ' 00:00:00')
            // ->where('date_of_joining', '<=', $oneDayPreviousDate . ' 23:59:59')
            ->whereIn('class_of_account_id', $ClassOfAccount->pluck('id'))
            ->selectRaw('id, class_of_account_id, CONCAT(first_name, " ", last_name) as account_name,date_of_joining as date')
            ->get();

        // $opAllAccounts = $opcustomers->concat($opsuppliers)->concat($opexpenses)->concat($opadminOtherAccounts)->concat($opstaffAndSalesman);

        // $opHalfFirstAccounts = $opcustomers->concat($opsuppliers)->concat($opexpenses);
        // $opHalfSecondAccounts = $opadminOtherAccounts->concat($opstaffAndSalesman);

        // $opAllAccounts = $opHalfFirstAccounts->concat($opHalfSecondAccounts);

        $opAllAccounts = $opcustomers->concat($opsuppliers)->concat($opexpenses)->concat($opadminOtherAccounts)->concat($opstaffAndSalesman);

        // dd($opAllAccounts);

        $opAccountDetails = [];

        // currentYearFirstDate to oneDayPreviousDate - date range data

        foreach ($opAllAccounts as $opAccount) {
            $opDebitOBalance = 0;
            $opCreditOBalance = 0;
            $opCreateDebitOpeningBalance = 0;
            $opCreateCreditOpeningBalance = 0;
            $debitAllAccountsDate = 0;
            $creditAllAccountsDate = 0;

            if ($opAccount->type === 'Debit' || $opAccount->type === 'debit' ) {
                $debitAllAccountsDate = $opAccount->date;
                $opCreateDebitOpeningBalance = $opAccount->opening_balance;

            } elseif ($opAccount->type === 'Credit' || $opAccount->type === 'credit' ) {
                $creditAllAccountsDate = $opAccount->date;
                $opCreateCreditOpeningBalance = $opAccount->opening_balance;

            }

         // dd($DebitOB,$CreditOB,$debitAllAccountsDate,$creditAllAccountsDate);

         $opPurchaesInvoiceTotalNetAmount = AdminPurchaesInvoice::where('account_name', $opAccount->account_name)
             ->where('branch_id', session()->get('selected_branch'))
             ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
             ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
             ->whereNull('deleted_at')
             ->groupBy('invoice_no')
             ->get()
             ->sum('total_purchase_amount_with_cf');

         $opSaleInvoiceTotalNetAmount = AdminSalesInvoice::where('account_name', $opAccount->account_name)
             ->where('branch_id', session()->get('selected_branch'))
             ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
             ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
             ->whereNull('deleted_at')
             ->groupBy('invoice_no')
             ->get()
             ->sum('total_net_amount');

         $opReceiptVoucherTotalNetAmountForCash = ReceiptVoucherExpense::where('account_name', $opAccount->account_name)
             ->where('branch_id', session()->get('selected_branch'))
            //  ->where('payment_method','cash')
             ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
             ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
             ->whereNull('deleted_at')
             ->groupBy('invoice_no')
             ->get()
             ->sum('amount');
         $opReceiptVoucherTotalNetAmountForBank = ReceiptVoucherExpense::
              where('bank_name', $opAccount->account_name)
             ->where('branch_id', session()->get('selected_branch'))
            //  ->where('payment_method','bank')
             ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
             ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
             ->whereNull('deleted_at')
             ->groupBy('invoice_no')
             ->get()
             ->sum('amount');

         $opPaymentVoucherTotalNetAmountForBank = PaymentVoucherExpense::
              where('bank_name', $opAccount->account_name)
             ->where('branch_id', session()->get('selected_branch'))
             ->where('payment_method','bank')
             ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
             ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
             ->whereNull('deleted_at')
             ->groupBy('invoice_no')
             ->get()
             ->sum(function ($voucher) {
                 return $voucher->amount + $voucher->new_vat_amount;
             });
         $opPaymentVoucherTotalNetAmountForCash = PaymentVoucherExpense::where('account_name', $opAccount->account_name)
             ->where('branch_id', session()->get('selected_branch'))
             ->where('payment_method','cash')
             ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
             ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
             ->whereNull('deleted_at')
             ->groupBy('invoice_no')
             ->get()
             ->sum(function ($voucher) {
                 return $voucher->amount + $voucher->new_vat_amount;
             });

             // dd($PaymentVoucherTotalNetAmountForBank,$PaymentVoucherTotalNetAmountForCash);

         $opCreditNoteTotalNetAmount = CreditNote::where('account_name', $opAccount->account_name)
             ->where('branch_id', session()->get('selected_branch'))
             ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
             ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
             ->groupBy('invoice_no')
             ->sum('total_net_amount');

         $opDebitNoteTotalNetAmount = DebitNote::where('account_name', $opAccount->account_name)
             ->where('branch_id', session()->get('selected_branch'))
             ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
             ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
             ->groupBy('invoice_no')
             ->sum('total_net_amount');

         $opJournalVoucherNetAmountForDebit = AdminJournalVoucher::where('account_name', $opAccount->account_name)
             ->where('branch_id', session()->get('selected_branch'))
             ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
             ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
             ->where('type','debit')
             ->groupBy('invoice_no')
             ->get()
             ->sum('amount');
         $opJournalVoucherNetAmountForCredit = AdminJournalVoucher::where('account_name', $opAccount->account_name)
             ->where('branch_id', session()->get('selected_branch'))
             ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
             ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
             ->where('type','credit')
             ->groupBy('invoice_no')
             ->get()
             ->sum('amount');

         // dd($ObJournalVoucherNetAmountForDebit,$ObJournalVoucherNetAmountForCredit);

         $opDebitOBalance += $opCreateDebitOpeningBalance + $opSaleInvoiceTotalNetAmount + $opDebitNoteTotalNetAmount + $opPaymentVoucherTotalNetAmountForCash + $opJournalVoucherNetAmountForDebit + $opReceiptVoucherTotalNetAmountForBank;

         $opCreditOBalance += $opCreateCreditOpeningBalance + $opPurchaesInvoiceTotalNetAmount + $opCreditNoteTotalNetAmount + $opJournalVoucherNetAmountForCredit + $opReceiptVoucherTotalNetAmountForCash + $opPaymentVoucherTotalNetAmountForBank;


         $opAccountDetails[$opAccount->class_of_account_id][] = [
             'account_id' => $opAccount->id,
             'accoun_name' => $opAccount->name_of_organisation ?? $opAccount->account_name,
             'type' => $opAccount->type,
             'class_of_account_id' => $opAccount->class_of_account_id,
             'DebitBalance' => $opDebitOBalance,
             'CreditBalance' => $opCreditOBalance,
         ];
         }

        // from_date to to_date - date range data


        $customers = Customer::where('branch_id', session()->get('selected_branch'))
        ->whereIn('class_of_account_id', $ClassOfAccount->pluck('id'))
        ->get(['id', 'class_of_account_id', 'name_of_organisation as account_name', 'opening_balance', 'type', 'date']);



        $suppliers = Supplier::where('branch_id', session()->get('selected_branch'))
            ->whereIn('class_of_account_id', $ClassOfAccount->pluck('id'))
            ->get(['id', 'class_of_account_id','name_of_organisation as account_name','opening_balance','type','date']);

        $expenses = Expense::where('branch_id', session()->get('selected_branch'))
            ->whereIn('class_of_account_id', $ClassOfAccount->pluck('id'))
            ->get(['id', 'class_of_account_id','account_name','opening_balance','type','date']);

        $adminOtherAccounts = AdminOtherAccount::where('branch_id', session()->get('selected_branch'))
            ->whereIn('class_of_account_id', $ClassOfAccount->pluck('id'))
            ->get(['id', 'class_of_account_id','account_name','opening_balance','type','date']);

        $staffAndSalesman = StaffAndSalesman::where('branch_id', session()->get('selected_branch'))
            ->whereIn('class_of_account_id', $ClassOfAccount->pluck('id'))
            ->selectRaw('id, class_of_account_id, CONCAT(first_name, " ", last_name) as account_name,date_of_joining as date,type')
            ->get();


        // $halfFirstAccounts = $customers->concat($suppliers)->concat($expenses);
        // $halfSecondAccounts = $adminOtherAccounts->concat($staffAndSalesman);

        $allAccounts = $customers->concat($suppliers)->concat($expenses)->concat($adminOtherAccounts)->concat($staffAndSalesman);


        // from_date to to_date - date range data

        $accountDetails = [];

        foreach ($allAccounts as $account) {
            $DebitOB = 0;
            $CreditOB = 0;
            $CreateDebitOpeningBalance = 0;
            $CreateCreditOpeningBalance = 0;
            $debitAllAccountsDate = 0;
            $creditAllAccountsDate = 0;

            if ($account->type === 'Debit' || $account->type === 'debit' ) {
                $debitAllAccountsDate = $account->date;
                $CreateDebitOpeningBalance = $account->opening_balance;

            } elseif ($account->type === 'Credit' || $account->type === 'credit' ) {
                $creditAllAccountsDate = $account->date;
                $CreateCreditOpeningBalance = $account->opening_balance;

            }

            // dd($CreateDebitOpeningBalance,$CreateCreditOpeningBalance,$debitAllAccountsDate,$creditAllAccountsDate);

            $ReceiptVoucherTotalNetAmountForCash = ReceiptVoucherExpense::where('account_name', $account->account_name)
                ->where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->whereNull('deleted_at')
                ->groupBy('invoice_no')
                // ->get()
                ->sum('amount');

            $ReceiptVoucherTotalNetAmountForBank = ReceiptVoucherExpense::where('bank_name', $account->account_name)
                ->where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->whereNull('deleted_at')
                ->groupBy('invoice_no')
                // ->get()
                ->sum('amount');

            // dd($ReceiptVoucherTotalNetAmountForCash,$ReceiptVoucherTotalNetAmountForBank);


            $PurchaesInvoiceTotalNetAmount = AdminPurchaesInvoice::where('account_name', $account->account_name)
                ->where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->whereNull('deleted_at')
                ->groupBy('invoice_no')
                ->get()
                ->sum('total_purchase_amount_with_cf');

            $SaleInvoiceTotalNetAmount = AdminSalesInvoice::where('account_name', $account->account_name)
                ->where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->whereNull('deleted_at')
                ->groupBy('invoice_no')
                ->get()
                ->sum('total_net_amount');



            $PaymentVoucherTotalNetAmountForBank = PaymentVoucherExpense::where(function($query) use ($account) {
                $query->where('bank_name', $account->account_name);
                })
                ->where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->whereNull('deleted_at')
                ->groupBy('invoice_no')
                ->get()
                ->sum(function ($voucher) {
                    return $voucher->amount + $voucher->new_vat_amount;
                });
            $PaymentVoucherTotalNetAmountForCash = PaymentVoucherExpense::where(function($query) use ($account) {
                $query->where('account_name', $account->account_name);
                })
                ->where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->whereNull('deleted_at')
                ->groupBy('invoice_no')
                ->get()
                ->sum(function ($voucher) {
                    return $voucher->amount + $voucher->new_vat_amount;
                });

                // dd($PaymentVoucherTotalNetAmountForBank,$PaymentVoucherTotalNetAmountForCash);

            $CreditNoteTotalNetAmount = CreditNote::where('account_name', $account->account_name)
                ->where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->groupBy('invoice_no')
                ->get()
                ->sum('total_net_amount');
            // dd($CreditNoteTotalNetAmount);
            $DebitNoteTotalNetAmount = DebitNote::where('account_name', $account->account_name)
                ->where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->groupBy('invoice_no')
                ->sum('total_net_amount');

            $JournalVoucherNetAmountForDebit = AdminJournalVoucher::where('account_name', $account->account_name)
                ->where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->where('type','debit')
                ->whereNull('deleted_at')
                ->groupBy('invoice_no')
                ->get()
                ->sum('amount');
            $JournalVoucherNetAmountForCredit = AdminJournalVoucher::where('account_name', $account->account_name)
                ->where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->where('type','credit')
                ->whereNull('deleted_at')
                ->groupBy('invoice_no')
                ->get()
                ->sum('amount');



                // dd($ReceiptVoucherTotalNetAmountForCash,$ReceiptVoucherTotalNetAmountForBank);

            // dd($JournalVoucherNetAmountForDebit,$JournalVoucherNetAmountForCredit);

            $DebitOB += $CreateDebitOpeningBalance +  $SaleInvoiceTotalNetAmount + $DebitNoteTotalNetAmount + $PaymentVoucherTotalNetAmountForCash  + $JournalVoucherNetAmountForDebit + $ReceiptVoucherTotalNetAmountForBank;

            $CreditOB += $CreateCreditOpeningBalance + $PurchaesInvoiceTotalNetAmount + $CreditNoteTotalNetAmount + $JournalVoucherNetAmountForCredit + $ReceiptVoucherTotalNetAmountForCash + $PaymentVoucherTotalNetAmountForBank;



            $accountDetails[$account->class_of_account_id][] = [
                'account_id' => $account->id,
                'accoun_name' => $account->name_of_organisation ?? $account->account_name,
                'type' => $account->type,
                'class_of_account_id' => $account->class_of_account_id,
                'DebitBalance' => $DebitOB,
                'CreditBalance' => $CreditOB,
            ];
            }

            // dd($accountDetails,$opAccountDetails);

                $mergedAccountDetails = [];

                foreach ($opAccountDetails as $classId => $accounts) {
                    foreach ($accounts as $account) {
                        $mergedAccountDetails[$account['account_id']] = $account;
                    }
                }

                foreach ($accountDetails as $classId => $accounts) {
                    foreach ($accounts as $account) {
                        $mergedAccountDetails[$account['account_id']] = $account;
                    }
                }

                foreach ($mergedAccountDetails as $account) {
                    $totalDebit = array_sum(array_column($mergedAccountDetails, 'DebitBalance'));
                    $totalCredit = array_sum(array_column($mergedAccountDetails, 'CreditBalance'));
                }

                foreach ($mergedAccountDetails as &$account) {
                    $netBalance = $account['DebitBalance'] - $account['CreditBalance'];

                    if ($netBalance > 0) {
                        $account['DebitBalance'] = $netBalance;
                        $account['CreditBalance'] = 0;
                    } else {
                        $account['CreditBalance'] = abs($netBalance);
                        $account['DebitBalance'] = 0;
                    }
                }
                // dd($mergedAccountDetails);

                // $groupedAccountDetails = [];

                // foreach ($mergedAccountDetails as $account) {
                //     $classId = $account['class_of_account_id'];
                //     if (!isset($groupedAccountDetails[$classId])) {
                //         $groupedAccountDetails[$classId] = [];
                //     }
                //     $groupedAccountDetails[$classId][] = $account;
                // }

                // // Print or process the grouped data as needed
                // dd($groupedAccountDetails);

                // Step 1: Retrieve ClassOfAccount details from the database
                $classOfAccountDetails = ClassOfAccount::all()->keyBy('id');

                // Step 2: Initialize mergedAccountDetails and populate it
                $mergedAccountDetails = [];

                foreach ($opAccountDetails as $classId => $accounts) {
                    foreach ($accounts as $account) {
                        $mergedAccountDetails[$account['account_id']] = $account;
                    }
                }

                foreach ($accountDetails as $classId => $accounts) {
                    foreach ($accounts as $account) {
                        $mergedAccountDetails[$account['account_id']] = $account;
                    }
                }

                // Step 3: Group by class of account name
                $groupedAccountDetails = [];

                foreach ($mergedAccountDetails as $account) {
                    $classId = $account['class_of_account_id'];
                    $className = $classOfAccountDetails[$classId]->name ?? 'Unknown';

                    if (!isset($groupedAccountDetails[$className])) {
                        $groupedAccountDetails[$className] = [];
                    }
                    $groupedAccountDetails[$className][] = $account;
                }

                // Step 4: Adjust balances within each group
                foreach ($groupedAccountDetails as &$group) {
                    foreach ($group as &$account) {
                        $netBalance = $account['DebitBalance'] - $account['CreditBalance'];

                        if ($netBalance > 0) {
                            $account['DebitBalance'] = $netBalance;
                            $account['CreditBalance'] = 0;
                        } else {
                            $account['CreditBalance'] = abs($netBalance);
                            $account['DebitBalance'] = 0;
                        }
                    }
                }

                // Debug output
                // dd($groupedAccountDetails);


                // yahan tak perfect hai

                // $classOfAccountDetails = ClassOfAccount::get()->keyBy('id');

                // $groupedAccountDetails = [];

                // foreach ($mergedAccountDetails as $account) {
                //     $classId = $account['class_of_account_id'];
                //     $className = $classOfAccountDetails[$classId]->name ?? 'Unknown';

                //     if (!isset($groupedAccountDetails[$className][$account['account_id']])) {
                //         $groupedAccountDetails[$className][$account['account_id']] = $account;
                //     }
                // }
                // dd($mergedAccountDetails);

                // foreach ($groupedAccountDetails as $className => &$accounts) {
                //     $accounts = array_values($accounts);
                // }

                // dd($groupedAccountDetails);


                // accountDetails or opAccountDetails ka data dd me bilkul accurate ara hai, lekin groupedAccountDetails me data complete nahi ara ye thik karo

            return [$groupedAccountDetails,$from_date, $to_date,];

    }

    public function AllAccountsCreateOpeningBalanceWithAllTransactionClosingBalance($request)
    {
        $from_date = $request->from_date;
        $to_date = $request->to_date;
        // $classOfAccountId = $request->class_of_account;

        $currentYearFirstDate = date("2003-01-01");
        $oneDayPreviousDate = date('Y-m-d', strtotime('-1 day', strtotime($from_date)));

        // // Vat Report Amount --------------------------------

        // list($debitVatReportCB,$creditVatReportCB) = $this->vatReportService->vatReportClosingBalance($request, $request->from_date, $request->to_date);


        // // dd($debitVatReportCB,$creditVatReportCB);

        // // Cash Report Data -----------------------------------------------------

        // list($debitCashReportCB,$creditCashReportCB) = $this->cashReportService->CashReportServiceClosingBalance($request, $request->from_date, $request->to_date);

        // // Vat Report Data -----------------------------------------------------

        // list($debitDiscountReportCB,$creditDiscountReportCB) = $this->discountReportService->DiscountReportServiceClosingBalance($request, $request->from_date, $request->to_date);

        // from_date to to_date - date range data

        $ClassOfAccount = ClassOfAccount::get();

        $customers = Customer::where('branch_id', session()->get('selected_branch'))
            ->where('date', '>=', $from_date . ' 00:00:00')
            ->where('date', '<=', $to_date . ' 23:59:59')
            ->whereIn('class_of_account_id', $ClassOfAccount->pluck('id'))
            ->get(['id', 'class_of_account_id','name_of_organisation as account_name','opening_balance','type','date']);

        $suppliers = Supplier::where('branch_id', session()->get('selected_branch'))
            ->where('date', '>=', $from_date . ' 00:00:00')
            ->where('date', '<=', $to_date . ' 23:59:59')
            ->whereIn('class_of_account_id', $ClassOfAccount->pluck('id'))
            ->get(['id', 'class_of_account_id','name_of_organisation as account_name','opening_balance','type','date']);

        $expenses = Expense::where('branch_id', session()->get('selected_branch'))
            ->where('date', '>=', $from_date . ' 00:00:00')
            ->where('date', '<=', $to_date . ' 23:59:59')
            ->whereIn('class_of_account_id', $ClassOfAccount->pluck('id'))
            ->get(['id', 'class_of_account_id','account_name','opening_balance','type','date']);

        $adminOtherAccounts = AdminOtherAccount::where('branch_id', session()->get('selected_branch'))
            ->where('date', '>=', $from_date . ' 00:00:00')
            ->where('date', '<=', $to_date . ' 23:59:59')
            ->whereIn('class_of_account_id', $ClassOfAccount->pluck('id'))
            ->get(['id', 'class_of_account_id','account_name','opening_balance','type','date']);

        $staffAndSalesman = StaffAndSalesman::where('branch_id', session()->get('selected_branch'))
            ->where('date_of_joining', '>=', $from_date . ' 00:00:00')
            ->where('date_of_joining', '<=', $to_date . ' 23:59:59')
            ->whereIn('class_of_account_id', $ClassOfAccount->pluck('id'))
            ->selectRaw('id, class_of_account_id, CONCAT(first_name, " ", last_name) as account_name,date_of_joining as date')
            ->get();

        $allAccounts = $customers->concat($suppliers)->concat($expenses)->concat($adminOtherAccounts)->concat($staffAndSalesman);

        // dd($allAccounts);

        $allAccountsData = [];

        foreach ($allAccounts as $account) {
            $AccountName = $account->account_name;
            $openingBalanceDebit = null;
            $openingBalanceCredit = null;

            if ($account->type == 'debit' || $account->type == 'Debit') {
                $openingBalanceDebit = $account->opening_balance;
            } elseif ($account->type == 'credit' || $account->type == 'Credit') {
                $openingBalanceCredit = $account->opening_balance;
            }

            // Calculate total purchase invoice amount for the account
            $PurchaesInvoice = AdminPurchaesInvoice::where('account_name', $account->account_name)
                ->where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->whereNull('deleted_at')
                ->sum('total_net_amount');

            // Calculate total sale invoice amount for the account
            $SaleInvoice = AdminSalesInvoice::where('account_name', $account->account_name)
                ->where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->whereNull('deleted_at')
                ->sum('total_net_amount');

            // Add total purchase invoice amount to opening balance debit
            $openingBalanceDebit += $PurchaesInvoice;

            // Add total sale invoice amount to opening balance credit
            $openingBalanceCredit += $SaleInvoice;

            // Add data to $allAccountsData array
            $allAccountsData[] = [
                'name' => $AccountName,
                'opening_balance_debit' => $openingBalanceDebit,
                'opening_balance_credit' => $openingBalanceCredit
            ];
        }

        dd($allAccountsData);


        // allAccounts me jo same class_of_account_id pe banein hai wo account ko ClassOfAccount name group wise kar do


        $totalDebit = [];
        $totalCredit = [];
        $obtotalDebit = [];
        $obtotalCredit = [];

        foreach ($allAccounts as $account) {
            $PurchaesInvoice = AdminPurchaesInvoice::where('account_name', $account->account_name)
                ->where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->whereNull('deleted_at')
                ->groupBy('invoice_no')
                ->get();

            $SaleInvoice = AdminSalesInvoice::where('account_name', $account->account_name)
                ->where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->whereNull('deleted_at')
                ->groupBy('invoice_no')
                ->get();

            $PaymentVoucher = PaymentVoucherExpense::where(function($query) use ($account) {
                    $query->where('account_name', $account->account_name)
                        ->orWhere('bank_name', $account->account_name);
                })
                ->where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->whereNull('deleted_at')
                ->groupBy('invoice_no')
                ->get();

            $ReceiptVoucherForBank = ReceiptVoucherExpense::where(function($query) use ($account) {
                    $query->where('account_name', $account->account_name)
                        ->orWhere('bank_name', $account->account_name);
                })
                ->where('branch_id', session()->get('selected_branch'))
                ->where('payment_method','bank')
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->whereNull('deleted_at')
                ->groupBy('invoice_no')
                ->get();
            $ReceiptVoucherForCash = ReceiptVoucherExpense::where(function($query) use ($account) {
                    $query->where('account_name', $account->account_name)
                        ->orWhere('bank_name', $account->account_name);
                })
                ->where('branch_id', session()->get('selected_branch'))
                ->where('payment_method','cash')
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->whereNull('deleted_at')
                ->groupBy('invoice_no')
                ->get();
            $ReceiptVoucherTotalNetAmountForCash = ReceiptVoucherExpense::where(function($query) use ($account) {
                    $query->where('account_name', $account->account_name)
                    ->orWhere('bank_name', $account->account_name);
                })
                ->where('branch_id', session()->get('selected_branch'))
                ->where('payment_method','bank')
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->whereNull('deleted_at')
                ->groupBy('invoice_no')
                ->get();

            $CreditNote = CreditNote::where('account_name', $account->account_name)
                ->where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->whereNull('deleted_at')
                ->groupBy('invoice_no')
                ->get();

            $DebitNote = DebitNote::where('account_name', $account->account_name)
                ->where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->whereNull('deleted_at')
                ->groupBy('invoice_no')
                ->get();

            $JournalVoucherForDebit = AdminJournalVoucher::where('account_name', $account->account_name)
                ->where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->where('type', 'debit')
                ->whereNull('deleted_at')
                ->groupBy('invoice_no')
                ->get();

            $JournalVoucherForCredit = AdminJournalVoucher::where('account_name', $account->account_name)
                ->where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->where('type', 'credit')
                ->whereNull('deleted_at')
                ->groupBy('invoice_no')
                ->get();

                // dd($JournalVoucherForDebit,$JournalVoucherForCredit);

            $TotalPurchaesInvoice = $PurchaesInvoice->sum('total_net_amount');
            $TotalDebitNote = $DebitNote->sum('total_net_amount');
            $TotalPaymentVoucher = $PaymentVoucher->sum('amount');
            $TotalJournalVoucherForDebit = $JournalVoucherForDebit->sum('amount');

            $TotalSaleInvoice = $SaleInvoice->sum('total_net_amount');
            $TotalReceiptVoucherForBank = $ReceiptVoucherForBank->sum('amount');
            $TotalReceiptVoucherForCash = $ReceiptVoucherForCash->sum('amount');
            $TotalJournalVoucherForCredit = $JournalVoucherForCredit->sum('amount');
            $TotalCreditNote = $CreditNote->sum('total_net_amount');

            $totalDebitValue = $TotalSaleInvoice + $TotalPaymentVoucher + $TotalDebitNote + $TotalJournalVoucherForDebit + $TotalReceiptVoucherForBank;
            $totalCreditValue = $TotalPurchaesInvoice + $TotalReceiptVoucherForCash + $TotalCreditNote + $TotalJournalVoucherForCredit;

            $totalDebit[] = [
                'account_name' => $account->account_name,
                'type' => $account->type,
                'opening_balance' => $account->opening_balance,
                'DebitBalance' => $totalDebitValue,
            ];

            // Check if the account type is 'Debit' and update 'DebitBalance' accordingly
            if (strtolower($account->type) === 'debit') {
                $totalDebit[count($totalDebit) - 1]['DebitBalance'] += $account->opening_balance;
            }

            $totalCredit[] = [
                'account_name' => $account->account_name,
                'type' => $account->type,
                'opening_balance' => $account->opening_balance,
                'creditBalance' => $totalCreditValue,
            ];

            // Check if the account type is 'Credit' and update 'creditBalance' accordingly
            if (strtolower($account->type) === 'credit') {
                $totalCredit[count($totalCredit) - 1]['creditBalance'] += $account->opening_balance;
            }

            }

            // dd($totalDebit,$totalCredit);

            foreach ($allAccounts as $account) {
                $obPurchaesInvoice = AdminPurchaesInvoice::where('account_name', $account->account_name)
                    ->where('branch_id', session()->get('selected_branch'))
                    ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
                    ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
                    ->whereNull('deleted_at')
                    ->groupBy('invoice_no')
                    ->get();

                $obSaleInvoice = AdminSalesInvoice::where('account_name', $account->account_name)
                    ->where('branch_id', session()->get('selected_branch'))
                    ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
                    ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
                    ->whereNull('deleted_at')
                    ->groupBy('invoice_no')
                    ->get();

                $obReceiptVoucher = ReceiptVoucherExpense::where(function($query) use ($account) {
                        $query->where('account_name', $account->account_name)
                            ->orWhere('bank_name', $account->account_name);
                    })
                    ->where('branch_id', session()->get('selected_branch'))
                    ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
                    ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
                        ->whereNull('deleted_at')
                        ->groupBy('invoice_no')

                    ->get();

                $obPaymentVoucher = PaymentVoucherExpense::where(function($query) use ($account) {
                        $query->where('account_name', $account->account_name)
                            ->orWhere('bank_name', $account->account_name);
                    })
                    ->where('branch_id', session()->get('selected_branch'))
                    ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
                    ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
                    ->whereNull('deleted_at')
                        ->groupBy('invoice_no')
                    ->get();

                $obCreditNote = CreditNote::where('account_name', $account->account_name)
                    ->where('branch_id', session()->get('selected_branch'))
                    ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
                    ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
                    ->whereNull('deleted_at')
                    ->groupBy('invoice_no')
                    ->get();

                $obDebitNote = DebitNote::where('account_name', $account->account_name)
                    ->where('branch_id', session()->get('selected_branch'))
                    ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
                    ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
                    ->whereNull('deleted_at')
                    ->groupBy('invoice_no')
                    ->get();
                $obJournalVoucherForDebit = AdminJournalVoucher::where('account_name', $account->account_name)
                    ->where('branch_id', session()->get('selected_branch'))
                    ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
                    ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
                    ->where('type', 'debit')
                    ->whereNull('deleted_at')
                    ->groupBy('invoice_no')
                    ->get();

                $obJournalVoucherForCredit = AdminJournalVoucher::where('account_name', $account->account_name)
                    ->where('branch_id', session()->get('selected_branch'))
                    ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
                    ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
                    ->where('type', 'credit')
                    ->whereNull('deleted_at')
                    ->groupBy('invoice_no')
                    ->get();

                // dd($obJournalVoucherForDebit,$obJournalVoucherForCredit);

                $TotalPurchaesInvoice = $obPurchaesInvoice->sum('total_net_amount');
                $TotalDebitNote = $obDebitNote->sum('total_net_amount');
                $TotalPaymentVoucher = $obPaymentVoucher->sum('amount');
                $TotalobJournalVoucherForDebit = $obJournalVoucherForDebit->sum('amount');

                $TotalSaleInvoice = $obSaleInvoice->sum('total_net_amount');
                $TotalReceiptVoucher = $obReceiptVoucher->sum('amount');
                $TotalobJournalVoucherForCredit = $obJournalVoucherForCredit->sum('amount');
                $TotalCreditNote = $obCreditNote->sum('total_net_amount');

                $obTotalDebitValue = $TotalSaleInvoice + $TotalPaymentVoucher + $TotalDebitNote + $TotalobJournalVoucherForDebit;
                $obTotalCreditValue = $TotalPurchaesInvoice  + $TotalReceiptVoucher + $TotalCreditNote + $TotalobJournalVoucherForCredit;


                $Debit = null;
                $Credit = null;

                if ($obTotalDebitValue > $obTotalCreditValue) {
                    $Debit = $obTotalDebitValue - $obTotalCreditValue;
                } elseif ($obTotalDebitValue < $obTotalCreditValue) {
                    $Credit = $obTotalCreditValue - $obTotalDebitValue;
                }

                $obDebitBalance = $Debit;
                $obcreditBalance = $Credit;

                $obtotalDebit[] = [
                    'account_name' => $account->account_name,
                    'DebitBalance' => $obDebitBalance,
                ];

                $obtotalCredit[] = [
                    'account_name' => $account->account_name,
                    'creditBalance' => $obcreditBalance,
                ];

                }

                dd($totalDebit,$totalCredit,$obtotalDebit,$obtotalCredit);

                return [$totalDebit,$totalCredit,$obtotalDebit,$obtotalCredit,$from_date, $to_date,];

    }

    // -----   Cash In Hand   ------------------------------------------------------------- >>>>>>>>>>>>>>>>>>

    public function AllCashInHandClassofAccounts($request, $from_date, $to_date)
    {

        $from_date = $request->from_date;
        $to_date = $request->to_date;

        $currentYearFirstDate = date("2003-01-01");
        $oneDayPreviousDate = date('Y-m-d', strtotime('-1 day', strtotime($from_date)));

        $opcustomers = Customer::where('branch_id', session()->get('selected_branch'))
            ->where('class_of_account_id', 3)
            ->get(['id', 'class_of_account_id','name_of_organisation as account_name','opening_balance','type','date']);

        $opsuppliers = Supplier::where('branch_id', session()->get('selected_branch'))
            ->where('class_of_account_id', 3)
            ->get(['id', 'class_of_account_id','name_of_organisation as account_name','opening_balance','type','date']);

        $opexpenses = Expense::where('branch_id', session()->get('selected_branch'))
            ->where('class_of_account_id',3)
            ->get(['id', 'class_of_account_id','account_name','opening_balance','type','date']);

        $opadminOtherAccounts = AdminOtherAccount::where('branch_id', session()->get('selected_branch'))
            ->where('class_of_account_id', 3)
            ->get(['id', 'class_of_account_id','account_name','opening_balance','type','date']);

        $opstaffAndSalesman = StaffAndSalesman::where('branch_id', session()->get('selected_branch'))
            ->where('class_of_account_id', 3)
            ->selectRaw('id, class_of_account_id, CONCAT(first_name, " ", last_name) as account_name,date_of_joining as date')
            ->get();

        $opAllAccounts = $opcustomers->concat($opsuppliers)->concat($opexpenses)->concat($opadminOtherAccounts)->concat($opstaffAndSalesman);

        // dd($opAllAccounts);

        $opAccountDetails = [];

        foreach ($opAllAccounts as $opAccount) {
            $opDebitOBalance = null;
            $opCreditOBalance = null;
            $opCreateDebitOpeningBalance = null;
            $opCreateCreditOpeningBalance = null;
            $debitAllAccountsDate = null;
            $creditAllAccountsDate = null;

            if (($opAccount->type === 'Debit' || $opAccount->type === 'debit') && $opAccount->date >= $currentYearFirstDate && $opAccount->date <= $oneDayPreviousDate) {
                $debitAllAccountsDate = $opAccount->date;
                $opCreateDebitOpeningBalance = $opAccount->opening_balance;

            } elseif (($opAccount->type === 'Credit' || $opAccount->type === 'credit') && $opAccount->date >= $currentYearFirstDate && $opAccount->date <= $oneDayPreviousDate) {
                $creditAllAccountsDate = $opAccount->date;
                $opCreateCreditOpeningBalance = $opAccount->opening_balance;

            }

         // dd($DebitOB,$CreditOB,$debitAllAccountsDate,$creditAllAccountsDate);

         $opPurchaesInvoiceTotalNetAmount = AdminPurchaesInvoice::where('account_name', $opAccount->account_name)
             ->where('branch_id', session()->get('selected_branch'))
             ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
             ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
             ->whereNull('deleted_at')
             ->groupBy('invoice_no')
             ->get()
             ->sum('total_net_amount');

         $opSaleInvoiceTotalNetAmount = AdminSalesInvoice::where('account_name', $opAccount->account_name)
             ->where('branch_id', session()->get('selected_branch'))
             ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
             ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
             ->whereNull('deleted_at')
             ->groupBy('invoice_no')
             ->get()
             ->sum('total_net_amount');

         $opReceiptVoucherTotalNetAmountForCash = ReceiptVoucherExpense::where('account_name', $opAccount->account_name)
             ->where('branch_id', session()->get('selected_branch'))
            //  ->where('payment_method','cash')
             ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
             ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
             ->whereNull('deleted_at')
             ->groupBy('invoice_no')
             ->get()
             ->sum('amount');
         $opReceiptVoucherTotalNetAmountForBank = ReceiptVoucherExpense::
              where('bank_name', $opAccount->account_name)
             ->where('branch_id', session()->get('selected_branch'))
            //  ->where('payment_method','bank')
             ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
             ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
             ->whereNull('deleted_at')
             ->groupBy('invoice_no')
             ->get()
             ->sum('amount');

         $opPaymentVoucherTotalNetAmountForBank = PaymentVoucherExpense::
              where('bank_name', $opAccount->account_name)
             ->where('branch_id', session()->get('selected_branch'))
            //  ->where('payment_method','bank')
             ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
             ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
             ->whereNull('deleted_at')
             ->groupBy('invoice_no')
             ->get()
             ->sum(function ($voucher) {
                 return $voucher->amount + $voucher->new_vat_amount;
             });
         $opPaymentVoucherTotalNetAmountForCash = PaymentVoucherExpense::where('account_name', $opAccount->account_name)
             ->where('branch_id', session()->get('selected_branch'))
            //  ->where('payment_method','cash')
             ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
             ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
             ->whereNull('deleted_at')
             ->groupBy('invoice_no')
             ->get()
             ->sum(function ($voucher) {
                 return $voucher->amount + $voucher->new_vat_amount;
             });

             // dd($PaymentVoucherTotalNetAmountForBank,$PaymentVoucherTotalNetAmountForCash);

         $opCreditNoteTotalNetAmount = CreditNote::where('account_name', $opAccount->account_name)
             ->where('branch_id', session()->get('selected_branch'))
             ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
             ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
             ->groupBy('invoice_no')
             ->sum('total_net_amount');

         $opDebitNoteTotalNetAmount = DebitNote::where('account_name', $opAccount->account_name)
             ->where('branch_id', session()->get('selected_branch'))
             ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
             ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
             ->groupBy('invoice_no')
             ->sum('total_net_amount');

         $opJournalVoucherNetAmountForDebit = AdminJournalVoucher::where('account_name', $opAccount->account_name)
             ->where('branch_id', session()->get('selected_branch'))
             ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
             ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
             ->where('type','debit')
             ->groupBy('invoice_no')
             ->get()
             ->sum('amount');
         $opJournalVoucherNetAmountForCredit = AdminJournalVoucher::where('account_name', $opAccount->account_name)
             ->where('branch_id', session()->get('selected_branch'))
             ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
             ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
             ->where('type','credit')
             ->groupBy('invoice_no')
             ->get()
             ->sum('amount');


         $opDebitOBalance += $opCreateDebitOpeningBalance + $opSaleInvoiceTotalNetAmount + $opDebitNoteTotalNetAmount + $opPaymentVoucherTotalNetAmountForCash + $opJournalVoucherNetAmountForDebit + $opReceiptVoucherTotalNetAmountForBank;

         $opCreditOBalance += $opCreateCreditOpeningBalance + $opPurchaesInvoiceTotalNetAmount + $opCreditNoteTotalNetAmount + $opJournalVoucherNetAmountForCredit + $opReceiptVoucherTotalNetAmountForCash + $opPaymentVoucherTotalNetAmountForBank;


         $opAccountDetails[$opAccount->class_of_account_id][] = [
             'account_id' => $opAccount->id,
             'account_name' => $opAccount->name_of_organisation ?? $opAccount->account_name,
             'type' => $opAccount->type,
             'class_of_account_id' => $opAccount->class_of_account_id,
             'DebitBalance' => $opDebitOBalance,
             'CreditBalance' => $opCreditOBalance,
         ];
         }

        // from_date to to_date - date range data


        $customers = Customer::where('branch_id', session()->get('selected_branch'))
        ->where('class_of_account_id', 3)
        ->get(['id', 'class_of_account_id', 'name_of_organisation as account_name', 'opening_balance', 'type', 'date']);

        $suppliers = Supplier::where('branch_id', session()->get('selected_branch'))
            ->where('class_of_account_id', 3)
            ->get(['id', 'class_of_account_id','name_of_organisation as account_name','opening_balance','type','date']);

        $expenses = Expense::where('branch_id', session()->get('selected_branch'))
            ->where('class_of_account_id', 3)
            ->get(['id', 'class_of_account_id','account_name','opening_balance','type','date']);

        $adminOtherAccounts = AdminOtherAccount::where('branch_id', session()->get('selected_branch'))
            ->where('class_of_account_id', 3)
            ->get(['id', 'class_of_account_id','account_name','opening_balance','type','date']);

        $staffAndSalesman = StaffAndSalesman::where('branch_id', session()->get('selected_branch'))
            ->where('class_of_account_id', 3)
            ->selectRaw('id, class_of_account_id, CONCAT(first_name, " ", last_name) as account_name,date_of_joining as date,type')
            ->get();


        // $halfFirstAccounts = $customers->concat($suppliers)->concat($expenses);
        // $halfSecondAccounts = $adminOtherAccounts->concat($staffAndSalesman);

        $allAccounts = $customers->concat($suppliers)->concat($expenses)->concat($adminOtherAccounts)->concat($staffAndSalesman);


        // from_date to to_date - date range data

        $accountDetails = [];

        foreach ($allAccounts as $account) {
            $DebitOB = null;
            $CreditOB = null;
            $CreateDebitOpeningBalance = null;
            $CreateCreditOpeningBalance = null;
            $debitAllAccountsDate = null;
            $creditAllAccountsDate = null;

            if (($account->type === 'Debit' || $account->type === 'debit') && $account->date >= $from_date && $account->date <= $to_date) {
                $debitAllAccountsDate = $account->date;
                $CreateDebitOpeningBalance = $account->opening_balance;

            } elseif (($account->type === 'Credit' || $account->type === 'credit') && $account->date >= $from_date && $account->date <= $to_date) {
                $creditAllAccountsDate = $account->date;
                $CreateCreditOpeningBalance = $account->opening_balance;

            }

            $ReceiptVoucherTotalNetAmountForCash = ReceiptVoucherExpense::where('account_name', $account->account_name)
                ->where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->whereNull('deleted_at')
                ->groupBy('invoice_no')
                ->get()
                ->sum('amount');

            $ReceiptVoucherTotalNetAmountForBank = ReceiptVoucherExpense::where('bank_name', $account->account_name)
                ->where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->whereNull('deleted_at')
                ->groupBy('invoice_no')
                ->get()
                ->sum('amount');

            $PurchaesInvoiceTotalNetAmount = AdminPurchaesInvoice::where('account_name', $account->account_name)
                ->where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->whereNull('deleted_at')
                ->groupBy('invoice_no')
                ->get()
                ->sum('total_net_amount');

            $SaleInvoiceTotalNetAmount = AdminSalesInvoice::where('account_name', $account->account_name)
                ->where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->whereNull('deleted_at')
                ->groupBy('invoice_no')
                ->get()
                ->sum('total_net_amount');



            $PaymentVoucherTotalNetAmountForBank = PaymentVoucherExpense::where(function($query) use ($account) {
                $query->where('bank_name', $account->account_name);
                })
                ->where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->whereNull('deleted_at')
                ->groupBy('invoice_no')
                ->get()
                ->sum(function ($voucher) {
                    return $voucher->amount + $voucher->new_vat_amount;
                });
            $PaymentVoucherTotalNetAmountForCash = PaymentVoucherExpense::where(function($query) use ($account) {
                $query->where('account_name', $account->account_name);
                })
                ->where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->whereNull('deleted_at')
                ->groupBy('invoice_no')
                ->get()
                ->sum(function ($voucher) {
                    return $voucher->amount + $voucher->new_vat_amount;
                });

                // dd($PaymentVoucherTotalNetAmountForBank,$PaymentVoucherTotalNetAmountForCash);

            $CreditNoteTotalNetAmount = CreditNote::where('account_name', $account->account_name)
                ->where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->groupBy('invoice_no')
                ->get()
                ->sum('total_net_amount');
            // dd($CreditNoteTotalNetAmount);
            $DebitNoteTotalNetAmount = DebitNote::where('account_name', $account->account_name)
                ->where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->groupBy('invoice_no')
                ->sum('total_net_amount');

            $JournalVoucherNetAmountForDebit = AdminJournalVoucher::where('account_name', $account->account_name)
                ->where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->where('type','debit')
                ->whereNull('deleted_at')
                ->groupBy('invoice_no')
                ->get()
                ->sum('amount');
            $JournalVoucherNetAmountForCredit = AdminJournalVoucher::where('account_name', $account->account_name)
                ->where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->where('type','credit')
                ->whereNull('deleted_at')
                ->groupBy('invoice_no')
                ->get()
                ->sum('amount');

                // dd($ReceiptVoucherTotalNetAmountForCash,$ReceiptVoucherTotalNetAmountForBank);

            // dd($JournalVoucherNetAmountForDebit,$JournalVoucherNetAmountForCredit);

            $DebitOB += $CreateDebitOpeningBalance +  $SaleInvoiceTotalNetAmount + $DebitNoteTotalNetAmount + $PaymentVoucherTotalNetAmountForCash  + $JournalVoucherNetAmountForDebit + $ReceiptVoucherTotalNetAmountForBank;

            $CreditOB += $CreateCreditOpeningBalance + $PurchaesInvoiceTotalNetAmount + $CreditNoteTotalNetAmount + $JournalVoucherNetAmountForCredit + $ReceiptVoucherTotalNetAmountForCash + $PaymentVoucherTotalNetAmountForBank;



            $accountDetails[$account->class_of_account_id][] = [
                'account_id' => $account->id,
                'account_name' => $account->name_of_organisation ?? $account->account_name,
                'type' => $account->type,
                'class_of_account_id' => $account->class_of_account_id,
                'DebitBalance' => $DebitOB,
                'CreditBalance' => $CreditOB,
            ];
            }

            // Initialize the mergedAccountDetails array
            $mergedAccountDetails = [];

            // Merge and sum balances from $opAccountDetails
            foreach ($opAccountDetails as $classId => $accounts) {
                foreach ($accounts as $account) {
                    if (!isset($mergedAccountDetails[$account['account_id']])) {
                        $mergedAccountDetails[$account['account_id']] = $account;
                    } else {
                        $mergedAccountDetails[$account['account_id']]['DebitBalance'] += $account['DebitBalance'];
                        $mergedAccountDetails[$account['account_id']]['CreditBalance'] += $account['CreditBalance'];
                    }
                }
            }

            // Merge and sum balances from $accountDetails
            foreach ($accountDetails as $classId => $accounts) {
                foreach ($accounts as $account) {
                    if (!isset($mergedAccountDetails[$account['account_id']])) {
                        $mergedAccountDetails[$account['account_id']] = $account;
                    } else {
                        $mergedAccountDetails[$account['account_id']]['DebitBalance'] += $account['DebitBalance'];
                        $mergedAccountDetails[$account['account_id']]['CreditBalance'] += $account['CreditBalance'];
                    }
                }
            }

            // Adjust the balances to have either a DebitBalance or CreditBalance but not both
            foreach ($mergedAccountDetails as &$account) {
                $netBalance = $account['DebitBalance'] - $account['CreditBalance'];

                if ($netBalance > 0) {
                    $account['DebitBalance'] = $netBalance;
                    $account['CreditBalance'] = 0;
                } else {
                    $account['CreditBalance'] = abs($netBalance);
                    $account['DebitBalance'] = 0;
                }
            }

            // Filter out accounts with the name "cash"
            $filteredAccountDetails = array_filter($mergedAccountDetails, function($account) {
                return strtolower($account['account_name']) !== 'cash';
            });

            // Calculate the total Debit and Credit balances
            $CashInHandTotalDebit = array_sum(array_column($filteredAccountDetails, 'DebitBalance'));
            $CashInHandTotalCredit = array_sum(array_column($filteredAccountDetails, 'CreditBalance'));

            // Output the results

            // dd([
            //     'mergedAccountDetails' => $filteredAccountDetails,
            //     'CashInHandTotalDebit' => $CashInHandTotalDebit,
            //     'CashInHandTotalCredit' => $CashInHandTotalCredit
            // ]);


            return [$CashInHandTotalDebit,$CashInHandTotalCredit,$from_date, $to_date,];


            // dd($accountDetails,$opAccountDetails);

            //     $mergedAccountDetails = [];

            //     foreach ($opAccountDetails as $classId => $accounts) {
            //         foreach ($accounts as $account) {
            //             $mergedAccountDetails[$account['account_id']] = $account;
            //         }
            //     }

            //     foreach ($accountDetails as $classId => $accounts) {
            //         foreach ($accounts as $account) {
            //             $mergedAccountDetails[$account['account_id']] = $account;
            //         }
            //     }

            //     foreach ($mergedAccountDetails as $account) {
            //         $totalDebit = array_sum(array_column($mergedAccountDetails, 'DebitBalance'));
            //         $totalCredit = array_sum(array_column($mergedAccountDetails, 'CreditBalance'));
            //     }

            //     foreach ($mergedAccountDetails as &$account) {
            //         $netBalance = $account['DebitBalance'] - $account['CreditBalance'];

            //         if ($netBalance > 0) {
            //             $account['DebitBalance'] = $netBalance;
            //             $account['CreditBalance'] = 0;
            //         } else {
            //             $account['CreditBalance'] = abs($netBalance);
            //             $account['DebitBalance'] = 0;
            //         }
            //     }
            //     dd($mergedAccountDetails);





                // // Step 1: Retrieve ClassOfAccount details from the database
                // $classOfAccountDetails = ClassOfAccount::all()->keyBy('id');

                // // Step 2: Initialize mergedAccountDetails and populate it
                // $mergedAccountDetails = [];

                // foreach ($opAccountDetails as $classId => $accounts) {
                //     foreach ($accounts as $account) {
                //         $mergedAccountDetails[$account['account_id']] = $account;
                //     }
                // }

                // foreach ($accountDetails as $classId => $accounts) {
                //     foreach ($accounts as $account) {
                //         $mergedAccountDetails[$account['account_id']] = $account;
                //     }
                // }

                // // Step 3: Group by class of account name
                // $groupedAccountDetails = [];

                // foreach ($mergedAccountDetails as $account) {
                //     $classId = $account['class_of_account_id'];
                //     $className = $classOfAccountDetails[$classId]->name ?? 'Unknown';

                //     if (!isset($groupedAccountDetails[$className])) {
                //         $groupedAccountDetails[$className] = [];
                //     }
                //     $groupedAccountDetails[$className][] = $account;
                // }

                // // Step 4: Adjust balances within each group
                // foreach ($groupedAccountDetails as &$group) {
                //     foreach ($group as &$account) {
                //         $netBalance = $account['DebitBalance'] - $account['CreditBalance'];

                //         if ($netBalance > 0) {
                //             $account['DebitBalance'] = $netBalance;
                //             $account['CreditBalance'] = 0;
                //         } else {
                //             $account['CreditBalance'] = abs($netBalance);
                //             $account['DebitBalance'] = 0;
                //         }
                //     }
                // }

                // dd($groupedAccountDetails);

            // return [$groupedAccountDetails,$from_date, $to_date,];

    }
    // -----   Tax & Duties  ------------------------------------------------------------- >>>>>>>>>>>>>>>>>>

    public function AllTaxAndDutiesClassofAccounts($request, $from_date, $to_date)
    {

        $from_date = $request->from_date;
        $to_date = $request->to_date;

        $currentYearFirstDate = date("2003-01-01");
        $oneDayPreviousDate = date('Y-m-d', strtotime('-1 day', strtotime($from_date)));

        $opcustomers = Customer::where('branch_id', session()->get('selected_branch'))
            ->where('class_of_account_id', 18)
            ->get(['id', 'class_of_account_id','name_of_organisation as account_name','opening_balance','type','date']);

        $opsuppliers = Supplier::where('branch_id', session()->get('selected_branch'))
            ->where('class_of_account_id', 18)
            ->get(['id', 'class_of_account_id','name_of_organisation as account_name','opening_balance','type','date']);

        $opexpenses = Expense::where('branch_id', session()->get('selected_branch'))
            ->where('class_of_account_id',18)
            ->get(['id', 'class_of_account_id','account_name','opening_balance','type','date']);

        $opadminOtherAccounts = AdminOtherAccount::where('branch_id', session()->get('selected_branch'))
            ->where('class_of_account_id', 18)
            ->get(['id', 'class_of_account_id','account_name','opening_balance','type','date']);

        $opstaffAndSalesman = StaffAndSalesman::where('branch_id', session()->get('selected_branch'))
            ->where('class_of_account_id', 18)
            ->selectRaw('id, class_of_account_id, CONCAT(first_name, " ", last_name) as account_name,date_of_joining as date')
            ->get();

        $opAllAccounts = $opcustomers->concat($opsuppliers)->concat($opexpenses)->concat($opadminOtherAccounts)->concat($opstaffAndSalesman);

        // dd($opAllAccounts);

        $opAccountDetails = [];

        foreach ($opAllAccounts as $opAccount) {
            $opDebitOBalance = null;
            $opCreditOBalance = null;
            $opCreateDebitOpeningBalance = null;
            $opCreateCreditOpeningBalance = null;
            $debitAllAccountsDate = null;
            $creditAllAccountsDate = null;

            if (($opAccount->type === 'Debit' || $opAccount->type === 'debit') && $opAccount->date >= $currentYearFirstDate && $opAccount->date <= $oneDayPreviousDate) {
                $debitAllAccountsDate = $opAccount->date;
                $opCreateDebitOpeningBalance = $opAccount->opening_balance;

            } elseif (($opAccount->type === 'Credit' || $opAccount->type === 'credit') && $opAccount->date >= $currentYearFirstDate && $opAccount->date <= $oneDayPreviousDate) {
                $creditAllAccountsDate = $opAccount->date;
                $opCreateCreditOpeningBalance = $opAccount->opening_balance;

            }

         // dd($DebitOB,$CreditOB,$debitAllAccountsDate,$creditAllAccountsDate);

         $opPurchaesInvoiceTotalNetAmount = AdminPurchaesInvoice::where('account_name', $opAccount->account_name)
             ->where('branch_id', session()->get('selected_branch'))
             ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
             ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
             ->whereNull('deleted_at')
             ->groupBy('invoice_no')
             ->get()
             ->sum('total_net_amount');

         $opSaleInvoiceTotalNetAmount = AdminSalesInvoice::where('account_name', $opAccount->account_name)
             ->where('branch_id', session()->get('selected_branch'))
             ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
             ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
             ->whereNull('deleted_at')
             ->groupBy('invoice_no')
             ->get()
             ->sum('total_net_amount');

         $opReceiptVoucherTotalNetAmountForCash = ReceiptVoucherExpense::where('account_name', $opAccount->account_name)
             ->where('branch_id', session()->get('selected_branch'))
            //  ->where('payment_method','cash')
             ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
             ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
             ->whereNull('deleted_at')
             ->groupBy('invoice_no')
             ->get()
             ->sum('amount');
         $opReceiptVoucherTotalNetAmountForBank = ReceiptVoucherExpense::
              where('bank_name', $opAccount->account_name)
             ->where('branch_id', session()->get('selected_branch'))
            //  ->where('payment_method','bank')
             ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
             ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
             ->whereNull('deleted_at')
             ->groupBy('invoice_no')
             ->get()
             ->sum('amount');

         $opPaymentVoucherTotalNetAmountForBank = PaymentVoucherExpense::
              where('bank_name', $opAccount->account_name)
             ->where('branch_id', session()->get('selected_branch'))
            //  ->where('payment_method','bank')
             ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
             ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
             ->whereNull('deleted_at')
             ->groupBy('invoice_no')
             ->get()
             ->sum(function ($voucher) {
                 return $voucher->amount + $voucher->new_vat_amount;
             });
         $opPaymentVoucherTotalNetAmountForCash = PaymentVoucherExpense::where('account_name', $opAccount->account_name)
             ->where('branch_id', session()->get('selected_branch'))
            //  ->where('payment_method','cash')
             ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
             ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
             ->whereNull('deleted_at')
             ->groupBy('invoice_no')
             ->get()
             ->sum(function ($voucher) {
                 return $voucher->amount + $voucher->new_vat_amount;
             });

             // dd($PaymentVoucherTotalNetAmountForBank,$PaymentVoucherTotalNetAmountForCash);

         $opCreditNoteTotalNetAmount = CreditNote::where('account_name', $opAccount->account_name)
             ->where('branch_id', session()->get('selected_branch'))
             ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
             ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
             ->groupBy('invoice_no')
             ->sum('total_net_amount');

         $opDebitNoteTotalNetAmount = DebitNote::where('account_name', $opAccount->account_name)
             ->where('branch_id', session()->get('selected_branch'))
             ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
             ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
             ->groupBy('invoice_no')
             ->sum('total_net_amount');

         $opJournalVoucherNetAmountForDebit = AdminJournalVoucher::where('account_name', $opAccount->account_name)
             ->where('branch_id', session()->get('selected_branch'))
             ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
             ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
             ->where('type','debit')
             ->groupBy('invoice_no')
             ->get()
             ->sum('amount');
         $opJournalVoucherNetAmountForCredit = AdminJournalVoucher::where('account_name', $opAccount->account_name)
             ->where('branch_id', session()->get('selected_branch'))
             ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
             ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
             ->where('type','credit')
             ->groupBy('invoice_no')
             ->get()
             ->sum('amount');


         $opDebitOBalance += $opCreateDebitOpeningBalance + $opSaleInvoiceTotalNetAmount + $opDebitNoteTotalNetAmount + $opPaymentVoucherTotalNetAmountForCash + $opJournalVoucherNetAmountForDebit + $opReceiptVoucherTotalNetAmountForBank;

         $opCreditOBalance += $opCreateCreditOpeningBalance + $opPurchaesInvoiceTotalNetAmount + $opCreditNoteTotalNetAmount + $opJournalVoucherNetAmountForCredit + $opReceiptVoucherTotalNetAmountForCash + $opPaymentVoucherTotalNetAmountForBank;


         $opAccountDetails[$opAccount->class_of_account_id][] = [
             'account_id' => $opAccount->id,
             'account_name' => $opAccount->name_of_organisation ?? $opAccount->account_name,
             'type' => $opAccount->type,
             'class_of_account_id' => $opAccount->class_of_account_id,
             'DebitBalance' => $opDebitOBalance,
             'CreditBalance' => $opCreditOBalance,
         ];
         }

        // from_date to to_date - date range data


        $customers = Customer::where('branch_id', session()->get('selected_branch'))
        ->where('class_of_account_id', 18)
        ->get(['id', 'class_of_account_id', 'name_of_organisation as account_name', 'opening_balance', 'type', 'date']);

        $suppliers = Supplier::where('branch_id', session()->get('selected_branch'))
            ->where('class_of_account_id', 18)
            ->get(['id', 'class_of_account_id','name_of_organisation as account_name','opening_balance','type','date']);

        $expenses = Expense::where('branch_id', session()->get('selected_branch'))
            ->where('class_of_account_id', 18)
            ->get(['id', 'class_of_account_id','account_name','opening_balance','type','date']);

        $adminOtherAccounts = AdminOtherAccount::where('branch_id', session()->get('selected_branch'))
            ->where('class_of_account_id', 18)
            ->get(['id', 'class_of_account_id','account_name','opening_balance','type','date']);

        $staffAndSalesman = StaffAndSalesman::where('branch_id', session()->get('selected_branch'))
            ->where('class_of_account_id', 18)
            ->selectRaw('id, class_of_account_id, CONCAT(first_name, " ", last_name) as account_name,date_of_joining as date,type')
            ->get();


        // $halfFirstAccounts = $customers->concat($suppliers)->concat($expenses);
        // $halfSecondAccounts = $adminOtherAccounts->concat($staffAndSalesman);

        $allAccounts = $customers->concat($suppliers)->concat($expenses)->concat($adminOtherAccounts)->concat($staffAndSalesman);


        // from_date to to_date - date range data

        $accountDetails = [];

        foreach ($allAccounts as $account) {
            $DebitOB = null;
            $CreditOB = null;
            $CreateDebitOpeningBalance = null;
            $CreateCreditOpeningBalance = null;
            $debitAllAccountsDate = null;
            $creditAllAccountsDate = null;

            if (($account->type === 'Debit' || $account->type === 'debit') && $account->date >= $from_date && $account->date <= $to_date) {
                $debitAllAccountsDate = $account->date;
                $CreateDebitOpeningBalance = $account->opening_balance;

            } elseif (($account->type === 'Credit' || $account->type === 'credit') && $account->date >= $from_date && $account->date <= $to_date) {
                $creditAllAccountsDate = $account->date;
                $CreateCreditOpeningBalance = $account->opening_balance;

            }

            $ReceiptVoucherTotalNetAmountForCash = ReceiptVoucherExpense::where('account_name', $account->account_name)
                ->where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->whereNull('deleted_at')
                ->groupBy('invoice_no')
                ->get()
                ->sum('amount');

            $ReceiptVoucherTotalNetAmountForBank = ReceiptVoucherExpense::where('bank_name', $account->account_name)
                ->where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->whereNull('deleted_at')
                ->groupBy('invoice_no')
                ->get()
                ->sum('amount');

            $PurchaesInvoiceTotalNetAmount = AdminPurchaesInvoice::where('account_name', $account->account_name)
                ->where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->whereNull('deleted_at')
                ->groupBy('invoice_no')
                ->get()
                ->sum('total_net_amount');

            $SaleInvoiceTotalNetAmount = AdminSalesInvoice::where('account_name', $account->account_name)
                ->where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->whereNull('deleted_at')
                ->groupBy('invoice_no')
                ->get()
                ->sum('total_net_amount');



            $PaymentVoucherTotalNetAmountForBank = PaymentVoucherExpense::where(function($query) use ($account) {
                $query->where('bank_name', $account->account_name);
                })
                ->where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->whereNull('deleted_at')
                ->groupBy('invoice_no')
                ->get()
                ->sum(function ($voucher) {
                    return $voucher->amount + $voucher->new_vat_amount;
                });
            $PaymentVoucherTotalNetAmountForCash = PaymentVoucherExpense::where(function($query) use ($account) {
                $query->where('account_name', $account->account_name);
                })
                ->where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->whereNull('deleted_at')
                ->groupBy('invoice_no')
                ->get()
                ->sum(function ($voucher) {
                    return $voucher->amount + $voucher->new_vat_amount;
                });

                // dd($PaymentVoucherTotalNetAmountForBank,$PaymentVoucherTotalNetAmountForCash);

            $CreditNoteTotalNetAmount = CreditNote::where('account_name', $account->account_name)
                ->where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->groupBy('invoice_no')
                ->get()
                ->sum('total_net_amount');
            // dd($CreditNoteTotalNetAmount);
            $DebitNoteTotalNetAmount = DebitNote::where('account_name', $account->account_name)
                ->where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->groupBy('invoice_no')
                ->sum('total_net_amount');

            $JournalVoucherNetAmountForDebit = AdminJournalVoucher::where('account_name', $account->account_name)
                ->where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->where('type','debit')
                ->whereNull('deleted_at')
                ->groupBy('invoice_no')
                ->get()
                ->sum('amount');
            $JournalVoucherNetAmountForCredit = AdminJournalVoucher::where('account_name', $account->account_name)
                ->where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->where('type','credit')
                ->whereNull('deleted_at')
                ->groupBy('invoice_no')
                ->get()
                ->sum('amount');

                // dd($ReceiptVoucherTotalNetAmountForCash,$ReceiptVoucherTotalNetAmountForBank);

            // dd($JournalVoucherNetAmountForDebit,$JournalVoucherNetAmountForCredit);

            $DebitOB += $CreateDebitOpeningBalance +  $SaleInvoiceTotalNetAmount + $DebitNoteTotalNetAmount + $PaymentVoucherTotalNetAmountForCash  + $JournalVoucherNetAmountForDebit + $ReceiptVoucherTotalNetAmountForBank;

            $CreditOB += $CreateCreditOpeningBalance + $PurchaesInvoiceTotalNetAmount + $CreditNoteTotalNetAmount + $JournalVoucherNetAmountForCredit + $ReceiptVoucherTotalNetAmountForCash + $PaymentVoucherTotalNetAmountForBank;



            $accountDetails[$account->class_of_account_id][] = [
                'account_id' => $account->id,
                'account_name' => $account->name_of_organisation ?? $account->account_name,
                'type' => $account->type,
                'class_of_account_id' => $account->class_of_account_id,
                'DebitBalance' => $DebitOB,
                'CreditBalance' => $CreditOB,
            ];
            }

            // Initialize the mergedAccountDetails array
            $mergedAccountDetails = [];

            // Merge and sum balances from $opAccountDetails
            foreach ($opAccountDetails as $classId => $accounts) {
                foreach ($accounts as $account) {
                    if (!isset($mergedAccountDetails[$account['account_id']])) {
                        $mergedAccountDetails[$account['account_id']] = $account;
                    } else {
                        $mergedAccountDetails[$account['account_id']]['DebitBalance'] += $account['DebitBalance'];
                        $mergedAccountDetails[$account['account_id']]['CreditBalance'] += $account['CreditBalance'];
                    }
                }
            }

            // Merge and sum balances from $accountDetails
            foreach ($accountDetails as $classId => $accounts) {
                foreach ($accounts as $account) {
                    if (!isset($mergedAccountDetails[$account['account_id']])) {
                        $mergedAccountDetails[$account['account_id']] = $account;
                    } else {
                        $mergedAccountDetails[$account['account_id']]['DebitBalance'] += $account['DebitBalance'];
                        $mergedAccountDetails[$account['account_id']]['CreditBalance'] += $account['CreditBalance'];
                    }
                }
            }

            // Adjust the balances to have either a DebitBalance or CreditBalance but not both
            foreach ($mergedAccountDetails as &$account) {
                $netBalance = $account['DebitBalance'] - $account['CreditBalance'];

                if ($netBalance > 0) {
                    $account['DebitBalance'] = $netBalance;
                    $account['CreditBalance'] = 0;
                } else {
                    $account['CreditBalance'] = abs($netBalance);
                    $account['DebitBalance'] = 0;
                }
            }

            // Filter out accounts with the name "cash"
            $filteredAccountDetails = array_filter($mergedAccountDetails, function($account) {
                return strtolower($account['account_name']) !== 'vat';
            });

            // Calculate the total Debit and Credit balances
            $CashInHandTotalDebit = array_sum(array_column($filteredAccountDetails, 'DebitBalance'));
            $CashInHandTotalCredit = array_sum(array_column($filteredAccountDetails, 'CreditBalance'));

            // Output the results

            // dd([
            //     'mergedAccountDetails' => $filteredAccountDetails,
            //     'CashInHandTotalDebit' => $CashInHandTotalDebit,
            //     'CashInHandTotalCredit' => $CashInHandTotalCredit
            // ]);


            return [$CashInHandTotalDebit,$CashInHandTotalCredit,$from_date, $to_date,];


            // dd($accountDetails,$opAccountDetails);

            //     $mergedAccountDetails = [];

            //     foreach ($opAccountDetails as $classId => $accounts) {
            //         foreach ($accounts as $account) {
            //             $mergedAccountDetails[$account['account_id']] = $account;
            //         }
            //     }

            //     foreach ($accountDetails as $classId => $accounts) {
            //         foreach ($accounts as $account) {
            //             $mergedAccountDetails[$account['account_id']] = $account;
            //         }
            //     }

            //     foreach ($mergedAccountDetails as $account) {
            //         $totalDebit = array_sum(array_column($mergedAccountDetails, 'DebitBalance'));
            //         $totalCredit = array_sum(array_column($mergedAccountDetails, 'CreditBalance'));
            //     }

            //     foreach ($mergedAccountDetails as &$account) {
            //         $netBalance = $account['DebitBalance'] - $account['CreditBalance'];

            //         if ($netBalance > 0) {
            //             $account['DebitBalance'] = $netBalance;
            //             $account['CreditBalance'] = 0;
            //         } else {
            //             $account['CreditBalance'] = abs($netBalance);
            //             $account['DebitBalance'] = 0;
            //         }
            //     }
            //     dd($mergedAccountDetails);





                // // Step 1: Retrieve ClassOfAccount details from the database
                // $classOfAccountDetails = ClassOfAccount::all()->keyBy('id');

                // // Step 2: Initialize mergedAccountDetails and populate it
                // $mergedAccountDetails = [];

                // foreach ($opAccountDetails as $classId => $accounts) {
                //     foreach ($accounts as $account) {
                //         $mergedAccountDetails[$account['account_id']] = $account;
                //     }
                // }

                // foreach ($accountDetails as $classId => $accounts) {
                //     foreach ($accounts as $account) {
                //         $mergedAccountDetails[$account['account_id']] = $account;
                //     }
                // }

                // // Step 3: Group by class of account name
                // $groupedAccountDetails = [];

                // foreach ($mergedAccountDetails as $account) {
                //     $classId = $account['class_of_account_id'];
                //     $className = $classOfAccountDetails[$classId]->name ?? 'Unknown';

                //     if (!isset($groupedAccountDetails[$className])) {
                //         $groupedAccountDetails[$className] = [];
                //     }
                //     $groupedAccountDetails[$className][] = $account;
                // }

                // // Step 4: Adjust balances within each group
                // foreach ($groupedAccountDetails as &$group) {
                //     foreach ($group as &$account) {
                //         $netBalance = $account['DebitBalance'] - $account['CreditBalance'];

                //         if ($netBalance > 0) {
                //             $account['DebitBalance'] = $netBalance;
                //             $account['CreditBalance'] = 0;
                //         } else {
                //             $account['CreditBalance'] = abs($netBalance);
                //             $account['DebitBalance'] = 0;
                //         }
                //     }
                // }

                // dd($groupedAccountDetails);

            // return [$groupedAccountDetails,$from_date, $to_date,];

    }









}
